/*
 * bpfx.a.c
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <bpfx-defs.h>
#include <bpfx-inter.h>
#include <bpfx-names.h>
#include <bpfx-types.h>

#define bpfset(bpfset)			((struct bpfset_type *) (bpfset))

int
x1f4_high_bpfset(void *bpfset)
{
    int status;

    status = _libx1f4l2_ceil_bpfset(bpfset);
    if (status) {
    } else {
	if (bpfset(bpfset)->link_a.fpnews.link_v.rate) {
	    void *data;

	    data = bpfset(bpfset)->link_a.fpnews.node;

	    status = bpfset(bpfset)->link_m.mode
		(bpfset(bpfset)->link_m.data, &data,
		 integral_q_bits_and_half
		 * (bpfset(bpfset)->link_a.fpnews.link_v.size
		    + SIZEOF_integral_q));
	    if (status) {
		status = MODE_ERROR;
	    } else {
		bpfset(bpfset)->link_a.fpnews.link_v.rate = 0;

		*((integral_q *) data) = 0;

		if (1) {
		    bpfset(bpfset)->link_a.fpnews.node = data;
		}
	    }
	} else {
	    integral_q *data;

	    data = bpfset(bpfset)->link_a.fpnews.node;

	    *data = 0;
	}
    }

    return status;
}
