/*
 * bppx.p.c
 * Copyright (C) 2009-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <bcount.h>
#include <bpfx-lines.h>
#include <bpfx-names.h>
#include <bpfx-types.h>
#include <bppx-types.h>

#define __HALF_TRANSFER__		1

#define __UNROLL_TRANSFER__		0

#undef Q
#define Q(e)				((integral_q) (e))

#define bpfset(bpfset)			((struct bpfset_type *) (bpfset))

int
_libx1f4l2_four_bppset(void *bpfset, integral_q last, integral_q **lead,
		       integral_q pipe, void **lift, unsigned *mile,
		       integral_q **land, integral_q **lock, integral_q **lane,
		       integral_q next, unsigned *rate)
{
    integral_q *club, *file, *head, port, *tier;
    unsigned call, copy, deck, ever;
    void *node;

    club = *lead;

    file = *lock;

    tier = *lane;

    node = *lift;

    call = *mile;

    copy = *rate;

    if (1) {
	integral_q *fast, text;

	fast = tier;

	text = next & ~Lx55555555;

	text >>= 2;
	if (text) {
	    fast += 2;

	    last = *fast;

	    text >>= 2;
	    if (text) {
		port = *(fast + 2);
		*fast = port;
		fast += 2;

		text >>= 2;

# if __UNROLL_TRANSFER__
		mode = text >> 2;
		for (; mode; mode >>= 4) {
		    *fast = *(fast + 2);
		    fast += 2;
		    *fast = *(fast + 2);
		    fast += 2;
		}
		if (text & Lx22222222) {
		    *fast = *(fast + 2);
		    fast += 2;
		}
# else
		for (; text; text >>= 2) {
		    *fast = *(fast + 2);
		    fast += 2;
		}
# endif				/* __UNROLL_TRANSFER__ */
		{
		    *fast = *(fast + 1);
		}
	    } else {
		port = fast[1];
		*fast = port;
	    }
	} else {
	    last = fast[1];
	    port = fast[2];
	}

	*KD(tier) = next ^ Q(1) << (fast - tier + 1);

	fast = file;

	if (copy & 1) {
	    *KD(fast) = Lx55555555 | (Q(1) << integral_q_last);

	    *(fast + integral_q_last) = last;
	} else {
	    text = *fast & ~Lx55555555;

	    if (text >> copy) {
		*KD(fast) = Lx55555555 | (Q(1) << integral_q_last);

		fast += copy;

		next = text >> copy >> 2;

# if __UNROLL_TRANSFER__
		mode = next >> 2;
		for (; mode; mode >>= 4) {
		    *fast = *(fast + 2);
		    fast += 2;
		    *fast = *(fast + 2);
		    fast += 2;
		}
		if (next & Lx22222222) {
		    *fast = *(fast + 2);
		    fast += 2;
		}
# else
		for (; next; next >>= 2) {
		    *fast = *(fast + 2);
		    fast += 2;
		}
# endif				/* __UNROLL_TRANSFER__ */
		{
		    *fast = *(fast + 1);
		}

		{
		    *(file + integral_q_last) = last;
		}
	    } else {
		if (Q(1) << copy < text << (integral_q_bits - copy)) {
		    *KD(fast) = Lx55555555 | (Q(1) << integral_q_last);

		    fast += copy;

		    next = text << (integral_q_bits - copy + 1);

# if __UNROLL_TRANSFER__
		    mode = next << 2;
		    for (; mode; mode <<= 4) {
			*fast = *(fast - 2);
			fast -= 2;
			*fast = *(fast - 2);
			fast -= 2;
		    }
		    if (next & Lx44444444) {
			*fast = *(fast - 2);
			fast -= 2;
		    }
# else
		    for (; next; next <<= 2) {
			*fast = *(fast - 2);
			fast -= 2;
		    }
# endif				/* __UNROLL_TRANSFER__ */
		    {
			*fast = *(fast - 1);
		    }

		    {
			*(file + integral_q_last) = last;
		    }
		} else {
		    *KD(fast) = text | Lx55555555;

		    fast += copy;

		    deck = (integral_q_bits - 2 - copy) >> 1;
# if __UNROLL_TRANSFER__
		    ever = deck >> 1;
		    for (; ever; ever--) {
			*fast = *(fast + 2);
			fast += 2;
			*fast = *(fast + 2);
			fast += 2;
		    }
		    if (deck & 1) {
			*fast = *(fast + 2);
			fast += 2;
		    }
# else
		    for (; deck; deck--) {
			*fast = *(fast + 2);
			fast += 2;
		    }
# endif				/* __UNROLL_TRANSFER__ */
		    {
			*fast = last;
		    }
		}
	    }
	}
    }

    if (1) {
	club = file;

	file = tier;

	head = KD(node) + call + 1;

	*head = port;
    } else {
    }

    if (call) {
	if (pipe & Q(1) << 3) {
	    call = 2;
	    tier = PD(node)[3];
	} else {
	    call = 3;
	    if (pipe & Q(1) << 5) {
		tier = PD(node)[4];
	    } else {
		tier = PD(node)[5];
	    }
	}
    } else {
	call = 1;
	if (pipe & Q(1) << 3) {
	    tier = PD(node)[2];
	} else {
	    tier = PD(node)[3];
	}
    }

    next = *tier & ~Lx55555555;
    if (next & (next - 1)) {
#if __HALF_TRANSFER__
	if (1) {
	    integral_q *fast, *side, text;

	    fast = file;

	    l2_q_bitcount(ever, next);
	    ever &= ~1;

	    fast = file;

	    *KD(fast) = Lx55555555 | ~Q(0) << (integral_q_bits - ever);

	    fast += integral_q_bits - ever + 1;

	    side = fast + 1;

	    ever >>= 1;

	    deck = ever - 1;
	    for (; deck; deck--) {
		*fast = *side;
		side += 2;
		fast++;
	    }

	    side = tier;

	    text = *side;

	    while (ever & ~1) {
		if (text & Q(2)) {
		    side++;
		    *fast = *side;
		    fast++;
		    side++;
		    *fast = *side;
		    fast++;

		    ever -= 2;
		} else {
		    ever--;

		    side += 2;
		    *fast = *side;
		    fast++;
		}

		text >>= 2;
	    }
	    if (ever) {
		if (text & Q(2)) {
		    side++;
		    *fast = *side;
		    fast++;

		    side++;

		    fast = tier + 2;

		    text >>= 1;
		} else {
		    side += 2;
		    *fast = *side;
		    fast++;

		    side++;

		    fast = tier + 2;

		    text >>= 2;

		    if (fast < side) {
			text >>= 1;
			if (text & Q(1)) {
			    *fast = *side;
			    fast += 2;
			} else {
			}

			side++;
		    }
		}
	    } else {
		side++;

		fast = tier + 2;

		if (fast < side) {
		    text >>= 1;
		    if (text & Q(1)) {
			*fast = *side;
			fast += 2;
		    } else {
		    }

		    side++;
		}
	    }
	    while (fast < side) {
		if (text & Q(4)) {
		    *fast = *side;
		    fast += 2;
		    side++;
		    *fast = *side;
		    fast += 2;
		    side++;
		} else {
		    *fast = *side;
		    fast += 2;
		    side += 2;
		}

		text >>= 2;
	    }

	    *KD(tier) &= Lx55555555 | ~Q(0) << (fast - tier);
	}

	if (1) {
	    KD(node)[call + 1] = *(tier + 2);
	} else {
	}
#else
	if (1) {
	    integral_q *fast, text;

	    fast = tier;

	    text = next & ~Lx55555555;
	    text &= (text - 1) << 1;

	    text >>= 2;
	    if (text) {
		fast += 2;

		last = *fast;

		text >>= 2;
		if (text) {
		    port = *(fast + 2);
		    *fast = port;
		    fast += 2;

		    text >>= 2;

# if __UNROLL_TRANSFER__
		    mode = text >> 2;
		    for (; mode; mode >>= 4) {
			*fast = *(fast + 2);
			fast += 2;
			*fast = *(fast + 2);
			fast += 2;
		    }
		    if (text & Lx22222222) {
			*fast = *(fast + 2);
			fast += 2;
		    }
# else
		    for (; text; text >>= 2) {
			*fast = *(fast + 2);
			fast += 2;
		    }
# endif				/* __UNROLL_TRANSFER__ */
		    {
			*fast = *(fast + 1);
		    }
		} else {
		    port = fast[1];
		    *fast = port;
		}
	    } else {
		last = fast[1];
		port = fast[2];
	    }

	    *KD(tier) = (next ^ Q(1) << (fast - tier + 1)) | Lx55555555;

	    fast = file;

	    if (1) {
		*KD(fast) = Lx55555555 | (Q(1) << integral_q_last);

		*(fast + integral_q_last) = last;
	    }
	}

	if (1) {
	    KD(node)[call + 1] = port;
	}
#endif				/* __HALF_TRANSFER__ */
    } else {
	*rate = 1;

	*mile = call;

	*lane = tier;

	*lock = file;

	*land = head;

	*lead = club;
    }

    return 0;
}
