/*
 * dfxy.3.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <stddef.h>

#include <dfxx-defs.h>
#include <dfxx-inter.h>
#include <dfxx-names.h>
#include <dfxx-types.h>

#if SIZEOF_VOID_P == SIZEOF_LONG
# define integral_q			unsigned long
#else
# define integral_q			unsigned
#endif				/* SIZEOF_VOID_P == SIZEOF_LONG */

#define dflist(dflist)			((struct dflist_type *) (dflist))

int
x1f4_head_dflist(void *dflist, unsigned size, void **push)
{
    int status;
    void *dfnode;

    status = dflist(dflist)->link_m.link
	(dflist(dflist)->link_m.data, &dfnode,
	 sizeof(struct fpnode_type) + size);
    if (status) {
	status = LINK_ERROR;
    } else {
	struct fpnode_type *fpnode_data;
	unsigned size;

	fpnode_data = dfnode;

	size = dflist(dflist)->link_a.fplist.link_v.size;
	if (size) {
	    struct fpnode_type *fpnode_text;

	    fpnode_text = dflist(dflist)->link_a.fplist.fplink.fpnode_data[1];

	    dflist(dflist)->link_a.fplist.fplink.fpnode_data[1] = fpnode_data;

	    fpnode_data->fpnode_case = fpnode_text;

	    fpnode_text->fpnode_case = (void *)
		((integral_q) fpnode_data
		 ^ (integral_q) fpnode_text->fpnode_case);

	    dflist(dflist)->link_a.fplist.link_v.size = size + 1;
	} else {
	    dflist(dflist)->link_a.fplist.link_v.size = 1;

	    fpnode_data->fpnode_case = NULL;

	    dflist(dflist)->link_a.fplist.fplink.fpnode_data[0] = fpnode_data;
	    dflist(dflist)->link_a.fplist.fplink.fpnode_data[1] = fpnode_data;
	}

	*push = fpnode_data + 1;
    }

    return status;
}
