/*
 * l2xx.7.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l2xx-names.h>
#include <l2xx-types.h>

#define l2list(l2list)			((struct l2list_type *) (l2list))

int
x1f4_lime_l2list(void *l2list, void *back, int (*call) (void *, void *))
{
    int delete;
    struct fpnode_type *fpnode_data;

    fpnode_data = l2list(l2list)->link_a.fplist.fplink.fpnode_data[1];
    if (fpnode_data) {
	do {
	    delete = call(back, fpnode_data + 1);
	    if (delete) {
		break;
	    }

	    fpnode_data = fpnode_data->fpnode_data[1];
	} while (fpnode_data);
    } else {
	delete = 0;
    }

    return delete;
}
