/*
 * l2xy.w.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <l2xx-names.h>
#include <l2xx-types.h>

#define __LONG_FLIP__			1

#define l2list(l2list)			((struct l2list_type *) (l2list))

int
x1f4_flip_l2list(void *l2list)
{
    struct fpnode_type *fpnode_data;

    fpnode_data = l2list(l2list)->link_a.fplist.fplink.fpnode_data[1];
    if (fpnode_data) {
	struct fpnode_type *fqnode_data, *fsnode_data = NULL;
#if __LONG_FLIP__
	unsigned size;
#endif				/* __LONG_FLIP__ */

	fqnode_data = l2list(l2list)->link_a.fplist.fplink.fpnode_data[0];

	l2list(l2list)->link_a.fplist.fplink.fpnode_data[0] = fpnode_data;
	l2list(l2list)->link_a.fplist.fplink.fpnode_data[1] = fqnode_data;

#if __LONG_FLIP__
	size = l2list(l2list)->link_a.fplist.link_v.size / 3;
#endif				/* __LONG_FLIP__ */

#if __LONG_FLIP__
	while (size) {
	    fqnode_data = fpnode_data->fpnode_data[1];

	    fpnode_data->fpnode_data[0] = fqnode_data;
	    fpnode_data->fpnode_data[1] = fsnode_data;

	    fsnode_data = fqnode_data->fpnode_data[1];

	    fqnode_data->fpnode_data[0] = fsnode_data;
	    fqnode_data->fpnode_data[1] = fpnode_data;

	    fpnode_data = fsnode_data->fpnode_data[1];

	    fsnode_data->fpnode_data[0] = fpnode_data;
	    fsnode_data->fpnode_data[1] = fqnode_data;

	    --size;
	}
#endif				/* __LONG_FLIP__ */
	while (1) {
	    fqnode_data = fpnode_data->fpnode_data[1];

	    fpnode_data->fpnode_data[0] = fqnode_data;
	    fpnode_data->fpnode_data[1] = fsnode_data;

	    if (fqnode_data) {
	    } else {
		break;
	    }

	    fsnode_data = fqnode_data->fpnode_data[1];

	    fqnode_data->fpnode_data[0] = fsnode_data;
	    fqnode_data->fpnode_data[1] = fpnode_data;

	    if (fsnode_data) {
	    } else {
		break;
	    }

	    fpnode_data = fsnode_data->fpnode_data[1];

	    fsnode_data->fpnode_data[0] = fpnode_data;
	    fsnode_data->fpnode_data[1] = fqnode_data;

	    if (fpnode_data) {
	    } else {
		break;
	    }
	}
    }

    return 0;
}
