/*
 * l4xx-types.h
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_l4xx_types_H__
#define __LIBx1f4_l4xx_types_H__

#include <trans.h>

typedef struct list64_type {
    struct list64_type *last_0, *last_1, *next_1, *next_7;
} list64_type;

typedef struct list88_type {
    struct list64_type *head64_data, *tail64_data;
    unsigned count, stride;
} list88_type;

typedef struct l4list_type {
    struct {
	struct list88_type list88;
    } link_a;
    struct {
	struct list64_type *list64_data;
	unsigned class;
    } link_c;
    struct {
	int (*free) (void *, void *), (*link) (void *, void **, unsigned),
	    (*mode) (void *, void **, unsigned);
	void *data;
    } link_m;
} l4list_type;

typedef struct screen_type {
    struct trans_type *trans_data;
} screen_type;

#endif				/* __LIBx1f4_l4xx_types_H__ */
