/*
 * l4xx.2.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <stddef.h>

#include <l4xx-defs.h>
#include <l4xx-inter.h>
#include <l4xx-types.h>

#define false(e)			0

static int ceil_list(struct l4list_type *, unsigned, struct list64_type *);
static int lose_list(struct l4list_type *);
static int miss_list(struct l4list_type *, unsigned);

static int
ceil_list(struct l4list_type *l4list_data, unsigned index,
	  struct list64_type *list64_data)
{
    int status;

    _libx1f4l2_fast_l4list(l4list_data, index, list64_data);
    if (0) {
    } else {
	l4list_data->link_a.list88.count--;

	status = l4list_data->link_m.free
	    (l4list_data->link_m.data, list64_data);
	if (status) {
	    status = FREE_ERROR;
	} else {
	    status = _libx1f4l2_tack_l4list(l4list_data);
	}
    }

    return status;
}


static int
lose_list(struct l4list_type *l4list_data)
{
    int status;

    status = l4list_data->link_m.free
	(l4list_data->link_m.data, l4list_data->link_c.list64_data);
    if (status) {
	status = FREE_ERROR;
    } else {
	l4list_data->link_a.list88.count = 0;
    }

    return status;
}


static int
miss_list(struct l4list_type *l4list_data, unsigned index)
{
    int status;
    void *list64;

    _libx1f4l2_seek_l4list(l4list_data, index, &list64);

    status = ceil_list(l4list_data, index, list64);

    return status;
}


int
x1f4_miss_l4list(void *l4list, unsigned index)
{
    int status;
    unsigned count;

    count = ((struct l4list_type *) l4list)->link_a.list88.count;

    if (!(index < count)) {
	status = DECK_ERROR;
    } else {
	if (count == 1) {
	    status = lose_list(l4list);
	} else {
	    status = miss_list(l4list, index);
	}
    }

    return status;
}
