/*
 * l4xx.5.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <l4xx-defs.h>
#include <l4xx-inter.h>
#include <l4xx-types.h>

#define l4list(l4list)			((struct l4list_type *) (l4list))

static int mode_list(struct l4list_type *, struct list64_type *, unsigned);

static int
mode_list(struct l4list_type *l4list_data, struct list64_type *list64_data,
	  unsigned index)
{
    int status;
    struct list64_type *list64_text;
    void *list64;

    _libx1f4l2_seek_l4list(l4list_data, index, &list64);

    *list64_data = *(struct list64_type *) list64;

    list64_text = list64_data->last_0;
    if (list64_text) {
	list64_text->next_7 = list64_data;
    }
    list64_text = list64_data->last_1;
    if (list64_text) {
	list64_text->next_1 = list64_data;
    }
    list64_text = list64_data->next_1;
    if (list64_text) {
	list64_text->last_1 = list64_data;
    }
    list64_text = list64_data->next_7;
    if (list64_text) {
	list64_text->last_0 = list64_data;
    }

    if (list64 == l4list_data->link_c.list64_data) {
	l4list_data->link_c.list64_data = list64_data;
    }

    if (list64 == l4list_data->link_a.list88.head64_data) {
	l4list_data->link_a.list88.head64_data = list64_data;
    }
    if (list64 == l4list_data->link_a.list88.tail64_data) {
	l4list_data->link_a.list88.tail64_data = list64_data;
    }

    status = l4list_data->link_m.free(l4list_data->link_m.data, list64);
    if (status) {
	status = FREE_ERROR;
    }

    return status;
}


int
x1f4_mode_l4list(void *l4list, unsigned index, unsigned size, void **mode)
{
    int status;
    unsigned count;

    count = l4list(l4list)->link_a.list88.count;

    if (!(index < count)) {
	status = DECK_ERROR;
    } else {
	void *list64;

	status = l4list(l4list)->link_m.link
	    (l4list(l4list)->link_m.data, &list64,
	     sizeof(struct list64_type) + size);
	if (status) {
	    status = LINK_ERROR;
	} else {
	    status = mode_list(l4list, list64, index);
	    if (status) {
	    } else {
		*mode = ((struct list64_type *) list64) + 1;
	    }
	}
    }

    return status;
}
