/*
 * l4xx.7.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <l4xx-defs.h>
#include <l4xx-inter.h>
#include <l4xx-types.h>

int
x1f4_text_l4list(void **l4list, struct l4list_type *l4list_text,
		 int (*size) (void *, unsigned *, const void *),
		 int (*copy) (void *, void *, const void *),
		 int (*free) (void *, void *), void *context)
{
    int status;
    void *text;

    status = l4list_text->link_m.link
	(l4list_text->link_m.data, &text, sizeof(struct l4list_type));
    if (status) {
	status = LINK_ERROR;
    } else {
	struct l4list_type *l4list_data;
	unsigned count;

	l4list_data = text;

	l4list_data->link_m = l4list_text->link_m;

	count = l4list_text->link_a.list88.count;
	if (!count) {
	    l4list_data->link_a.list88.count = 0;

	    *l4list = text;
	} else {
	    status = _libx1f4l2_rail_l4list
		(l4list_data, l4list_text, count, size, copy, free, context);
	    if (status) {
		l4list_text->link_m.free(l4list_text->link_m.data, text);
	    } else {
		*l4list = text;

		l4list_data->link_c.class = 0;
		l4list_data->link_c.list64_data =
		    l4list_data->link_a.list88.head64_data;
	    }
	}
    }

    return status;
}
