/*
 * l4xx.f.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l4xx-defs.h>
#include <l4xx-inter.h>
#include <l4xx-types.h>

#define list64(list64)			((struct list64_type *) (list64))

#define l4list(l4list)			((struct l4list_type *) (l4list))

static int spin_list(struct l4list_type *, unsigned, unsigned);

static int
spin_list(struct l4list_type *l4list_data, unsigned index, unsigned class)
{
    struct list64_type exchange_list32, *list64_data;
    void *list64, *list96;

    _libx1f4l2_seek_l4list(l4list_data, index, &list64);
    _libx1f4l2_seek_l4list(l4list_data, class, &list96);

    exchange_list32 = *list64(list64);
    *list64(list64) = *list64(list96);
    *list64(list96) = exchange_list32;

    l4list_data->link_c.class = index;

    list64_data = list64(list64)->last_0;
    if (list64_data) {
	if (list64_data == list64) {
	    list64(list64)->last_0 = list96;
	    list64(list96)->next_7 = list64;
	} else {
	    list64_data->next_7 = list64;
	    list64_data = list64(list96)->next_7;
	    if (list64_data) {
		list64_data->last_0 = list96;
	    }
	}
    } else {
	list64_data = list64(list96)->next_7;
	if (list64_data) {
	    list64_data->last_0 = list96;
	}
    }

    list64_data = list64(list64)->last_1;
    if (list64_data) {
	if (list64_data == list64) {
	    list64(list64)->last_1 = list96;
	    list64(list96)->next_1 = list64;
	} else {
	    list64_data->next_1 = list64;
	    list64_data = list64(list96)->next_1;
	    if (list64_data) {
		list64_data->last_1 = list96;
	    }
	}
    } else {
	list64_data = list64(list96)->next_1;
	if (list64_data) {
	    list64_data->last_1 = list96;
	}
    }

    list64_data = list64(list64)->next_1;
    if (list64_data) {
	if (list64_data == list64) {
	    list64(list64)->next_1 = list96;
	    list64(list96)->last_1 = list64;
	} else {
	    list64_data->last_1 = list64;
	    list64_data = list64(list96)->last_1;
	    if (list64_data) {
		list64_data->next_1 = list96;
	    }
	}
    } else {
	list64_data = list64(list96)->last_1;
	if (list64_data) {
	    list64_data->next_1 = list96;
	}
    }

    list64_data = list64(list64)->next_7;
    if (list64_data) {
	if (list64_data == list64) {
	    list64(list64)->next_7 = list96;
	    list64(list96)->last_0 = list64;
	} else {
	    list64_data->last_0 = list64;
	    list64_data = list64(list96)->last_0;
	    if (list64_data) {
		list64_data->next_7 = list96;
	    }
	}
    } else {
	list64_data = list64(list96)->last_0;
	if (list64_data) {
	    list64_data->next_7 = list96;
	}
    }

    if (list64 == l4list_data->link_a.list88.head64_data) {
	l4list_data->link_a.list88.head64_data = list96;
	if (list96 == l4list_data->link_a.list88.tail64_data) {
	    l4list_data->link_a.list88.tail64_data = list64;
	}
    } else {
	if (list64 == l4list_data->link_a.list88.tail64_data) {
	    l4list_data->link_a.list88.tail64_data = list96;
	    if (list96 == l4list_data->link_a.list88.head64_data) {
		l4list_data->link_a.list88.head64_data = list64;
	    }
	} else {
	    if (list96 == l4list_data->link_a.list88.head64_data) {
		l4list_data->link_a.list88.head64_data = list64;
	    } else {
		if (list96 == l4list_data->link_a.list88.tail64_data) {
		    l4list_data->link_a.list88.tail64_data = list64;
		}
	    }
	}
    }

    return 0;
}


int
x1f4_spin_l4list(void *l4list, unsigned index, unsigned class)
{
    int status;
    unsigned count;

    count = l4list(l4list)->link_a.list88.count;

    if (!(index < count)) {
	status = DECK_ERROR;
    } else {
	if (!(class < count)) {
	    status = DECK_ERROR;
	} else {
	    if (index == class) {
		status = 0;
	    } else {
		status = spin_list(l4list, index, class);
	    }
	}
    }

    return status;
}
