/*
 * l4xx.h.c
 * Copyright (C) 2007-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <math.h>

#include <l4xx-inter.h>
#include <l4xx-types.h>

#define SHIFT_THRESH			2

#define SCALE_MIRROR			2
#define SCALE_SECOND			1

#define l4list(l4list)			((struct l4list_type *) (l4list))

int
_libx1f4l2_tack_l4list(void *l4list)
{
    int status;
    unsigned Stride, count, stride;

    count = l4list(l4list)->link_a.list88.count;

    stride = sqrt(count);
    if (stride < 1) {
	stride = 1;
    } else {
	if (stride < count) {
	} else {
	    if (count == 1) {
		stride = 1;
	    } else {
		stride = count - 1;
	    }
	}
    }

    Stride = l4list(l4list)->link_a.list88.stride;

    if (stride == Stride) {
	status = 0;
    } else {
	do {
	    if (stride < Stride) {
		if (Stride - stride < SHIFT_THRESH) {
		    status = 0;
		    break;
		}
		if (Stride * SCALE_SECOND < SCALE_MIRROR * stride) {
		    status = 0;
		    break;
		}
	    } else {
		if (stride - Stride < SHIFT_THRESH) {
		    status = 0;
		    break;
		}
		if (stride * SCALE_SECOND < SCALE_MIRROR * Stride) {
		    status = 0;
		    break;
		}
	    }

	    l4list(l4list)->link_a.list88.stride = stride;

	    status = _libx1f4l2_link_l4list
		(l4list(l4list)->link_a.list88.head64_data, count, stride,
		 l4list(l4list)->link_a.list88.tail64_data);
	} while (0);
    }

    return status;
}
