/*
 * l4xx.i.c
 * Copyright (C) 2005-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <l4xx-types.h>

int
_libx1f4l2_link_l4list(void *head, unsigned count, unsigned stride, void *tail)
{
    struct list64_type *head64_list, *tail64_list;

    head64_list = head;
    tail64_list = tail;

    head64_list->last_1 = NULL;
    tail64_list->next_1 = NULL;

    if (!(stride < count)) {
	unsigned i;

	i = count;
	for (; i; i--) {
	    head64_list->last_0 = NULL;
	    head64_list->next_7 = NULL;
	    head64_list = head64_list->next_1;
	}
    } else {
	struct list64_type *head64_data, *tail64_data;
	unsigned i;

	head64_data = head64_list;
	tail64_data = tail64_list;

	i = stride;
	for (; i; i--) {
	    head64_data->last_0 = NULL;
	    head64_data = head64_data->next_1;
	    tail64_data->next_7 = NULL;
	    tail64_data = tail64_data->last_1;
	}
	i = count - stride;
	for (; i; i--) {
	    head64_data->last_0 = head64_list;
	    head64_data = head64_data->next_1;
	    head64_list = head64_list->next_1;
	    tail64_data->next_7 = tail64_list;
	    tail64_data = tail64_data->last_1;
	    tail64_list = tail64_list->last_1;
	}
    }

    return 0;
}
