/*
 * l4xx.j.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l4xx-inter.h>
#include <l4xx-types.h>

#define l4list(l4list)			((struct l4list_type *) (l4list))

int
_libx1f4l2_seek_l4list(void *l4list, unsigned index, void **seek)
{
    unsigned class;
    void *list64;

    class = l4list(l4list)->link_c.class;
    if (class < index) {
	l4list(l4list)->link_c.class = index;
	if (index - class == 1) {
	    list64 = l4list(l4list)->link_c.list64_data->next_1;
	} else {
	    unsigned becca, order;

	    becca = index - class;
	    order = l4list(l4list)->link_a.list88.count - 1 - index;
	    if (becca < order) {
		list64 = l4list(l4list)->link_c.list64_data;
		_libx1f4l2_lock_l4list
		    (&l4list(l4list)->link_a.list88, &list64, becca);
	    } else {
		list64 = l4list(l4list)->link_a.list88.tail64_data;
		_libx1f4l2_back_l4list
		    (&l4list(l4list)->link_a.list88, &list64, order);
	    }
	}

	l4list(l4list)->link_c.list64_data = list64;
    } else {
	if (index < class) {
	    l4list(l4list)->link_c.class = index;
	    if (class - index == 1) {
		list64 = l4list(l4list)->link_c.list64_data->last_1;
	    } else {
		unsigned becca, order;

		becca = class - index;
		order = index;
		if (becca < order) {
		    list64 = l4list(l4list)->link_c.list64_data;
		    _libx1f4l2_back_l4list
			(&l4list(l4list)->link_a.list88, &list64, becca);
		} else {
		    list64 = l4list(l4list)->link_a.list88.head64_data;
		    _libx1f4l2_lock_l4list
			(&l4list(l4list)->link_a.list88, &list64, order);
		}
	    }

	    l4list(l4list)->link_c.list64_data = list64;
	} else {
	    list64 = l4list(l4list)->link_c.list64_data;
	}
    }

    *seek = list64;

    return 0;
}
