/*
 * l4xx.k.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l4xx-types.h>

#define l4list(l4list)			((struct l4list_type *) (l4list))

int
_libx1f4l2_rack_l4list(void *l4list, void *list64)
{
    int (*free) (void *, void *);
    struct list64_type *list64_miss;
    void *data;

    data = l4list(l4list)->link_m.data;
    free = l4list(l4list)->link_m.free;

    list64_miss = list64;

    while (list64_miss) {
	struct list64_type *list64_fast;

	list64_fast = list64_miss->last_1;
	free(data, list64_miss);
	if (!list64_fast) {
	    break;
	} else {
	    list64_miss = list64_fast->last_1;
	    free(data, list64_fast);
	}
    }

    return 0;
}
