/*
 * l4xx.o.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <l4xx-inter.h>
#include <l4xx-types.h>

#define l4list(l4list)			((struct l4list_type *) (l4list))

#define list64(list64)			((struct list64_type *) (list64))

int
_libx1f4l2_mfix_l4list(void *l4list, unsigned count, unsigned stride,
		       unsigned index, void *list96)
{
    struct list64_type *last64_list, *next64_list;
    void *list64;

    _libx1f4l2_seek_l4list(l4list, index, &list64);

    if (0) {
	unsigned class;

	class = l4list(l4list)->link_c.class;
	if (class < index) {
	} else {
	    l4list(l4list)->link_c.class = class + 1;
	}
    }

    next64_list = list64;
    last64_list = next64_list->last_1;

    last64_list->next_1 = list96;
    list64(list96)->last_1 = last64_list;
    list64(list96)->next_1 = next64_list;
    next64_list->last_1 = list96;

    if (stride == count) {
	struct list64_type *head64_list, *tail64_list;

	head64_list = l4list(l4list)->link_a.list88.head64_data;
	tail64_list = l4list(l4list)->link_a.list88.tail64_data;

	list64(list96)->last_0 = NULL;
	list64(list96)->next_7 = NULL;

	head64_list->next_7 = tail64_list;
	tail64_list->last_0 = head64_list;
    } else {
	struct list64_type *miss64_list, *post64_list, *swap64_list;

	miss64_list = last64_list->next_7;
	if (miss64_list) {
	} else {
	    miss64_list = l4list(l4list)->link_a.list88.tail64_data;
	}

	post64_list = next64_list->last_0;
	if (post64_list) {
	} else {
	    post64_list = l4list(l4list)->link_a.list88.head64_data;
	}

	swap64_list = post64_list->next_7->last_1;

	for (;;) {
	    post64_list->next_7 = swap64_list;
	    if (post64_list == list96) {
		break;
	    } else {
		swap64_list = swap64_list->next_1;
		if (!swap64_list) {
		    list64(list96)->next_7 = NULL;
		    break;
		} else {
		    post64_list = post64_list->next_1;
		}
	    }
	}

	post64_list = miss64_list;

	swap64_list = post64_list->last_0->next_1;

	for (;;) {
	    post64_list->last_0 = swap64_list;
	    if (post64_list == list96) {
		break;
	    } else {
		swap64_list = swap64_list->last_1;
		if (!swap64_list) {
		    list64(list96)->last_0 = NULL;
		    break;
		} else {
		    post64_list = post64_list->last_1;
		}
	    }
	}
    }

    return 0;
}
