/*
 * l4xy.0.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l4xx-defs.h>
#include <l4xx-inter.h>
#include <l4xx-types.h>

#define list64(list64)			((struct list64_type *) (list64))

#define l4list(l4list)			((struct l4list_type *) (l4list))

static int deux_list(struct l4list_type *, unsigned, struct l4list_type *,
		     unsigned);

static int
deux_list(struct l4list_type *l4list_data, unsigned index,
	  struct l4list_type *l4list_text, unsigned class)
{
    struct list64_type exchange_list32, *list64_data;
    void *list64, *list96;

    _libx1f4l2_seek_l4list(l4list_data, index, &list64);
    _libx1f4l2_seek_l4list(l4list_text, class, &list96);

    exchange_list32 = *list64(list64);
    *list64(list64) = *list64(list96);
    *list64(list96) = exchange_list32;

    l4list_data->link_c.list64_data = list96;
    l4list_text->link_c.list64_data = list64;

    list64_data = list64(list64)->last_0;
    if (list64_data) {
	list64_data->next_7 = list64;
    }
    list64_data = list64(list64)->last_1;
    if (list64_data) {
	list64_data->next_1 = list64;
    }
    list64_data = list64(list64)->next_1;
    if (list64_data) {
	list64_data->last_1 = list64;
    }
    list64_data = list64(list64)->next_7;
    if (list64_data) {
	list64_data->last_0 = list64;
    }

    list64_data = list64(list96)->last_0;
    if (list64_data) {
	list64_data->next_7 = list96;
    }
    list64_data = list64(list96)->last_1;
    if (list64_data) {
	list64_data->next_1 = list96;
    }
    list64_data = list64(list96)->next_1;
    if (list64_data) {
	list64_data->last_1 = list96;
    }
    list64_data = list64(list96)->next_7;
    if (list64_data) {
	list64_data->last_0 = list96;
    }

    if (list64 == l4list_data->link_a.list88.head64_data) {
	l4list_data->link_a.list88.head64_data = list96;
    } else {
	if (list64 == l4list_data->link_a.list88.tail64_data) {
	    l4list_data->link_a.list88.tail64_data = list96;
	}
    }

    if (list96 == l4list_text->link_a.list88.head64_data) {
	l4list_text->link_a.list88.head64_data = list64;
    } else {
	if (list96 == l4list_text->link_a.list88.tail64_data) {
	    l4list_text->link_a.list88.tail64_data = list64;
	}
    }

    return 0;
}


int
x1f4_deux_l4list(void *l4data, unsigned index, void *l4text, unsigned class)
{
    int status;

    if (l4data == l4text) {
	status = _libx1f4l2_spin_l4list(l4data, index, class);
    } else {
	if (!(index < l4list(l4data)->link_a.list88.count)) {
	    status = DECK_ERROR;
	} else {
	    if (!(class < l4list(l4text)->link_a.list88.count)) {
		status = DECK_ERROR;
	    } else {
		status = deux_list(l4data, index, l4text, class);
	    }
	}
    }

    return status;
}
