/*
 * lsaf.2.c
 * Copyright (C) 2011-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <lsas-class.h>
#include <lsas-defs.h>
#include <lsas-names.h>
#include <lsas-inter.h>
#include <lsas-types.h>

#define lsnote(lsnote)			((struct lsnote_type *) (lsnote))

int
x1f4_post_lsbill(void *lsnote, const unsigned char *name, unsigned size,
		 unsigned decq, void **post)
{
    int status = 0;

    do {
	unsigned head = 0, hope = 0, rate;
	void *node;

	node = lsnote(lsnote)->link_a.fplist.fpnode;

	rate = lsnote(lsnote)->link_a.fplist.rate;

	if (rate) {
	    unsigned *near, take = 0;
	    void *join;

	    join = NULL;

	    size <<= 3;

	    do {
		const byte *copy;
		int Monday = 0, delete;
		unsigned blue = 0, call, *fare, gray = 0, last, lead = 0, left,
		    lock, news, tier;

		if (*((unsigned *) node + 1)) {
		    take = 0;
		} else {
		    lsnote(lsnote)->link_a.fplist.fvnode[take][0] = join;
		    take++;
		}

		delete = 0;

		lock = hope;

		last = hope;

		near = node;
		near = (void *) ((char *) node + *near);

		copy = name + (head >> 3);

		fare = near;

		left = 0;

		call = *near;
		news = (call & ~POINT_SEEK) ^ POINT_CAST;
		while (news < size) {
		    unsigned down;

		    down = news - lock;
		    if (down) {
			unsigned fine, mind, spin;

			spin = news - head;
			if (spin & ~7) {
			    if (32 < down) {
				do {
				    if (call & POINT_SEEK) {
					near = X2ND(node, near);
					last = news;
				    } else {
					last = news + 1;
					near = (void *)
					    ((char *) node
					     + (near[1]
						>> (class_pick(name, news)
						    << 4) & 65535));
				    }

				    call = *near;
				    news = (call & ~POINT_SEEK) ^ POINT_CAST;
				} while (news < size);

				break;
			    } else {
				fine = news & ~7;
				do {
				    head += 8;
				    lead <<= 8;
				    lead |= *copy++;
				} while (head < fine);

				spin = news & 7;
			    }
			}

			mind = lead << spin;
			mind |= *copy >> (8 - spin);

			fine = near[2];
			if (mind ^ fine) {
			    tier = mind < fine ? 1 : 0;

			    delete = 1;

			    break;
			}

			lock = news;

			if (call & POINT_SEEK) {
			    left = near[1];
			    gray = lock;
			    near = (void *) ((char *) node + L2ND(left));
			    S1ST(left);
			} else {
			    if (*copy >> (7 - spin) & 1) {
				left = near[1];
				gray = lock;
				near = (void *) ((char *) node + L2ND(left));
				S1ST(left);
			    } else {
				blue = lock;
				near = X1ST(node, near);
			    }

			    lock++;
			}
		    } else {
			if (call & POINT_SEEK) {
			    left = near[1];
			    gray = news;
			    near = (void *) ((char *) node + L2ND(left));
			    S1ST(left);
			} else {
			    lock++;

			    if (class_pick(name, news)) {
				left = near[1];
				gray = news;
				near = (void *) ((char *) node + L2ND(left));
				S1ST(left);
			    } else {
				blue = news;
				near = X1ST(node, near);
			    }
			}
		    }

		    last = lock;

		    fare = near;

		    call = *near;
		    news = (call & ~POINT_SEEK) ^ POINT_CAST;
		}

		if (delete) {
		} else {
		    if (call & POINT_CAST) {
			if (lock + 32 < news) {
			    do {
				news = point_rate(call);

				last = news;
				last += seek_bit(call) ^ 1;

				near = X1ST(node, near);

				call = *near;
			    } while (call & POINT_CAST);
			} else {
			    unsigned fine;

			    fine = news - size;
			    if (fine == 32) {
				Monday = 1;
				delete = 1;

				tier = 1;
			    } else {
				unsigned dana, mind;

				while (head < size) {
				    head += 8;
				    lead <<= 8;
				    lead |= *copy++;
				}

				mind = lead << (news - size);

				dana = ~((1u << fine) - 1);

				fine = near[2];

				if ((mind ^ fine) & dana) {
				    tier = mind < fine ? 1 : 0;

				    delete = 1;
				} else {
				    Monday = 1;
				    delete = 1;

				    if (call & POINT_SEEK) {
					if (size == news) {
					    status = 1;

					    near = X1ST(node, near);

					    delete = 1;
					} else {
					    tier = 1;
					}
				    } else {
					tier = 1;
				    }
				}
			    }
			}
		    }
		}

		if (delete) {
		    if (status == EVER_MATCH) {
			break;
		    }
		} else {
		    if (lock ^ last) {
		    } else {
			if (last < size) {
			    unsigned fine, mind;

			    lock += near[1] >> 24;
			    if (size < lock) {
				lock = size;
			    }

			    while (head < lock) {
				head += 8;
				lead <<= 8;
				lead |= *copy++;
			    }

			    mind = lead;
			    if (last + 24 < head) {
				mind >>= head - 24 - last;
			    } else {
				mind <<= last + 24 - head;
			    }

			    mind &= (1 << 24) - 1;

			    fine = near[1] & ((1 << 24) - 1);

			    if ((mind ^ fine)
				& ~((1 << (last + 24 - lock)) - 1)) {
				tier = mind < fine ? 1 : 0;

				delete = 1;
			    } else {
				if (size ^ lock) {
				    if ((call << 3) == lock) {
					Monday = 1;
					delete = 1;

					if (1) {
					    tier = 0;
					}
				    }
				} else {
				    if ((call << 3) == size) {
					status = EVER_MATCH;

					delete = 1;

					break;
				    } else {
					Monday = 1;
					delete = 1;

					if (1) {
					    tier = 1;
					}
				    }
				}
			    }
			} else {
			    if ((call << 3) == size) {
				status = EVER_MATCH;

				delete = 1;

				if (1) {
				    break;
				}
			    } else {
				Monday = 1;
				delete = 1;

				if (1) {
				    tier = 1;
				}
			    }
			}
		    }
		}

		join = node;

		if (delete) {
		} else {
		    unsigned club;

		    copy = ((struct fpcase_type *) near)->data[0];

		    size >>= 3;

		    class_miss(size, name, *near, copy, lock >> 3, club, tier,
			       EVER_MATCH, class_line);

		    size <<= 3;

		    class_fill(*near, near[1], last, copy);

		    near = fare;
		    for (;;) {
			call = *near;
			if (call & POINT_CAST) {
			    unsigned news;

			    news = point_rate(call);
			    if (club < news) {
				break;
			    } else {
				if (call & POINT_SEEK) {
				    left = F1ST(near);
				    gray = news;
				    near = X2ND(node, near);
				} else {
				    if (class_pick(name, news)) {
					left = F1ST(near);
					gray = news;
					near = X2ND(node, near);
				    } else {
					blue = news;
					near = X1ST(node, near);
				    }
				}
			    }
			} else {
			    break;
			}
		    }
		}

		if (tier) {
		    if (left) {
			near = (void *) ((char *) node + left);

			blue = gray;

			call = *near;
			while (call & POINT_CAST) {
			    near = X2ND(node, near);
			    call = *near;
			}

			node = ((struct fpcase_type *) near)->data[1];
		    } else {
			struct fpcase_type *fpcase_data;

			fpcase_data = (void *)
			    ((char *) node
			     + (lead_switch
				* lsnote(lsnote)->link_a.fplist.call));

			blue = 0;

			node = fpcase_data->data[1];
		    }
		} else {
		    if (call & POINT_CAST) {
			do {
			    near = X2ND(node, near);
			    call = *near;
			} while (call & POINT_CAST);
		    } else {
		    }

		    node = ((struct fpcase_type *) near)->data[1];
		}

		if (blue) {
		    hope = blue;
		}

		rate--;

		delete = hope - 32;
		head = delete & ~(delete >> 31);
		head &= ~7;
	    } while (rate);

	    if (status) {
		*post = (char *) ((struct fpcase_type *) near)->data[0]
		    + vert_noir(*near);
		if (1) {
		    break;
		}
	    }

	    size >>= 3;

	    if (*((unsigned *) node + 1)) {
	    } else {
		status = _libx1f4l2_dana_lsbill
		    (lsnote, join, hope, node, (const void *) name, size, decq,
		     post, take);
		if (1) {
		    break;
		}
	    }
	} else {
	    if (node) {
		if (*((unsigned *) node + 1)) {
		} else {
		    status = _libx1f4l2_beta_lsbill
			(lsnote, (const void *) name, size, decq, post);
		    if (1) {
			break;
		    }
		}
	    } else {
		status = _libx1f4l2_root_lsbill
		    (lsnote, name, size, decq, post);
		if (1) {
		    break;
		}
	    }
	}

	{
	    const byte *copy;
	    int Monday = 0, delete;
	    unsigned call, club = 0, date = 0, *fare, last, late = 0, lead = 0,
		line, lock, *near, *star = NULL, tier = 0;
	    void *sect;

	    delete = 0;

	    near = node;
	    near = (void *) ((char *) node + *near);

	    copy = name + (head >> 3);

	    fare = near;

	    lock = hope;

	    last = hope;

	    size <<= 3;

	    call = *near;

	    while (call & POINT_CAST) {
		rate = point_rate(call);
		if (rate < size) {
		    unsigned down;

		    down = rate - lock;
		    if (32 < down) {
		    } else {
			if (down) {
			    unsigned fine, mind;

			    fine = rate & ~7;

			    while (head < fine) {
				head += 8;
				lead <<= 8;
				lead |= *copy++;
			    }

			    fine = rate & 7;
			    if (fine) {
				mind = lead << fine;
				mind |= *copy >> (8 - fine);
			    } else {
				mind = lead;
			    }

			    fine = near[2];

			    if (mind ^ fine) {
				tier = mind < fine ? 1 : 0;

				mind ^= fine;

				club = rate - down;

				mind <<= 32 - down;

				while (!(mind & (unsigned) 15 << 28)) {
				    mind <<= 4;
				    club += 4;
				}
				while (!(mind & (unsigned) 1 << 31)) {
				    mind <<= 1;
				    club++;
				}

				delete = 1;

				break;
			    }

			    lock = rate;
			}

			lock += seek_bit(call) ^ 1;

			fare = near;
		    }

		    star = near;

		    if (call & POINT_SEEK) {
			date = 1;
			late = F2ND(near);

			last = rate + 0;
		    } else {
			date = name[rate >> 3] >> (7 - (rate & 7)) & 1;
			late = near[1] >> (date << 4) & 65535;

			last = rate + 1;
		    }

		    near = (void *) ((char *) node + late);
		} else {
		    if (lock + 32 < rate) {
		    } else {
			unsigned fine;

			fine = rate - size;
			if (fine == 32) {
			    Monday = 1;
			    delete = 1;

			    club = size;

			    tier = 1;

			    break;
			} else {
			    unsigned dana, mind;

			    while (head < size) {
				head += 8;
				lead <<= 8;
				lead |= *copy++;
			    }

			    mind = lead << (rate - size);

			    dana = ~((1u << fine) - 1);

			    fine = near[2];

			    if ((mind ^ fine) & dana) {
				unsigned down;

				down = last + 32 - rate;

				tier = mind < fine ? 1 : 0;

				mind ^= fine;

				mind <<= down;

				club = last;

				while (!(mind & (unsigned) 15 << 28)) {
				    mind <<= 4;
				    club += 4;
				}
				while (!(mind & (unsigned) 1 << 31)) {
				    mind <<= 1;
				    club++;
				}

				delete = 1;

				break;
			    } else {
				Monday = 1;
				delete = 1;

				if (call & POINT_SEEK) {
				    if (size == rate) {
					status = EVER_MATCH;

					delete = 1;

					near = X1ST(node, near);

					if (1) {
					    break;
					}
				    }
				}

				{
				    club = size;

				    tier = 1;
				}

				break;
			    }
			}
		    }

		    last = rate;
		    last += seek_bit(call) ^ 1;

		    near = X1ST(node, near);
		}

		call = *near;
	    }

	    if (delete) {
	    } else {
		if (lock ^ last) {
		} else {
		    if (last < size) {
			unsigned fine, mind;

			lock += near[1] >> 24;
			if (size < lock) {
			    lock = size;
			}

			while (head < lock) {
			    head += 8;
			    lead <<= 8;
			    lead |= *copy++;
			}

			mind = lead;
			if (last + 24 < head) {
			    mind >>= head - 24 - last;
			} else {
			    mind <<= last + 24 - head;
			}

			mind &= (1 << 24) - 1;

			fine = near[1] & ((1 << 24) - 1);

			if ((mind ^ fine) & ~((1 << (last + 24 - lock)) - 1)) {
			    tier = mind < fine ? 1 : 0;

			    mind ^= fine;

			    club = last;

			    while (!(mind & (unsigned) 15 << 20)) {
				mind <<= 4;
				club += 4;
			    }
			    while (!(mind & (unsigned) 1 << 23)) {
				mind <<= 1;
				club++;
			    }

			    delete = 1;
			} else {
			    if (size ^ lock) {
				if ((call << 3) == lock) {
				    Monday = 1;
				    delete = 1;

				    if (1) {
					club = lock;

					tier = 0;
				    }
				}
			    } else {
				if ((call << 3) == size) {
				    status = EVER_MATCH;

				    delete = 1;
				} else {
				    Monday = 1;
				    delete = 1;

				    if (1) {
					club = size;

					tier = 1;
				    }
				}
			    }
			}
		    } else {
			if ((call << 3) == size) {
			    status = EVER_MATCH;

			    delete = 1;
			} else {
			    Monday = 1;
			    delete = 1;

			    if (1) {
				club = last;

				tier = 1;
			    }
			}
		    }
		}
	    }

	    size >>= 3;

	    if (delete) {
		if (status) {
		    *post = (char *) ((struct fpcase_type *) near)->data[0]
			+ vert_noir(*near);
		    if (1) {
			break;
		    }
		}
	    } else {
		class_miss(size, name, *near,
			   ((struct fpfast_type *) near)->data[0], lock >> 3,
			   club, tier, EVER_MATCH, class_fast);
	    }

	    line = vert_noir(size);

	    status = lsnote(lsnote)->link_m.link
		(lsnote(lsnote)->link_m.data, &sect, line + decq);
	    if (status) {
		status = LINK_ERROR;
	    } else {
		byte *text;
		struct fpfast_type *fpfast_data;
		unsigned *dana, deck, *fail, pick = 0, seek, side, slip, wide;

		if (delete) {
		} else {
		    class_fill(*near, near[1], last,
			       ((struct fpfast_type *) near)->data[0]);
		}

		near = node;

		near++;

		wide = *near;
		dana = (void *) ((char *) node + wide);

		seek = *dana;

		fpfast_data = (void *) ((char *) node + seek);

		fail = (void *) fpfast_data;

		*near = *fail;

		*post = (char *) sect + line;

		fpfast_data->data[0] = sect;

		text = sect;

		memcpy(text, name, size);

		text[size] = 0;

		*fail = size;

		if (Monday) {
		    side = club;
		} else {
		    side = club + 1;
		}

		class_nine(name, size, side, fail);

		slip = frame_rate(club);

		class_find(name, club, dana);

		if (Monday) {
		    slip |= POINT_SEEK;
		}

		dana[0] = slip;

		if (delete) {
		    if (star) {
			fail = star;
			pick = date;
			deck = late;
		    } else {
			fail = node;

			deck = *fail;
		    }
		} else {
		    fail = node;

		    deck = *fail;

		    near = fare;
		    for (;;) {
			call = *near;

			if (call & POINT_CAST) {
			    rate = point_rate(call);
			    if (club < rate) {
				break;
			    } else {
				if (club == rate) {
				    if (slip & POINT_SEEK) {
					break;
				    }
				}

				fail = near;
				if (call & POINT_SEEK) {
				    pick = 1;
				    last = rate;
				    deck = F2ND(near);
				} else {
				    last = rate + 1;
				    pick = class_pick(name, rate);
				    deck = near[1] >> (pick << 4) & 65535;
				}

				near = (void *) ((char *) node + deck);
			    }
			} else {
			    break;
			}
		    }
		}

		if (tier) {
		    dana[1] = deck << 16 | seek;
		} else {
		    dana[1] = deck | seek << 16;
		}

		if (fail == node) {
		    fail[0] = wide;
		} else {
		    fail++;
		    if (pick) {
			fail[0] = (*fail & 65535) | wide << 16;
		    } else {
			fail[0] = (*fail & ~65535) | wide;
		    }
		}

		class_rail(node, deck, side - last);
	    }
	}
    } while (0);

    return status;
}
