/*
 * lsaf.n.c
 * Copyright (C) 2011-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lsas-class.h>
#include <lsas-defs.h>
#include <lsas-names.h>
#include <lsas-types.h>

#define beta_type			quarter_type

int
_libx1f4l2_even_lsbill(struct beta_type *beta_data, void *node,
		       const byte *name, unsigned size, void **post)
{
    int status = 0;

    do {
	byte *copy;
	int Monday = 0;
	unsigned call, club, *near, rate, slip, tier;
	void *sect;

	near = node;
	near = (void *) ((char *) node + *near);

	size <<= 3;

	beta_data->name = name;

	call = *near;
	while (call & POINT_CAST) {
	    rate = point_rate(call);
	    if (rate < size) {
		if (call & POINT_SEEK) {
		    near = (void *) ((char *) node + F2ND(near));
		} else {
		    near = (void *)
			((char *) node
			 + (near[1] >> (class_pick(name, rate) << 4) & 65535));
		}
	    } else {
		near = (void *) ((char *) node + F1ST(near));
	    }

	    call = *near;
	}

	slip = *near;

	size >>= 3;

	sect = ((struct fpfast_type *) near)->data[0];

	copy = sect;

	club = size < slip ? size : slip;
	if (SIZEOF_LONG & (SIZEOF_LONG - 1)) {
	} else {
	    if (((integral_q) copy | (integral_q) name)
		& (SIZEOF_LONG - 1)) {
	    } else {
		call >>= 8;
		if (club < call) {
		    call = club;
		}
		scale(call);
		if (call) {
		    for (; call; call--) {
			if (*(long *) copy ^ *(const long *) name) {
			    break;
			}

			copy = (void *) ((long *) copy + 1);
			name = (const void *) ((const long *) name + 1);
		    }

		    club -= copy - (byte *) sect;
		}
	    }
	}
	for (; club; club--) {
	    rate = *copy ^ *name;
	    if (rate) {
		if (1) {
		    break;
		}
	    }

	    copy++;
	    name++;
	}

	if (club) {
	    if (size < slip) {
		club = size - club;
	    } else {
		club = slip - club;
	    }

	    club <<= 3;
	    if (rate & 240) {
	    } else {
		club += 4;
		rate <<= 4;
	    }
	    if (rate & 192) {
	    } else {
		club += 2;
		rate <<= 2;
	    }
	    if (rate & 128) {
	    } else {
		club++;
	    }

	    tier = *copy << (club & 7) >> 7 & 1;
	} else {
	    if (size ^ slip) {
		Monday = 1;
		if (size < slip) {
		    club = size << 3;
		    tier = 1;
		} else {
		    club = slip << 3;
		    tier = 0;
		}
	    } else {
		*post = (char *) sect + vert_noir(*near);

		status = EVER_MATCH;

		if (1) {
		    break;
		}
	    }
	}

	slip = frame_rate(club);

	if (Monday) {
	    slip |= POINT_SEEK;
	}

	beta_data->pick = slip;
	beta_data->side = Monday ? club : club + 1;
	beta_data->tier = tier;
    } while (0);

    return status;
}
