/*
 * lsas-inter.h
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lsas_inter_H__
#define __LIBx1f4_lsas_inter_H__

#include <lsas-names.h>
#include <lsas-types.h>

#if !defined _libx1f4l2_fast_lsnote
# define _libx1f4l2_fast_lsnote		x1f4_fast_lsnote
#endif				/* !_libx1f4l2_fast_lsnote */
#if !defined _libx1f4l2_flat_lsnote
# define _libx1f4l2_flat_lsnote		x1f4_flat_lsnote
#endif				/* !_libx1f4l2_flat_lsnote */

extern int _libx1f4l2_bend_lsnote(void *, void *, unsigned, int);
extern int _libx1f4l2_beta_lsbill
    (void *, const byte *, unsigned, unsigned, void **);
extern int _libx1f4l2_blue_lsbill(void *, void *, const byte *, unsigned);
extern int _libx1f4l2_ceil_lsnote(void *);
extern int _libx1f4l2_dana_lsbill
    (void *, void *, unsigned, void *, const byte *, unsigned, unsigned,
     void **, unsigned);
extern int _libx1f4l2_else_lsbill
    (struct quarter_type *, unsigned, void *, const byte *, unsigned,
     unsigned *, void **);
extern int _libx1f4l2_even_lsbill
    (struct quarter_type *, void *, const byte *, unsigned, void **);
extern int _libx1f4l2_fall_lsnote(void *, void **, void **);
extern int _libx1f4l2_fast_lsnote(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_flat_lsnote(void *);
extern int _libx1f4l2_gray_lsbill
    (void *, void *, void *, void *, const byte *, unsigned, unsigned);
extern int _libx1f4l2_join_lsbill
    (void *, void *, void *, const byte *, unsigned, unsigned);
extern int _libx1f4l2_long_lsbill
    (void *, void *, void *, const byte *, unsigned, unsigned);
extern int _libx1f4l2_moon_lsnote(void *, void *, unsigned, void *);
extern int _libx1f4l2_root_lsbill
    (void *, const byte *, unsigned, unsigned, void **);

#endif				/* __LIBx1f4_lsas_inter_H__ */
