/*
 * lsas.h.c
 * Copyright (C) 2011-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lsas-defs.h>
#include <lsas-names.h>
#include <lsas-types.h>

#define lsnote(lsnote)			((struct lsnote_type *) (lsnote))

int
_libx1f4l2_fall_lsnote(void *lsnote, void **root, void **side)
{
    int status;
    unsigned rate;
    void *fvnode;

    fvnode = lsnote(lsnote)->link_a.fplist.fvnode;

    rate = lsnote(lsnote)->link_a.fplist.rate;

    if (fvnode) {
	status = lsnote(lsnote)->link_m.mode
	    (lsnote(lsnote)->link_m.data, &fvnode,
	     sizeof(void *[1]) * (1 + rate));
	if (status) {
	    status = MODE_ERROR;
	}
    } else {
	status = lsnote(lsnote)->link_m.link
	    (lsnote(lsnote)->link_m.data, &fvnode, sizeof(void *));
	if (status) {
	    status = LINK_ERROR;
	}
    }
    if (status) {
    } else {
	unsigned beta;

	lsnote(lsnote)->link_a.fplist.fvnode = fvnode;

	beta = lsnote(lsnote)->link_a.fplist.call;

	status = lsnote(lsnote)->link_m.link
	    (lsnote(lsnote)->link_m.data, root, call_sizeof * beta);
	if (status) {
	    status = LINK_ERROR;
	} else {
	    unsigned rate;

	    rate = lsnote(lsnote)->link_a.fplist.rate;

	    if (rate) {
		status = lsnote(lsnote)->link_m.link
		    (lsnote(lsnote)->link_m.data, side, call_sizeof * beta);
	    } else {
		status = lsnote(lsnote)->link_m.link
		    (lsnote(lsnote)->link_m.data, side,
		     dana_sizeof * lsnote(lsnote)->link_a.fplist.dana);
	    }
	    if (status) {
		status = LINK_ERROR;
		lsnote(lsnote)->link_m.free
		    (lsnote(lsnote)->link_m.data, *root);
	    } else {
		unsigned deck, i, near, *slip;
		void *node;

		node = *root;

		slip = node;

		node = slip + (lead_shrews * beta);

		near = lead_switch;

		deck = lead_switch * beta;

		slip[0] = deck + sizeof(struct fpcase_type);
		slip[1] = lead_switch << 1;

		if (1) {
		    near += lead_switch;
		    deck += sizeof(struct fpcase_type);
		    slip += lead_shrews;
		    node = (char *) node + sizeof(struct fpcase_type);
		}

		i = beta;
		if (1) {
		    unsigned *call;

		    call = node;
		    *call = near;

		    i -= 2;
		}

		for (--i; i; i--) {
		    unsigned *call;

		    near += lead_switch;
		    deck += sizeof(struct fpcase_type);
		    slip += lead_shrews;
		    *slip = deck;
		    node = (char *) node + sizeof(struct fpcase_type);
		    call = node;
		    *call = near;
		}

		{
		    unsigned *call;

		    deck += sizeof(struct fpcase_type);
		    slip += lead_shrews;
		    *slip = deck;
		    node = (char *) node + sizeof(struct fpcase_type);
		    call = node;
		    *call = 0;
		}
	    }
	}
    }

    return status;
}
