/*
 * ncxv.h.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <ncxx-config.h>

#include <stddef.h>

#include <ncxx-inter.h>
#include <ncxx-names.h>
#include <ncxx-types.h>

#define __SLICE_UPLINK__		1
#define __TRACE_UPLINK__		2

#define ________UPLINK__		0

#if ____CLASS_DELETE__ == __SLICE_DELETE__
# define __CLASS_UPLINK__		__SLICE_UPLINK__
#elif __CLASS_DELETE__ == __TRACE_DELETE__
# define __CLASS_UPLINK__		__TRACE_UPLINK__
#else
# define __CLASS_UPLINK__		________UPLINK__
#endif				/* ____CLASS_DELETE__ == __SLICE_DELETE__ */

#define ____CLASS_UPLINK__		__CLASS_UPLINK__

#if ____CLASS_DELETE__ == __SLICE_DELETE__
# undef __CLASS_DELETE__
# define __CLASS_DELETE__		__TRACE_DELETE__
#endif				/* ____CLASS_DELETE__ == __SLICE_DELETE__ */

/*
 * __SCOPE_UPLINK__ method is buggy, for if processing stops the tree is left
 * messed up
 */
#define __SCOPE_UPLINK__		1
#define __SHORT_UPLINK__		2

#define __________LINK__		0

#if ____CLASS_DELETE__ == __TRACE_DELETE__
# define __BREAK_UPLINK__		__SHORT_UPLINK__
#else
# define __BREAK_UPLINK__		__________LINK__
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

#define ____BREAK_UPLINK__		__BREAK_UPLINK__

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
# define shift_break(fsnode_data, fxnode_data, fznode_data) \
    {									      \
	(fznode_data) = (fxnode_data)->fpnode_data[0];			      \
	(fxnode_data)->fpnode_data[0] = (fsnode_data);			      \
    }
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */

#define nclist(nclist)			((struct nclist_type *) (nclist))

int
_libx1f4l2_long_nclist(void *nclist, void *back, int (*call) (void *, void *))
{
    int delete;
#if ____CLASS_DELETE__ == __STACK_DELETE__
    int status = 0;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
    struct fpnode_type *ffnode_data;
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */
#if ____CLASS_DELETE__ == __TRACE_DELETE__
    struct fpnode_type *fhnode_data;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
#if ____CLASS_DELETE__ == __STACK_DELETE__
    struct fpnode_type **fpmiss;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
    struct fpnode_type fpnode, *fpnode_data;
#if ____CLASS_DELETE__ == __STACK_DELETE__
    unsigned miss = 1, seek;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
    seek = nclist(nclist)->link_e.seek;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
    fpmiss = nclist(nclist)->link_e.fpmiss;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
    fpmiss[0] = &nclist(nclist)->link_a.fplist.fplink;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __TRACE_DELETE__
    fhnode_data = &nclist(nclist)->link_a.fplist.fplink;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
    ffnode_data = fhnode_data;
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */

    fpnode_data = nclist(nclist)->link_a.fplist.fplink.fpnode_data[0];

    while (1) {
	struct fpnode_type *fqnode_data;

	fqnode_data = fpnode_data->fpnode_data[0];
	if (fqnode_data) {
	} else {
	    break;
	}

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
	if (fpnode_data->fqnode.tilt) {
	} else {
	    ffnode_data = fhnode_data;
	}
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
	if (fpnode_data->fqnode.tilt) {
	} else {
	    miss--;

	    fpmiss[0] = fpmiss[miss];

	    miss = 1;
	}
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
	if (miss == seek) {
	    status = _libx1f4l2_blue_nclist(nclist, &fpmiss, &seek);
	    if (status) {
		/*
		 * TODO
		 *
		 * list is in an inconsistent state - only operation that
		 * should work fine is destroying it.
		 */
		break;
	    }
	}
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
	fpmiss[miss] = fpnode_data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
	miss++;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

	fpnode_data->fqnode.size--;

#if ____CLASS_DELETE__ == __STACK_DELETE__
	fpnode_data = fqnode_data;
#elif __BREAK_UPLINK__ == __SHORT_UPLINK__
	fhnode_data = fpnode_data;
	fpnode_data = fqnode_data;
#elif __CLASS_DELETE__ == __TRACE_DELETE__
	if (1) {
	    fpnode_data->fpnode_data[0] = fhnode_data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
#elif __CLASS_UPLINK__ == __SLICE_UPLINK__
	    SET_T(fpnode_data, slip);
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */
#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
#elif __CLASS_DELETE__ == __TRACE_DELETE__
	    fhnode_data = fpnode_data;

	    fpnode_data = fqnode_data;
	}
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */
    }

#if ____CLASS_DELETE__ == __STACK_DELETE__
    if (status) {
	delete = status;
#elif 0
    }
#elif __CLASS_DELETE__ == __TRACE_DELETE__
    if (0) {
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
    } else {
	fpnode = *fpnode_data;

	delete = call(back, fpnode_data);
    }

#if ____CLASS_DELETE__ == __STACK_DELETE__
    if (status) {
#elif 0
    }
#elif __CLASS_DELETE__ == __TRACE_DELETE__
    if (0) {
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
    } else if (delete) {
	struct fpnode_type *fvnode_data;

	fvnode_data = nclist(nclist)->link_a.fplist.fplink.fpnode_data[0];

#if ____CLASS_DELETE__ == __STACK_DELETE__
	status = delete;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

	while (fvnode_data != fpnode_data) {
	    fvnode_data->fqnode.size++;
	    fvnode_data = fvnode_data->fpnode_data[0];
	}
    } else {
#if ____CLASS_DELETE__ == __TRACE_DELETE__
	struct fpnode_type *fvnode_data;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
	if (ffnode_data == &nclist(nclist)->link_a.fplist.fplink) {
	    fvnode_data = nclist(nclist)->link_a.fplist.fplink.fpnode_data[0];
	} else {
	    fvnode_data = ffnode_data->fpnode_data[0];
	}
	fhnode_data = ffnode_data;
	if (fvnode_data == fpnode_data) {
	} else {
	    while (1) {
		struct fpnode_type *fqnode_data;

		shift_break(fhnode_data, fvnode_data, fqnode_data);
		if (fqnode_data == fpnode_data) {
		    if (1) {
			fhnode_data = fvnode_data;
		    }

		    break;
		} else {
		    shift_break(fvnode_data, fqnode_data, fhnode_data);
		    if (fhnode_data == fpnode_data) {
			if (1) {
			    fhnode_data = fqnode_data;
			}

			break;
		    } else {
			shift_break(fqnode_data, fhnode_data, fvnode_data);
			if (fvnode_data == fpnode_data) {
			    if (0) {
				fhnode_data = fhnode_data;
			    }

			    break;
			}
		    }
		}
	    }
	}
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */

	fpnode_data = &fpnode;

	do {
#if ____CLASS_DELETE__ == __TRACE_DELETE__
	    unsigned slip = 0;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

	    if (1) {
#if ____CLASS_DELETE__ == __STACK_DELETE__
		fpmiss[miss - 1]->fpnode_data[0] = fpnode_data->fpnode_data[1];
#elif __CLASS_DELETE__ == __TRACE_DELETE__
		fvnode_data = fpnode_data->fpnode_data[1];
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
	    }

	    while (1) {
		struct fpnode_type *fqnode_data;

#if ____CLASS_DELETE__ == __STACK_DELETE__
		miss--;
		if (miss) {
		} else {
		    break;
		}
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		fqnode_data = fpmiss[miss];
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
		if (fhnode_data == ffnode_data) {
		    fhnode_data->fpnode_data[0] = fvnode_data;
#elif 0
		}
#elif __CLASS_DELETE__ == __TRACE_DELETE__
		if (fhnode_data == &nclist(nclist)->link_a.fplist.fplink) {
		    fhnode_data->fpnode_data[0] = fvnode_data;
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */
#if ____CLASS_DELETE__ == __TRACE_DELETE__

		    break;
		} else {
		    fqnode_data = fhnode_data;
		    fhnode_data = fqnode_data->fpnode_data[0];
		    fqnode_data->fpnode_data[0] = fvnode_data;
		    fvnode_data = fqnode_data;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
#if ____CLASS_DELETE__ == __TRACE_DELETE__

		    if (slip) {
			continue;
		    }
		}
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		if (1) {
#elif 0
		}
#elif __CLASS_DELETE__ == __TRACE_DELETE__
		if (1) {
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
		    int tilt;

		    tilt = fqnode_data->fqnode.tilt;

		    tilt++;

		    fqnode_data->fqnode.tilt = tilt;

		    if (tilt == 1) {
#if ____CLASS_DELETE__ == __TRACE_DELETE__
			slip |= 4096;
#elif __CLASS_DELETE__ == __STACK_DELETE__
			break;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
		    } else {
			if (tilt == 2) {
			    struct fpnode_type *fxnode_data;

			    fxnode_data = fqnode_data->fpnode_data[1];
			    if (fxnode_data->fqnode.tilt == -1) {
				int slip;
				struct fpnode_type *fwnode_data;

				fwnode_data = fxnode_data->fpnode_data[0];
				fxnode_data->fpnode_data[0] =
				    fwnode_data->fpnode_data[1];
				fwnode_data->fpnode_data[1] = fxnode_data;
				fqnode_data->fpnode_data[1] =
				    fwnode_data->fpnode_data[0];
				fwnode_data->fpnode_data[0] = fqnode_data;
				slip = fwnode_data->fqnode.tilt;
				fwnode_data->fqnode.tilt = 0;
				if (slip == 1) {
				    fxnode_data->fqnode.tilt = 0;
				    fqnode_data->fqnode.tilt = -1;
				} else {
				    if (!slip) {
					fxnode_data->fqnode.tilt = 0;
					fqnode_data->fqnode.tilt = 0;
				    } else {
					fxnode_data->fqnode.tilt = 1;
					fqnode_data->fqnode.tilt = 0;
				    }
				}
#if ____CLASS_DELETE__ == __STACK_DELETE__
				fpmiss[miss - 1]->fpnode_data[0] = fwnode_data;
#elif __CLASS_DELETE__ == __TRACE_DELETE__
				fvnode_data = fwnode_data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
				if (1) {
				    fxnode_data->fqnode.size -=
					fwnode_data->fqnode.size + 1;
				    fwnode_data->fqnode.size +=
					fqnode_data->fqnode.size + 1;
				}
			    } else {
				fqnode_data->fpnode_data[1] =
				    fxnode_data->fpnode_data[0];
				fxnode_data->fpnode_data[0] = fqnode_data;
#if ____CLASS_DELETE__ == __STACK_DELETE__
				fpmiss[miss - 1]->fpnode_data[0] = fxnode_data;
#elif __CLASS_DELETE__ == __TRACE_DELETE__
				fvnode_data = fxnode_data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
				if (1) {
				    fxnode_data->fqnode.size +=
					fqnode_data->fqnode.size + 1;
				}
				if (fxnode_data->fqnode.tilt) {
				    fqnode_data->fqnode.tilt = 0;
				    fxnode_data->fqnode.tilt = 0;
				} else {
				    fqnode_data->fqnode.tilt = 1;
				    fxnode_data->fqnode.tilt = -1;
#if ____CLASS_DELETE__ == __TRACE_DELETE__
				    slip |= 4096;
#elif __CLASS_DELETE__ == __STACK_DELETE__
				    break;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
				}
			    }
			}
		    }
		}
	    }
	} while (0);
    }

#if ____CLASS_DELETE__ == __TRACE_DELETE__
    return delete;
#elif __CLASS_DELETE__ == __STACK_DELETE__
    return status;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
}
