/*
 * ncxx.h.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <ncxx-config.h>

#include <stddef.h>

#include <ncxx-inter.h>
#include <ncxx-names.h>
#include <ncxx-types.h>

#if ____CLASS_INSERT__ == __SLICE_INSERT__
# define SET_T(fpnode_data, tilt) \
    (fpnode_data)->fqnode.fbnode.bits = (tilt)
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

#if ____CLASS_INSERT__ == __SLICE_INSERT__
# define GET_T(fpnode_data) \
    (fpnode_data)->fqnode.fbnode.bits
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

#define nclist(nclist)			((struct nclist_type *) (nclist))

int
_libx1f4l2_moon_nclist(void *nclist, unsigned index, void *ncnode)
{
#if ____CLASS_INSERT__ == __STACK_INSERT__
    int status = 0;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */
    struct fpnode_type *fpnode_data, *fqnode_data, *fxnode_data, *fznode_data;
#if ____CLASS_INSERT__ == __TWICE_INSERT__
    unsigned becca, nassa;
#endif				/* ____CLASS_INSERT__ == __TWICE_INSERT__ */
#if ____CLASS_INSERT__ == __STACK_INSERT__
    unsigned miss = 0, size;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */
    unsigned tilt = 0;
#if ____CLASS_INSERT__ == __STACK_INSERT__
    unsigned char *data;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

    fxnode_data = nclist(nclist)->link_a.fplist.fplink.fpnode_data[0];
    fznode_data = &nclist(nclist)->link_a.fplist.fplink;

#if ____CLASS_INSERT__ == __STACK_INSERT__
    data = nclist(nclist)->link_c.data;
    size = nclist(nclist)->link_c.size;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

    fpnode_data = fxnode_data;
    fqnode_data = fznode_data;

#if ____CLASS_INSERT__ == __TWICE_INSERT__
    becca = index;
    nassa = index;
#endif				/* ____CLASS_INSERT__ == __TWICE_INSERT__ */

    while (fpnode_data) {
	unsigned class;

	class = fpnode_data->fqnode.size;
	if (0) {
	} else {
	    if (0) {
	    } else {
		if (class < index) {
		    class++;
		    index -= class;
		    tilt = 1;
		} else {
		    tilt = 0;
		    fpnode_data->fqnode.size = class + 1;
		}
	    }
	}

	if (fpnode_data->fqnode.tilt) {
	    fxnode_data = fpnode_data;
	    fznode_data = fqnode_data;
#if ____CLASS_INSERT__ == __STACK_INSERT__
	    miss = 0;
#elif __CLASS_INSERT__ == __TWICE_INSERT__
	    becca = nassa;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */
	}

#if ____CLASS_INSERT__ == __STACK_INSERT__
	if (miss == size) {
	    status = _libx1f4l2_half_nclist(nclist, &data, &size);
	    if (status) {
		/*
		 * TODO
		 *
		 * list is in an inconsistent state - only operation that
		 * should work fine is destroying it.
		 */
		break;
	    }
	}
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

#if ____CLASS_INSERT__ == __STACK_INSERT__
	data[miss] = tilt;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

#if ____CLASS_INSERT__ == __STACK_INSERT__
	miss++;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

#if ____CLASS_INSERT__ == __TWICE_INSERT__
	nassa = index;
#endif				/* ____CLASS_INSERT__ == __TWICE_INSERT__ */

#if ____CLASS_INSERT__ == __SLICE_INSERT__
	SET_T(fpnode_data, tilt);
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

	fqnode_data = fpnode_data;
	fpnode_data = fpnode_data->fpnode_data[tilt];
    }

#if ____CLASS_INSERT__ == __STACK_INSERT__
    if (status) {
#elif 0
    }
#elif __CLASS_INSERT__ == __SLICE_INSERT__
    if (0) {
#elif 0
    }
#elif __CLASS_INSERT__ == __TWICE_INSERT__
    if (0) {
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */
    } else {
	struct fpnode_type *fnnode_data;

	fnnode_data = ncnode;

	fnnode_data->fpnode_data[0] = NULL;
	fnnode_data->fpnode_data[1] = NULL;

	fnnode_data->fqnode.size = 0;
	fnnode_data->fqnode.tilt = 0;

	fqnode_data->fpnode_data[tilt] = fnnode_data;

	if (fxnode_data) {
	    fpnode_data = fxnode_data;

#if ____CLASS_INSERT__ == __STACK_INSERT__
	    miss = 0;
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

#if ____CLASS_INSERT__ == __STACK_INSERT__
	    do {
		unsigned post;

		post = data[miss];

		miss++;

		if (post) {
		    fpnode_data->fqnode.tilt++;
		} else {
		    fpnode_data->fqnode.tilt--;
		}

		fpnode_data = fpnode_data->fpnode_data[post];
	    } while (fpnode_data != fnnode_data);
#elif __CLASS_INSERT__ == __SLICE_INSERT__
	    do {
		unsigned post;

		post = GET_T(fpnode_data);

		if (post) {
		    fpnode_data->fqnode.tilt++;
		} else {
		    fpnode_data->fqnode.tilt--;
		}

		fpnode_data = fpnode_data->fpnode_data[post];
	    } while (fpnode_data != fnnode_data);
#elif __CLASS_INSERT__ == __TWICE_INSERT__
	    do {
		unsigned class;

		class = fpnode_data->fqnode.size;
		if (becca < class) {
		    fpnode_data->fqnode.tilt--;
		    fpnode_data = fpnode_data->fpnode_data[0];
		} else {
		    class++;
		    becca -= class;
		    fpnode_data->fqnode.tilt++;
		    fpnode_data = fpnode_data->fpnode_data[1];
		}
	    } while (fpnode_data != fnnode_data);
#endif				/* ____CLASS_INSERT__ == __STACK_INSERT__ */

	    if (fxnode_data->fqnode.tilt == -2) {
		if (1) {
		    struct fpnode_type *fvnode_data, *fwnode_data;

		    fvnode_data = fxnode_data->fpnode_data[0];
		    if (fvnode_data->fqnode.tilt == -1) {
			fwnode_data = fvnode_data;
			fxnode_data->fpnode_data[0] =
			    fvnode_data->fpnode_data[1];
			fvnode_data->fpnode_data[1] = fxnode_data;
			fvnode_data->fqnode.tilt = 0;
			fxnode_data->fqnode.tilt = 0;
			if (1) {
			    fxnode_data->fqnode.size -=
				fvnode_data->fqnode.size + 1;
			}
		    } else {
			int slip;

			fwnode_data = fvnode_data->fpnode_data[1];
			fvnode_data->fpnode_data[1] =
			    fwnode_data->fpnode_data[0];
			fwnode_data->fpnode_data[0] = fvnode_data;
			fxnode_data->fpnode_data[0] =
			    fwnode_data->fpnode_data[1];
			fwnode_data->fpnode_data[1] = fxnode_data;
			slip = fwnode_data->fqnode.tilt;
			fwnode_data->fqnode.tilt = 0;
			if (slip == -1) {
			    fvnode_data->fqnode.tilt = 0;
			    fxnode_data->fqnode.tilt = 1;
			} else {
			    if (!slip) {
				fvnode_data->fqnode.tilt = 0;
				fxnode_data->fqnode.tilt = 0;
			    } else {
				fvnode_data->fqnode.tilt = -1;
				fxnode_data->fqnode.tilt = 0;
			    }
			}
			{
			    fwnode_data->fqnode.size +=
				fvnode_data->fqnode.size + 1;
			    fxnode_data->fqnode.size -=
				fwnode_data->fqnode.size + 1;
			}
		    }
		    if (fxnode_data == fznode_data->fpnode_data[0]) {
			fznode_data->fpnode_data[0] = fwnode_data;
		    } else {
			fznode_data->fpnode_data[1] = fwnode_data;
		    }
		}
	    } else {
		if (fxnode_data->fqnode.tilt == 2) {
		    struct fpnode_type *fvnode_data, *fwnode_data;

		    fvnode_data = fxnode_data->fpnode_data[1];
		    if (fvnode_data->fqnode.tilt == 1) {
			fwnode_data = fvnode_data;
			fxnode_data->fpnode_data[1] =
			    fvnode_data->fpnode_data[0];
			fvnode_data->fpnode_data[0] = fxnode_data;
			fvnode_data->fqnode.tilt = 0;
			fxnode_data->fqnode.tilt = 0;
			if (1) {
			    fvnode_data->fqnode.size +=
				fxnode_data->fqnode.size + 1;
			}
		    } else {
			int slip;

			fwnode_data = fvnode_data->fpnode_data[0];
			fvnode_data->fpnode_data[0] =
			    fwnode_data->fpnode_data[1];
			fwnode_data->fpnode_data[1] = fvnode_data;
			fxnode_data->fpnode_data[1] =
			    fwnode_data->fpnode_data[0];
			fwnode_data->fpnode_data[0] = fxnode_data;
			slip = fwnode_data->fqnode.tilt;
			fwnode_data->fqnode.tilt = 0;
			if (slip == 1) {
			    fvnode_data->fqnode.tilt = 0;
			    fxnode_data->fqnode.tilt = -1;
			} else {
			    if (!slip) {
				fvnode_data->fqnode.tilt = 0;
				fxnode_data->fqnode.tilt = 0;
			    } else {
				fvnode_data->fqnode.tilt = 1;
				fxnode_data->fqnode.tilt = 0;
			    }
			}
			{
			    fvnode_data->fqnode.size -=
				fwnode_data->fqnode.size + 1;
			    fwnode_data->fqnode.size +=
				fxnode_data->fqnode.size + 1;
			}
		    }
		    if (fxnode_data == fznode_data->fpnode_data[0]) {
			fznode_data->fpnode_data[0] = fwnode_data;
		    } else {
			fznode_data->fpnode_data[1] = fwnode_data;
		    }
		} else {
		}
	    }
	}
    }

#if ____CLASS_INSERT__ == __TWICE_INSERT__
    return 0;
#elif __CLASS_INSERT__ == __SLICE_INSERT__
    return 0;
#elif __CLASS_INSERT__ == __STACK_INSERT__
    return status;
#endif				/* ____CLASS_INSERT__ == __TWICE_INSERT__ */
}
