/*
 * ncxy.8.c
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <stdlib.h>

#include <ncxx-inter.h>
#include <ncxx-names.h>
#include <ncxx-types.h>

#define nclist(nclist)			((struct nclist_type *) (nclist))

static int rand_list(struct nclist_type *, struct fpnode_type *);

static int
rand_list(struct nclist_type *nclist_data, struct fpnode_type *fpnode_data)
{
    struct fpnode_type *fqnode_data;
    unsigned size;

    fqnode_data = fpnode_data->fpnode_data[0];

    if (fqnode_data) {
	rand_list(nclist_data, fqnode_data);
    }

    fqnode_data = fpnode_data->fpnode_data[1];

    size = nclist_data->link_a.fplist.fplink.fqnode.size;

    size++;

    _libx1f4l2_moon_nclist(nclist_data, rand() % size, fpnode_data);

    nclist_data->link_a.fplist.fplink.fqnode.size = size;

    if (fqnode_data) {
	rand_list(nclist_data, fqnode_data);
    }

    return 0;
}


int
x1f4_rand_nclist(void *nclist)
{
    unsigned size;

    size = nclist(nclist)->link_a.fplist.fplink.fqnode.size;
    if (1 < size) {
	void *tvnode;

	tvnode = nclist(nclist)->link_a.fplist.fplink.fpnode_data[0];

	nclist(nclist)->link_a.fplist.fplink.fpnode_data[0] = NULL;
	nclist(nclist)->link_a.fplist.fplink.fqnode.size = 0;

	rand_list(nclist, tvnode);
    }

    return 0;
}
