/*
 * nvxv.i.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <nvxx-names.h>
#include <nvxx-types.h>

#define nvlist(nvlist)			((struct nvlist_type *) (nvlist))

int
_libx1f4l2_away_nvlist(void *nvlist, void *back, int (*call) (void *, void *))
{
    int delete;
    struct fpnode_type fpnode, *fpnode_data;

    fpnode_data = nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[0];

    while (1) {
	struct fpnode_type *fqnode_data;

	fqnode_data = fpnode_data->fpnode_data[1];
	if (!fqnode_data) {
	    break;
	}

	fpnode_data = fqnode_data;
    }

    fpnode = *fpnode_data;

    delete = call(back, fpnode_data);
    if (delete) {
    } else {
	struct fpnode_type *fhnode_data;

	fpnode_data = &fpnode;

	nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[1] =
	    nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[0];

	fhnode_data = fpnode_data->uplink_data;
	if (fhnode_data) {
	} else {
	    fhnode_data = &nvlist(nvlist)->link_a.fplist.fplink;
	}

	do {
	    struct fpnode_type *fqnode_data;

	    if (1) {
		struct fpnode_type *fsnode_data;

		fsnode_data = fpnode_data->fpnode_data[0];
		fhnode_data->fpnode_data[1] = fsnode_data;
		if (fsnode_data) {
		    fsnode_data->uplink_data = fpnode_data->uplink_data;
		}
	    }

	    while (1) {
		if (fhnode_data == &nvlist(nvlist)->link_a.fplist.fplink) {
		    break;
		}

		fqnode_data = fhnode_data;
		fhnode_data = fqnode_data->uplink_data;
		if (fhnode_data) {
		} else {
		    fhnode_data = &nvlist(nvlist)->link_a.fplist.fplink;
		}

		if (1) {
		    int silt;

		    silt = fqnode_data->fqnode.tilt;

		    silt--;

		    fqnode_data->fqnode.tilt = silt;

		    if (silt == -1) {
			break;
		    } else {
			if (silt == -2) {
			    struct fpnode_type *fxnode_data;

			    fxnode_data = fqnode_data->fpnode_data[0];
			    if (fxnode_data->fqnode.tilt == 1) {
				int slip;
				struct fpnode_type *fbnode_data, *fdnode_data,
				    *fwnode_data;

				fwnode_data = fxnode_data->fpnode_data[1];
				fbnode_data = fwnode_data->fpnode_data[0];
				fxnode_data->fpnode_data[1] = fbnode_data;
				fwnode_data->fpnode_data[0] = fxnode_data;
				fdnode_data = fwnode_data->fpnode_data[1];
				fqnode_data->fpnode_data[0] = fdnode_data;
				fwnode_data->fpnode_data[1] = fqnode_data;
				slip = fwnode_data->fqnode.tilt;
				fwnode_data->fqnode.tilt = 0;
				if (slip == -1) {
				    fxnode_data->fqnode.tilt = 0;
				    fqnode_data->fqnode.tilt = 1;
				} else {
				    if (!slip) {
					fxnode_data->fqnode.tilt = 0;
					fqnode_data->fqnode.tilt = 0;
				    } else {
					fxnode_data->fqnode.tilt = -1;
					fqnode_data->fqnode.tilt = 0;
				    }
				}
				fwnode_data->uplink_data =
				    fqnode_data->uplink_data;
				fqnode_data->uplink_data = fwnode_data;
				fxnode_data->uplink_data = fwnode_data;
				if (fbnode_data) {
				    fbnode_data->uplink_data = fxnode_data;
				} else {
				}
				if (fdnode_data) {
				    fdnode_data->uplink_data = fqnode_data;
				} else {
				}
				fhnode_data->fpnode_data[1] = fwnode_data;
				if (1) {
				    fwnode_data->fqnode.size +=
					fxnode_data->fqnode.size + 1;
				    fqnode_data->fqnode.size -=
					fwnode_data->fqnode.size + 1;
				}
			    } else {
				struct fpnode_type *fmnode_data;

				fmnode_data = fxnode_data->fpnode_data[1];
				fqnode_data->fpnode_data[0] = fmnode_data;
				fxnode_data->fpnode_data[1] = fqnode_data;
				fxnode_data->uplink_data =
				    fqnode_data->uplink_data;
				fqnode_data->uplink_data = fxnode_data;
				if (fmnode_data) {
				    fmnode_data->uplink_data = fqnode_data;
				} else {
				}
				fhnode_data->fpnode_data[1] = fxnode_data;
				if (1) {
				    fqnode_data->fqnode.size -=
					fxnode_data->fqnode.size + 1;
				}
				if (fxnode_data->fqnode.tilt) {
				    fqnode_data->fqnode.tilt = 0;
				    fxnode_data->fqnode.tilt = 0;
				} else {
				    fqnode_data->fqnode.tilt = -1;
				    fxnode_data->fqnode.tilt = 1;
				    break;
				}
			    }
			}
		    }
		}
	    }
	} while (0);

	nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[0] =
	    nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[1];
    }

    return delete;
}
