/*
 * nvxx-inter.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_nvxx_inter_H__
#define __LIBx1f4_nvxx_inter_H__

#include <nvxx-names.h>
#include <nvxx-types.h>

#define _libx1f4l2_fast_nvlist		x1f4_fast_nvlist
#define _libx1f4l2_fini_nvlist		x1f4_fini_nvlist
#define _libx1f4l2_flat_nvlist		x1f4_flat_nvlist
#define _libx1f4l2_init_nvlist		x1f4_init_nvlist
#define _libx1f4l2_move_nvlist		x1f4_move_nvlist
#define _libx1f4l2_spin_nvlist		x1f4_spin_nvlist

extern int _libx1f4l2_away_nvlist(void *, void *, int (*) (void *, void *));
extern int _libx1f4l2_beta_nvlist(void *, void *);
extern int _libx1f4l2_case_nvlist(void *, unsigned, void *, void **);
extern int _libx1f4l2_ceil_nvlist(void *);
extern int _libx1f4l2_dana_nvlist(void *, void *);
extern int _libx1f4l2_dawn_nvlist
    (void *, void *, void *, int (*) (void *, void *, void *), unsigned);
extern int _libx1f4l2_elif_nvlist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **,
     int (*) (void *, unsigned, void **));
extern int _libx1f4l2_else_nvlist(void *, unsigned, void **);
extern int _libx1f4l2_fair_nvlist(void *, unsigned, void *, unsigned);
extern int _libx1f4l2_fast_nvlist(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_fini_nvlist(void **);
extern int _libx1f4l2_flat_nvlist(void *);
extern int _libx1f4l2_here_nvlist(void *, unsigned, void **);
extern int _libx1f4l2_init_nvlist(void **, unsigned, struct screen_type *);
extern int _libx1f4l2_lane_nvlist(void *, unsigned, unsigned);
extern int _libx1f4l2_long_nvlist(void *, void *, int (*) (void *, void *));
extern int _libx1f4l2_lose_nvlist(void *, unsigned, void **);
extern int _libx1f4l2_moon_nvlist(void *, unsigned, void *);
extern int _libx1f4l2_move_nvlist(void *, unsigned, unsigned);
extern int _libx1f4l2_nand_nvlist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int _libx1f4l2_rail_nvlist
    (void *, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int _libx1f4l2_spin_nvlist(void *, unsigned, unsigned);
extern int _libx1f4l2_wave_nvlist
    (void *, void *, void *, int (*) (void *, void *));

#endif				/* __LIBx1f4_nvxx_inter_H__ */
