/*
 * nvxx.6.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <nvxx-defs.h>
#include <nvxx-inter.h>
#include <nvxx-names.h>
#include <nvxx-types.h>

#define nvlist(nvlist)			((struct nvlist_type *) (nvlist))

int
x1f4_miss_nvlist(void *nvlist, unsigned index)
{
    int status;
    unsigned count;

    count = nvlist(nvlist)->link_a.fplist.fplink.fqnode.size;

    if (!(index < count)) {
	status = DECK_ERROR;
    } else {
	status = _libx1f4l2_nand_nvlist
	    (nvlist, index, nvlist(nvlist)->link_m.data,
	     nvlist(nvlist)->link_m.free);
	if (status) {
	    status = FREE_ERROR;
	} else {
	    nvlist(nvlist)->link_a.fplist.fplink.fqnode.size = count - 1;
	}
    }

    return status;
}
