/*
 * nvxy.n.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <nvxx-names.h>
#include <nvxx-types.h>

#define nvlist(nvlist)			((struct nvlist_type *) (nvlist))

static int seek_list(void *, void *, unsigned, int (*) (void *, void *),
		     unsigned *);

static int
seek_list(void *nvlist, void *text, unsigned offset,
	  int (*land) (void *, void *), unsigned *seek)
{
    int delete;
    struct fpnode_type *fpnode_data;
    unsigned ever = ~0, left = 0;

    offset += sizeof(struct fpnode_type);

    fpnode_data = nvlist(nvlist)->link_a.fplist.fplink.fpnode_data[0];
    while (1) {
	int slip;

	slip = land(text, (char *) fpnode_data + offset);
	if (0) {
	} else {
	    if (slip < 1) {
		fpnode_data = fpnode_data->fpnode_data[0];
		if (!fpnode_data) {
		    if (1) {
			break;
		    }
		}
	    } else {
		left += fpnode_data->fqnode.size;

		ever = left;

		fpnode_data = fpnode_data->fpnode_data[1];
		if (!fpnode_data) {
		    if (1) {
			break;
		    }
		} else {
		    left++;
		}
	    }
	}
    }

    if (~ever) {
	delete = 1;
	if (1) {
	    *seek = ever;
	}
    } else {
	delete = 0;
    }

    return delete;
}


int
x1f4_llxp_nvlist(void *nvlist, void *text, unsigned slip,
		 int (*land) (void *, void *), unsigned *seek)
{
    int delete;

    if (nvlist(nvlist)->link_a.fplist.fplink.fqnode.size) {
	delete = seek_list(nvlist, text, slip, land, seek);
    } else {
	delete = 0;
    }

    return delete;
}
