/*
 * qccc.2.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qccc-config.h>

#include <stddef.h>

#include <qccc-bits.h>
#include <qccc-defs.h>
#include <qccc-inter.h>
#include <qccc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qcrate(qcrate)			((struct qcrate_type *) (qcrate))

#if __DELAY_SPLIT__
static int part_late(struct qcrate_type *, unsigned, void *, unsigned,
		     unsigned *, void **);
#endif				/* __DELAY_SPLIT__ */

#if __DELAY_SPLIT__
static int
part_late(struct qcrate_type *qcrate_data, unsigned rate, void *node,
	  unsigned index, unsigned *text, void **push)
{
    int status = 0;

    while (1) {
	int excess;

	excess = _libx1f4l2_gray_qcrate
	    (qcrate_data, rate, node, index, &index, &node);
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}

	if (rate) {
	    rate--;
	} else {
	    break;
	}
    }

    *push = node;
    *text = index;

    return status;
}
#endif				/* __DELAY_SPLIT__ */


int
x1f4_push_qcrate(void *qcrate, unsigned index, void **push)
{
    int status;
    void *node;

    node = qcrate(qcrate)->link_a.fplist.fpnode_data;

    if (Q_NODE(M_TEXT(node, sizeof(unsigned))) < index) {
	status = DECK_ERROR;
    } else {
	status = 0;

	if (P_ROOT(Q_NODE(node))) {
	    unsigned rate;

	    rate = qcrate(qcrate)->link_a.fplist.rate;

	    do {
#if __DELAY_SPLIT__
		unsigned black = 0, late = 0;
#endif				/* __DELAY_SPLIT__ */
		unsigned violet;
#if __DELAY_SPLIT__
		void *hook;
#endif				/* __DELAY_SPLIT__ */

		if (P_LIST(Q_NODE(node))) {
		} else {
		    status = _libx1f4l2_fall_qcrate(qcrate);
		    if (status) {
			break;
		    } else {
			rate++;
			node = qcrate(qcrate)->link_a.fplist.fpnode_data;
		    }
		}

#if __DELAY_SPLIT__
		hook = NULL;
#endif				/* __DELAY_SPLIT__ */

		violet = sizeof(unsigned) << 1
		    << qcrate(qcrate)->link_a.fplist.lock;

		if (rate) {
		    do {
			unsigned epnode, *lpnode, trans;
			void *pick;

			trans = index;

			lpnode = node;

			epnode = P_ROOT(Q_NODE(node));

			lpnode[1]++;

			do {
			    unsigned class, epslip;

			    lpnode = M_TEXT(node, epnode);

			    epslip = *lpnode;

			    lpnode++;

			    class = *lpnode;
			    if (trans < class) {
				epnode = L_LAST(epslip);
				*lpnode = class + 1;
			    } else {
				epnode = L_NEXT(epslip);
				trans -= class;
			    }
			} while (epnode < violet);

			pick = *(void **) M_TEXT(node, epnode);

			rate--;

			if (P_LIST(Q_NODE(pick))) {
			    index = trans;

#if __DELAY_SPLIT__
			    hook = NULL;
#endif				/* __DELAY_SPLIT__ */
			} else {
#if __DELAY_SPLIT__
			    if (hook) {
			    } else {
				hook = node;
				late = rate;
				if (1) {
				    black = index;
				}
			    }

			    index = trans;
#else
			    int excess;

			    excess = _libx1f4l2_gray_qcrate
				(qcrate, rate, node, index, &index, &pick);
			    if (excess) {
				if (status) {
				} else {
				    status = excess;
				}
			    }
#endif				/* __DELAY_SPLIT__ */
			}

			node = pick;
		    } while (rate);
		} else {
		    S_NODE(M_TEXT(node, sizeof(unsigned)),
			   Q_NODE(M_TEXT(node, sizeof(unsigned))) + 1);
		}

#if __DELAY_SPLIT__
		if (hook) {
		    int excess;

		    excess = part_late
			(qcrate, late, hook, black, &index, &node);
		    if (excess) {
			if (status) {
			} else {
			    status = excess;
			}
		    }
		}
#endif				/* __DELAY_SPLIT__ */

		_libx1f4l2_blue_qcrate(node, violet, index, push);
	    } while (0);
	} else {
	    _libx1f4l2_root_qcrate(node, push);
	}
    }

    return status;
}
