/*
 * qccc.4.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qccc-bits.h>
#include <qccc-defs.h>
#include <qccc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qcrate(qcrate)			((struct qcrate_type *) (qcrate))

int
x1f4_peek_qcrate(void *qcrate, unsigned index, void **peek)
{
    int status;
    void *node;

    node = qcrate(qcrate)->link_a.fplist.fpnode_data;

    if (!(index < Q_NODE(M_TEXT(node, sizeof(unsigned))))) {
	status = DECK_ERROR;
    } else {
	unsigned rate, violet;

	status = 0;

	rate = qcrate(qcrate)->link_a.fplist.rate;

	violet = sizeof(unsigned) << 1 << qcrate(qcrate)->link_a.fplist.lock;

	while (rate) {
	    unsigned epnode, *lpnode;

	    lpnode = node;

	    epnode = P_ROOT(Q_NODE(node));

	    do {
		unsigned class, epslip;

		lpnode = M_TEXT(node, epnode);

		epslip = *lpnode;

		class = lpnode[1];
		if (index < class) {
		    epnode = L_LAST(epslip);
		} else {
		    epnode = L_NEXT(epslip);
		    index -= class;
		}
	    } while (epnode < violet);

	    if (1) {
		node = *(void **) M_TEXT(node, epnode);
		if (1) {
		    rate--;
		}
	    }
	}

	{
	}

	{
	    unsigned epnode, *lpnode;

	    lpnode = node;

	    epnode = P_ROOT(Q_NODE(node));

	    while (epnode < violet) {
		unsigned class, epslip;

		lpnode = M_TEXT(node, epnode);

		epslip = *lpnode;

		class = lpnode[1];
		if (index < class) {
		    epnode = L_LAST(epslip);
		} else {
		    epnode = L_NEXT(epslip);
		    index -= class;
		}
	    }

	    if (0) {
	    } else {
		*peek = M_TEXT(node, epnode);
	    }
	}
    }

    return status;
}
