/*
 * qlcb.g.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <qlcc-defs.h>
#include <qlcc-inter.h>
#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_true_qlrate(void *qlrate, struct fpnode_type *fpnode_line,
		       void *side, struct fpnode_type *fpnode_data,
		       unsigned index, void **push)
{
    int delete;
    struct fpnode_type *fpnode_slip = NULL, *fpnode_text = NULL;
    unsigned cell, line, mall, text;

    mall = qlrate(qlrate)->link_a.fplist.mall;

    cell = fpnode_data - fpnode_line;

    line = 1 << qlrate(qlrate)->link_a.fplist.lock;

    text = 2;
    while (text & ~cell) {
	if (cell + text < line) {
	} else {
	    break;
	}

	/*
	 * may go top down instead
	 */
	if (fpnode_data[text].call == QLBITS + 1) {
	    fpnode_text = fpnode_slip;
	    fpnode_slip = fpnode_data + text;
	} else {
	    break;
	}

	text <<= 1;
    }
    if (fpnode_slip) {
	if (cell) {
	    struct fpnode_type *fpnode_rail;
	    unsigned size, slip, tile;

	    fpnode_rail = fpnode_data + text;
	    slip = cell + text;
	    if (slip == line) {
		size = qlrate(qlrate)->link_a.fplist.size;
	    } else {
		size = fpnode_rail->call;
	    }
	    slip = (slip & (slip - 1)) ^ slip;
	    tile = text >> 1;
	    slip >>= 1;
	    while (slip ^ tile) {
		size -= (fpnode_rail - slip)->call;
		slip >>= 1;
	    }
	    if (size == fpnode_slip->call) {
		fpnode_text = fpnode_slip;
	    }
	}
    }
    if (fpnode_text) {
	unsigned half, i, miss;
	void *deck, *near, *sale;

	delete = 1;

	fpnode_data->node = Lx55555555;

	fpnode_text->node = Lx55555555;

	fpnode_text->star = side;

	half = QLBITS * mall >> 1;

	sale = fpnode_data->star;

	deck = side;
	near = (char *) sale + half;

	i = QLBITS >> 1;
	for (; i; i--) {
	    memcpy(deck, near, mall);
	    deck = (char *) deck + mall * 2;
	    near = (char *) near + mall * 1;
	}

	deck = (char *) sale + (half << 1);
	near = (char *) sale + half;

	i = (QLBITS >> 1) - 1;
	for (; i; i--) {
	    deck = (char *) deck - mall * 2;
	    near = (char *) near - mall * 1;
	    memcpy(deck, near, mall);
	}

	if (index < (QLBITS >> 1) + 1) {
	    fpnode_text->call = (QLBITS >> 1) + 1;

	    text = fpnode_text - fpnode_line;

	    miss = (text - cell) >> 1;
	    while (miss) {
		fpnode_text[miss].call = QLBITS >> 1;
		fpnode_data[miss].call = (QLBITS >> 1) + 1;
		miss >>= 1;
	    }

	    if (index) {
		fpnode_data->node =
		    (Lx55555555 & (((QLNODE) 1 << (index - 1)) - 1))
		    | (Lx55555555 & ~(QLNODE) 0 << (index - 1 + 1)) << 1;
		*push = (char *) sale + ((index << 1) - 1) * mall;
	    } else {
		deck = (char *) deck - mall * 1;
		memcpy(deck, sale, mall);
		fpnode_data->node = (Lx55555555 & ~(QLNODE) 1) << 1;
		*push = sale;
	    }
	} else {
	    fpnode_text->call = QLBITS >> 1;

	    index -= QLBITS >> 1;

	    text = fpnode_text - fpnode_line;

	    miss = (text - cell) >> 1;
	    while (miss) {
		fpnode_text[miss].call = (QLBITS >> 1) + 1;
		fpnode_data[miss].call = QLBITS >> 1;
		miss >>= 1;
	    }

	    {
		fpnode_text->node =
		    (Lx55555555 & (((QLNODE) 1 << (index - 1)) - 1))
		    | (Lx55555555 & ~(QLNODE) 0 << (index - 1 + 1)) << 1;
		*push = (char *) side + ((index << 1) - 1) * mall;
	    }
	}
    } else {
	delete = 0;
    }

    return delete;
}
