/*
 * qlcc-inter.h
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_qlcc_inter_H__
#define __LIBx1f4_qlcc_inter_H__

#include <qlcc-config.h>

#include <qlcc-names.h>
#include <qlcc-types.h>

#if !defined _libx1f4l2_fast_qlrate
# define _libx1f4l2_fast_qlrate		x1f4_fast_qlrate
#endif				/* !_libx1f4l2_fast_qlrate */
#if !defined _libx1f4l2_flat_qlrate
# define _libx1f4l2_flat_qlrate		x1f4_flat_qlrate
#endif				/* !_libx1f4l2_flat_qlrate */

extern int _libx1f4l2_away_qlrate
    (void *, unsigned, QLNODE *, struct fpnode_type *, struct fpnode_type *,
     unsigned *, QLNODE **, void **);
extern int _libx1f4l2_beta_qlrate
    (void *, QLNODE *, struct fpnode_type *, unsigned);
extern int _libx1f4l2_bill_qlrate
    (void *, QLNODE *, struct fpnode_type *, struct fpnode_type *, unsigned,
     struct fpnode_type *, unsigned);
extern int _libx1f4l2_blue_qlrate(void *);
extern int _libx1f4l2_ceil_qlrate(void *);
extern int _libx1f4l2_cs00_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cs10_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cs11_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cs12_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cs13_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cv00_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cv10_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cv11_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cv12_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cv13_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cx10_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cx11_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cx12_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cx13_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cz10_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cz11_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cz12_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_cz13_qlrate
    (void *, unsigned, void *, void *, QLNODE *, void **);
extern int _libx1f4l2_else_qlrate
    (void *, QLNODE *, struct fpnode_type *, struct fpnode_type *, unsigned,
     struct fpnode_type *, unsigned, unsigned, unsigned *, QLNODE **, void **);
extern int _libx1f4l2_fair_qlrate
    (void *, QLNODE *, struct fpnode_type *, struct fpnode_type *, unsigned,
     struct fpnode_type *, unsigned, unsigned, QLNODE **, void **);
extern int _libx1f4l2_fall_qlrate(void *);
extern int _libx1f4l2_fast_qlrate(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_flat_qlrate(void *);
extern int _libx1f4l2_gray_qlrate(void *);
extern int _libx1f4l2_hs00_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE, unsigned *);
extern int _libx1f4l2_hs11_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE, unsigned *);
extern int _libx1f4l2_hs12_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE, unsigned *);
extern int _libx1f4l2_hs13_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE, unsigned *);
extern int _libx1f4l2_hv00_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE);
extern int _libx1f4l2_hv11_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE);
extern int _libx1f4l2_hv12_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE);
extern int _libx1f4l2_hv13_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE);
extern int _libx1f4l2_hx10_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE, unsigned *);
extern int _libx1f4l2_hx11_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE, unsigned *);
extern int _libx1f4l2_hx12_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE, unsigned *);
extern int _libx1f4l2_hx13_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE, unsigned *);
extern int _libx1f4l2_hz10_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE);
extern int _libx1f4l2_hz11_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE);
extern int _libx1f4l2_hz12_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE);
extern int _libx1f4l2_hz13_qlrate
    (void *, unsigned, struct fpnode_type *, QLNODE);
#if __DELAY_MERGE__
extern int _libx1f4l2_long_qlrate
    (void *, QLNODE *, struct fpnode_type *, struct fpnode_type *, unsigned,
     void *);
#else
extern int _libx1f4l2_long_qlrate
    (void *, QLNODE *, struct fpnode_type *, struct fpnode_type *, unsigned);
#endif				/* __DELAY_MERGE__ */
extern int _libx1f4l2_mail_qlrate
    (void *, QLNODE *, struct fpnode_type *, struct fpnode_type *, unsigned,
     struct fpnode_type *);
extern int _libx1f4l2_mold_qlrate
    (void *, struct fpnode_type *, struct fpnode_type *, unsigned, void **);
extern int _libx1f4l2_moon_qlrate
    (void *, QLNODE *, struct fpnode_type *, unsigned);
extern int _libx1f4l2_ms00_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_ms11_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_ms12_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_ms13_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_mv00_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_mv11_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_mv12_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_mv13_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_mx10_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_mx11_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_mx12_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_mx13_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_mz10_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_mz11_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_mz12_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_mz13_qlrate
    (void *, unsigned, unsigned, struct fpnode_type *, struct fpnode_type *,
     unsigned *);
extern int _libx1f4l2_rack_qlrate(void *, unsigned, void **);
extern int _libx1f4l2_rail_qlrate(void *, unsigned, void **);
extern int _libx1f4l2_rs00_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rs11_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rs12_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rs13_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rv00_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rv11_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rv12_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rv13_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rx10_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rx11_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rx12_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rx13_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rz10_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rz11_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rz12_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_rz13_qlrate
    (void *, unsigned, struct fpnode_type *, struct fpnode_type *);
extern int _libx1f4l2_sail_qlrate
    (void *, struct fpnode_type **, unsigned, void *, unsigned *,
     struct fpnode_type **);
#if __DELAY_SPLIT__
extern int _libx1f4l2_sand_qlrate
    (void *, struct fpnode_type *, struct fpnode_type **, unsigned *,
     unsigned, void *);
#else
extern int _libx1f4l2_sand_qlrate
    (void *, struct fpnode_type *, struct fpnode_type **, unsigned *,
     unsigned);
#endif				/* __DELAY_SPLIT__ */
#if __DELAY_MERGE__
extern int _libx1f4l2_trap_qlrate
    (void *, QLNODE *, struct fpnode_type *, struct fpnode_type *, unsigned,
     void *);
#else
extern int _libx1f4l2_trap_qlrate
    (void *, QLNODE *, struct fpnode_type *, struct fpnode_type *, unsigned);
#endif				/* __DELAY_MERGE__ */
extern int _libx1f4l2_true_qlrate
    (void *, struct fpnode_type *, void *, struct fpnode_type *, unsigned,
     void **);
#if __DELAY_MERGE__ && __STAMP_MERGE__
extern int _libx1f4l2_type_qlrate
    (void *, void *, QLNODE **, struct fpnode_type **, struct fpnode_type **);
#elif __DELAY_MERGE__
extern int _libx1f4l2_type_qlrate
    (void *, void *, unsigned, QLNODE **, struct fpnode_type **,
     struct fpnode_type **);
#endif				/* __DELAY_MERGE__ */

#endif				/* __LIBx1f4_qlcc_inter_H__ */
