/*
 * qlcc.3.c
 * Copyright (C) 2010-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qlcc-config.h>

#include <stddef.h>
#include <string.h>

#include <qlcc-bits.h>
#include <qlcc-defs.h>
#include <qlcc-inter.h>
#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
x1f4_miss_qlrate(void *qlrate, unsigned index)
{
    int status;
    unsigned count;

    count = qlrate(qlrate)->link_a.fplist.size;

    if (!(index < count)) {
	status = DECK_ERROR;
    } else {
	unsigned rate;
	void *node;

	qlrate(qlrate)->link_a.fplist.size = count - 1;

	node = qlrate(qlrate)->link_a.fplist.fpnode;

	status = 0;

	rate = qlrate(qlrate)->link_a.fplist.rate;

	do {
	    if (rate) {
		QLNODE *near, news;
#if __DELAY_MERGE__
		struct dhmiss_type dhmiss;
#endif				/* __DELAY_MERGE__ */
		struct fpnode_type *fpnode_data;
		unsigned *cell;

#if __DELAY_MERGE__
		dhmiss.hook = NULL;
#endif				/* __DELAY_MERGE__ */

		near = &qlrate(qlrate)->link_a.fplist.node;

		if (1) {
		    unsigned lock, miss;

		    lock = qlrate(qlrate)->link_a.fplist.lock;

		    miss = 1 << lock >> 1;

		    while (1) {
			unsigned half;

			fpnode_data = node;

			half = lock;

			cell = &fpnode_data->call;

			while (3 < half) {
			    unsigned *call, sail, side;

			    sail = sizeof(struct fpnode_type) << half;

			    sail >>= 1;
			    call = (void *) ((char *) cell + sail);

			    side = *call;
			    if (index < side) {
				*call = side - 1;
			    } else {
				index -= side;
				cell = call;
			    }

			    sail >>= 1;
			    call = (void *) ((char *) cell + sail);

			    side = *call;
			    if (index < side) {
				*call = side - 1;
			    } else {
				index -= side;
				cell = call;
			    }

			    sail >>= 1;
			    call = (void *) ((char *) cell + sail);

			    side = *call;
			    if (index < side) {
				*call = side - 1;
			    } else {
				index -= side;
				cell = call;
			    }

			    sail >>= 1;
			    call = (void *) ((char *) cell + sail);

			    side = *call;
			    if (index < side) {
				*call = side - 1;
			    } else {
				index -= side;
				cell = call;
			    }

			    half -= 4;
			}
			while (half) {
			    unsigned *call, side;

			    half--;

			    call = (void *)
				((char *) cell
				 + (sizeof(struct fpnode_type) << half));

			    side = *call;
			    if (index < side) {
				*call = side - 1;
			    } else {
				index -= side;
				cell = call;
			    }
			}

			fpnode_data = (void *)
			    ((char *) cell
			     - offsetof(struct fpnode_type, call));

			rate--;

			if (rate) {
			    QLNODE *fail;

			    fail = &fpnode_data->node;
			    if (*fail ^ miss) {
				near = fail;

				node = fpnode_data->star;

#if __DELAY_MERGE__
				dhmiss.hook = NULL;
#endif				/* __DELAY_MERGE__ */
			    } else {
#if __DELAY_MERGE__
				if (dhmiss.hook) {
				    unsigned call;

				    call = fpnode_data
					- (struct fpnode_type *) node;
				    do {
					if (call) {
					    if ((fpnode_data - 2)->node
						^ miss) {
						dhmiss.hook = NULL;
						break;
					    }
					}
					call += 2;
					if (call ^ (miss << 1)) {
					    if ((fpnode_data + 2)->node
						^ miss) {
						dhmiss.hook = NULL;
					    }
					}
				    } while (0);
				}
				if (dhmiss.hook) {
# if __STAMP_MERGE__
				    struct fpnode_type *fpnode_slip;

				    fpnode_slip = node;
				    fpnode_slip->call =
					fpnode_data - fpnode_slip;
# endif				/* __STAMP_MERGE__ */
				} else {
				    dhmiss.hook = node;
				    dhmiss.late = rate;
				    dhmiss.meta = near;
				    if (1) {
# if __STAMP_MERGE__
# else
					dhmiss.black = index;
# endif				/* __STAMP_MERGE__ */
					if (1) {
					    dhmiss.side = fpnode_data;
					}
				    }
				}

				near = fail;

				node = fpnode_data->star;
#else
				int excess;

				excess = _libx1f4l2_away_qlrate
				    (qlrate, rate, near, node, fpnode_data,
				     &index, &near, &node);
				if (excess) {
				    if (status) {
				    } else {
					status = excess;
				    }
				}
#endif				/* __DELAY_MERGE__ */
			    }
			} else {
			    break;
			}
		    }
		}

		news = fpnode_data->node;

		if (news == Lx55555555) {
		    int excess;

#if __DELAY_MERGE__
		    excess = _libx1f4l2_long_qlrate
			(qlrate, near, node, fpnode_data, index, &dhmiss);
#else
		    excess = _libx1f4l2_long_qlrate
			(qlrate, near, node, fpnode_data, index);
#endif				/* __DELAY_MERGE__ */
		    if (1) {
			if (status) {
			} else {
			    status = excess;
			}

			break;
		    }
		}

		{
		    QLNODE call, slip;
		    unsigned trans;

		    call = (QLNODE) 1 << index;

		    slip = call - 1;

		    ql_bitcount(trans, news & slip);

		    if ((index ^ trans) & 1) {
			fpnode_data->node =
			    (news & slip) | call >> 1 | (news & ~slip) >> 1;
		    } else {
			/*
			 * may try the "feeling lucky" approach:
			 * check whether one of the neighbours is good for
			 * transfer
			 */

			if (~news & slip) {
			    QLNODE fail, mind;

			    fail = news >> index;
			    mind = news << (QLBITS - index);
			    ql_reverse(mind);

			    fail = fail & (~fail - 1);
			    mind = mind & (~mind - 1);

			    if (fail < mind) {
				trans += index;
				if (fail << (trans >> 1)
				    & (1 << (HALF_QLBITS - 1))) {
				    qlrate(qlrate)->link_v.near
					(qlrate, trans, fpnode_data, mind,
					 &trans);

				    index -= 2;
				    index -= trans;
				    mind = (QLNODE) 1 << index;
				    fail = mind - 1;
				    fpnode_data->node =
					(news & fail) | mind
					| (news & ~fail) >> 1;
				} else {
				    qlrate(qlrate)->link_v.plus
					(qlrate, trans, fpnode_data, fail);

				    fail <<= 1;
				    fail |= 1;
				    fail ^= fail >> 1;
				    fail <<= index;
				    mind = fail - 1;
				    fpnode_data->node =
					(news & mind) | fail
					| (news & ~mind) >> 1;
				}
			    } else {
				{
				    qlrate(qlrate)->link_v.near
					(qlrate, index + trans, fpnode_data,
					 mind, &trans);

				    index -= 2;
				    index -= trans;
				    mind = (QLNODE) 1 << index;
				    fail = mind - 1;
				    fpnode_data->node =
					(news & fail) | mind
					| (news & ~fail) >> 1;
				}
			    }
			} else {
			    {
				{
				    QLNODE fail, mind;

				    fail = news >> index;

				    fail = fail & (~fail - 1);

				    qlrate(qlrate)->link_v.plus
					(qlrate, index + trans, fpnode_data,
					 fail);

				    fail <<= 1;
				    fail |= 1;
				    fail ^= fail >> 1;
				    fail <<= index;
				    mind = fail - 1;
				    fpnode_data->node =
					(news & mind) | fail
					| (news & ~mind) >> 1;
				}
			    }
			}
		    }
		}
	    } else {
		count -= index;
		count--;
		if (count) {
		    unsigned mall;

		    mall = qlrate(qlrate)->link_a.fplist.mall;

		    node = (char *) node + index * mall;

		    memmove(node, (char *) node + mall, count * mall);
		} else {
		}
	    }
	} while (0);
    }

    return status;
}
