/*
 * qlcc.j.c
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <qlcc-inter.h>
#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_blue_qlrate(void *qlrate)
{
    int status;
    unsigned mall;
    void *side;

    mall = qlrate(qlrate)->link_a.fplist.mall;

    status = qlrate(qlrate)->link_m.link
	(qlrate(qlrate)->link_m.data, &side, QLBITS * mall);
    if (status) {
	status = _libx1f4l2_rack_qlrate(qlrate, 0, &side);
    }

    if (0) {
    } else {
	struct fpnode_type *fpnode_data;
	unsigned lock, half, i, slip;
	void *deck, *near, *sale;

	lock = qlrate(qlrate)->link_a.fplist.lock;

	fpnode_data = qlrate(qlrate)->link_a.fplist.fpnode;

	slip = 1 << lock >> 1;

	fpnode_data += slip;

	while (slip) {
	    fpnode_data->call = QLBITS * 3 >> 2;
	    slip >>= 1;
	    fpnode_data -= slip;
	}

	fpnode_data--;

	sale = fpnode_data->star;

	fpnode_data->node = Lx77777777;

	half = 3 * QLBITS * mall >> 2;

	deck = side;
	near = (char *) sale + half;

	i = QLBITS >> 2;
	for (; i; i--) {
	    memcpy(deck, near, mall * 3);
	    deck = (char *) deck + mall * 4;
	    near = (char *) near + mall * 3;
	}

	if (qlrate(qlrate)->link_m.mode
	    (qlrate(qlrate)->link_m.data, &sale, QLBITS * mall)) {
	} else {
	    fpnode_data->star = sale;
	}

	deck = (char *) sale + mall * QLBITS;
	near = (char *) sale + half;

	i = QLBITS >> 2;
	i -= 3;
	for (; i; i--) {
	    deck = (char *) deck - mall * 4;
	    near = (char *) near - mall * 3;
	    memcpy(deck, near, mall * 3);
	}
	i = 2;
	for (; i; i--) {
	    deck = (char *) deck - mall * 4;
	    near = (char *) near - mall * 3;
	    memmove(deck, near, mall * 3);
	}

	slip = 1 << lock >> 1;

	fpnode_data += slip;

	slip >>= 1;

	fpnode_data += slip;

	while (slip) {
	    fpnode_data->call = QLBITS * 3 >> 2;
	    slip >>= 1;
	    fpnode_data -= slip;
	}

	fpnode_data--;

	fpnode_data->node = Lx77777777;
	fpnode_data->star = side;

	qlrate(qlrate)->link_a.fplist.node = 2;
    }

    return status;
}
