/*
 * qlcc.q.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <qlcc-inter.h>
#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_rail_qlrate(void *qlrate, unsigned index, void **push)
{
    int status;

    status = _libx1f4l2_fall_qlrate(qlrate);
    if (status) {
    } else {
	struct fpnode_type *fpnode_data;
	unsigned half, mall;
	void *node;

	half = 1 << qlrate(qlrate)->link_a.fplist.lock >> 1;

	fpnode_data = qlrate(qlrate)->link_a.fplist.fpnode;

	if (3 * QLBITS >> 2 < index) {
	    fpnode_data += half;

	    half >>= 1;

	    index -= 3 * QLBITS >> 2;
	}
	{
	    fpnode_data += half;

	    while (half) {
		fpnode_data->call++;
		half >>= 1;
		fpnode_data -= half;
	    }

	    fpnode_data--;

	    node = fpnode_data->star;
	}

	mall = qlrate(qlrate)->link_a.fplist.mall;

	if (index & ~1) {
	    QLNODE slip, news;
	    unsigned class, trans;

	    news = fpnode_data->node;

	    trans = index % 3;

	    class = index - trans;

	    node = (char *) node + ((index / 3) * mall << 2);

	    switch (trans) {
	    case 0:
		slip = ~(QLNODE) 0 << (class + 0);
		news = (news & slip) << 1 | (news & ~slip >> 3);
		node = (char *) node - mall;
		break;
	    case 1:
		slip = ~(QLNODE) 0 << (class + 0);
		news = (news & slip) << 1 | (news & ~slip >> 3);
		memmove((char *) node - mall, node, mall);
		break;
	    default:
		slip = ~(QLNODE) 0 << (class + 3);
		news = (news & slip) << 1 | (news & ~slip >> 3);
		node = (char *) node + mall * 2;
		memmove((char *) node + mall, node, mall);
	    }

	    fpnode_data->node = news;
	} else {
	    fpnode_data->node = (Lx77777777 & ~7) << 1;

	    if (index) {
		node = (char *) node + mall;
		memmove((char *) node + mall, node, mall << 1);
	    } else {
		memmove((char *) node + mall, node, mall * 3);
	    }
	}

	*push = node;

	qlrate(qlrate)->link_a.fplist.size = (3 * QLBITS >> 1) + 1;
    }

    return status;
}
