/*
 * qlcc.v.c
 * Copyright (C) 2010-2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qlcc-config.h>

#include <stddef.h>

#include <qlcc-bits.h>
#include <qlcc-inter.h>
#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define true(e)				1

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

#if __DELAY_MERGE__
int
_libx1f4l2_long_qlrate(void *qlrate, QLNODE *near,
		       struct fpnode_type *fpnode_line,
		       struct fpnode_type *fpnode_data, unsigned index,
		       void *dhmiss)
#else
int
_libx1f4l2_long_qlrate(void *qlrate, QLNODE *near,
		       struct fpnode_type *fpnode_line,
		       struct fpnode_type *fpnode_data, unsigned index)
#endif				/* __DELAY_MERGE__ */
{
    int status = 0;

    if (fpnode_line == qlrate(qlrate)->link_a.fplist.fpnode) {
#if __DELAY_MERGE__
	status = _libx1f4l2_trap_qlrate
	    (qlrate, near, fpnode_line, fpnode_data, index, dhmiss);
#else
	status = _libx1f4l2_trap_qlrate
	    (qlrate, near, fpnode_line, fpnode_data, index);
#endif				/* __DELAY_MERGE__ */
    } else {
	unsigned call;

#if __DELAY_MERGE__
      label:
#endif				/* __DELAY_MERGE__ */
	call = fpnode_data - fpnode_line;
	if (call & 1) {
	    QLNODE lead;

	    lead = (fpnode_data - 1)->node;
	    if (true(0)) {
		unsigned seek;

		if (~lead & Lx55555555) {
		    unsigned last;
		    void *fpnode, *fqnode;

		    fpnode = (fpnode_data - 0)->star;
		    fqnode = (fpnode_data - 1)->star;

		    ql_bitcount(last, lead);

		    qlrate(qlrate)->link_v.lead
			(qlrate, index, last, fpnode_data, fpnode_data - 1,
			 &seek);

		    (fpnode_data - 0)->call = QLBITS - last - seek;
		} else {
#if __DELAY_MERGE__
		    int excess;
#else
# define excess				status
#endif				/* __DELAY_MERGE__ */

		    qlrate(qlrate)->link_v.mind
			(qlrate, index, fpnode_data, fpnode_data - 1);

		    (fpnode_data - 0)->call = QLBITS - 1;

		    excess = _libx1f4l2_beta_qlrate
			(qlrate, near, fpnode_line, call);
#if __DELAY_MERGE__
		    if (excess) {
			if (status) {
			} else {
			    status = excess;
			}
		    }
#endif				/* __DELAY_MERGE__ */

#if __DELAY_MERGE__
#else
# undef excess
#endif				/* __DELAY_MERGE__ */
		}
	    } else {
	    }
	} else {
	    QLNODE ever;

	    ever = (fpnode_data + 1)->node;
	    if (~ever) {
		unsigned seek;

		if (~ever & Lx55555555) {
		    unsigned post;

		    ql_bitcount(post, ever);

		    qlrate(qlrate)->link_v.ever
			(qlrate, index, post, fpnode_data, fpnode_data + 1,
			 &seek);

		    (fpnode_data + 1)->call = HALF_QLBITS + seek - 1;
		} else {
#if __DELAY_MERGE__
		    int excess;
#else
# define excess				status
#endif				/* __DELAY_MERGE__ */

		    qlrate(qlrate)->link_v.slip
			(qlrate, index, fpnode_data, fpnode_data + 1);

		    (fpnode_data + 1)->call = QLBITS - 1;

		    excess = _libx1f4l2_beta_qlrate
			(qlrate, near, fpnode_line, call + 1);
#if __DELAY_MERGE__
		    if (excess) {
			if (status) {
			} else {
			    status = excess;
			}
		    }
#endif				/* __DELAY_MERGE__ */

#if __DELAY_MERGE__
#else
# undef excess
#endif				/* __DELAY_MERGE__ */
		}
	    } else {
		if (call & 2) {
		    QLNODE lead;

		    lead = (fpnode_data - 1)->node;
		    if (~lead) {
			unsigned seek;

			if (~lead & Lx55555555) {
			    unsigned last;

			    ql_bitcount(last, lead);

			    qlrate(qlrate)->link_v.lead
				(qlrate, index, last, fpnode_data,
				 fpnode_data - 1, &seek);

			    (fpnode_data - 0)->call -= seek;
			    (fpnode_data + 1)->call = HALF_QLBITS + seek - 1;

			} else {
#if __DELAY_MERGE__
			    int excess;
#else
# define excess				status
#endif				/* __DELAY_MERGE__ */
			    void *fpnode, *fqnode;

			    qlrate(qlrate)->link_v.mind
				(qlrate, index, fpnode_data, fpnode_data - 1);

			    fpnode = (fpnode_data - 0)->star;
			    fqnode = (fpnode_data - 1)->star;

			    (fpnode_data - 0)->star = fqnode;
			    (fpnode_data - 1)->star = fpnode;

			    (fpnode_data - 0)->call -= QLBITS >> 1;

			    (fpnode_data + 1)->call = QLBITS - 1;

			    (fpnode_data - 0)->node = (fpnode_data - 1)->node;
			    (fpnode_data - 1)->node = ~(QLNODE) 0;

			    excess = _libx1f4l2_beta_qlrate
				(qlrate, near, fpnode_line, call - 1);
#if __DELAY_MERGE__
			    if (excess) {
				if (status) {
				} else {
				    status = excess;
				}
			    }
#endif				/* __DELAY_MERGE__ */

#if __DELAY_MERGE__
#else
# undef excess
#endif				/* __DELAY_MERGE__ */
			}
		    } else {
			lead = (fpnode_data - 2)->node;
			if (true(0)) {
			    unsigned mind, seek;

			    if (~lead & Lx55555555) {
				unsigned last;

				ql_bitcount(last, lead);

				qlrate(qlrate)->link_v.lead
				    (qlrate, index, last, fpnode_data,
				     fpnode_data - 2, &seek);

				(fpnode_data + 1)->call =
				    HALF_QLBITS + seek - 1;

				mind = QLBITS - last - seek;

				(fpnode_data - 0)->call = mind;
				(fpnode_data - 1)->call = mind;
			    } else {
#if __DELAY_MERGE__
				if (((struct dhmiss_type *) dhmiss)->hook) {
				    int excess;
# if __STAMP_MERGE__
# else
				    unsigned mind = 0;
# endif				/* __STAMP_MERGE__ */

# if __STAMP_MERGE__
# else
				    if (index == fpnode_data->node - 1) {
					mind = 1;
				    }
# endif				/* __STAMP_MERGE__ */

# if __STAMP_MERGE__
				    excess = _libx1f4l2_type_qlrate
					(qlrate, dhmiss, &near, &fpnode_line,
					 &fpnode_data);
# else
				    excess = _libx1f4l2_type_qlrate
					(qlrate, dhmiss, mind, &near,
					 &fpnode_line, &fpnode_data);
# endif				/* __STAMP_MERGE__ */
				    if (excess) {
					if (status) {
					} else {
					    status = excess;
					}
				    }

				    ((struct dhmiss_type *) dhmiss)->hook =
					NULL;

				    goto label;
				}
#endif				/* __DELAY_MERGE__ */
				{
#if __DELAY_MERGE__
				    int excess;
#else
# define excess				status
#endif				/* __DELAY_MERGE__ */

				    qlrate(qlrate)->link_v.mind
					(qlrate, index, fpnode_data,
					 fpnode_data - 2);

				    (fpnode_data + 1)->call = 0;
				    (fpnode_data - 0)->call = QLBITS - 1;
				    (fpnode_data - 1)->call = QLBITS - 1;

				    excess = _libx1f4l2_beta_qlrate
					(qlrate, near, fpnode_line, call);
#if __DELAY_MERGE__
				    if (excess) {
					if (status) {
					} else {
					    status = excess;
					}
				    }
#endif				/* __DELAY_MERGE__ */

#if __DELAY_MERGE__
#else
# undef excess
#endif				/* __DELAY_MERGE__ */
				}
			    }
			}
		    }
		} else {
		    QLNODE ever;

		    ever = (fpnode_data + 2)->node;
		    if (true(0)) {
			unsigned seek;

			if (~ever & Lx55555555) {
			    unsigned post, rail;

			    ql_bitcount(post, ever);

			    qlrate(qlrate)->link_v.ever
				(qlrate, index, post, fpnode_data,
				 fpnode_data + 2, &seek);

			    rail = HALF_QLBITS + seek - 1;
			    (fpnode_data + 1)->call = rail;
			    (fpnode_data + 2)->call = rail;

			    (fpnode_data + 3)->call = QLBITS - post - seek;
			} else {
#if __DELAY_MERGE__
			    if (((struct dhmiss_type *) dhmiss)->hook) {
				int excess;
# if __STAMP_MERGE__
# else
				unsigned mind = 0;
# endif				/* __STAMP_MERGE__ */

# if __STAMP_MERGE__
# else
				if (index == fpnode_data->node - 1) {
				    mind = 1;
				}
# endif				/* __STAMP_MERGE__ */

# if __STAMP_MERGE__
				excess = _libx1f4l2_type_qlrate
				    (qlrate, dhmiss, &near, &fpnode_line,
				     &fpnode_data);
# else
				excess = _libx1f4l2_type_qlrate
				    (qlrate, dhmiss, mind, &near, &fpnode_line,
				     &fpnode_data);
# endif				/* __STAMP_MERGE__ */
				if (excess) {
				    if (status) {
				    } else {
					status = excess;
				    }
				}

				((struct dhmiss_type *) dhmiss)->hook = NULL;

				goto label;
			    }
#endif				/* __DELAY_MERGE__ */
			    {
#if __DELAY_MERGE__
				int excess;
#else
# define excess				status
#endif				/* __DELAY_MERGE__ */

				qlrate(qlrate)->link_v.slip
				    (qlrate, index, fpnode_data,
				     fpnode_data + 2);

				(fpnode_data + 1)->call = QLBITS - 1;
				(fpnode_data + 2)->call = QLBITS - 1;
				(fpnode_data + 3)->call = 0;

				excess = _libx1f4l2_beta_qlrate
				    (qlrate, near, fpnode_line, call + 2);
#if __DELAY_MERGE__
				if (excess) {
				    if (status) {
				    } else {
					status = excess;
				    }
				}
#endif				/* __DELAY_MERGE__ */

#if __DELAY_MERGE__
#else
# undef excess
#endif				/* __DELAY_MERGE__ */
			    }
			}
		    }
		}
	    }
	}
    }

    return status;
}
