/*
 * qlcc.x.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <qlcc-defs.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_mail_qlrate(void *qlrate, QLNODE *near,
		       struct fpnode_type *fpnode_line,
		       struct fpnode_type *fpnode_data, unsigned call,
		       struct fpnode_type *fpnode_post)
{
    int status;

    status = qlrate(qlrate)->link_m.free
	(qlrate(qlrate)->link_m.data, fpnode_post->star);
    if (status) {
	status = FREE_ERROR;
    }

    if (1) {
	if (*near == 2) {
	    int excess;
	    unsigned mall;
	    void *node, *star;

	    node = qlrate(qlrate)->link_a.fplist.fpnode;

	    star = fpnode_data->star;

	    excess = qlrate(qlrate)->link_m.free
		(qlrate(qlrate)->link_m.data, node);
	    if (excess) {
		if (status) {
		} else {
		    status = FREE_ERROR;
		}
	    }

	    node = qlrate(qlrate)->link_e.fplink_text;

	    qlrate(qlrate)->link_e.fplink_text = NULL;

	    mall = qlrate(qlrate)->link_a.fplist.mall;

	    if (qlrate(qlrate)->link_m.mode
		(qlrate(qlrate)->link_m.data, &star, QLBITS * 3 * mall >> 1)) {
		void *sail;

		memcpy(node, star, mall * fpnode_data->node);

		sail = node;
		node = star;
		star = sail;
	    } else {
	    }

	    qlrate(qlrate)->link_a.fplist.fpnode = star;
	    qlrate(qlrate)->link_a.fplist.node =
		qlrate(qlrate)->link_a.fplist.size;
	    qlrate(qlrate)->link_a.fplist.rate = 0;

	    excess = qlrate(qlrate)->link_m.free
		(qlrate(qlrate)->link_m.data, node);
	    if (excess) {
		if (status) {
		} else {
		    status = FREE_ERROR;
		}
	    }
	} else {
	    unsigned line, post;

	    line = 1 << qlrate(qlrate)->link_a.fplist.lock;

	    (*near)--;

	    post = fpnode_post - fpnode_line;

	    post++;
	    while (post < line) {
		(fpnode_line + post)->call -= QLBITS >> 1;
		post += post & ~(post - 1);
	    }

	    call++;
	    do {
		(fpnode_line + call)->call += QLBITS >> 1;
		call += call & ~(call - 1);
	    } while (call < line);
	}
    }

    return status;
}
