/*
 * qlcf.6.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#if SIZEOF_UNSIGNED == 4
# define RANGE_SHIFT			2
#endif				/* SIZEOF_UNSIGNED == 4 */

#if SIZEOF_UNSIGNED == 8
# define RANGE_SHIFT			3
#endif				/* SIZEOF_UNSIGNED == 8 */

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_hx12_qlrate(void *qlrate, unsigned index,
		       struct fpnode_type *fpnode_data, QLNODE copy,
		       unsigned *call)
{
#if SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1)
#else
    unsigned *deck, fast = 0, j, mall, seek;

    mall = qlrate(qlrate)->link_a.fplist.mall;

    seek = mall >> RANGE_SHIFT;

    mall = seek >> 2;

    deck = fpnode_data->star;
    deck += (index + 1) * seek;

    for (; copy; copy >>= 1) {
	unsigned *near;

	fast++;

	near = deck - (seek << 1);
	for (j = mall; j; j--) {
	    *--deck = *--near;
	    *--deck = *--near;
	    *--deck = *--near;
	    *--deck = *--near;
	}
	{
	    *--deck = *--near;
	    *--deck = *--near;
	}

	deck -= seek;
    }
    {
	unsigned *near;

	near = deck - (seek << 0);
	for (j = mall; j; j--) {
	    *--deck = *--near;
	    *--deck = *--near;
	    *--deck = *--near;
	    *--deck = *--near;
	}
	{
	    *--deck = *--near;
	    *--deck = *--near;
	}
    }
    {
	*call = fast;
    }
#endif				/* SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1) */

    return 0;
}
