/*
 * qlcj.0.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define cell(___s, ___n, ___t) \
    ((char *) (___s) - (___n) * (___t))

#define dana(___s, ___n) \
    (___s) = (char *) (___s) + ((___n) << 1)

#define life(___s, ___n) \
    ((char *) (___s) - (___n))

#define posh(___s, ___n) \
    (___s) = (char *) (___s) - (___n)

#define road(___s, ___n) \
    ((char *) (___s) + ((___n) << 1))

#define rule(___s, ___n, ___t) \
    ((char *) (___s) + (___n) * (___t))

#define sans(___s, ___n) \
    ((char *) (___s) + (___n))

#define skip(___s, ___n) \
    (___s) = (char *) (___s) + (___n)

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_ms00_qlrate(void *qlrate, unsigned index, unsigned post,
		       struct fpnode_type *fpnode_data,
		       struct fpnode_type *fpnode_post, unsigned *lock)
{
    QLNODE ever;
    unsigned mall, seek;
    void *fpnode, *fqnode;

    seek = (QLBITS >> 1) - post;

    ever = fpnode_post->node;

    mall = qlrate(qlrate)->link_a.fplist.mall;

    fpnode = fpnode_data->star;

    if (2 < seek) {
	QLNODE clip;
	unsigned i;

	seek++;
	seek >>= 1;

	*lock = seek;

	fpnode = rule(fpnode, mall, index << 1);

	i = HALF_QLBITS - 1 - index;
	if (i & 1) {
	    fqnode = fpnode;
	    dana(fpnode, mall);
	    memcpy(fqnode, fpnode, mall);
	}
	i >>= 1;
	for (; i; i--) {
	    fqnode = road(fpnode, mall);
	    memcpy(fpnode, fqnode, mall);
	    fpnode = road(fqnode, mall);
	    memcpy(fqnode, fpnode, mall);
	}
	if (3 < seek) {
	    fqnode = cell(fpnode, mall, (seek - 3) << 1);
	    fpnode = life(fqnode, mall);

	    i = seek - 3;
	    for (; i; i--) {
		memcpy(fpnode, fqnode, mall);
		skip(fpnode, mall);
		dana(fqnode, mall);
	    }
	} else {
	    if (seek ^ 2) {
		posh(fpnode, mall);
	    }
	}

	clip = 1;

	fqnode = fpnode_post->star;

	i = seek;
	while (1) {
	    memcpy(fpnode, fqnode, mall);
	    skip(fpnode, mall);
	    if (ever & clip) {
		dana(fqnode, mall);
		i--;
		clip <<= 1;
		if (i) {
		} else {
		    fpnode = fpnode_post->star;

		    break;
		}
	    } else {
		clip <<= 2;
		if (i & ~1) {
		    i -= 2;
		    skip(fqnode, mall);
		    memcpy(fpnode, fqnode, mall);
		    skip(fpnode, mall);
		    skip(fqnode, mall);
		    if (i) {
		    } else {
			fpnode = fpnode_post->star;

			break;
		    }
		} else {
		    skip(fqnode, mall);
		    if (0) {
		    } else {
			fpnode = fpnode_post->star;

			memcpy(fpnode, fqnode, mall);
			dana(fpnode, mall);
			skip(fqnode, mall);

			break;
		    }
		}
	    }
	}

	i = (fqnode - fpnode) >> 1;
	while (i) {
	    if (ever & clip) {
		memcpy(fpnode, fqnode, mall);
		dana(fpnode, mall);
		dana(fqnode, mall);
		clip <<= 1;
	    } else {
		clip <<= 2;
		i -= mall;
		memcpy(fpnode, fqnode, mall);
		dana(fpnode, mall);
		skip(fqnode, mall);
		memcpy(fpnode, fqnode, mall);
		dana(fpnode, mall);
		skip(fqnode, mall);
	    }
	}

	clip--;

	fpnode_post->node = (ever & ~clip) >> seek | clip >> seek;

	fpnode_data->node =
	    Lx55555555 & (((QLNODE) 1 << (HALF_QLBITS + 1 - seek)) - 1);
    } else {
	QLNODE clip, fail;
	unsigned i;

	clip = 1;

	fpnode = rule(fpnode, mall, index << 1);

	i = HALF_QLBITS - 1 - index;
	if (i & 1) {
	    fqnode = fpnode;
	    dana(fpnode, mall);
	    memcpy(fqnode, fpnode, mall);
	}
	i >>= 1;
	for (; i; i--) {
	    fqnode = road(fpnode, mall);
	    memcpy(fpnode, fqnode, mall);
	    fpnode = road(fqnode, mall);
	    memcpy(fqnode, fpnode, mall);
	}

	fqnode = fpnode_post->star;

	memcpy(fpnode, fqnode, mall);

	while (1) {
	    if (ever & clip) {
		fpnode = road(fqnode, mall);
		memcpy(fqnode, fpnode, mall);
		clip <<= 1;
		if (ever & clip) {
		    fqnode = road(fpnode, mall);
		    memcpy(fpnode, fqnode, mall);
		    clip <<= 1;
		} else {
		    fqnode = sans(fpnode, mall);
		    memcpy(fpnode, fqnode, mall);

		    break;
		}
	    } else {
		fpnode = sans(fqnode, mall);
		memcpy(fqnode, fpnode, mall);

		break;
	    }
	}

	*lock = 1;

	fail = clip - 1;

	fpnode_post->node = (ever & fail) | clip | (ever & ~fail) >> 1;

	fpnode_data->node = Lx55555555;
    }

    return 0;
}
