/*
 * qlcj.5.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_ms11_qlrate(void *qlrate, unsigned index, unsigned post,
		       struct fpnode_type *fpnode_data,
		       struct fpnode_type *fpnode_post, unsigned *lock)
{
#if SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1)
#else
    QLNODE ever;
    unsigned *deck, i, *near, seek;

    seek = (QLBITS >> 1) - post;

    ever = fpnode_post->node;

    deck = fpnode_data->star;

    deck += index << 1;

    i = HALF_QLBITS - 1 - index;
    if (i & 1) {
	near = deck;
	deck += 2;
	*near = *deck;
    }
    i >>= 1;
    for (; i; i--) {
	near = deck + 2;
	*deck = *near;
	deck = near + 2;
	*near = *deck;
    }

    if (2 < seek) {
	QLNODE clip;

	seek++;
	seek >>= 1;

	*lock = seek;

	if (3 < seek) {
	    near = deck - ((seek - 3) << 1);
	    deck = near - 1;

	    i = seek - 3;
	    for (; i; i--) {
		*deck++ = *near;
		near += 2;
	    }
	} else {
	    if (seek ^ 2) {
		deck--;
	    }
	}

	clip = 1;

	near = fpnode_post->star;

	i = seek;
	while (1) {
	    *deck = *near;
	    deck++;
	    if (ever & clip) {
		near += 2;
		i--;
		clip <<= 1;
		if (i) {
		} else {
		    deck = fpnode_post->star;

		    break;
		}
	    } else {
		clip <<= 2;
		if (i & ~1) {
		    i -= 2;
		    near++;
		    *deck++ = *near++;
		    if (i) {
		    } else {
			deck = fpnode_post->star;

			break;
		    }
		} else {
		    near++;
		    if (0) {
		    } else {
			deck = fpnode_post->star;

			*deck = *near++;
			deck += 2;

			break;
		    }
		}
	    }
	}

	i = (near - deck) >> 1;
	while (i) {
	    if (ever & clip) {
		*deck = *near;
		deck += 2;
		near += 2;
		clip <<= 1;
	    } else {
		clip <<= 2;
		i--;
		*deck = *near++;
		deck += 2;
		*deck = *near++;
		deck += 2;
	    }
	}

	clip--;

	fpnode_post->node = (ever & ~clip) >> seek | clip >> seek;

	fpnode_data->node =
	    Lx55555555 & (((QLNODE) 1 << (HALF_QLBITS + 1 - seek)) - 1);
    } else {
	QLNODE clip, fail;

	clip = 1;

	near = fpnode_post->star;

	*deck = *near;

	while (1) {
	    if (ever & clip) {
		deck = near + 2;
		*near = *deck;
		clip <<= 1;
		if (ever & clip) {
		    near = deck + 2;
		    *deck = *near;
		    clip <<= 1;
		} else {
		    *deck = *(deck + 1);

		    break;
		}
	    } else {
		*near = *(near + 1);

		break;
	    }
	}

	*lock = 1;

	fail = clip - 1;

	fpnode_post->node = (ever & fail) | clip | (ever & ~fail) >> 1;

	fpnode_data->node = Lx55555555;
    }
#endif				/* SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1) */

    return 0;
}
