/*
 * qlcp.6.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_cs12_qlrate(void *qlrate, unsigned index, void *sale, void *side,
		       QLNODE *news, void **push)

{
#if SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1)
#else
    unsigned *deck, half, i, *near;

    half = QLBITS * SIZEOF_UNSIGNED * 2 >> 1;

    deck = side;
    near = (unsigned *) ((char *) sale + half);

    if (index < QLBITS >> 1) {
	{
	    near -= 2;
	    *deck++ = *near++;
	    *deck++ = *near++;
	    *deck++ = *near++;
	    *deck++ = *near++;
	}
	i = (QLBITS >> 1) - 1;
	for (; i; i--) {
	    *deck++ = *near++;
	    *deck = *near++;
	    deck += 3;
	}

	deck = (unsigned *) ((char *) sale + (half << 1));
	near = (unsigned *) ((char *) sale + half);

	near -= 2;

	i = (QLBITS >> 1) - 1 - index;
	for (; i; i--) {
	    deck -= 3;
	    *deck = *--near;
	    *--deck = *--near;
	}

	{
	    deck -= 2 << 1;
	    *push = deck;
	}

	i = index;
	if (i) {
	    i--;
	    for (; i; i--) {
		deck -= 3;
		*deck = *--near;
		*--deck = *--near;
	    }
	}

	{
	    *news = (Lx55555555 & ~(QLNODE) 1) << 1;
	}
    } else {
	index -= QLBITS >> 1;

	if (index) {
	    *deck++ = *near++;
	    *deck = *near++;
	    deck += 3;
	} else {
	    deck += 2;
	    *deck++ = *near++;
	    *deck++ = *near++;
	}
	i = (QLBITS >> 1) - 1;
	for (; i; i--) {
	    *deck++ = *near++;
	    *deck = *near++;
	    deck += 3;
	}

	deck = (unsigned *) ((char *) sale + (half << 1));
	near = (unsigned *) ((char *) sale + half);

	i = (QLBITS >> 1) - 1;
	for (; i; i--) {
	    deck -= 3;
	    *deck = *--near;
	    *--deck = *--near;
	}

	if (index) {
	    *news = (Lx55555555 & (((QLNODE) 1 << (index - 1)) - 1))
		| (Lx55555555 & ~(QLNODE) 0 << (index - 1 + 1)) << 1;
	    *push = (char *) side + ((index << 1) - 1) * SIZEOF_UNSIGNED * 2;
	} else {
	    *news = (Lx55555555 & ~(QLNODE) 1) << 1;
	    *push = side;
	}
    }
#endif				/* SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1) */

    return 0;
}
