/*
 * qlcz.4.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <qlcc-lines.h>
#include <qlcc-names.h>
#include <qlcc-types.h>

#if SIZEOF_UNSIGNED == 4
# define RANGE_SHIFT			2
#endif				/* SIZEOF_UNSIGNED == 4 */

#if SIZEOF_UNSIGNED == 8
# define RANGE_SHIFT			3
#endif				/* SIZEOF_UNSIGNED == 8 */

#define qlrate(qlrate)			((struct qlrate_type *) (qlrate))

int
_libx1f4l2_rz10_qlrate(void *qlrate, unsigned index,
		       struct fpnode_type *fpnode_data,
		       struct fpnode_type *fpnode_last)
{
#if SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1)
#else
    unsigned *deck, *fast, j, mall, seek;

    mall = qlrate(qlrate)->link_a.fplist.mall;

    seek = mall >> RANGE_SHIFT;

    mall = seek >> 2;

    if (0) {
    } else {
	unsigned i;

	deck = fpnode_last->star;

	deck += seek;

	fast = deck + seek;

	i = HALF_QLBITS - 1;
	for (; i; i--) {
	    for (j = mall; j; j--) {
		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;
	    }

	    fast += seek;
	}

	fast = fpnode_data->star;

	i = index & ~1;
	for (; i; i--) {
	    for (j = mall; j; j--) {
		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;
	    }

	    fast += seek;
	}

	if (index & 1) {
	    for (j = mall; j; j--) {
		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;
	    }

	    fast += seek << 1;

	    index--;
	} else {
	    fast += seek << 1;
	    for (j = mall; j; j--) {
		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;
	    }
	}

	if (qlrate(qlrate)->link_a.fplist.size == QLBITS - 1) {
	} else {
	    deck += seek;
	}

	i = HALF_QLBITS - 2 - index;
	for (; i; i--) {
	    fast += seek;

	    for (j = mall; j; j--) {
		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;
		*deck++ = *fast++;
	    }
	}
    }

    fpnode_data->node = ~(QLNODE) 0;
    fpnode_last->node = (QLNODE) 1 << (HALF_QLBITS + index);
#endif				/* SIZEOF_UNSIGNED & (SIZEOF_UNSIGNED - 1) */

    return 0;
}
