/*
 * qxcc-config.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_qxcc_config_H__
#define __LIBx1f4_qxcc_config_H__

/*
 * insertion method definitions
 *
 * the SLICE method records direction choices (in the node records)
 */
#define __SLICE_INSERT__		1

#define __CLASS_INSERT__		__SLICE_INSERT__

#define ____CLASS_INSERT__		__CLASS_INSERT__

/*
 * deletion method definitions
 *
 * the SLICE method reverses pointers as it goes to point up instead of down.
 *     it also uses some of the node records to record direction choices.
 */
#define __SLICE_DELETE__		1
#define __TRACE_DELETE__		3

#define __CLASS_DELETE__		__SLICE_DELETE__

#define ____CLASS_DELETE__		__CLASS_DELETE__

#define __DELAY_MERGE__			1

#define __DELAY_SPLIT__			1

#define __BREADTH_FIRST__		1
#define __BREADTH_FIRST_DOUBLE_LAYERED__ \
					2
#define __BREADTH_FIRST_TRIPLE_LAYERED__ \
					3

#define __REFORM_MEMORY_LAYOUT__	__BREADTH_FIRST_TRIPLE_LAYERED__

#define ____REFORM_MEMORY_LAYOUT__	__REFORM_MEMORY_LAYOUT__

#endif				/* __LIBx1f4_qxcc_config_H__ */
