/*
 * qxcc-inter.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_qxcc_inter_H__
#define __LIBx1f4_qxcc_inter_H__

#include <qxcc-names.h>
#include <qxcc-types.h>

#if !defined _libx1f4l2_fast_qxrate
# define _libx1f4l2_fast_qxrate		x1f4_fast_qxrate
#endif				/* !_libx1f4l2_fast_qxrate */
#if !defined _libx1f4l2_flat_qxrate
# define _libx1f4l2_flat_qxrate		x1f4_flat_qxrate
#endif				/* !_libx1f4l2_flat_qxrate */

extern int _libx1f4l2_away_qxrate
    (void *, void *, unsigned, unsigned, unsigned, unsigned *, unsigned,
     unsigned *, void **);
extern int _libx1f4l2_beta_qxrate
    (void *, unsigned, void *, int, unsigned, unsigned *, void **);
extern int _libx1f4l2_bill_qxrate(void *, void *, unsigned, void *);
extern int _libx1f4l2_blue_qxrate(void *, void *);
extern int _libx1f4l2_ceil_qxrate(void *);
extern int _libx1f4l2_else_qxrate(void *, void *, unsigned *, void **);
extern int _libx1f4l2_fair_qxrate(void *, void *, unsigned *, void **);
extern int _libx1f4l2_fall_qxrate(void *);
extern int _libx1f4l2_fast_qxrate(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_flat_qxrate(void *);
extern int _libx1f4l2_gray_qxrate
    (void *, unsigned, void *, unsigned, unsigned *, void **);
extern int _libx1f4l2_lane_qxrate(void *, void *, void *, void **);
extern int _libx1f4l2_long_qxrate
    (void *, unsigned, unsigned, unsigned, unsigned, unsigned, unsigned,
     unsigned, unsigned *, void *);
extern int _libx1f4l2_mail_qxrate(void *, void *, unsigned, void *);
extern int _libx1f4l2_mold_qxrate(void *, void *, unsigned, unsigned *);
extern int _libx1f4l2_moon_qxrate(void *, void **);
extern int _libx1f4l2_rack_qxrate(void *, unsigned, void **);
extern int _libx1f4l2_root_qxrate(void *, void **);
extern int _libx1f4l2_sail_qxrate(void *, unsigned, unsigned);
extern int _libx1f4l2_trap_qxrate(void *, unsigned);
extern int _libx1f4l2_true_qxrate(unsigned *, unsigned);
extern int _libx1f4l2_type_qxrate(void *, unsigned, unsigned);

#endif				/* __LIBx1f4_qxcc_inter_H__ */
