/*
 * qxcc.4.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qxcc-bits.h>
#include <qxcc-defs.h>
#include <qxcc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qxrate(qxrate)			((struct qxrate_type *) (qxrate))

int
x1f4_peek_qxrate(void *qxrate, unsigned index, void **peek)
{
    int status;
    unsigned count;

    count = qxrate(qxrate)->link_a.fplist.size;

    if (!(index < count)) {
	status = DECK_ERROR;
    } else {
	unsigned rate, violet;
	void *node;

	node = qxrate(qxrate)->link_a.fplist.fpnode_data;

	status = 0;

	rate = qxrate(qxrate)->link_a.fplist.rate;

	violet = sizeof(unsigned) << 1 << qxrate(qxrate)->link_a.fplist.lock;

	while (rate) {
	    unsigned epnode, *lpnode;

	    lpnode = node;

	    epnode = P_ROOT(Q_NODE(node));

	    do {
		unsigned class, epslip;

		lpnode = M_TEXT(node, epnode);

		epslip = *lpnode;

		class = lpnode[1];
		if (index < class) {
		    epnode = L_LAST(epslip);
		} else {
		    epnode = L_NEXT(epslip);
		    index -= class;
		}
	    } while (epnode < violet);

	    if (1) {
		node = *(void **) M_TEXT(node, epnode);
		if (1) {
		    rate--;
		}
	    }
	}

	*peek = M_TEXT(node, index * qxrate(qxrate)->link_a.fplist.mall);
    }

    return status;
}
