/*
 * qxcc.h.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qxcc-bits.h>
#include <qxcc-defs.h>
#include <qxcc-inter.h>
#include <qxcc-names.h>
#include <qxcc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qxrate(qxrate)			((struct qxrate_type *) (qxrate))

int
_libx1f4l2_fall_qxrate(void *qxrate)
{
    int (*link) (void *, void **, unsigned), status;
    unsigned lock, rate, size;
    void *data, *fall;

    lock = qxrate(qxrate)->link_a.fplist.lock;

    data = qxrate(qxrate)->link_m.data;
    link = qxrate(qxrate)->link_m.link;

    rate = qxrate(qxrate)->link_a.fplist.rate;

    size = ((sizeof(unsigned) << 1) + sizeof(void *)) << lock;

    status = link(data, &fall, size);
    if (status) {
	status = LINK_ERROR;
    } else {
	void *mall;

	if (rate) {
	} else {
	    size = qxrate(qxrate)->link_a.fplist.line * 3
		* qxrate(qxrate)->link_a.fplist.mall >> 1;
	}

	status = link(data, &mall, size);
	if (status) {
	    status = LINK_ERROR;

	    qxrate(qxrate)->link_m.free(data, fall);
	} else {
	    {
		void **lise, *pick;

		_libx1f4l2_type_qxrate(fall, 1 << lock, sizeof(void *));
		_libx1f4l2_root_qxrate(fall, &pick);
		lise = pick;
		*lise = qxrate(qxrate)->link_a.fplist.fpnode_data;
		qxrate(qxrate)->link_a.fplist.fpnode_data = fall;
	    }

	    if (rate) {
		struct fplink_type *fplink_data;
		unsigned land;
		void *pick;

		fplink_data = mall;
		fplink_data->fplink_data =
		    qxrate(qxrate)->link_e.fplink_data;
		qxrate(qxrate)->link_e.fplink_data = mall;

		qxrate(qxrate)->link_a.fplist.rate = rate + 1;
		status = _libx1f4l2_gray_qxrate
		    (qxrate, rate, fall, ~0, &land, &pick);
		S_NODE(M_TEXT(fall, sizeof(unsigned)),
		       qxrate(qxrate)->link_a.fplist.size);
	    } else {
		qxrate(qxrate)->link_e.fplink_text = mall;

		qxrate(qxrate)->link_a.fplist.rate = 1;
		status = _libx1f4l2_blue_qxrate(qxrate, fall);
		S_NODE(M_TEXT(fall, sizeof(unsigned)),
		       3 * qxrate(qxrate)->link_a.fplist.line >> 1);
	    }
	}
    }

    return status;
}
