/*
 * qxcc.n.c
 * Copyright (C) 2008, 2009, 2010, 2011, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qxcc-config.h>

#include <stddef.h>
#include <string.h>

#include <qxcc-bits.h>
#include <qxcc-defs.h>
#include <qxcc-inter.h>
#include <qxcc-names.h>
#include <qxcc-types.h>

#define __SLICE_UPLINK__		1

#define ________UPLINK__		0

#if ____CLASS_DELETE__ == __SLICE_DELETE__
# define __CLASS_UPLINK__		__SLICE_UPLINK__
#else
# define __CLASS_UPLINK__		________UPLINK__
#endif				/* ____CLASS_DELETE__ == __SLICE_DELETE__ */

#define ____CLASS_UPLINK__		__CLASS_UPLINK__

#if ____CLASS_DELETE__ == __SLICE_DELETE__
# undef __CLASS_DELETE__
# define __CLASS_DELETE__		__TRACE_DELETE__
#endif				/* ____CLASS_DELETE__ == __SLICE_DELETE__ */

#define __SHORT_UPLINK__		2

#define __________LINK__		0

#if ____CLASS_DELETE__ == __TRACE_DELETE__
# define __BREAK_UPLINK__		__SHORT_UPLINK__
#else
# define __BREAK_UPLINK__		__________LINK__
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

#define ____BREAK_UPLINK__		__BREAK_UPLINK__

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
# define shift_break(fsnode, fxnode, fznode) \
    {									      \
	unsigned epslip;						      \
	void *lsslip;							      \
									      \
	lsslip = M_TEXT(node, fxnode);					      \
	epslip = Q_NODE(lsslip);					      \
	if (L_SIGN(epslip)) {						      \
	    fznode = L_LAST(epslip);					      \
	    S_NODE(lsslip, B_LAST(fsnode) | E_LAST(epslip));		      \
	} else {							      \
	    fznode = L_NEXT(epslip);					      \
	    S_NODE(lsslip, B_NEXT(fsnode) | E_NEXT(epslip));		      \
	}								      \
    }
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qxrate(qxrate)			((struct qxrate_type *) (qxrate))

int
_libx1f4l2_beta_qxrate(void *qxrate, unsigned rate, void *node, int lead,
		       unsigned index, unsigned *text, void **beta)
{
    int status;
#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
    unsigned efnode, elnode;
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */
#if ____CLASS_DELETE__ == __TRACE_DELETE__
    unsigned ehnode;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
    unsigned epnode, violet;

#if ____CLASS_DELETE__ == __TRACE_DELETE__
    ehnode = 0;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
    efnode = 0;
    elnode = 0;
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */

    epnode = P_ROOT(Q_NODE(node));

    violet = sizeof(unsigned) << 1 << qxrate(qxrate)->link_a.fplist.lock;

    index -= lead;

    while (1) {
	unsigned class, ennode, epslip;
	void *lpnode;

	lpnode = M_TEXT(node, epnode);

	if (1) {
	    epslip = Q_NODE(lpnode);

	    class = ((unsigned *) lpnode)[1];
	    if (index < class) {
		ennode = L_LAST(epslip);
#if ____CLASS_DELETE__ == __TRACE_DELETE__
		S_NODE(lpnode, F_SIGN(epslip));
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
	    } else {
		ennode = L_NEXT(epslip);
		index -= class;
#if ____CLASS_DELETE__ == __TRACE_DELETE__
		S_NODE(lpnode, E_SIGN(epslip));
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
	    }

	    if (ennode < violet) {
		lpnode = M_TEXT(node, ennode);

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
		if (Q_tilt_odd(epslip)) {
		} else {
		    efnode = elnode;
		    elnode = ehnode;
		}
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */

		if (1) {
		    epslip = Q_NODE(lpnode);

#if ____CLASS_DELETE__ == __TRACE_DELETE__
		    ehnode = ennode;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
		    ennode = epnode;
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */

		    class = ((unsigned *) lpnode)[1];
		    if (index < class) {
			epnode = L_LAST(epslip);
#if ____CLASS_DELETE__ == __TRACE_DELETE__
			S_NODE(lpnode, F_SIGN(epslip));
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
		    } else {
			epnode = L_NEXT(epslip);
			index -= class;
#if ____CLASS_DELETE__ == __TRACE_DELETE__
			S_NODE(lpnode, E_SIGN(epslip));
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
		    }

		    if (epnode < violet) {
#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
			if (Q_tilt_odd(epslip)) {
			} else {
			    efnode = elnode;
			    elnode = ennode;
			}
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */
		    } else {
#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
			efnode = elnode;
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */
			if (1) {
			    break;
			}
		    }
		}
	    } else {
#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
		efnode = elnode;
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */
#if ____CLASS_DELETE__ == __TRACE_DELETE__
		ehnode = epnode;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
		epnode = ennode;
		if (1) {
		    break;
		}
	    }
	}
    }

    index += lead;

    if (0) {
    } else {
#if ____CLASS_DELETE__ == __TRACE_DELETE__
	unsigned evnode;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
	if (efnode == 0) {
	    evnode = P_ROOT(Q_NODE(node));
	    S_NODE(node, E_SIGN(Q_NODE(node)));
	} else {
	    unsigned epslip;

	    epslip = Q_NODE(M_TEXT(node, efnode));
	    if (L_SIGN(epslip)) {
		evnode = L_LAST(epslip);
	    } else {
		evnode = L_NEXT(epslip);
	    }
	}
	ehnode = efnode;
	if (evnode == epnode) {
	} else {
	    while (1) {
		unsigned eqnode;

		shift_break(ehnode, evnode, eqnode);
		if (eqnode == epnode) {
		    if (1) {
			ehnode = evnode;
		    }

		    break;
		} else {
		    shift_break(evnode, eqnode, ehnode);
		    if (ehnode == epnode) {
			if (1) {
			    ehnode = eqnode;
			}

			break;
		    } else {
			shift_break(eqnode, ehnode, evnode);
			if (evnode == epnode) {
			    if (0) {
				ehnode = ehnode;
			    }

			    break;
			}
		    }
		}
	    }
	}
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */

	do {
	    unsigned eqnode, slip;

	    if (1) {
		unsigned epslip, esnode;
		void *fpnode;

		fpnode = *(void **) M_TEXT(node, epnode);

		epslip = Q_NODE(M_TEXT(node, ehnode));
		if (L_SIGN(epslip)) {
		    eqnode = L_NEXT(epslip);
		    esnode = L_LAST(epslip);
		    slip = 0;
		} else {
		    eqnode = L_LAST(epslip);
		    esnode = L_NEXT(epslip);
		    slip = 1;
		}

		if (rate) {
		    void *fqnode;

		    if (eqnode < violet) {
			void *tqnode;

			evnode = eqnode;

			tqnode = M_TEXT(node, eqnode);

			if (L_SIGN(epslip)) {
			    void **lqnode;

			    lqnode = M_TEXT(node, L_LAST(Q_NODE(tqnode)));

			    _libx1f4l2_lane_qxrate
				(qxrate, fpnode, *lqnode, lqnode);

			    fqnode = *lqnode;

#if __DELAY_MERGE__
			    S_NODE(M_TEXT(node, eqnode + sizeof(unsigned)),
				   Q_NODE(M_TEXT(fqnode, sizeof(unsigned))));
#else
			    S_NODE(M_TEXT(node, eqnode + sizeof(unsigned)),
				   Q_NODE(M_TEXT(fqnode, sizeof(unsigned)))
				   - 1);
#endif				/* __DELAY_MERGE__ */
			} else {
			    void **lqnode;

			    lqnode = M_TEXT(node, L_NEXT(Q_NODE(tqnode)));

			    fqnode = *lqnode;

			    *text += Q_NODE(M_TEXT(fqnode, sizeof(unsigned)));

			    _libx1f4l2_lane_qxrate
				(qxrate, fqnode, fpnode, lqnode);

			    fqnode = *lqnode;
			}
		    } else {
			void **lqnode;

			evnode = eqnode;

			lqnode = M_TEXT(node, eqnode);

			if (L_SIGN(epslip)) {
			    _libx1f4l2_lane_qxrate
				(qxrate, fpnode, *lqnode, lqnode);
			} else {
			    fqnode = *lqnode;

			    *text += Q_NODE(M_TEXT(fqnode, sizeof(unsigned)));

			    _libx1f4l2_lane_qxrate
				(qxrate, fqnode, fpnode, lqnode);
			}

			fqnode = *lqnode;
		    }

		    *beta = fqnode;
		} else {
		    unsigned line;

		    line = qxrate(qxrate)->link_a.fplist.line;

		    if (eqnode < violet) {
			unsigned mall;
			void *tqnode;

			evnode = eqnode;

			tqnode = M_TEXT(node, eqnode);

			mall = qxrate(qxrate)->link_a.fplist.mall;

			if (L_SIGN(epslip)) {
			    void *fqnode, **lise;

			    fqnode = *(void **)
				M_TEXT(node, L_LAST(Q_NODE(tqnode)));

			    S_NODE(M_TEXT(tqnode, sizeof(unsigned)), line - 1);

			    line >>= 1;
			    memmove(M_TEXT(fpnode, index * mall),
				    M_TEXT(fpnode, (index + 1) * mall),
				    (line - 1 - index) * mall);
			    memcpy(M_TEXT(fpnode, (line - 1) * mall), fqnode,
				   line * mall);

			    lise = M_TEXT(node, epnode);
			    *lise = fqnode;
			    lise = M_TEXT(node, L_LAST(Q_NODE(tqnode)));
			    *lise = fpnode;
			    fpnode = fqnode;
			} else {
			    void *fqnode;

			    fqnode = *(void **)
				M_TEXT(node, L_NEXT(Q_NODE(tqnode)));

			    line >>= 1;
			    memcpy(M_TEXT(fqnode, mall * line), fpnode,
				   index * mall);
			    memcpy(M_TEXT(fqnode, mall * (line + index)),
				   M_TEXT(fpnode, (index + 1) * mall),
				   (line - index - 1) * mall);
			}
		    } else {
			unsigned mall;
			void *fqnode;

			evnode = eqnode;

			fqnode = *(void **) M_TEXT(node, eqnode);

			mall = qxrate(qxrate)->link_a.fplist.mall;

			if (L_SIGN(epslip)) {
			    void **lise;

			    line >>= 1;
			    memmove(M_TEXT(fpnode, index * mall),
				    M_TEXT(fpnode, (index + 1) * mall),
				    (line - 1 - index) * mall);
			    memcpy(M_TEXT(fpnode, (line - 1) * mall), fqnode,
				   line * mall);

			    lise = M_TEXT(node, epnode);
			    *lise = fqnode;
			    lise = M_TEXT(node, eqnode);
			    *lise = fpnode;
			    fpnode = fqnode;
			} else {
			    line >>= 1;
			    memcpy(M_TEXT(fqnode, mall * line), fpnode,
				   index * mall);
			    memcpy(M_TEXT(fqnode, mall * (line + index)),
				   M_TEXT(fpnode, (index + 1) * mall),
				   (line - index - 1) * mall);
			}
		    }
		}

		{
		    unsigned list;
		    void *lhnode;

		    list = P_LIST(Q_NODE(node));
		    S_NODE(M_TEXT(node, epnode), list);
		    lhnode = M_TEXT(node, ehnode);
		    S_NODE(lhnode, epnode);
		    if (list) {
			S_NODE(M_TEXT(lhnode, sizeof(unsigned)),
			       Q_NODE(M_TEXT(node, list + sizeof(unsigned)))
			       + 1);
		    } else {
			S_NODE(M_TEXT(lhnode, sizeof(unsigned)), 0);
		    }

		    S_NODE(node,
			   B_LIST(ehnode) | L_SIGN(Q_NODE(node))
			   | M_ROOT(Q_NODE(node)));
		}

		{
		    if (1) {
			void *lsslip;

			lsslip = M_TEXT(node, esnode);

			if (L_SIGN(Q_NODE(lsslip))) {
			    slip = 0;
			} else {
			    slip = 1;
			}
		    }
		}

		ehnode = esnode;

		status = qxrate(qxrate)->link_m.free
		    (qxrate(qxrate)->link_m.data, fpnode);
		if (status) {
		    status = FREE_ERROR;
		}
	    }

	    while (1) {
#if ____CLASS_DELETE__ == __TRACE_DELETE__
		unsigned dana;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
		void *lqslip;

#if ____BREAK_UPLINK__ == __SHORT_UPLINK__
		if (ehnode == efnode) {
		    unsigned epslip;
		    void *lsslip;

		    lsslip = M_TEXT(node, ehnode);
		    epslip = Q_NODE(lsslip);
		    if (slip & 4095) {
			S_NODE(lsslip, B_NEXT(evnode) | E_NEXT(epslip));
		    } else {
			S_NODE(lsslip, B_LAST(evnode) | E_LAST(epslip));
		    }
#elif 0
		}
#elif __CLASS_DELETE__ == __TRACE_DELETE__
		if () {
#endif				/* ____BREAK_UPLINK__ == __SHORT_UPLINK__ */
#if ____CLASS_DELETE__ == __TRACE_DELETE__

		    break;
		} else {
		    unsigned epslip, skip;

		    skip = slip & 4096;

		    slip = slip & 4095;

		    eqnode = ehnode;
		    lqslip = M_TEXT(node, eqnode);
		    epslip = Q_NODE(lqslip);
		    if (L_SIGN(epslip)) {
			ehnode = L_LAST(epslip);
			S_NODE(lqslip, B_LAST(evnode) | E_LAST(epslip));
		    } else {
			ehnode = L_NEXT(epslip);
			S_NODE(lqslip, B_NEXT(evnode) | E_NEXT(epslip));
		    }

		    evnode = eqnode;

		    dana = slip;

#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
#if ____CLASS_UPLINK__ == __SLICE_UPLINK__
		    slip = X_SIGN(Q_NODE(M_TEXT(node, ehnode))) ^ 1;
#endif				/* ____CLASS_UPLINK__ == __SLICE_UPLINK__ */
#if ____CLASS_DELETE__ == __TRACE_DELETE__

		    slip = slip | skip;
		    if (slip & 4096) {
			continue;
		    }
		}
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */

#if ____CLASS_DELETE__ == __TRACE_DELETE__
		if (!dana) {
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
		    unsigned eqslip;

		    eqslip = Q_NODE(lqslip);

		    if (Q_TILT(eqslip, 0)) {
#if ____CLASS_DELETE__ == __TRACE_DELETE__
			slip |= 4096;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
			S_NODE(lqslip, B_TILT(1) | E_TILT(eqslip));
		    } else {
			if (Q_TILT(eqslip, 1)) {
			    unsigned exnode, exslip;
			    void *lxslip;

			    exnode = L_NEXT(eqslip);

			    lxslip = M_TEXT(node, exnode);

			    exslip = Q_NODE(lxslip);

			    if (Q_TILT(exslip, -1)) {
				unsigned ewnode, ewslip;
				void *lwslip;

				ewnode = L_LAST(exslip);

				lwslip = M_TEXT(node, ewnode);

				ewslip = Q_NODE(lwslip);

#if ____CLASS_DELETE__ == __TRACE_DELETE__
				evnode = ewnode;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
				ewnode = M_TILT(ewslip);
				if (H_TILT(ewnode, 1)) {
				    S_NODE(lxslip,
					   B_LAST(L_NEXT(ewslip))
					   | M_NEXT(exslip) | B_TILT(0));
				    S_NODE(lqslip,
					   M_LAST(eqslip)
					   | B_NEXT(L_LAST(ewslip))
					   | B_TILT(-1));
				} else {
				    if (H_TILT(ewnode, 0)) {
					S_NODE(lxslip,
					       B_LAST(L_NEXT(ewslip))
					       | M_NEXT(exslip) | B_TILT(0));
					S_NODE(lqslip,
					       M_LAST(eqslip)
					       | B_NEXT(L_LAST(ewslip))
					       | B_TILT(0));
				    } else {
					S_NODE(lxslip,
					       B_LAST(L_NEXT(ewslip))
					       | M_NEXT(exslip) | B_TILT(1));
					S_NODE(lqslip,
					       M_LAST(eqslip)
					       | B_NEXT(L_LAST(ewslip))
					       | B_TILT(0));
				    }
				}
				{
				    S_NODE(lwslip,
					   B_LAST(eqnode) | B_NEXT(exnode)
					   | B_TILT(0));
				}
				{
				    unsigned jwnode;

				    lqslip = M_TEXT(lqslip, sizeof(unsigned));
				    lwslip = M_TEXT(lwslip, sizeof(unsigned));
				    lxslip = M_TEXT(lxslip, sizeof(unsigned));
				    jwnode = Q_NODE(lwslip);
				    S_NODE(lxslip, Q_NODE(lxslip) - jwnode);
				    S_NODE(lwslip, jwnode + Q_NODE(lqslip));
				}
			    } else {
#if ____CLASS_DELETE__ == __TRACE_DELETE__
				evnode = exnode;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
				if (Q_tilt_odd(exslip)) {
				    S_NODE(lqslip,
					   M_LAST(eqslip)
					   | B_NEXT(L_LAST(exslip))
					   | B_TILT(0));
				    S_NODE(lxslip,
					   B_LAST(eqnode) | M_NEXT(exslip)
					   | B_TILT(0));
				} else {
				    S_NODE(lqslip,
					   M_LAST(eqslip)
					   | B_NEXT(L_LAST(exslip))
					   | B_TILT(1));
				    S_NODE(lxslip,
					   B_LAST(eqnode) | M_NEXT(exslip)
					   | B_TILT(-1));
#if ____CLASS_DELETE__ == __TRACE_DELETE__
				    slip |= 4096;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
				}
				{
				    lqslip = M_TEXT(lqslip, sizeof(unsigned));
				    lxslip = M_TEXT(lxslip, sizeof(unsigned));
				    S_NODE(lxslip,
					   Q_NODE(lxslip) + Q_NODE(lqslip));
				}
			    }
			} else {
			    S_NODE(lqslip, B_TILT(0) | E_TILT(eqslip));
			}
		    }
		} else {
		    unsigned eqslip;

		    eqslip = Q_NODE(lqslip);

		    if (Q_TILT(eqslip, 0)) {
#if ____CLASS_DELETE__ == __TRACE_DELETE__
			slip |= 4096;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
			S_NODE(lqslip, B_TILT(-1) | E_TILT(eqslip));
		    } else {
			if (Q_TILT(eqslip, -1)) {
			    unsigned exnode, exslip;
			    void *lxslip;

			    exnode = L_LAST(eqslip);

			    lxslip = M_TEXT(node, exnode);

			    exslip = Q_NODE(lxslip);

			    if (Q_TILT(exslip, 1)) {
				unsigned ewnode, ewslip;
				void *lwslip;

				ewnode = L_NEXT(exslip);

				lwslip = M_TEXT(node, ewnode);

				ewslip = Q_NODE(lwslip);

#if ____CLASS_DELETE__ == __TRACE_DELETE__
				evnode = ewnode;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
				ewnode = M_TILT(ewslip);
				if (H_TILT(ewnode, -1)) {
				    S_NODE(lxslip,
					   M_LAST(exslip)
					   | B_NEXT(L_LAST(ewslip))
					   | B_TILT(0));
				    S_NODE(lqslip,
					   B_LAST(L_NEXT(ewslip))
					   | M_NEXT(eqslip) | B_TILT(1));
				} else {
				    if (H_TILT(ewnode, 0)) {
					S_NODE(lxslip,
					       M_LAST(exslip)
					       | B_NEXT(L_LAST(ewslip))
					       | B_TILT(0));
					S_NODE(lqslip,
					       B_LAST(L_NEXT(ewslip))
					       | M_NEXT(eqslip) | B_TILT(0));
				    } else {
					S_NODE(lxslip,
					       M_LAST(exslip)
					       | B_NEXT(L_LAST(ewslip))
					       | B_TILT(-1));
					S_NODE(lqslip,
					       B_LAST(L_NEXT(ewslip))
					       | M_NEXT(eqslip) | B_TILT(0));
				    }
				}
				{
				    S_NODE(lwslip,
					   B_LAST(exnode) | B_NEXT(eqnode)
					   | B_TILT(0));
				}
				{
				    unsigned jwnode;

				    lqslip = M_TEXT(lqslip, sizeof(unsigned));
				    lwslip = M_TEXT(lwslip, sizeof(unsigned));
				    lxslip = M_TEXT(lxslip, sizeof(unsigned));
				    jwnode = Q_NODE(lwslip) + Q_NODE(lxslip);
				    S_NODE(lwslip, jwnode);
				    S_NODE(lqslip, Q_NODE(lqslip) - jwnode);
				}
			    } else {
#if ____CLASS_DELETE__ == __TRACE_DELETE__
				evnode = exnode;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
				if (Q_tilt_odd(exslip)) {
				    S_NODE(lqslip,
					   B_LAST(L_NEXT(exslip))
					   | M_NEXT(eqslip) | B_TILT(0));
				    S_NODE(lxslip,
					   M_LAST(exslip) | B_NEXT(eqnode)
					   | B_TILT(0));
				} else {
				    S_NODE(lqslip,
					   B_LAST(L_NEXT(exslip))
					   | M_NEXT(eqslip) | B_TILT(-1));
				    S_NODE(lxslip,
					   M_LAST(exslip) | B_NEXT(eqnode)
					   | B_TILT(1));
#if ____CLASS_DELETE__ == __TRACE_DELETE__
				    slip |= 4096;
#endif				/* ____CLASS_DELETE__ == __TRACE_DELETE__ */
				}
				{
				    lqslip = M_TEXT(lqslip, sizeof(unsigned));
				    lxslip = M_TEXT(lxslip, sizeof(unsigned));
				    S_NODE(lqslip,
					   Q_NODE(lqslip) - Q_NODE(lxslip));
				}
			    }
			} else {
			    S_NODE(lqslip, B_TILT(0) | E_TILT(eqslip));
			}
		    }
		}
	    }
	} while (0);
    }

    return status;
}
