/*
 * qxcc.y.c
 * Copyright (C) 2010-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qxcc-bits.h>
#include <qxcc-defs.h>
#include <qxcc-names.h>
#include <qxcc-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

#define qxrate(qxrate)			((struct qxrate_type *) (qxrate))

static int back_rate(struct qxrate_type *, void *, unsigned, unsigned,
		     unsigned);
static int flat_rate(struct qxrate_type *, void *, unsigned);

static int
back_rate(struct qxrate_type *qxrate_data, void *node, unsigned rate,
	  unsigned pick, unsigned violet)
{
    int excess, status = 0;

    do {
	unsigned slip, text;

	text = Q_NODE(M_TEXT(node, pick));

	slip = L_LAST(text);
	if (slip < violet) {
	    excess = back_rate(qxrate_data, node, rate, slip, violet);
	} else {
	    excess = flat_rate
		(qxrate_data, *(void **) M_TEXT(node, slip), rate);
	}
	if (excess) {
	    if (status) {
	    } else {
		status = FREE_ERROR;
	    }
	}

	pick = L_NEXT(text);
    } while (pick < violet);
    if (0) {
    } else {
	if (1) {
	    excess = flat_rate
		(qxrate_data, *(void **) M_TEXT(node, pick), rate);
	}
	if (excess) {
	    if (status) {
	    } else {
		status = FREE_ERROR;
	    }
	}
    }

    return status;
}


static int
flat_rate(struct qxrate_type *qxrate_data, void *node, unsigned rate)
{
    int excess, status;

    if (rate) {
	status = back_rate
	    (qxrate_data, node, rate - 1, P_ROOT(Q_NODE(node)),
	     sizeof(unsigned) << 1 << qxrate_data->link_a.fplist.lock);
    } else {
	status = 0;
    }

    excess = qxrate_data->link_m.free(qxrate_data->link_m.data, node);
    if (excess) {
	if (status) {
	} else {
	    status = FREE_ERROR;
	}
    }

    return status;
}


int
_libx1f4l2_ceil_qxrate(void *qxrate)
{
    int excess, status;
    unsigned rate;
    void *land;

    rate = qxrate(qxrate)->link_a.fplist.rate;
    if (rate) {
	void *node;

	node = qxrate(qxrate)->link_a.fplist.fpnode_data;
	status = back_rate
	    (qxrate, node, rate - 1, P_ROOT(Q_NODE(node)),
	     sizeof(unsigned) << 1 << qxrate(qxrate)->link_a.fplist.lock);
    } else {
	status = 0;
    }

    land = qxrate(qxrate)->link_e.fplink_text;
    if (land) {
	excess = qxrate(qxrate)->link_m.free
	    (qxrate(qxrate)->link_m.data, land);
	if (excess) {
	    if (status) {
	    } else {
		status = FREE_ERROR;
	    }
	}
    }

    land = qxrate(qxrate)->link_e.fplink_data;
    while (land) {
	struct fplink_type *fplink_data;

	fplink_data = ((struct fplink_type *) land)->fplink_data;

	excess = qxrate(qxrate)->link_m.free
	    (qxrate(qxrate)->link_m.data, land);
	if (excess) {
	    if (status) {
	    } else {
		status = FREE_ERROR;
	    }
	}

	land = fplink_data;
    }

    return status;
}
