/*
 * s3xx.2.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <s3xx-defs.h>
#include <s3xx-names.h>
#include <s3xx-types.h>

#define s3deck(s3deck)			((struct s3deck_type *) (s3deck))

static int free_list(struct fpnode_type *, void *, int (*) (void *, void *));
static int free_node(struct fpnode_type *, void *, int (*) (void *, void *));

static int
free_list(struct fpnode_type *fpnode_data, void *data,
	  int (*free) (void *, void *))
{
    int status;

    if (extant(fpnode_data)) {
	struct fpnode_type *fpnode_slip;
	unsigned size;

	size = spread(fpnode_data);

	fpnode_slip = (struct fpnode_type *) fpnode_data->data;

	fpnode_data = fpnode_slip;

	while (1) {
	    status = free_node(fpnode_data, data, free);
	    if (status) {
		break;
	    } else {
		size--;
		if (size) {
		    fpnode_data++;
		} else {
		    status = free(data, fpnode_slip);
		    if (status) {
			status = FREE_ERROR;
			if (2) {
			    break;
			}
		    } else {
			if (4) {
			    break;
			}
		    }
		}
	    }
	}
    } else {
	status = 0;
    }

    return status;
}


static int
free_node(struct fpnode_type *fpnode_data, void *data,
	  int (*free) (void *, void *))
{
    int status;

    if (1) {
	byte *base;

	base = fpnode_data->base;
	if (base) {
	    status = free(data, base);
	    if (status) {
		status = FREE_ERROR;
	    } else {
		status = free_list(fpnode_data, data, free);
	    }
	} else {
	    status = free_list(fpnode_data, data, free);
	}
    }

    return status;
}


int
x1f4_flat_s3deck(void *s3deck)
{
    int status;
    struct fpnode_type *fpnode_data;

    fpnode_data = s3deck(s3deck)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	status = free_node
	    (fpnode_data, s3deck(s3deck)->link_m.data,
	     s3deck(s3deck)->link_m.free);
	if (status) {
	} else {
	    status = s3deck(s3deck)->link_m.free
		(s3deck(s3deck)->link_m.data, fpnode_data);
	    if (status) {
		status = FREE_ERROR;
	    }
	}
    } else {
	status = 0;
    }

    return status;
}
