/*
 * s8xv.5.c
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <s8xx-defs.h>
#include <s8xx-names.h>
#include <s8xx-types.h>

#define fast(miss)			((const byte *) (miss))

#define s8deck(s8deck)			((struct s8deck_type *) (s8deck))

#define fpnode_data(fpnode) \
    ((struct fpnode_type **) ((struct fpnode_type *) (fpnode) + 1))

int
x1f4_find_s8path(void *s8deck, const char *name, unsigned size,
		 const void **data)
{
    int delete;
    struct fpnode_type *fpnode_data;

    fpnode_data = s8deck(s8deck)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	unsigned call, rate;

	size <<= 3;

	call = fpnode_data->data.call;
	while (call & POINT_CAST) {
	    rate = point_rate(call);
	    if (rate < size) {
		if (call & POINT_SEEK) {
		    fpnode_data = fpnode_data(fpnode_data)[1];
		} else {
		    fpnode_data = fpnode_data(fpnode_data)
			[name[rate >> 3] >> (7 - (rate & 7)) & 1];
		}
	    } else {
		do {
		    fpnode_data = fpnode_data(fpnode_data)[0];

		    call = fpnode_data->data.call;
		} while (call & POINT_CAST);

		break;
	    }

	    call = fpnode_data->data.call;
	}

	size >>= 3;

	if (call ^ size) {
	    delete = 0;
	} else {
	    delete = !memcmp((void **) (fpnode_data + 1) + 1, name, size);
	    if (delete) {
		*data = *(const void **) (fpnode_data + 1);
	    }
	}
    } else {
	delete = 0;
    }

    return delete;
}
