/*
 * scxi.j.c
 * Copyright (C) 2009-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <scxx-defs.h>
#include <scxx-names.h>
#include <scxx-types.h>

#define Null(___n) \
    ((___n) == (&scdeck(scdeck)->link_i.zero))

#define scdeck(scdeck)			((struct scdeck_type *) (scdeck))

int
_libx1f4l2_fail_scdeck(void *scdeck, struct fpnode_type *fpnode_data)
{
    int status;

    do {
	byte *base;

	base = fpnode_data->base;
	if (Null(base)) {
	} else {
	    status = scdeck(scdeck)->link_m.free
		(scdeck(scdeck)->link_m.data, base);
	    if (status) {
		status = FREE_ERROR;

		break;
	    }
	}

	status = scdeck(scdeck)->link_m.free
	    (scdeck(scdeck)->link_m.data, fpnode_data);
	if (status) {
	    status = FREE_ERROR;
	} else {
	    scdeck(scdeck)->link_a.fpdeck.fpnode_data = NULL;
	}
    } while (0);

    return status;
}
