/*
 * scxs.m.c
 * Copyright (C) 2009-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <scxx-names.h>
#include <scxx-patch.h>
#include <scxx-types.h>

#define fast(miss)			((const byte *) (miss))

#define scdeck(scdeck)			((struct scdeck_type *) (scdeck))

int
x1f4_llxd_scdeck(void *scdeck, const char *name, const void ***data)
{
    int delete;
    const struct fpnode_type *fpnode_data;

    fpnode_data = scdeck(scdeck)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	byte *slip;
	int e;
	const struct fpnode_type *fpnode_pick = NULL;

	slip = fpnode_data->base;
	e = prefix(fpnode_data);
	if (e) {
	    slip--;
	}

	while (1) {
	    int c;

	    c = *fast(name);
	    if (c) {
		name++;
		if (e) {
		    if (c == e) {
			slip++;
			if (1) {
			    e = *slip;
			}
		    } else {
			if (e < c) {
			    fpnode_pick = fpnode_data;
			}

			break;
		    }
		} else {
		    unsigned bits;

		    bits = fpnode_data->bits;
		    if (Extant(bits)) {
			const struct fpnode_type *fpnode_slip;
			unsigned effect;

			effect = Effect(bits);

			fpnode_slip = fpnode_data->data;
			fpnode_data = fpnode_slip;

			Progress_node(fpnode_data, effect);

			e = prefix(fpnode_data);
			if (e ^ c) {
			    if (c < e) {
				if (fpnode_data != fpnode_slip) {
				    fpnode_pick = fpnode_data - 1;
				}
			    } else {
				fpnode_pick = fpnode_data;
			    }

			    break;
			} else {
			    slip = fpnode_data->base;
			    if (1) {
				e = *slip;
				if (fpnode_data != fpnode_slip) {
				    fpnode_pick = fpnode_data - 1;
				}
			    }
			}
		    } else {
			if (1) {
			    fpnode_pick = fpnode_data;
			}

			break;
		    }
		}
	    } else {
		break;
	    }
	}

	if (fpnode_pick) {
	    delete = 1;

	    while (1) {
		unsigned bits;

		bits = fpnode_pick->bits;
		if (Extant(bits)) {
		    fpnode_pick = fpnode_pick->data;
		    fpnode_pick += Effect(bits);
		} else {
		    *data = (const void **) &fpnode_pick->data;
		    if (1) {
			break;
		    }
		}
	    }
	} else {
	    delete = 0;
	}
    } else {
	delete = 0;
    }

    return delete;
}
