/*
 * scxv.2.c
 * Copyright (C) 2009-2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <scxx-names.h>
#include <scxx-types.h>

#define scdeck(scdeck)			((struct scdeck_type *) (scdeck))

static int back_node(const struct fpnode_type *, void *,
		     int (*) (void *, unsigned, unsigned), unsigned);

static int
back_node(const struct fpnode_type *fpnode_data, void *back,
	  int (*call) (void *, unsigned, unsigned), unsigned scan)
{
    int delete;
    unsigned size;

    size = spread(fpnode_data);

    delete = call(back, scan, size);
    if (delete) {
    } else {
	fpnode_data = fpnode_data->data;

	scan++;

	while (1) {
	    if (extant(fpnode_data)) {
		delete = back_node(fpnode_data, back, call, scan);
		if (delete) {
		    break;
		}
	    }
	    {
		size--;
		if (size) {
		    fpnode_data++;
		} else {
		    break;
		}
	    }
	}
    }

    return delete;
}


int
x1f4_rush_scdeck(void *scdeck, void *back,
		 int (*call) (void *, unsigned, unsigned))
{
    int delete;
    struct fpnode_type *fpnode_data;

    fpnode_data = scdeck(scdeck)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	if (extant(fpnode_data)) {
	    delete = back_node(fpnode_data, back, call, 0);
	} else {
	    delete = 0;
	}
    } else {
	delete = 0;
    }

    return delete;
}
