/*
 * scxx.g.c
 * Copyright (C) 2009-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <scxx-defs.h>
#include <scxx-names.h>
#include <scxx-types.h>

#define back(miss)			((const char *) (miss))

#define scdeck(scdeck)			((struct scdeck_type *) (scdeck))

int
x1f4_lift_scdeck(void *scdeck, const void **data, void **sail, unsigned *high,
		 unsigned *ling)
{
    int status;
    const struct fpnode_type *fpnode_data;

    fpnode_data = scdeck(scdeck)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	char *path;
	unsigned line = 0, news;

	news = *ling;
	path = *sail;

	status = 0;

	while (1) {
	    unsigned bits;

	    bits = fpnode_data->bits;
	    if (Prefix(bits)) {
		byte *base;
		unsigned copy;

		base = fpnode_data->base;
		copy = Length(bits);
		if (copy < Record) {
		} else {
		    copy += strlen(back(base) + Record);
		}

		if (news < copy + 2) {
		    unsigned lane;

		    lane = line + copy + 2;
		    status = scdeck(scdeck)->link_m.mode
			(scdeck(scdeck)->link_m.data, sail, lane);
		    if (status) {
			status = MODE_ERROR;
			if (1) {
			    break;
			}
		    }

		    news = 1;

		    *ling = lane;
		    path = (char *) *sail + line;
		} else {
		    news--;
		    news -= copy;
		}

		*path++ = Prefix(bits);
		memcpy(path, base, copy);
		path += copy;
		copy++;
		line += copy;
	    }

	    if (Extant(bits)) {
		fpnode_data = fpnode_data->data;
	    } else {
		*path = 0;
		*high = line;
		*data = fpnode_data->data;
		if (1) {
		    break;
		}
	    }
	}
    } else {
	status = DECK_ERROR;
    }

    return status;
}
