/*
 * sfxu.3.c
 * Copyright (C) 2008-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <sfxx-names.h>
#include <sfxx-types.h>

#define sfdeck(sfdeck)			((struct sfdeck_type *) (sfdeck))

static int bank_list(struct fpnode_type *, void *,
		     int (*) (void *, const char *, unsigned));
static int bank_node(struct fpnode_type *, void *,
		     int (*) (void *, const char *, unsigned));

static int
bank_list(struct fpnode_type *fpnode_data, void *back,
	  int (*call) (void *, const char *, unsigned))
{
    int delete;
    struct fpnode_type *fpnode_slip;
    unsigned size;

    size = spread(fpnode_data);

    fpnode_slip = (struct fpnode_type *) fpnode_data->data;

    fpnode_data = fpnode_slip;

    while (1) {
	delete = bank_node(fpnode_data, back, call);
	if (delete) {
	    break;
	} else {
	    size--;
	    if (size) {
		fpnode_data++;
	    } else {
		break;
	    }
	}
    }

    return delete;
}


static int
bank_node(struct fpnode_type *fpnode_data, void *back,
	  int (*call) (void *, const char *, unsigned))
{
    int delete;

    if (1) {
	unsigned length;

	length = length(fpnode_data);
	if (sizeof(byte *) < length) {
	    char *base;

	    base = (char *) fpnode_data->base;

	    if (length < Record) {
	    } else {
		length += strlen(base + Record);
	    }

	    delete = call(back, base, length);
	    if (delete) {
	    } else {
		if (extant(fpnode_data)) {
		    delete = bank_list(fpnode_data, back, call);
		} else {
		    delete = 0;
		}
	    }
	} else {
	    if (extant(fpnode_data)) {
		delete = bank_list(fpnode_data, back, call);
	    } else {
		delete = 0;
	    }
	}
    }

    return delete;
}


int
x1f4_bank_sfdeck(void *sfdeck, void *back,
		 int (*call) (void *, const char *, unsigned))
{
    int delete;
    struct fpnode_type *fpnode_data;

    fpnode_data = sfdeck(sfdeck)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	if (extant(fpnode_data)) {
	    delete = bank_node(fpnode_data, back, call);
	} else {
	    delete = 0;
	}
    } else {
	delete = 0;
    }

    return delete;
}
