/*
 * sfxx.m.c
 * Copyright (C) 2009-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <sfxx-defs.h>
#include <sfxx-inter.h>
#include <sfxx-names.h>
#include <sfxx-types.h>

#define sfdeck(sfdeck)			((struct sfdeck_type *) (sfdeck))

static int fini_deck(void **);
static int init_deck(void **, struct sfdeck_type *);

static int
fini_deck(void **text)
{
    return _libx1f4l2_fini_sfdeck(text);
}


static int
init_deck(void **text, struct sfdeck_type *sfdeck_data)
{
    int status;
    struct screen_type screen;
    struct trans_type trans;

    screen.trans_data = &trans;

    trans.data = sfdeck_data->link_m.data;
    trans.free = sfdeck_data->link_m.free;
    trans.link = sfdeck_data->link_m.link;
    trans.mode = sfdeck_data->link_m.mode;

    status = _libx1f4l2_init_sfdeck(text, TRANS_MASK, &screen);

    return status;
}


int
x1f4_text_sfdeck(void **sfdeck, void *sctext,
		 int (*copy) (void *, const void **, const void *),
		 int (*free) (void *, const void *), void *context)
{
    int status;
    void *text;

    status = init_deck(&text, sctext);
    if (status) {
    } else {
	status = _libx1f4l2_rail_sfdeck(text, sctext, copy, free, context);
	if (status) {
	    fini_deck(&text);
	} else {
	    *sfdeck = text;
	}
    }

    return status;
}
