/*
 * sign.x.h
 * Copyright (C) 2006-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_sign_x_H__
#define __LIBx1f4_sign_x_H__

#include <config.h>

/* N -> +1, P -> _0 */
#define break_integer(___i) \
    ((unsigned) (___i) >> ((SIZEOF_UNSIGNED << 3) - 1))

/* N -> _0, P -> +1 */
#define class_integer(___i) \
    ((unsigned) (___i) >> ((SIZEOF_UNSIGNED << 3) - 1) ^ 1)

/* M -> +1, Q -> _0 */
#define index_integer(___i) \
    ((unsigned) ~((___i) | ((___i) - 1)) >> ((SIZEOF_UNSIGNED << 3) - 1) ^ 1)

/* N -> _0, P -> -1 */
#define scale_integer(___i) \
    ((int) ~(___i) >> ((SIZEOF_UNSIGNED << 3) - 1))

/* M -> _0, Q -> +1 */
#define trans_integer(___i) \
    ((unsigned) ~((___i) | ((___i) - 1)) >> ((SIZEOF_UNSIGNED << 3) - 1))

#endif				/* __LIBx1f4_sign_x_H__ */
