/*
 * sjxx-patch.h
 * Copyright (C) 2009-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_sjxx_patch_H__
#define __LIBx1f4_sjxx_patch_H__

#include <sjxx-types.h>

/*
 * `c' is expect not zero
 */
#define Dispatch_node(fpnode_data, bits, c, dispatch_miss) \
    {									      \
	unsigned size;							      \
									      \
	size = Effect(bits);						      \
	fpnode_data = (struct fpnode_type *) fpnode_data->data;		      \
	if (size < MIRROR_set) {					      \
	    byte *pick;							      \
									      \
	    pick = (void *) fpnode_data;				      \
	    pick += prefixof();						      \
	    while (size) {						      \
		byte *lock;						      \
		unsigned half;						      \
									      \
		half = (size + 1) >> 1;					      \
		lock = pick + half * sizeof(struct fpnode_type);	      \
		if (c < *lock) {					      \
		    size = half - 1;					      \
		} else {						      \
		    pick = lock;					      \
		    size -= half;					      \
		}							      \
	    }								      \
									      \
	    e = *pick;							      \
									      \
	    pick -= prefixof();						      \
	    fpnode_data = (void *) pick;				      \
									      \
	    if (e != c) {						      \
		dispatch_miss;						      \
	    } else {							      \
		slip = fpnode_data->base;				      \
		if (1) {						      \
		    e = *slip;						      \
		}							      \
	    }								      \
	} else {							      \
	    if (___c_type_X(___fplead(fpnode_data)->mirror, c)) {	      \
		if (c < 129) {						      \
		    if (c < 65) {					      \
			if (c < 33) {					      \
			    unsigned club;				      \
									      \
			    club = ___fplead(fpnode_data)->mirror[0];	      \
									      \
			    club &= (unsigned) ~0 >> (32 - c);		      \
									      \
			    club = (club & 0x55555555)			      \
				+ ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
			    club = (club & 0x00ff00ff)			      \
				+ ((club >> 0x08) & 0x00ff00ff);	      \
			    club = (club & 0x0000ffff)			      \
				+ ((club >> 0x10) & 0x0000ffff);	      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + club;	      \
			} else {					      \
			    unsigned club, deck;			      \
									      \
			    club = ___fplead(fpnode_data)->mirror[0];	      \
			    deck = ___fplead(fpnode_data)->mirror[1];	      \
									      \
			    deck &= (unsigned) ~0 >> (64 - c);		      \
									      \
			    deck = (deck & 0x55555555)			      \
				+ ((deck >> 0x01) & 0x55555555);	      \
			    deck = (deck & 0x33333333)			      \
				+ ((deck >> 0x02) & 0x33333333);	      \
									      \
			    club = (club & 0x55555555)			      \
				+ ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
									      \
			    club += deck;				      \
									      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
			    club = (club & 0x00ff00ff)			      \
				+ ((club >> 0x08) & 0x00ff00ff);	      \
			    club = (club & 0x0000ffff)			      \
				+ ((club >> 0x10) & 0x0000ffff);	      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + club;	      \
			}						      \
		    } else {						      \
			if (c < 97) {					      \
			    unsigned club, deck, ever;			      \
									      \
			    club = ___fplead(fpnode_data)->mirror[0];	      \
			    deck = ___fplead(fpnode_data)->mirror[1];	      \
			    ever = ___fplead(fpnode_data)->mirror[2];	      \
									      \
			    ever &= (unsigned) ~0 >> (96 - c);		      \
									      \
			    ever = (ever & 0x55555555)			      \
				+ ((ever >> 0x01) & 0x55555555);	      \
			    ever = (ever & 0x33333333)			      \
				+ ((ever >> 0x02) & 0x33333333);	      \
			    ever = (ever & 0x0f0f0f0f)			      \
				+ ((ever >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    deck = (deck & 0x55555555)			      \
				+ ((deck >> 0x01) & 0x55555555);	      \
			    deck = (deck & 0x33333333)			      \
				+ ((deck >> 0x02) & 0x33333333);	      \
									      \
			    club = (club & 0x55555555)			      \
				+ ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
									      \
			    club += deck;				      \
									      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    club += ever;				      \
									      \
			    club = (club & 0x00ff00ff)			      \
				+ ((club >> 0x08) & 0x00ff00ff);	      \
			    club = (club & 0x0000ffff)			      \
				+ ((club >> 0x10) & 0x0000ffff);	      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + club;	      \
			} else {					      \
			    unsigned club, deck, ever, fast;		      \
									      \
			    club = ___fplead(fpnode_data)->mirror[0];	      \
			    deck = ___fplead(fpnode_data)->mirror[1];	      \
			    ever = ___fplead(fpnode_data)->mirror[2];	      \
			    fast = ___fplead(fpnode_data)->mirror[3];	      \
									      \
			    fast &= (unsigned) ~0 >> (128 - c);		      \
									      \
			    fast = (fast & 0x55555555)			      \
				+ ((fast >> 0x01) & 0x55555555);	      \
			    fast = (fast & 0x33333333)			      \
				+ ((fast >> 0x02) & 0x33333333);	      \
									      \
			    ever = (ever & 0x55555555)			      \
				+ ((ever >> 0x01) & 0x55555555);	      \
			    ever = (ever & 0x33333333)			      \
				+ ((ever >> 0x02) & 0x33333333);	      \
									      \
			    ever += fast;				      \
									      \
			    ever = (ever & 0x0f0f0f0f)			      \
				+ ((ever >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    deck = (deck & 0x55555555)			      \
				+ ((deck >> 0x01) & 0x55555555);	      \
			    deck = (deck & 0x33333333)			      \
				+ ((deck >> 0x02) & 0x33333333);	      \
									      \
			    club = (club & 0x55555555)			      \
				+ ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
									      \
			    club += deck;				      \
									      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    club += ever;				      \
									      \
			    club = (club & 0x00ff00ff)			      \
				+ ((club >> 0x08) & 0x00ff00ff);	      \
			    club = (club & 0x0000ffff)			      \
				+ ((club >> 0x10) & 0x0000ffff);	      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + club;	      \
			}						      \
		    }							      \
		} else {						      \
		    size++;						      \
									      \
		    if (c < 192) {					      \
			if (c < 160) {					      \
			    unsigned club, deck, ever, fast;		      \
									      \
			    club = ___fplead(fpnode_data)->mirror[7];	      \
			    deck = ___fplead(fpnode_data)->mirror[6];	      \
			    ever = ___fplead(fpnode_data)->mirror[5];	      \
			    fast = ___fplead(fpnode_data)->mirror[4];	      \
									      \
			    fast &= (unsigned) ~0 << (c & 31);		      \
									      \
			    fast = (fast & 0x55555555)			      \
				+ ((fast >> 0x01) & 0x55555555);	      \
			    fast = (fast & 0x33333333)			      \
				+ ((fast >> 0x02) & 0x33333333);	      \
									      \
			    ever = (ever & 0x55555555)			      \
				+ ((ever >> 0x01) & 0x55555555);	      \
			    ever = (ever & 0x33333333)			      \
				+ ((ever >> 0x02) & 0x33333333);	      \
									      \
			    ever += fast;				      \
									      \
			    ever = (ever & 0x0f0f0f0f)			      \
				+ ((ever >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    deck = (deck & 0x55555555)			      \
				+ ((deck >> 0x01) & 0x55555555);	      \
			    deck = (deck & 0x33333333)			      \
				+ ((deck >> 0x02) & 0x33333333);	      \
									      \
			    club = (club & 0x55555555)			      \
				+ ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
									      \
			    club += deck;				      \
									      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    club += ever;				      \
									      \
			    club = (club & 0x00ff00ff)			      \
				+ ((club >> 0x08) & 0x00ff00ff);	      \
			    club = (club & 0x0000ffff)			      \
				+ ((club >> 0x10) & 0x0000ffff);	      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + (size - club); \
			} else {					      \
			    unsigned club, deck, ever;			      \
									      \
			    club = ___fplead(fpnode_data)->mirror[7];	      \
			    deck = ___fplead(fpnode_data)->mirror[6];	      \
			    ever = ___fplead(fpnode_data)->mirror[5];	      \
									      \
			    ever &= (unsigned) ~0 << (c & 31);		      \
									      \
			    ever = (ever & 0x55555555)			      \
				+ ((ever >> 0x01) & 0x55555555);	      \
			    ever = (ever & 0x33333333)			      \
				+ ((ever >> 0x02) & 0x33333333);	      \
			    ever = (ever & 0x0f0f0f0f)			      \
				+ ((ever >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    deck = (deck & 0x55555555)			      \
				+ ((deck >> 0x01) & 0x55555555);	      \
			    deck = (deck & 0x33333333)			      \
				+ ((deck >> 0x02) & 0x33333333);	      \
									      \
			    club = (club & 0x55555555)			      \
				+ ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
									      \
			    club += deck;				      \
									      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    club += ever;				      \
									      \
			    club = (club & 0x00ff00ff)			      \
				+ ((club >> 0x08) & 0x00ff00ff);	      \
			    club = (club & 0x0000ffff)			      \
				+ ((club >> 0x10) & 0x0000ffff);	      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + (size - club); \
			}						      \
		    } else {						      \
			if (c < 224) {					      \
			    unsigned club, deck;			      \
									      \
			    club = ___fplead(fpnode_data)->mirror[7];	      \
			    deck = ___fplead(fpnode_data)->mirror[6];	      \
									      \
			    deck &= (unsigned) ~0 << (c & 31);		      \
									      \
			    deck = (deck & 0x55555555)			      \
				+ ((deck >> 0x01) & 0x55555555);	      \
			    deck = (deck & 0x33333333)			      \
				+ ((deck >> 0x02) & 0x33333333);	      \
									      \
			    club = (club & 0x55555555)			      \
				+ ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
									      \
			    club += deck;				      \
									      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
			    club = (club & 0x00ff00ff)			      \
				+ ((club >> 0x08) & 0x00ff00ff);	      \
			    club = (club & 0x0000ffff)			      \
				+ ((club >> 0x10) & 0x0000ffff);	      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + (size - club); \
			} else {					      \
			    unsigned club;				      \
									      \
			    club = ___fplead(fpnode_data)->mirror[7];	      \
									      \
			    club &= (unsigned) ~0 << (c & 31);		      \
									      \
			    club = (club & 0x55555555)			      \
				+ ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
			    club = (club & 0x00ff00ff)			      \
				+ ((club >> 0x08) & 0x00ff00ff);	      \
			    club = (club & 0x0000ffff)			      \
				+ ((club >> 0x10) & 0x0000ffff);	      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + (size - club); \
			}						      \
		    }							      \
		}							      \
									      \
		slip = fpnode_data->base;				      \
		if (1) {						      \
		    e = *slip;						      \
		}							      \
	    } else {							      \
		dispatch_miss;						      \
	    }								      \
	}								      \
    }

#undef Dispatch_node

/*
 * `c' is expect not zero
 */
#define Dispatch_node(fpnode_data, bits, c, dispatch_miss) \
    {									      \
	unsigned size;							      \
									      \
	size = Effect(bits);						      \
	fpnode_data = (struct fpnode_type *) fpnode_data->data;		      \
	if (size < MIRROR_set) {					      \
	    byte *pick;							      \
									      \
	    pick = (void *) fpnode_data;				      \
	    pick += prefixof();						      \
	    while (size) {						      \
		byte *lock;						      \
		unsigned half;						      \
									      \
		half = (size + 1) >> 1;					      \
		lock = pick + half * sizeof(struct fpnode_type);	      \
		if (c < *lock) {					      \
		    size = half - 1;					      \
		} else {						      \
		    pick = lock;					      \
		    size -= half;					      \
		}							      \
	    }								      \
									      \
	    e = *pick;							      \
									      \
	    pick -= prefixof();						      \
	    fpnode_data = (void *) pick;				      \
									      \
	    if (e != c) {						      \
		dispatch_miss;						      \
	    } else {							      \
		slip = fpnode_data->base;				      \
		if (1) {						      \
		    e = *slip;						      \
		}							      \
	    }								      \
	} else {							      \
	    if (___c_type_X(___fplead(fpnode_data)->mirror, c)) {	      \
		if (c < 129) {						      \
		    if (c < 65) {					      \
			if (c < 33) {					      \
			    unsigned club;				      \
									      \
			    club = ___fplead(fpnode_data)->mirror[0];	      \
									      \
			    club &= (unsigned) ~0 >> (32 - c);		      \
									      \
			    club = (club)				      \
				- ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
			    club = (club + (club >> 0x04)) & 0x0f0f0f0f;      \
			    club = (club) + (club >> 8);		      \
			    club = (club) + (club >> 16);		      \
			    club = (club & 255);			      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + club;	      \
			} else {					      \
			    unsigned club, deck;			      \
									      \
			    club = ___fplead(fpnode_data)->mirror[0];	      \
			    deck = ___fplead(fpnode_data)->mirror[1];	      \
									      \
			    deck &= (unsigned) ~0 >> (64 - c);		      \
									      \
			    deck = (deck)				      \
				- ((deck >> 0x01) & 0x55555555);	      \
			    deck = (deck & 0x33333333)			      \
				+ ((deck >> 0x02) & 0x33333333);	      \
									      \
			    club = (club)				      \
				- ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
									      \
			    club += deck;				      \
									      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
			    club = (club) + (club >> 8);		      \
			    club = (club) + (club >> 16);		      \
			    club = (club & 255);			      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + club;	      \
			}						      \
		    } else {						      \
			if (c < 97) {					      \
			    unsigned club, deck, ever;			      \
									      \
			    club = ___fplead(fpnode_data)->mirror[0];	      \
			    deck = ___fplead(fpnode_data)->mirror[1];	      \
			    ever = ___fplead(fpnode_data)->mirror[2];	      \
									      \
			    ever &= (unsigned) ~0 >> (96 - c);		      \
									      \
			    ever = (ever)				      \
				- ((ever >> 0x01) & 0x55555555);	      \
			    ever = (ever & 0x33333333)			      \
				+ ((ever >> 0x02) & 0x33333333);	      \
			    ever = (ever + (ever >> 0x04)) & 0x0f0f0f0f;      \
									      \
			    deck = (deck)				      \
				- ((deck >> 0x01) & 0x55555555);	      \
			    deck = (deck & 0x33333333)			      \
				+ ((deck >> 0x02) & 0x33333333);	      \
									      \
			    club = (club)				      \
				- ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
									      \
			    club += deck;				      \
									      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    club += ever;				      \
									      \
			    club = (club) + (club >> 8);		      \
			    club = (club) + (club >> 16);		      \
			    club = (club & 255);			      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + club;	      \
			} else {					      \
			    unsigned club, deck, ever, fast;		      \
									      \
			    club = ___fplead(fpnode_data)->mirror[0];	      \
			    deck = ___fplead(fpnode_data)->mirror[1];	      \
			    ever = ___fplead(fpnode_data)->mirror[2];	      \
			    fast = ___fplead(fpnode_data)->mirror[3];	      \
									      \
			    fast &= (unsigned) ~0 >> (128 - c);		      \
									      \
			    fast = (fast)				      \
				- ((fast >> 0x01) & 0x55555555);	      \
			    fast = (fast & 0x33333333)			      \
				+ ((fast >> 0x02) & 0x33333333);	      \
									      \
			    ever = (ever)				      \
				- ((ever >> 0x01) & 0x55555555);	      \
			    ever = (ever & 0x33333333)			      \
				+ ((ever >> 0x02) & 0x33333333);	      \
									      \
			    ever += fast;				      \
									      \
			    ever = (ever & 0x0f0f0f0f)			      \
				+ ((ever >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    deck = (deck)				      \
				- ((deck >> 0x01) & 0x55555555);	      \
			    deck = (deck & 0x33333333)			      \
				+ ((deck >> 0x02) & 0x33333333);	      \
									      \
			    club = (club)				      \
				- ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
									      \
			    club += deck;				      \
									      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    club += ever;				      \
									      \
			    club = (club) + (club >> 8);		      \
			    club = (club) + (club >> 16);		      \
			    club = (club & 255);			      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + club;	      \
			}						      \
		    }							      \
		} else {						      \
		    size++;						      \
									      \
		    if (c < 192) {					      \
			if (c < 160) {					      \
			    unsigned club, deck, ever, fast;		      \
									      \
			    club = ___fplead(fpnode_data)->mirror[7];	      \
			    deck = ___fplead(fpnode_data)->mirror[6];	      \
			    ever = ___fplead(fpnode_data)->mirror[5];	      \
			    fast = ___fplead(fpnode_data)->mirror[4];	      \
									      \
			    fast &= (unsigned) ~0 << (c & 31);		      \
									      \
			    fast = (fast)				      \
				- ((fast >> 0x01) & 0x55555555);	      \
			    fast = (fast & 0x33333333)			      \
				+ ((fast >> 0x02) & 0x33333333);	      \
									      \
			    ever = (ever)				      \
				- ((ever >> 0x01) & 0x55555555);	      \
			    ever = (ever & 0x33333333)			      \
				+ ((ever >> 0x02) & 0x33333333);	      \
									      \
			    ever += fast;				      \
									      \
			    ever = (ever & 0x0f0f0f0f)			      \
				+ ((ever >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    deck = (deck)				      \
				- ((deck >> 0x01) & 0x55555555);	      \
			    deck = (deck & 0x33333333)			      \
				+ ((deck >> 0x02) & 0x33333333);	      \
									      \
			    club = (club)				      \
				- ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
									      \
			    club += deck;				      \
									      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    club += ever;				      \
									      \
			    club = (club) + (club >> 8);		      \
			    club = (club) + (club >> 16);		      \
			    club = (club & 255);			      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + (size - club); \
			} else {					      \
			    unsigned club, deck, ever;			      \
									      \
			    club = ___fplead(fpnode_data)->mirror[7];	      \
			    deck = ___fplead(fpnode_data)->mirror[6];	      \
			    ever = ___fplead(fpnode_data)->mirror[5];	      \
									      \
			    ever &= (unsigned) ~0 << (c & 31);		      \
									      \
			    ever = (ever)				      \
				- ((ever >> 0x01) & 0x55555555);	      \
			    ever = (ever & 0x33333333)			      \
				+ ((ever >> 0x02) & 0x33333333);	      \
			    ever = (ever + (ever >> 0x04)) & 0x0f0f0f0f;      \
									      \
			    deck = (deck)				      \
				- ((deck >> 0x01) & 0x55555555);	      \
			    deck = (deck & 0x33333333)			      \
				+ ((deck >> 0x02) & 0x33333333);	      \
									      \
			    club = (club)				      \
				- ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
									      \
			    club += deck;				      \
									      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
									      \
			    club += ever;				      \
									      \
			    club = (club) + (club >> 8);		      \
			    club = (club) + (club >> 16);		      \
			    club = (club & 255);			      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + (size - club); \
			}						      \
		    } else {						      \
			if (c < 224) {					      \
			    unsigned club, deck;			      \
									      \
			    club = ___fplead(fpnode_data)->mirror[7];	      \
			    deck = ___fplead(fpnode_data)->mirror[6];	      \
									      \
			    deck &= (unsigned) ~0 << (c & 31);		      \
									      \
			    deck = (deck)				      \
				- ((deck >> 0x01) & 0x55555555);	      \
			    deck = (deck & 0x33333333)			      \
				+ ((deck >> 0x02) & 0x33333333);	      \
									      \
			    club = (club)				      \
				- ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
									      \
			    club += deck;				      \
									      \
			    club = (club & 0x0f0f0f0f)			      \
				+ ((club >> 0x04) & 0x0f0f0f0f);	      \
			    club = (club) + (club >> 8);		      \
			    club = (club) + (club >> 16);		      \
			    club = (club & 255);			      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + (size - club); \
			} else {					      \
			    unsigned club;				      \
									      \
			    club = ___fplead(fpnode_data)->mirror[7];	      \
									      \
			    club &= (unsigned) ~0 << (c & 31);		      \
									      \
			    club = (club)				      \
				- ((club >> 0x01) & 0x55555555);	      \
			    club = (club & 0x33333333)			      \
				+ ((club >> 0x02) & 0x33333333);	      \
			    club = (club + (club >> 0x04)) & 0x0f0f0f0f;      \
			    club = (club) + (club >> 8);		      \
			    club = (club) + (club >> 16);		      \
			    club = (club & 255);			      \
									      \
			    fpnode_data = (struct fpnode_type *)	      \
				(___fplead(fpnode_data) + 1) + (size - club); \
			}						      \
		    }							      \
		}							      \
									      \
		slip = fpnode_data->base;				      \
		if (1) {						      \
		    e = *slip;						      \
		}							      \
	    } else {							      \
		dispatch_miss;						      \
	    }								      \
	}								      \
    }

#define backward_node(fpnode_data, mind) \
    {									      \
	byte *pick;							      \
	unsigned size;							      \
									      \
	size = (mind);							      \
	pick = (void *) (fpnode_data);					      \
	pick += prefixof();						      \
	while (size) {							      \
	    byte *lock;							      \
	    unsigned half;						      \
									      \
	    half = (size + 1) >> 1;					      \
	    lock = pick + half * sizeof(struct fpnode_type);		      \
	    if (c < *lock) {						      \
		size = half - 1;					      \
	    } else {							      \
		pick = lock;						      \
		size -= half;						      \
	    }								      \
	}								      \
									      \
	e = *pick;							      \
									      \
	pick -= prefixof();						      \
	fpnode_data = (void *) pick;					      \
    }

/*
 * `c' is expect not zero
 */
#define transfer_node(fpnode_data, mind, club) \
    {									      \
	if (c < 129) {							      \
	    if (c < 65) {						      \
		if (c < 33) {						      \
		    club = ___fplead(fpnode_data)->mirror[0];		      \
									      \
		    club &= (unsigned) ~0 >> (32 - c);			      \
									      \
		    club = (club & 0x55555555)				      \
			+ ((club >> 0x01) & 0x55555555);		      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
		    club = (club & 0x00ff00ff)				      \
			+ ((club >> 0x08) & 0x00ff00ff);		      \
		    club = (club & 0x0000ffff)				      \
			+ ((club >> 0x10) & 0x0000ffff);		      \
		} else {						      \
		    unsigned deck;					      \
									      \
		    club = ___fplead(fpnode_data)->mirror[0];		      \
		    deck = ___fplead(fpnode_data)->mirror[1];		      \
									      \
		    deck &= (unsigned) ~0 >> (64 - c);			      \
									      \
		    deck = (deck & 0x55555555)				      \
			+ ((deck >> 0x01) & 0x55555555);		      \
		    deck = (deck & 0x33333333)				      \
			+ ((deck >> 0x02) & 0x33333333);		      \
									      \
		    club = (club & 0x55555555)				      \
			+ ((club >> 0x01) & 0x55555555);		      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
									      \
		    club += deck;					      \
									      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
		    club = (club & 0x00ff00ff)				      \
			+ ((club >> 0x08) & 0x00ff00ff);		      \
		    club = (club & 0x0000ffff)				      \
			+ ((club >> 0x10) & 0x0000ffff);		      \
		}							      \
	    } else {							      \
		if (c < 97) {						      \
		    unsigned deck, ever;				      \
									      \
		    club = ___fplead(fpnode_data)->mirror[0];		      \
		    deck = ___fplead(fpnode_data)->mirror[1];		      \
		    ever = ___fplead(fpnode_data)->mirror[2];		      \
									      \
		    ever &= (unsigned) ~0 >> (96 - c);			      \
									      \
		    ever = (ever & 0x55555555)				      \
			+ ((ever >> 0x01) & 0x55555555);		      \
		    ever = (ever & 0x33333333)				      \
			+ ((ever >> 0x02) & 0x33333333);		      \
		    ever = (ever & 0x0f0f0f0f)				      \
			+ ((ever >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    deck = (deck & 0x55555555)				      \
			+ ((deck >> 0x01) & 0x55555555);		      \
		    deck = (deck & 0x33333333)				      \
			+ ((deck >> 0x02) & 0x33333333);		      \
									      \
		    club = (club & 0x55555555)				      \
			+ ((club >> 0x01) & 0x55555555);		      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
									      \
		    club += deck;					      \
									      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    club += ever;					      \
									      \
		    club = (club & 0x00ff00ff)				      \
			+ ((club >> 0x08) & 0x00ff00ff);		      \
		    club = (club & 0x0000ffff)				      \
			+ ((club >> 0x10) & 0x0000ffff);		      \
		} else {						      \
		    unsigned deck, ever, fast;				      \
									      \
		    club = ___fplead(fpnode_data)->mirror[0];		      \
		    deck = ___fplead(fpnode_data)->mirror[1];		      \
		    ever = ___fplead(fpnode_data)->mirror[2];		      \
		    fast = ___fplead(fpnode_data)->mirror[3];		      \
									      \
		    fast &= (unsigned) ~0 >> (128 - c);			      \
									      \
		    fast = (fast & 0x55555555)				      \
			+ ((fast >> 0x01) & 0x55555555);		      \
		    fast = (fast & 0x33333333)				      \
			+ ((fast >> 0x02) & 0x33333333);		      \
									      \
		    ever = (ever & 0x55555555)				      \
			+ ((ever >> 0x01) & 0x55555555);		      \
		    ever = (ever & 0x33333333)				      \
			+ ((ever >> 0x02) & 0x33333333);		      \
									      \
		    ever += fast;					      \
									      \
		    ever = (ever & 0x0f0f0f0f)				      \
			+ ((ever >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    deck = (deck & 0x55555555)				      \
			+ ((deck >> 0x01) & 0x55555555);		      \
		    deck = (deck & 0x33333333)				      \
			+ ((deck >> 0x02) & 0x33333333);		      \
									      \
		    club = (club & 0x55555555)				      \
			+ ((club >> 0x01) & 0x55555555);		      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
									      \
		    club += deck;					      \
									      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    club += ever;					      \
									      \
		    club = (club & 0x00ff00ff)				      \
			+ ((club >> 0x08) & 0x00ff00ff);		      \
		    club = (club & 0x0000ffff)				      \
			+ ((club >> 0x10) & 0x0000ffff);		      \
		}							      \
	    }								      \
	} else {							      \
	    if (c < 192) {						      \
		if (c < 160) {						      \
		    unsigned deck, ever, fast;				      \
									      \
		    club = ___fplead(fpnode_data)->mirror[7];		      \
		    deck = ___fplead(fpnode_data)->mirror[6];		      \
		    ever = ___fplead(fpnode_data)->mirror[5];		      \
		    fast = ___fplead(fpnode_data)->mirror[4];		      \
									      \
		    fast &= (unsigned) ~0 << (c & 31);			      \
									      \
		    fast = (fast & 0x55555555)				      \
			+ ((fast >> 0x01) & 0x55555555);		      \
		    fast = (fast & 0x33333333)				      \
			+ ((fast >> 0x02) & 0x33333333);		      \
									      \
		    ever = (ever & 0x55555555)				      \
			+ ((ever >> 0x01) & 0x55555555);		      \
		    ever = (ever & 0x33333333)				      \
			+ ((ever >> 0x02) & 0x33333333);		      \
									      \
		    ever += fast;					      \
									      \
		    ever = (ever & 0x0f0f0f0f)				      \
			+ ((ever >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    deck = (deck & 0x55555555)				      \
			+ ((deck >> 0x01) & 0x55555555);		      \
		    deck = (deck & 0x33333333)				      \
			+ ((deck >> 0x02) & 0x33333333);		      \
									      \
		    club = (club & 0x55555555)				      \
			+ ((club >> 0x01) & 0x55555555);		      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
									      \
		    club += deck;					      \
									      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    club += ever;					      \
									      \
		    club = (club & 0x00ff00ff)				      \
			+ ((club >> 0x08) & 0x00ff00ff);		      \
		    club = (club & 0x0000ffff)				      \
			+ ((club >> 0x10) & 0x0000ffff);		      \
		} else {						      \
		    unsigned deck, ever;				      \
									      \
		    club = ___fplead(fpnode_data)->mirror[7];		      \
		    deck = ___fplead(fpnode_data)->mirror[6];		      \
		    ever = ___fplead(fpnode_data)->mirror[5];		      \
									      \
		    ever &= (unsigned) ~0 << (c & 31);			      \
									      \
		    ever = (ever & 0x55555555)				      \
			+ ((ever >> 0x01) & 0x55555555);		      \
		    ever = (ever & 0x33333333)				      \
			+ ((ever >> 0x02) & 0x33333333);		      \
		    ever = (ever & 0x0f0f0f0f)				      \
			+ ((ever >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    deck = (deck & 0x55555555)				      \
			+ ((deck >> 0x01) & 0x55555555);		      \
		    deck = (deck & 0x33333333)				      \
			+ ((deck >> 0x02) & 0x33333333);		      \
									      \
		    club = (club & 0x55555555)				      \
			+ ((club >> 0x01) & 0x55555555);		      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
									      \
		    club += deck;					      \
									      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    club += ever;					      \
									      \
		    club = (club & 0x00ff00ff)				      \
			+ ((club >> 0x08) & 0x00ff00ff);		      \
		    club = (club & 0x0000ffff)				      \
			+ ((club >> 0x10) & 0x0000ffff);		      \
		}							      \
	    } else {							      \
		if (c < 224) {						      \
		    unsigned deck;					      \
									      \
		    club = ___fplead(fpnode_data)->mirror[7];		      \
		    deck = ___fplead(fpnode_data)->mirror[6];		      \
									      \
		    deck &= (unsigned) ~0 << (c & 31);			      \
									      \
		    deck = (deck & 0x55555555)				      \
			+ ((deck >> 0x01) & 0x55555555);		      \
		    deck = (deck & 0x33333333)				      \
			+ ((deck >> 0x02) & 0x33333333);		      \
									      \
		    club = (club & 0x55555555)				      \
			+ ((club >> 0x01) & 0x55555555);		      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
									      \
		    club += deck;					      \
									      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
		    club = (club & 0x00ff00ff)				      \
			+ ((club >> 0x08) & 0x00ff00ff);		      \
		    club = (club & 0x0000ffff)				      \
			+ ((club >> 0x10) & 0x0000ffff);		      \
		} else {						      \
		    club = ___fplead(fpnode_data)->mirror[7];		      \
									      \
		    club &= (unsigned) ~0 << (c & 31);			      \
									      \
		    club = (club & 0x55555555)				      \
			+ ((club >> 0x01) & 0x55555555);		      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
		    club = (club & 0x00ff00ff)				      \
			+ ((club >> 0x08) & 0x00ff00ff);		      \
		    club = (club & 0x0000ffff)				      \
			+ ((club >> 0x10) & 0x0000ffff);		      \
		}							      \
	    }								      \
									      \
	    club = (mind) - club;					      \
	}								      \
    }

#undef transfer_node

/*
 * `c' is expect not zero
 */
#define transfer_node(fpnode_data, mind, club) \
    {									      \
	if (c < 129) {							      \
	    if (c < 65) {						      \
		if (c < 33) {						      \
		    club = ___fplead(fpnode_data)->mirror[0];		      \
									      \
		    club &= (unsigned) ~0 >> (32 - c);			      \
									      \
		    club = (club) - ((club >> 0x01) & 0x55555555);	      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
		    club = (club + (club >> 0x04)) & 0x0f0f0f0f;	      \
		    club = (club) + (club >> 8);			      \
		    club = (club) + (club >> 16);			      \
		    club = (club & 255);				      \
		} else {						      \
		    unsigned deck;					      \
									      \
		    club = ___fplead(fpnode_data)->mirror[0];		      \
		    deck = ___fplead(fpnode_data)->mirror[1];		      \
									      \
		    deck &= (unsigned) ~0 >> (64 - c);			      \
									      \
		    deck = (deck) - ((deck >> 0x01) & 0x55555555);	      \
		    deck = (deck & 0x33333333)				      \
			+ ((deck >> 0x02) & 0x33333333);		      \
									      \
		    club = (club) - ((club >> 0x01) & 0x55555555);	      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
									      \
		    club += deck;					      \
									      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
		    club = (club) + (club >> 8);			      \
		    club = (club) + (club >> 16);			      \
		    club = (club & 255);				      \
		}							      \
	    } else {							      \
		if (c < 97) {						      \
		    unsigned deck, ever;				      \
									      \
		    club = ___fplead(fpnode_data)->mirror[0];		      \
		    deck = ___fplead(fpnode_data)->mirror[1];		      \
		    ever = ___fplead(fpnode_data)->mirror[2];		      \
									      \
		    ever &= (unsigned) ~0 >> (96 - c);			      \
									      \
		    ever = (ever) - ((ever >> 0x01) & 0x55555555);	      \
		    ever = (ever & 0x33333333)				      \
			+ ((ever >> 0x02) & 0x33333333);		      \
		    ever = (ever + (ever >> 0x04)) & 0x0f0f0f0f;	      \
									      \
		    deck = (deck) - ((deck >> 0x01) & 0x55555555);	      \
		    deck = (deck & 0x33333333)				      \
			+ ((deck >> 0x02) & 0x33333333);		      \
									      \
		    club = (club) - ((club >> 0x01) & 0x55555555);	      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
									      \
		    club += deck;					      \
									      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    club += ever;					      \
									      \
		    club = (club) + (club >> 8);			      \
		    club = (club) + (club >> 16);			      \
		    club = (club & 255);				      \
		} else {						      \
		    unsigned deck, ever, fast;				      \
									      \
		    club = ___fplead(fpnode_data)->mirror[0];		      \
		    deck = ___fplead(fpnode_data)->mirror[1];		      \
		    ever = ___fplead(fpnode_data)->mirror[2];		      \
		    fast = ___fplead(fpnode_data)->mirror[3];		      \
									      \
		    fast &= (unsigned) ~0 >> (128 - c);			      \
									      \
		    fast = (fast) - ((fast >> 0x01) & 0x55555555);	      \
		    fast = (fast & 0x33333333)				      \
			+ ((fast >> 0x02) & 0x33333333);		      \
									      \
		    ever = (ever) - ((ever >> 0x01) & 0x55555555);	      \
		    ever = (ever & 0x33333333)				      \
			+ ((ever >> 0x02) & 0x33333333);		      \
									      \
		    ever += fast;					      \
									      \
		    ever = (ever & 0x0f0f0f0f)				      \
			+ ((ever >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    deck = (deck) - ((deck >> 0x01) & 0x55555555);	      \
		    deck = (deck & 0x33333333)				      \
			+ ((deck >> 0x02) & 0x33333333);		      \
									      \
		    club = (club) - ((club >> 0x01) & 0x55555555);	      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
									      \
		    club += deck;					      \
									      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    club += ever;					      \
									      \
		    club = (club) + (club >> 8);			      \
		    club = (club) + (club >> 16);			      \
		    club = (club & 255);				      \
		}							      \
	    }								      \
	} else {							      \
	    if (c < 192) {						      \
		if (c < 160) {						      \
		    unsigned deck, ever, fast;				      \
									      \
		    club = ___fplead(fpnode_data)->mirror[7];		      \
		    deck = ___fplead(fpnode_data)->mirror[6];		      \
		    ever = ___fplead(fpnode_data)->mirror[5];		      \
		    fast = ___fplead(fpnode_data)->mirror[4];		      \
									      \
		    fast &= (unsigned) ~0 << (c & 31);			      \
									      \
		    fast = (fast) - ((fast >> 0x01) & 0x55555555);	      \
		    fast = (fast & 0x33333333)				      \
			+ ((fast >> 0x02) & 0x33333333);		      \
									      \
		    ever = (ever) - ((ever >> 0x01) & 0x55555555);	      \
		    ever = (ever & 0x33333333)				      \
			+ ((ever >> 0x02) & 0x33333333);		      \
									      \
		    ever += fast;					      \
									      \
		    ever = (ever & 0x0f0f0f0f)				      \
			+ ((ever >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    deck = (deck) - ((deck >> 0x01) & 0x55555555);	      \
		    deck = (deck & 0x33333333)				      \
			+ ((deck >> 0x02) & 0x33333333);		      \
									      \
		    club = (club) - ((club >> 0x01) & 0x55555555);	      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
									      \
		    club += deck;					      \
									      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    club += ever;					      \
									      \
		    club = (club) + (club >> 8);			      \
		    club = (club) + (club >> 16);			      \
		    club = (club & 255);				      \
		} else {						      \
		    unsigned deck, ever;				      \
									      \
		    club = ___fplead(fpnode_data)->mirror[7];		      \
		    deck = ___fplead(fpnode_data)->mirror[6];		      \
		    ever = ___fplead(fpnode_data)->mirror[5];		      \
									      \
		    ever &= (unsigned) ~0 << (c & 31);			      \
									      \
		    ever = (ever) - ((ever >> 0x01) & 0x55555555);	      \
		    ever = (ever & 0x33333333)				      \
			+ ((ever >> 0x02) & 0x33333333);		      \
		    ever = (ever + (ever >> 0x04)) & 0x0f0f0f0f;	      \
									      \
		    deck = (deck) - ((deck >> 0x01) & 0x55555555);	      \
		    deck = (deck & 0x33333333)				      \
			+ ((deck >> 0x02) & 0x33333333);		      \
									      \
		    club = (club) - ((club >> 0x01) & 0x55555555);	      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
									      \
		    club += deck;					      \
									      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
									      \
		    club += ever;					      \
									      \
		    club = (club) + (club >> 8);			      \
		    club = (club) + (club >> 16);			      \
		    club = (club & 255);				      \
		}							      \
	    } else {							      \
		if (c < 224) {						      \
		    unsigned deck;					      \
									      \
		    club = ___fplead(fpnode_data)->mirror[7];		      \
		    deck = ___fplead(fpnode_data)->mirror[6];		      \
									      \
		    deck &= (unsigned) ~0 << (c & 31);			      \
									      \
		    deck = (deck) - ((deck >> 0x01) & 0x55555555);	      \
		    deck = (deck & 0x33333333)				      \
			+ ((deck >> 0x02) & 0x33333333);		      \
									      \
		    club = (club) - ((club >> 0x01) & 0x55555555);	      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
									      \
		    club += deck;					      \
									      \
		    club = (club & 0x0f0f0f0f)				      \
			+ ((club >> 0x04) & 0x0f0f0f0f);		      \
		    club = (club) + (club >> 8);			      \
		    club = (club) + (club >> 16);			      \
		    club = (club & 255);				      \
		} else {						      \
		    club = ___fplead(fpnode_data)->mirror[7];		      \
									      \
		    club &= (unsigned) ~0 << (c & 31);			      \
									      \
		    club = (club) - ((club >> 0x01) & 0x55555555);	      \
		    club = (club & 0x33333333)				      \
			+ ((club >> 0x02) & 0x33333333);		      \
		    club = (club + (club >> 0x04)) & 0x0f0f0f0f;	      \
		    club = (club) + (club >> 8);			      \
		    club = (club) + (club >> 16);			      \
		    club = (club & 255);				      \
		}							      \
	    }								      \
									      \
	    club = (mind) - club;					      \
	}								      \
    }

#define dispatch_node(fpnode_data, bits, c) \
    Dispatch_node((fpnode_data), (bits), (c), ___dispatch_miss)

#define dispatch_slip(fpnode_data, bits, c) \
    Dispatch_node((fpnode_data), (bits), (c), ___dispatch_none)

#define ___fplead(fplead) \
    ((struct fplead_type *) (fplead))

#define ___c_type_X(___c_type_x, ___c) \
    ((___c_type_x)[(___c) >> 5] & 1 << ((___c) & 31))

#define ___dispatch_miss \
		delete = 0;						      \
		if (1) {						      \
		    break;						      \
		}

#define ___dispatch_none \
		status = 0;						      \
		if (1) {						      \
		    break;						      \
		}

#endif				/* __LIBx1f4_sjxx_patch_H__ */
