/*
 * sjxx.6.c
 * Copyright (C) 2009-2012, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <sjxx-defs.h>
#include <sjxx-inter.h>
#include <sjxx-names.h>
#include <sjxx-patch.h>
#include <sjxx-types.h>

#define fast(miss)			((const byte *) (miss))

#define sjdeck(sjdeck)			((struct sjdeck_type *) (sjdeck))

int
x1f4_pass_sjdeck(void *sjdeck, const char *name)
{
    int status;
    struct fpnode_type *fpnode_data, *fpnode_slip = NULL;

    fpnode_data = sjdeck(sjdeck)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	byte *slip;
	int e;

	slip = fpnode_data->base;
	e = prefix(fpnode_data);
	if (e) {
	    slip--;
	}

	while (1) {
	    int c;

	    c = *fast(name);
	    name++;
	    if (c) {
		if (e) {
		    if (c == e) {
			slip++;
			if (1) {
			    e = *slip;
			}
		    } else {
			status = 0;
			if (1) {
			    break;
			}
		    }
		} else {
		    unsigned bits;

		    bits = fpnode_data->bits;
		    if (Extant(bits)) {
			fpnode_slip = fpnode_data;
			dispatch_slip(fpnode_data, bits, c);
		    } else {
			status = 0;
			if (1) {
			    break;
			}
		    }
		}
	    } else {
		if (extant(fpnode_data)) {
		    if (e) {
			status = 0;
		    } else {
			fpnode_slip = fpnode_data;
			if (effect(fpnode_data) < MIRROR_set) {
			    fpnode_data = (struct fpnode_type *)
				fpnode_data->data;
			} else {
			    fpnode_data = (struct fpnode_type *)
				((struct fplead_type *) fpnode_data->data + 1);
			}
			if (prefix(fpnode_data)) {
			    if (1) {
				status = 0;
			    }
			} else {
			    status = _libx1f4l2_blue_sjdeck
				(sjdeck, fpnode_slip, fpnode_data);
			}
		    }
		} else {
		    if (e) {
			status = 0;
		    } else {
			if (fpnode_slip) {
			    status = _libx1f4l2_blue_sjdeck
				(sjdeck, fpnode_slip, fpnode_data);
			} else {
			    status = _libx1f4l2_fail_sjdeck
				(sjdeck, fpnode_data);
			}
		    }
		}

		break;
	    }
	}
    } else {
	status = 0;
    }

    return status;
}
