/*
 * slxx.6.c
 * Copyright (C) 2009, 2010, 2011, 2012, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <slxx-inter.h>
#include <slxx-names.h>
#include <slxx-patch.h>
#include <slxx-types.h>

#define back(miss)			((const char *) (miss))
#define fast(miss)			((const byte *) (miss))

#define sldeck(sldeck)			((struct sldeck_type *) (sldeck))

int
x1f4_pass_sldeck(void *sldeck, const char *name)
{
    int status;
    struct fpnode_type *fpnode_data, *fpnode_slip = NULL;

    fpnode_data = &sldeck(sldeck)->link_a.fpdeck.fpnode;
    if (vacant(fpnode_data)) {
	status = 0;
    } else {
	do {
	    byte *slip;
	    int e;
	    unsigned length;

	    e = prefix(fpnode_data);
	    if (e) {
		if (e ^ *fast(name)) {
		    status = 0;
		    if (1) {
			break;
		    }
		} else {
		    name++;
		    length = length(fpnode_data);
		    if (sizeof(byte *) < length) {
			slip = fpnode_data->base;
			if (length < Record) {
			} else {
			    length += strlen(back(slip) + Record);
			}
		    } else {
			slip = (byte *) &fpnode_data->base;
		    }
		}
	    } else {
		length = 0;
		slip = NULL;
	    }

	    while (1) {
		int c;

		c = *fast(name);
		if (c) {
		    name++;
		    if (length) {
			if (c == *slip) {
			    length--;
			    slip++;
			} else {
			    status = 0;
			    if (1) {
				break;
			    }
			}
		    } else {
			unsigned bits;

			bits = fpnode_data->bits;
			if (Extant(bits)) {
			    fpnode_slip = fpnode_data;

			    dispatch_slip(fpnode_data, bits, c);
			} else {
			    status = 0;
			    if (1) {
				break;
			    }
			}
		    }
		} else {
		    unsigned bits;

		    bits = fpnode_data->bits;
		    if (Extant(bits)) {
			if (length) {
			    status = 0;
			} else {
			    fpnode_slip = fpnode_data;
			    fpnode_data =
				(struct fpnode_type *) fpnode_data->data;
			    if (Target(bits)) {
				if (Offset(bits)) {
				    status = _libx1f4l2_blue_sldeck
					(sldeck, fpnode_slip, fpnode_data);
				} else {
				    status = 0;
				}
			    } else {
				if (prefix(fpnode_data)) {
				    if (1) {
					status = 0;
				    }
				} else {
				    status = _libx1f4l2_blue_sldeck
					(sldeck, fpnode_slip, fpnode_data);
				}
			    }
			}
		    } else {
			if (length) {
			    status = 0;
			} else {
			    if (fpnode_slip) {
				status = _libx1f4l2_blue_sldeck
				    (sldeck, fpnode_slip, fpnode_data);
			    } else {
				status = _libx1f4l2_fail_sldeck
				    (sldeck, fpnode_data);
			    }
			}
		    }

		    break;
		}
	    }
	} while (0);
    }

    return status;
}
