/*
 * tcmf.a.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <sign.x.h>
#include <tcmn-bits.h>
#include <tcmn-names.h>
#include <tcmn-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

static int find_list(void *, unsigned, void *, unsigned,
		     int (*) (void *, void *), void **);

static int
find_list(void *tcmini, unsigned node, void *text, unsigned offset,
	  int (*land) (void *, void *), void **find)
{
    offset += 4;

    while (1) {
	int slip;
	void *extend;

	extend = M_TEXT(tcmini, node);

	slip = land(text, M_TEXT(extend, offset));
	if (!slip) {
	    *find = (char *) extend + 4;

	    break;
	} else {
#if 0
	    node = L_NODE(Q_NODE(extend), scale_integer(slip));
#else
	    if (slip < 1) {
		node = L_LAST(Q_NODE(extend));
	    } else {
		node = L_NEXT(Q_NODE(extend));
	    }
#endif				/* 1 */
	}
    }

    return 1;
}


int
x1f4_look_tcmini(void *tcmini, void *text, unsigned slip,
		 int (*land) (void *, void *), void **find)
{
    return find_list(tcmini, P_ROOT(Q_NODE(tcmini)), text, slip, land, find);
}
