/*
 * tcmn-types.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_tcmn_types_H__
#define __LIBx1f4_tcmn_types_H__

/* translate value to code */
#define B_LAST(___n)			(___n)

#define B_LIST(___l)			(___l)

#define B_NEXT(___n)			((___n) << 18)

#define B_ROOT(___n)			((___n) << 18)

#define B_TILT(___e)			(((___e) + 2) << 15)

/* reset field in packet */
#define E_LAST(___b)			((___b) & ~((1 << 14) - 1))
#define E_NEXT(___b)			((___b) & ((1 << 18) - 1))

#define E_SIGN(___b)			((___b) & ~(1 << 14))

/* set field in packet */
#define F_SIGN(___b)			((___b) | (1 << 14))

/* test code for value */
#define H_TILT(___c, ___e)		((___c) == (((___e) + 2) << 15))

/* extract value from packet */
#define L_LAST(___b)			((___b) & ((1 << 14) - 1))
#define L_NEXT(___b)			((___b) >> 18)

#define L_NODE(___b, ___s) \
    ((___b) >> (18 & (___s)) & ((1 << 14) - 1))

#define L_SIGN(___b)			((___b) & (1 << 14))

/* packet field */
#define M_LAST(___b)			((___b) & ((1 << 14) - 1))
#define M_NEXT(___b)			((___b) & (((1 << 14) - 1) << 18))

#define M_LIST(___b)			((___b) & ((1 << 14) - 1))
#define M_ROOT(___b)			((___b) & (((1 << 14) - 1) << 18))

#define M_TILT(___b)			((___b) & (((1 << 3) - 1) << 15))

/* test packet field for value */
#define N_TILT(___b, ___e)		(M_TILT((___b)) ^ ((___e) + 2) << 15)

/* test packet field for value */
#define Q_TILT(___b, ___e)		(M_TILT((___b)) == ((___e) + 2) << 15)

#define Q_tilt_2m(___b)			(!((___b) & (((1 << 3) - 1) << 15)))
#define Q_tilt_2p(___b)			((___b) & ((1 << 2) << 15))

#define Q_tilt_odd(___b)		((___b) & (1 << 15))

/*
 * _list_ is assumed on the lowest bits.  as well, non _list_ bits are assumed
 * 0.
 */
/* extract value from packet */
#define P_ROOT(___b)			((___b) >> 18)
#define P_LIST(___b)			((___b) & ((1 << 14) - 1))

/* packet, field added 1 */
#define U_TILT(___b)			((___b) + (1 << 15))

/* packet, field subtracted 1 */
#define V_TILT(___b)			((___b) - (1 << 15))

/*
 * some values are assumed here and there.  some of the assumptions are marked
 * by VALUE ASSUMED comments.
 */

#endif				/* __LIBx1f4_tcmn_types_H__ */
