/*
 * tcmn.2.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcmn-config.h>

#include <tcmn-bits.h>
#include <tcmn-defs.h>
#include <tcmn-inter.h>
#include <tcmn-names.h>
#include <tcmn-types.h>

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

int
x1f4_port_tcmini(void *tcmini, void *text, int (*land) (void *, void *),
		 unsigned offset, void **push)
{
    int status = 0;
    unsigned epnode, eqnode, eznode, scnode;

    epnode = P_ROOT(Q_NODE(tcmini));
    eqnode = 0;

    offset += 4;

    eznode = eqnode;

#if ____CLASS_INSERT__ == __SLICE_INSERT__
    /*
     * VALUE ASSUMED (for root being recorded as right)
     */
    S_NODE(tcmini, F_SIGN(Q_NODE(tcmini)));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

    while (epnode) {
	int slip;
	unsigned ennode, epslip;
	void *lpnode;

	lpnode = M_TEXT(tcmini, epnode);

	slip = land(text, M_TEXT(lpnode, offset));

	if (slip) {
	    epslip = Q_NODE(lpnode);

	    if (slip < 0) {
		ennode = L_LAST(epslip);
#if ____CLASS_INSERT__ == __SLICE_INSERT__
		S_NODE(lpnode, E_SIGN(epslip));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */
	    } else {
		ennode = L_NEXT(epslip);
#if ____CLASS_INSERT__ == __SLICE_INSERT__
		S_NODE(lpnode, F_SIGN(epslip));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */
	    }

	    if (Q_tilt_odd(epslip)) {
		eznode = eqnode;
	    }

	    if (ennode) {
		lpnode = M_TEXT(tcmini, ennode);

		slip = land(text, M_TEXT(lpnode, offset));

		if (slip) {
		    epslip = Q_NODE(lpnode);

		    if (Q_tilt_odd(epslip)) {
			eznode = epnode;
		    }

		    eqnode = ennode;

		    if (slip < 0) {
			epnode = L_LAST(epslip);
#if ____CLASS_INSERT__ == __SLICE_INSERT__
			S_NODE(lpnode, E_SIGN(epslip));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */
		    } else {
			epnode = L_NEXT(epslip);
#if ____CLASS_INSERT__ == __SLICE_INSERT__
			S_NODE(lpnode, F_SIGN(epslip));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */
		    }
		} else {
		    status = EVER_MATCH;

		    *push = M_TEXT(tcmini, ennode + 4);

		    if (1) {
			break;
		    }
		}
	    } else {
		eqnode = epnode;
		if (1) {
		    break;
		}
	    }
	} else {
	    status = EVER_MATCH;

	    *push = M_TEXT(tcmini, epnode + 4);

	    if (1) {
		break;
	    }
	}
    }

    if (status) {
    } else {
	unsigned scmini;

	scmini = Q_NODE(tcmini);

	scnode = P_LIST(scmini);
	if (scnode) {
#if ____CLASS_INSERT__ == __SLICE_INSERT__
	    S_NODE(tcmini,
		   B_LIST(P_LIST(Q_NODE(M_TEXT(tcmini, scnode))))
		   | L_SIGN(scmini) | M_ROOT(scmini));
#elif __CLASS_INSERT__ == __TWICE_INSERT__
	    S_NODE(tcmini,
		   B_LIST(P_LIST(Q_NODE(M_TEXT(tcmini, scnode))))
		   | M_ROOT(scmini));
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */
	} else {
	    status = LINK_ERROR;
	}
    }

    if (status) {
    } else {
	unsigned epslip, exnode;

	*push = M_TEXT(tcmini, scnode + 4);

	S_NODE(M_TEXT(tcmini, scnode), B_TILT(0));

	epslip = Q_NODE(M_TEXT(tcmini, eznode));
	if (L_SIGN(epslip)) {
	    exnode = L_NEXT(epslip);
	} else {
	    exnode = L_LAST(epslip);
	}

	epslip = Q_NODE(M_TEXT(tcmini, eqnode));

#if ____CLASS_INSERT__ == __SLICE_INSERT__
	if (L_SIGN(epslip)) {
	    S_NODE(M_TEXT(tcmini, eqnode), epslip | B_NEXT(scnode));
	} else {
	    S_NODE(M_TEXT(tcmini, eqnode), epslip | B_LAST(scnode));
	}
#elif __CLASS_INSERT__ == __TWICE_INSERT__
	if (land(text, M_TEXT(tcmini, eqnode + offset)) < 0) {
	    S_NODE(M_TEXT(tcmini, eqnode), epslip | B_LAST(scnode));
	} else {
	    S_NODE(M_TEXT(tcmini, eqnode), epslip | B_NEXT(scnode));
	}
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

	if (exnode) {
	    epnode = exnode;

#if ____CLASS_INSERT__ == __SLICE_INSERT__
	    do {
		void *lpnode;

		lpnode = M_TEXT(tcmini, epnode);

		epslip = Q_NODE(lpnode);

		if (L_SIGN(epslip)) {
		    S_NODE(lpnode, U_TILT(epslip));
		    epnode = L_NEXT(epslip);
		} else {
		    S_NODE(lpnode, V_TILT(epslip));
		    epnode = L_LAST(epslip);
		}
	    } while (epnode != scnode);
#elif __CLASS_INSERT__ == __TWICE_INSERT__
	    do {
		void *lpnode;

		lpnode = M_TEXT(tcmini, epnode);

		epslip = Q_NODE(M_TEXT(tcmini, epnode));

		if (land(text, M_TEXT(lpnode, offset)) < 0) {
		    S_NODE(lpnode, V_TILT(epslip));
		    epnode = L_LAST(epslip);
		} else {
		    S_NODE(lpnode, U_TILT(epslip));
		    epnode = L_NEXT(epslip);
		}
	    } while (epnode != scnode);
#endif				/* ____CLASS_INSERT__ == __SLICE_INSERT__ */

	    epslip = Q_NODE(M_TEXT(tcmini, exnode));

	    if (Q_tilt_2m(epslip)) {
		if (1) {
		    unsigned esslip, evnode, ewnode;

		    evnode = L_LAST(epslip);

		    esslip = Q_NODE(M_TEXT(tcmini, evnode));

		    if (Q_TILT(esslip, -1)) {
			unsigned emnode;

			ewnode = evnode;
			emnode = L_NEXT(esslip);
			S_NODE(M_TEXT(tcmini, exnode),
			       B_LAST(emnode) | M_NEXT(epslip) | B_TILT(0));
			S_NODE(M_TEXT(tcmini, evnode),
			       M_LAST(esslip) | B_NEXT(exnode) | B_TILT(0));
		    } else {
			unsigned ebnode, ednode, emslip;

			ewnode = L_NEXT(esslip);

			emslip = Q_NODE(M_TEXT(tcmini, ewnode));

			ebnode = L_LAST(emslip);
			ednode = L_NEXT(emslip);
			emslip = M_TILT(emslip);
			S_NODE(M_TEXT(tcmini, ewnode),
			       B_LAST(evnode) | B_NEXT(exnode) | B_TILT(0));
			if (H_TILT(emslip, -1)) {
			    S_NODE(M_TEXT(tcmini, evnode),
				   M_LAST(esslip) | B_NEXT(ebnode)
				   | B_TILT(0));
			    S_NODE(M_TEXT(tcmini, exnode),
				   B_LAST(ednode) | M_NEXT(epslip)
				   | B_TILT(1));
			} else {
			    if (H_TILT(emslip, 0)) {
				S_NODE(M_TEXT(tcmini, evnode),
				       M_LAST(esslip) | B_NEXT(ebnode)
				       | B_TILT(0));
				S_NODE(M_TEXT(tcmini, exnode),
				       B_LAST(ednode) | M_NEXT(epslip)
				       | B_TILT(0));
			    } else {
				S_NODE(M_TEXT(tcmini, evnode),
				       M_LAST(esslip) | B_NEXT(ebnode)
				       | B_TILT(-1));
				S_NODE(M_TEXT(tcmini, exnode),
				       B_LAST(ednode) | M_NEXT(epslip)
				       | B_TILT(0));
			    }
			}
		    }

		    esslip = Q_NODE(M_TEXT(tcmini, eznode));

		    if (exnode == L_LAST(esslip)) {
			S_NODE(M_TEXT(tcmini, eznode),
			       B_LAST(ewnode) | M_NEXT(esslip)
			       | M_TILT(esslip));
		    } else {
			S_NODE(M_TEXT(tcmini, eznode),
			       M_LAST(esslip) | B_NEXT(ewnode)
			       | M_TILT(esslip));
		    }
		}
	    } else {
		if (Q_tilt_2p(epslip)) {
		    unsigned esslip, evnode, ewnode;

		    evnode = L_NEXT(epslip);

		    esslip = Q_NODE(M_TEXT(tcmini, evnode));

		    if (Q_TILT(esslip, 1)) {
			unsigned emnode;

			ewnode = evnode;
			emnode = L_LAST(esslip);
			S_NODE(M_TEXT(tcmini, exnode),
			       M_LAST(epslip) | B_NEXT(emnode) | B_TILT(0));
			S_NODE(M_TEXT(tcmini, evnode),
			       B_LAST(exnode) | M_NEXT(esslip) | B_TILT(0));
		    } else {
			unsigned ebnode, ednode, emslip;

			ewnode = L_LAST(esslip);

			emslip = Q_NODE(M_TEXT(tcmini, ewnode));

			ebnode = L_NEXT(emslip);
			ednode = L_LAST(emslip);
			emslip = M_TILT(emslip);
			S_NODE(M_TEXT(tcmini, ewnode),
			       B_LAST(exnode) | B_NEXT(evnode) | B_TILT(0));
			if (H_TILT(emslip, 1)) {
			    S_NODE(M_TEXT(tcmini, evnode),
				   B_LAST(ebnode) | M_NEXT(esslip)
				   | B_TILT(0));
			    S_NODE(M_TEXT(tcmini, exnode),
				   M_LAST(epslip) | B_NEXT(ednode)
				   | B_TILT(-1));
			} else {
			    if (H_TILT(emslip, 0)) {
				S_NODE(M_TEXT(tcmini, evnode),
				       B_LAST(ebnode) | M_NEXT(esslip)
				       | B_TILT(0));
				S_NODE(M_TEXT(tcmini, exnode),
				       M_LAST(epslip) | B_NEXT(ednode)
				       | B_TILT(0));
			    } else {
				/*
				 *      x+2                      w.0
				 *     /   \                    /   \
				 *    /     \                  /     \
				 *   /       \                /       \
				 * C.0       v-1            x+0       v+1
				 *          /   \          /   \     /   \
				 *         /     \        /     \   /     \
				 *       w-1     A.0    C.0    NEW *      A.0
				 *      /   \   /   \
				 *    NEW    * *     *
				 *
				 */
				S_NODE(M_TEXT(tcmini, evnode),
				       B_LAST(ebnode) | M_NEXT(esslip)
				       | B_TILT(1));
				S_NODE(M_TEXT(tcmini, exnode),
				       M_LAST(epslip) | B_NEXT(ednode)
				       | B_TILT(0));
			    }
			}
		    }

		    esslip = Q_NODE(M_TEXT(tcmini, eznode));

		    if (exnode == L_LAST(esslip)) {
			S_NODE(M_TEXT(tcmini, eznode),
			       B_LAST(ewnode) | M_NEXT(esslip)
			       | M_TILT(esslip));
		    } else {
			S_NODE(M_TEXT(tcmini, eznode),
			       M_LAST(esslip) | B_NEXT(ewnode)
			       | M_TILT(esslip));
		    }
		} else {
		}
	    }
	}
    }

    return status;
}
