/*
 * tcmn.7.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcmn-bits.h>
#include <tcmn-names.h>
#include <tcmn-types.h>

#define __UNBALANCED__			1

#define Delete				0

#define M_TEXT(___v, ___t) \
    ((void *) ((char *) (___v) + (___t)))

static int back_node(void *, unsigned, void *, int (*) (void *, void *));

static int
back_node(void *tcmini, unsigned node, void *back,
	  int (*call) (void *, void *))
{
    int delete;

    do {
	unsigned slip, text;

	text = Q_NODE(M_TEXT(tcmini, node));

	slip = L_LAST(text);
	if (slip) {
#if __UNBALANCED__
	    unsigned ever, miss;
#endif				/* __UNBALANCED__ */

#if __UNBALANCED__
	    miss = Q_NODE(M_TEXT(tcmini, slip));
#endif				/* __UNBALANCED__ */

#if __UNBALANCED__
	    ever = L_LAST(miss);
	    if (ever) {
		delete = back_node(tcmini, ever, back, call);
		if (delete) {
		    break;
		}
	    }
#endif				/* __UNBALANCED__ */

#if __UNBALANCED__
	    if (1) {
		delete = call(back, M_TEXT(tcmini, slip + 4));
		if (delete) {
		    break;
		}
	    }
#else
	    delete = back_node(tcmini, slip, back, call);
	    if (delete) {
		break;
	    }
#endif				/* __UNBALANCED__ */

#if __UNBALANCED__
	    ever = L_NEXT(miss);
	    if (ever) {
		delete = back_node(tcmini, ever, back, call);
		if (delete) {
		    break;
		}
	    }
#endif				/* __UNBALANCED__ */
	}

	if (1) {
	    delete = call(back, M_TEXT(tcmini, node + 4));
	    if (delete) {
		break;
	    }
	}

	slip = L_NEXT(text);
	if (slip) {
	    delete = back_node(tcmini, slip, back, call);
	    if (Delete) {
		break;
	    }
	}
    } while (0);

    return delete;
}


int
x1f4_lime_tcmini(void *tcmini, void *back, int (*call) (void *, void *))
{
    int delete;
    unsigned root;

    root = P_ROOT(Q_NODE(tcmini));
    if (root) {
	delete = back_node(tcmini, root, back, call);
    } else {
	delete = 0;
    }

    return delete;
}
