/*
 * tcxx.9.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcxx-defs.h>
#include <tcxx-inter.h>
#include <tcxx-names.h>
#include <tcxx-types.h>

#define tclist(tclist)			((struct tclist_type *) (tclist))

static int fast_list(struct tclist_type *, unsigned, unsigned);

static int
fast_list(struct tclist_type *tclist_data, unsigned index, unsigned class)
{
    int status;
    void *tcnode;

    status = _libx1f4l2_lose_tclist(tclist_data, index, &tcnode);
    if (status) {
    } else {
	if (index < class) {
	    class--;
	}

	status = _libx1f4l2_moon_tclist(tclist_data, class, tcnode);
	if (status) {
	    /*
	     * TODO/FEATURES
	     *
	     * some leakage here...
	     */
	}
    }

    return status;
}


int
x1f4_move_tclist(void *tclist, unsigned index, unsigned class)
{
    int status;
    unsigned count;

    count = tclist(tclist)->link_a.fplist.fplink.fqnode.size;

    if (!(index < count)) {
	status = DECK_ERROR;
    } else {
	if (count < class) {
	    status = DECK_ERROR;
	} else {
	    if (index == class) {
		status = 0;
	    } else {
		if (index + 1 == class) {
		    status = 0;
		} else {
		    status = fast_list(tclist, index, class);
		}
	    }
	}
    }

    return status;
}
