/*
 * tcxx.e.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcxx-defs.h>
#include <tcxx-inter.h>
#include <tcxx-names.h>
#include <tcxx-types.h>

#define tclist(tclist)			((struct tclist_type *) (tclist))

static int wind_list(struct tclist_type *, unsigned, struct tclist_type *,
		     unsigned);

static int
wind_list(struct tclist_type *tclist_data, unsigned index,
	  struct tclist_type *tclist_text, unsigned class)
{
    int status;
    void *tcnode;

    status = _libx1f4l2_lose_tclist(tclist_data, index, &tcnode);
    if (status) {
    } else {
	tclist_data->link_a.fplist.fplink.fqnode.size--;

	status = _libx1f4l2_moon_tclist(tclist_text, class, tcnode);
	if (status) {
	    /*
	     * TODO/FEATURES
	     *
	     * some leakage here...
	     */
	} else {
	    tclist_text->link_a.fplist.fplink.fqnode.size++;
	}
    }

    return status;
}


int
x1f4_wind_tclist(void *tcdata, unsigned index, void *tctext, unsigned class)
{
    int status;

    if (tcdata == tctext) {
	status = _libx1f4l2_move_tclist(tcdata, index, class);
    } else {
	if (!(index < tclist(tcdata)->link_a.fplist.fplink.fqnode.size)) {
	    status = DECK_ERROR;
	} else {
	    if (tclist(tctext)->link_a.fplist.fplink.fqnode.size < class) {
		status = DECK_ERROR;
	    } else {
		status = wind_list(tcdata, index, tctext, class);
	    }
	}
    }

    return status;
}
