/*
 * tcxy.8.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <stdlib.h>

#include <tcxx-inter.h>
#include <tcxx-names.h>
#include <tcxx-types.h>

#define tclist(tclist)			((struct tclist_type *) (tclist))

static int rand_list(struct tclist_type *, struct fpnode_type *);

static int
rand_list(struct tclist_type *tclist_data, struct fpnode_type *fpnode_data)
{
    struct fpnode_type *fqnode_data;
    unsigned size;

    fqnode_data = fpnode_data->fpnode_data[0];

    if (fqnode_data) {
	rand_list(tclist_data, fqnode_data);
    }

    fqnode_data = fpnode_data->fpnode_data[1];

    size = tclist_data->link_a.fplist.fplink.fqnode.size;

    size++;

    _libx1f4l2_moon_tclist(tclist_data, rand() % size, fpnode_data);

    tclist_data->link_a.fplist.fplink.fqnode.size = size;

    if (fqnode_data) {
	rand_list(tclist_data, fqnode_data);
    }

    return 0;
}


int
x1f4_rand_tclist(void *tclist)
{
    unsigned size;

    size = tclist(tclist)->link_a.fplist.fplink.fqnode.size;
    if (1 < size) {
	void *tvnode;

	tvnode = tclist(tclist)->link_a.fplist.fplink.fpnode_data[0];

	tclist(tclist)->link_a.fplist.fplink.fpnode_data[0] = NULL;
	tclist(tclist)->link_a.fplist.fplink.fqnode.size = 0;

	rand_list(tclist, tvnode);
    }

    return 0;
} 
