/*
 * tcxy.b.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tcxx-defs.h>
#include <tcxx-inter.h>
#include <tcxx-names.h>
#include <tcxx-types.h>

#define tclist(tclist)			((struct tclist_type *) (tclist))

typedef struct back_type {
    int (*call) (void *, void *);
    void *back, *list;
} back_type;

static int clip_list(void *, void *);

static int
clip_list(void *back, void *tcnode)
{
    int status;

    if (((struct back_type *) back)->call
	(((struct back_type *) back)->back,
	 ((struct fpnode_type *) tcnode) + 1)) {
	status = CALL_ERROR;
    } else {
	struct tclist_type *tclist_data;

	tclist_data = ((struct back_type *) back)->list;
	status = tclist_data->link_m.free(tclist_data->link_m.data, tcnode);
	if (status) {
	    status = FREE_ERROR;
	}
    }

    return status;
}


int
x1f4_pull_tclist(void *tclist, unsigned index, void *back,
		 int (*call) (void *, void *))
{
    int status;
    unsigned count;

    count = tclist(tclist)->link_a.fplist.fplink.fqnode.size;

    if (!(index < count)) {
	status = DECK_ERROR;
    } else {
	struct back_type nand;

	nand.list = tclist;

	nand.back = back;
	nand.call = call;

	status = _libx1f4l2_nand_tclist(tclist, index, &nand, clip_list);
	if (status) {
	} else {
	    tclist(tclist)->link_a.fplist.fplink.fqnode.size = count - 1;
	}
    }

    return status;
}
