/*
 * tfqb.9.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tfqp-defs.h>
#include <tfqp-inter.h>
#include <tfqp-names.h>
#include <tfqp-types.h>

#define tfline(tfline)			((struct tfline_type *) (tfline))

typedef struct back_type {
    int (*call) (void *, void *);
    void *back, *line;
} back_type;

static int shut_line(void *, void *);

static int
shut_line(void *back, void *tfnode)
{
    int status;

    if (((struct back_type *) back)->call
	(((struct back_type *) back)->back,
	 ((struct fpnode_type *) tfnode) + 1)) {
	status = CALL_ERROR;
    } else {
	struct tfline_type *tfline_data;

	tfline_data = ((struct back_type *) back)->line;
	status = tfline_data->link_m.free(tfline_data->link_m.data, tfnode);
	if (status) {
	    status = FREE_ERROR;
	}
    }

    return status;
}


int
x1f4_shut_tfline(void *tfline, void *text, int (*land) (void *, void *),
		 unsigned offset, void *back, int (*call) (void *, void *))
{
    int status;

    if (tfline(tfline)->link_a.fpline.fplink.fpnode_data[0]) {
	struct back_type nand;

	nand.line = tfline;

	nand.back = back;
	nand.call = call;

	status = _libx1f4l2_nand_tfline
	    (tfline, text, land, sizeof(struct fpnode_type) + offset, &nand,
	     shut_line);
	if (status) {
	    if (status == CALL_ERROR) {
		status = 0;
	    }
	}
    } else {
	status = MISS_CLASS;
    }

    return status;
}
