/*
 * tfqp.o.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <stdlib.h>

#include <tfqp-defs.h>
#include <tfqp-inter.h>
#include <tfqp-names.h>
#include <tfqp-types.h>

#define sLEFT(___size, ___node) \
    {									      \
	unsigned ___fine;						      \
									      \
	___fine = ___node->fqnode.fine;					      \
	if (___fine & 1) {						      \
	    unsigned ___swap;						      \
									      \
	    ___fine >>= 1;						      \
									      \
	    ___swap = ___size - 1 - ___fine;				      \
	    ___size = ___fine;						      \
									      \
	    ___node->fqnode.fine = ___swap << 1;			      \
	} else {							      \
	    ___size = ___size - 1 - (___fine >> 1);			      \
	}								      \
    }

#define sLESS(___size, ___node) \
    {									      \
	unsigned ___fine;						      \
									      \
	___fine = ___node->fqnode.fine;					      \
	if (___fine & 1) {						      \
	    ___size = ___size - 1 - (___fine >> 1);			      \
	} else {							      \
	    unsigned ___swap;						      \
									      \
	    ___fine >>= 1;						      \
									      \
	    ___swap = ___size - 1 - ___fine;				      \
	    ___size = ___fine;						      \
									      \
	    ___node->fqnode.fine = ___swap << 1 | 1;			      \
	}								      \
    }

#define tfline(tfline)			((struct tfline_type *) (tfline))

int
_libx1f4l2_nand_tfline(void *tfline, void *text, int (*land) (void *, void *),
		       unsigned offset, void *back,
		       int (*call) (void *, void *))
{
    int status;
    struct fpnode_type *fpnode_data, *fqnode_data = NULL;
    unsigned size, tilt = 0;

    size = tfline(tfline)->link_a.fpline.fplink.fqnode.fine >> 1;

    fpnode_data = tfline(tfline)->link_a.fpline.fplink.fpnode_data[0];

    while (1) {
	int fast;

	fast = land(text, (char *) fpnode_data + offset);

	if (fast) {
	    fqnode_data = fpnode_data;

	    if (fast < 0) {
		sLESS(size, fpnode_data);

		tilt = 0;

		fpnode_data = fpnode_data->fpnode_data[0];
	    } else {
		sLEFT(size, fpnode_data);

		tilt = 1;

		fpnode_data = fpnode_data->fpnode_data[1];
	    }

	    if (fpnode_data) {
	    } else {
		status = MISS_CLASS;
		if (1) {
		    break;
		}
	    }
	} else {
	    struct fpnode_type fpnode;

	    fpnode = *fpnode_data;

	    status = call(back, fpnode_data);
	    if (status) {
	    } else {
		unsigned fine, none;

		if (fpnode.fqnode.fine & 1) {
		    none = fpnode.fqnode.fine >> 1;
		    fine = size - 1 - none;
		} else {
		    fine = fpnode.fqnode.fine >> 1;
		    none = size - 1 - fine;
		}

		size = fine + none;

		if (size) {
		    struct fpnode_type *fbnode_data, *fdnode_data, **fpmiss;

		    fpmiss = &fpnode_data;

		    fbnode_data = fpnode.fpnode_data[0];
		    fdnode_data = fpnode.fpnode_data[1];

		    do {
			if (rand() % size < fine) {
			    *fpmiss = fbnode_data;
			    fpmiss = fbnode_data->fpnode_data + 1;

			    sLEFT(fine, fbnode_data);

			    fbnode_data = fpmiss[0];
			} else {
			    *fpmiss = fdnode_data;
			    fpmiss = fdnode_data->fpnode_data + 0;

			    sLESS(none, fdnode_data);

			    fdnode_data = fpmiss[0];
			}

			size = fine + none;
		    } while (size);
		} else {
		    fpnode_data = NULL;
		}

		tfline(tfline)->link_a.fpline.fplink.fqnode.fine -= 2;

		if (fqnode_data) {
		    fqnode_data->fpnode_data[tilt] = fpnode_data;
		} else {
		    tfline(tfline)->link_a.fpline.fplink.fpnode_data[0] =
			fpnode_data;
		}
	    }

	    if (1) {
		break;
	    }
	}
    }

    return status;
}
