/*
 * tnqp.o.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tnqp-config.h>

#include <stddef.h>

#include <tnqp-defs.h>
#include <tnqp-inter.h>
#include <tnqp-types.h>

#define aBLACK(fpnode, c) \
    ((fpnode)->fqnode.bits |= c)

#define dBLACK(fpnode, c) \
    (c = eBLACK(fpnode))

#define eBLACK(fpnode) \
    ((fpnode)->fqnode.bits & cBLACK)

#define fBLACK(fpnode) \
    ((fpnode)->fqnode.bits &= ~cBLACK)

#define sBLACK(fpnode) \
    ((fpnode)->fqnode.bits |= cBLACK)

#define tnline(tnline)			((struct tnline_type *) (tnline))

int
_libx1f4l2_nand_tnline(void *tnline, void *text, int (*land) (void *, void *),
		       unsigned offset, void *back,
		       int (*call) (void *, void *))
{
    int status = 0;
#if ____CLASS_DELETE__ == __STACK_DELETE__
    struct fpnode_type **fpmiss;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
    struct fpnode_type fpnode, *fpnode_data;
#if ____CLASS_DELETE__ == __STACK_DELETE__
    unsigned miss = 1, seek, size;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
#if ____CLASS_DELETE__ == __STACK_DELETE__
    unsigned char *data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

    fpnode_data = tnline(tnline)->link_a.fpline.fplink.fpnode_data[0];

#if ____CLASS_DELETE__ == __STACK_DELETE__
    data = tnline(tnline)->link_c.data;
    size = tnline(tnline)->link_c.size;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
    seek = tnline(tnline)->link_e.seek;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
    fpmiss = tnline(tnline)->link_e.fpmiss;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
    fpmiss[0] = &tnline(tnline)->link_a.fpline.fplink;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
    data[0] = 0;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

    while (1) {
	int fast;

	fast = land(text, (char *) fpnode_data + offset);

	if (fast) {
#if ____CLASS_DELETE__ == __STACK_DELETE__
	    if (miss == size) {
		status = _libx1f4l2_half_tnline(tnline, &data, &size);
		if (status) {
		    break;
		}
	    }
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
	    if (miss == seek) {
		status = _libx1f4l2_blue_tnline(tnline, &fpmiss, &seek);
		if (status) {
		    break;
		}
	    }
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
	    fpmiss[miss] = fpnode_data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

	    if (fast < 0) {
#if ____CLASS_DELETE__ == __STACK_DELETE__
		data[miss] = 0;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		miss++;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

		fpnode_data = fpnode_data->fpnode_data[0];
		if (fpnode_data) {
		} else {
		    status = MISS_CLASS;
		    if (1) {
			break;
		    }
		}
	    } else {
#if ____CLASS_DELETE__ == __STACK_DELETE__
		data[miss] = 1;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		miss++;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

		fpnode_data = fpnode_data->fpnode_data[1];
		if (fpnode_data) {
		} else {
		    status = MISS_CLASS;
		    if (1) {
			break;
		    }
		}
	    }
	} else {
	    if (1) {
		break;
	    }
	}
    }

    if (status) {
    } else {
	fpnode = *fpnode_data;

	status = call(back, fpnode_data);
    }

    if (status) {
#if 0
	if (status == MISS_CLASS) {
	    status = 0;
	}
#endif				/* 0 */
    } else {
	fpnode_data = &fpnode;

	do {
	    struct fpnode_type *fhnode_data;

	    fhnode_data = fpnode_data->fpnode_data[1];
	    if (fhnode_data) {
		struct fpnode_type *fjnode_data;

		fjnode_data = fhnode_data->fpnode_data[0];
		if (fjnode_data) {
		    struct fpnode_type *fqnode_data, *fsnode_data;
#if ____CLASS_DELETE__ == __STACK_DELETE__
		    unsigned fast;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
		    unsigned p, s;

#if ____CLASS_DELETE__ == __STACK_DELETE__
		    fast = miss;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		    if (miss == size) {
			status = _libx1f4l2_half_tnline(tnline, &data, &size);
			if (status) {
			    fpmiss[fast - 1]->fpnode_data[data[fast - 1]] =
				NULL;

			    break;
			}
		    }
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		    if (miss == seek) {
			status = _libx1f4l2_blue_tnline
			    (tnline, &fpmiss, &seek);
			if (status) {
			    fpmiss[fast - 1]->fpnode_data[data[fast - 1]] =
				NULL;

			    break;
			}
		    }
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		    miss++;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

		    fqnode_data = fhnode_data;

		    for (;;) {
#if ____CLASS_DELETE__ == __STACK_DELETE__
			if (miss == size) {
			    status = _libx1f4l2_half_tnline
				(tnline, &data, &size);
			    if (status) {
				fpmiss[fast - 1]->fpnode_data[data[fast - 1]] =
				    NULL;

				break;
			    }
			}
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
			if (miss == seek) {
			    status = _libx1f4l2_blue_tnline
				(tnline, &fpmiss, &seek);
			    if (status) {
				fpmiss[fast - 1]->fpnode_data[data[fast - 1]] =
				    NULL;

				break;
			    }
			}
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
			data[miss] = 0;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
			fpmiss[miss] = fqnode_data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
			miss++;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

			fsnode_data = fjnode_data;
			fjnode_data = fsnode_data->fpnode_data[0];
			if (fjnode_data) {
			    fqnode_data = fsnode_data;
			} else {
			    break;
			}
		    }

#if ____CLASS_DELETE__ == __STACK_DELETE__
		    if (status) {
			break;
		    }
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		    data[fast] = 1;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		    fpmiss[fast] = fsnode_data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		    fpmiss[fast - 1]->fpnode_data[data[fast - 1]] =
			fsnode_data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

		    fsnode_data->fpnode_data[0] = fpnode_data->fpnode_data[0];
		    fqnode_data->fpnode_data[0] = fsnode_data->fpnode_data[1];
		    fsnode_data->fpnode_data[1] = fhnode_data;

		    dBLACK(fpnode_data, p);
		    dBLACK(fsnode_data, s);
		    fBLACK(fpnode_data);
		    aBLACK(fpnode_data, s);
		    fBLACK(fsnode_data);
		    aBLACK(fsnode_data, p);
		} else {
		    unsigned h, p;

#if ____CLASS_DELETE__ == __STACK_DELETE__
		    if (miss == size) {
			status = _libx1f4l2_half_tnline(tnline, &data, &size);
			if (status) {
			    break;
			}
		    }
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		    data[miss] = 1;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		    if (miss == seek) {
			status = _libx1f4l2_blue_tnline
			    (tnline, &fpmiss, &seek);
			if (status) {
			    break;
			}
		    }
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

#if ____CLASS_DELETE__ == __STACK_DELETE__
		    fpmiss[miss] = fhnode_data;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */

		    fhnode_data->fpnode_data[0] = fpnode_data->fpnode_data[0];

		    dBLACK(fpnode_data, p);
		    dBLACK(fhnode_data, h);
		    fBLACK(fpnode_data);
		    aBLACK(fpnode_data, h);
		    fBLACK(fhnode_data);
		    aBLACK(fhnode_data, p);

		    fpmiss[miss - 1]->fpnode_data[data[miss - 1]] =
			fhnode_data;

#if ____CLASS_DELETE__ == __STACK_DELETE__
		    miss++;
#endif				/* ____CLASS_DELETE__ == __STACK_DELETE__ */
		}
	    } else {
		fpmiss[miss - 1]->fpnode_data[data[miss - 1]] =
		    fpnode_data->fpnode_data[0];
	    }

	    if (eBLACK(fpnode_data)) {
		struct fpnode_type *ffnode_data;

		ffnode_data = fpmiss[miss - 1];

		if (1) {
		    struct fpnode_type *fxnode_data;

		    fxnode_data = ffnode_data->fpnode_data[data[miss - 1]];
		    if (fxnode_data) {
			if (eBLACK(fxnode_data)) {
			} else {
			    sBLACK(fxnode_data);
			    if (1) {
				goto xj;
			    }
			}
		    }
		}

		for (;;) {
		    unsigned slip;

		    if (miss < 2) {
			break;
		    }

		    slip = 1;

		    if (data[miss - 1]) {
			struct fpnode_type *fvnode_data;

			fvnode_data = ffnode_data->fpnode_data[0];
			if (eBLACK(fvnode_data)) {
			} else {
			    sBLACK(fvnode_data);
			    fBLACK(ffnode_data);

			    ffnode_data->fpnode_data[0] =
				fvnode_data->fpnode_data[1];
			    fvnode_data->fpnode_data[1] = ffnode_data;
			    fpmiss[miss - 2]->fpnode_data[data[miss - 2]] =
				fvnode_data;

			    slip = 0;

			    fpmiss[miss - 1] = fvnode_data;

			    fvnode_data = ffnode_data->fpnode_data[0];
			}

			do {
			    struct fpnode_type *fbnode_data, *fynode_data;
			    unsigned f;

			    fbnode_data = fvnode_data->fpnode_data[0];
			    fynode_data = fvnode_data->fpnode_data[1];
			    if (fbnode_data) {
				if (eBLACK(fbnode_data)) {
				    if (fynode_data) {
					if (eBLACK(fynode_data)) {
					    fBLACK(fvnode_data);
					    if (1) {
						break;
					    }
					} else {
					    struct fpnode_type *fanode_data;

					    sBLACK(fynode_data);
					    fBLACK(fvnode_data);

					    fanode_data =
						fynode_data->fpnode_data[0];
					    fvnode_data->fpnode_data[1] =
						fanode_data;
					    fynode_data->fpnode_data[0] =
						fvnode_data;

					    fbnode_data = fvnode_data;

					    fvnode_data = fynode_data;

					    ffnode_data->fpnode_data[0] =
						fynode_data;
					}
				    } else {
					fBLACK(fvnode_data);
					if (1) {
					    break;
					}
				    }
				}
			    } else {
				if (fynode_data) {
				    if (eBLACK(fynode_data)) {
					fBLACK(fvnode_data);
					if (1) {
					    break;
					}
				    } else {
					struct fpnode_type *fanode_data;

					sBLACK(fynode_data);
					fBLACK(fvnode_data);

					fanode_data =
					    fynode_data->fpnode_data[0];
					fvnode_data->fpnode_data[1] =
					    fanode_data;
					fynode_data->fpnode_data[0] =
					    fvnode_data;

					fbnode_data = fvnode_data;

					fvnode_data = fynode_data;

					ffnode_data->fpnode_data[0] =
					    fynode_data;
				    }
				} else {
				    fBLACK(fvnode_data);
				    if (1) {
					break;
				    }
				}
			    }

			    dBLACK(ffnode_data, f);
			    fBLACK(fvnode_data);
			    aBLACK(fvnode_data, f);
			    sBLACK(ffnode_data);
			    sBLACK(fbnode_data);

			    fynode_data = fvnode_data->fpnode_data[1];
			    ffnode_data->fpnode_data[0] = fynode_data;
			    fvnode_data->fpnode_data[1] = ffnode_data;

			    miss -= 1;
			    miss -= slip;

			    fpmiss[miss]->fpnode_data[data[miss]] =
				fvnode_data;

			    goto xj;
			} while (0);
		    } else {
			struct fpnode_type *fvnode_data;

			fvnode_data = ffnode_data->fpnode_data[1];
			if (eBLACK(fvnode_data)) {
			} else {
			    sBLACK(fvnode_data);
			    fBLACK(ffnode_data);

			    ffnode_data->fpnode_data[1] =
				fvnode_data->fpnode_data[0];
			    fvnode_data->fpnode_data[0] = ffnode_data;
			    fpmiss[miss - 2]->fpnode_data[data[miss - 2]] =
				fvnode_data;

			    slip = 0;

			    fpmiss[miss - 1] = fvnode_data;

			    fvnode_data = ffnode_data->fpnode_data[1];
			}

			do {
			    struct fpnode_type *fbnode_data, *fynode_data;
			    unsigned f;

			    fbnode_data = fvnode_data->fpnode_data[1];
			    fynode_data = fvnode_data->fpnode_data[0];
			    if (fbnode_data) {
				if (eBLACK(fbnode_data)) {
				    if (fynode_data) {
					if (eBLACK(fynode_data)) {
					    fBLACK(fvnode_data);
					    if (1) {
						break;
					    }
					} else {
					    struct fpnode_type *fanode_data;

					    sBLACK(fynode_data);
					    fBLACK(fvnode_data);

					    fanode_data =
						fynode_data->fpnode_data[1];
					    fvnode_data->fpnode_data[0] =
						fanode_data;
					    fynode_data->fpnode_data[1] =
						fvnode_data;

					    fbnode_data = fvnode_data;

					    fvnode_data = fynode_data;

					    ffnode_data->fpnode_data[1] =
						fynode_data;
					}
				    } else {
					fBLACK(fvnode_data);
					if (1) {
					    break;
					}
				    }
				}
			    } else {
				if (fynode_data) {
				    if (eBLACK(fynode_data)) {
					fBLACK(fvnode_data);
					if (1) {
					    break;
					}
				    } else {
					struct fpnode_type *fanode_data;

					sBLACK(fynode_data);
					fBLACK(fvnode_data);

					fanode_data =
					    fynode_data->fpnode_data[1];
					fvnode_data->fpnode_data[0] =
					    fanode_data;
					fynode_data->fpnode_data[1] =
					    fvnode_data;

					fbnode_data = fvnode_data;

					fvnode_data = fynode_data;

					ffnode_data->fpnode_data[1] =
					    fynode_data;
				    }
				} else {
				    fBLACK(fvnode_data);
				    if (1) {
					break;
				    }
				}
			    }

			    dBLACK(ffnode_data, f);
			    fBLACK(fvnode_data);
			    aBLACK(fvnode_data, f);
			    sBLACK(ffnode_data);
			    sBLACK(fbnode_data);

			    fynode_data = fvnode_data->fpnode_data[0];
			    ffnode_data->fpnode_data[1] = fynode_data;
			    fvnode_data->fpnode_data[0] = ffnode_data;

			    miss -= 1;
			    miss -= slip;

			    fpmiss[miss]->fpnode_data[data[miss]] =
				fvnode_data;

			    goto xj;
			} while (0);
		    }

		    if (eBLACK(ffnode_data)) {
		    } else {
			sBLACK(ffnode_data);
			if (1) {
			    break;
			}
		    }

		    miss -= slip;

		    ffnode_data = fpmiss[miss - 1];
		}

	      xj:
		;
	    }
	} while (0);
    }

    return status;
}
