/*
 * tqqb.9.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tqqp-defs.h>
#include <tqqp-inter.h>
#include <tqqp-types.h>

#define tqline(tqline)			((struct tqline_type *) (tqline))

typedef struct back_type {
    int (*call) (void *, void *);
    void *back, *line;
} back_type;

static int shut_line(void *, void *);

static int
shut_line(void *back, void *tqnode)
{
    int status;

    if (((struct back_type *) back)->call
	(((struct back_type *) back)->back,
	 ((struct fpnode_type *) tqnode) + 1)) {
	status = CALL_ERROR;
    } else {
	struct tqline_type *tqline_data;

	tqline_data = ((struct back_type *) back)->line;
	status = tqline_data->link_m.free(tqline_data->link_m.data, tqnode);
	if (status) {
	    status = FREE_ERROR;
	}
    }

    return status;
}


int
x1f4_shut_tqline(void *tqline, void *text, int (*land) (void *, void *),
		 unsigned offset, void *back, int (*call) (void *, void *))
{
    int status;

    if (tqline(tqline)->link_a.fpline.fplink.fpnode_data[0]) {
	struct back_type nand;

	nand.line = tqline;

	nand.back = back;
	nand.call = call;

	status = _libx1f4l2_nand_tqline
	    (tqline, text, land, sizeof(struct fpnode_type) + offset, &nand,
	     shut_line);
	if (status) {
	    if (status == CALL_ERROR) {
		status = 0;
	    }
	}
    } else {
	status = MISS_CLASS;
    }

    return status;
}
