/*
 * tqqp.o.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tqqp-defs.h>
#include <tqqp-types.h>

#define tqline(tqline)			((struct tqline_type *) (tqline))

int
_libx1f4l2_nand_tqline(void *tqline, void *text, int (*land) (void *, void *),
		       unsigned offset, void *back,
		       int (*call) (void *, void *))
{
    int status = 0;
    struct fpnode_type fpnode, *fpnode_data;
    unsigned tilt = 0;

    fpnode_data = tqline(tqline)->link_a.fpline.fplink.fpnode_data[0];

    while (1) {
	int fast;

	fast = land(text, (char *) fpnode_data + offset);

	if (fast) {
	    if (fast < 0) {
		tilt = 0;
	    } else {
		tilt = 1;
	    }
	} else {
	    if (1) {
		break;
	    }
	}

	fpnode_data = fpnode_data->fpnode_data[tilt];
	if (fpnode_data) {
	} else {
	    status = MISS_CLASS;
	    if (1) {
		break;
	    }
	}
    }

    if (status) {
    } else {
	fpnode = *fpnode_data;

	status = call(back, fpnode_data);
    }

    if (status) {
#if 0
	if (status == MISS_CLASS) {
	    status = 0;
	}
#endif				/* 0 */
    } else {
	struct fpnode_type *fznode_data;

	fpnode_data = &fpnode;

	fznode_data = &tqline(tqline)->link_a.fpline.fplink;

	if (1) {
	    struct fpnode_type *fqnode_data;

	    fqnode_data = fpnode_data->uplink_data;
	    if (fqnode_data) {
		fqnode_data->fpnode_data[tilt] = fpnode_data;
	    } else {
		fznode_data->fpnode_data[tilt] = fpnode_data;
	    }
	}

	if (1) {
	    struct fpnode_type *ffnode_data;

	    ffnode_data = fpnode_data->fpnode_data[0];
	    if (ffnode_data) {
		ffnode_data->uplink_data = fpnode_data;
	    }
	}

	if (1) {
	    struct fpnode_type *ffnode_data;

	    ffnode_data = fpnode_data->fpnode_data[1];
	    if (ffnode_data) {
		ffnode_data->uplink_data = fpnode_data;
	    }
	}

	fznode_data->fpnode_data[0]->uplink_data = fznode_data;

	do {
	    struct fpnode_type *ffnode_data, *fjnode_data, *fqnode_data;

	    ffnode_data = fpnode_data->fpnode_data[0];
	    if (ffnode_data) {
		fjnode_data = ffnode_data->fpnode_data[1];
		while (fjnode_data) {
		    ffnode_data = fjnode_data->fpnode_data[1];
		    if (ffnode_data) {
			fjnode_data = ffnode_data->fpnode_data[1];
		    } else {
			ffnode_data = fjnode_data;
			if (1) {
			    break;
			}
		    }
		}
	    } else {
		ffnode_data = fpnode_data->fpnode_data[1];
		if (ffnode_data) {
		} else {
		    ffnode_data = fpnode_data;
		}
	    }

	    if (fpnode_data == ffnode_data->uplink_data) {
		fqnode_data = ffnode_data;
	    } else {
		fqnode_data = ffnode_data->uplink_data;
	    }

	    fjnode_data = ffnode_data->uplink_data;
	    if (ffnode_data == fjnode_data->fpnode_data[0]) {
		fjnode_data->fpnode_data[0] = NULL;
	    } else {
		fjnode_data->fpnode_data[1] = NULL;
	    }

	    if (fpnode_data == ffnode_data) {
	    } else {
		fjnode_data = fpnode_data->uplink_data;
		if (fpnode_data == fjnode_data->fpnode_data[0]) {
		    fjnode_data->fpnode_data[0] = ffnode_data;
		} else {
		    fjnode_data->fpnode_data[1] = ffnode_data;
		}

		ffnode_data->uplink_data = fjnode_data;
		fjnode_data = fpnode_data->fpnode_data[0];
		if (fjnode_data) {
		    fjnode_data->uplink_data = ffnode_data;
		}

		ffnode_data->fpnode_data[0] = fjnode_data;
		fjnode_data = fpnode_data->fpnode_data[1];
		if (fjnode_data) {
		    fjnode_data->uplink_data = ffnode_data;
		}

		ffnode_data->fpnode_data[1] = fjnode_data;
		ffnode_data->fqnode.ever = fpnode_data->fqnode.ever;
	    }

	    while (fqnode_data != fznode_data) {
		unsigned ever, miss;

		miss = fqnode_data->fqnode.ever;

		ffnode_data = fqnode_data->fpnode_data[0];
		if (ffnode_data) {
		    ever = ffnode_data->fqnode.ever + 1;
		} else {
		    ever = 1;
		}
		if (ever < miss) {
		    fqnode_data->fqnode.ever = miss - 1;

		    fjnode_data = fqnode_data->fpnode_data[1];
		    if (fjnode_data) {
			struct fpnode_type *fdnode_data;

			fdnode_data = fjnode_data->fpnode_data[1];
			if (fdnode_data) {
			    if (fdnode_data->fqnode.ever
				== fqnode_data->fqnode.ever) {
				struct fpnode_type *fsnode_data;
				unsigned S;

				fdnode_data = fqnode_data->uplink_data;
				if (fqnode_data
				    == fdnode_data->fpnode_data[0]) {
				    S = 0;
				} else {
				    S = 1;
				}

				fsnode_data = fjnode_data->fpnode_data[0];
				fqnode_data->fpnode_data[1] = fsnode_data;

				fjnode_data->fpnode_data[0] = fqnode_data;
				fjnode_data->fqnode.ever =
				    fqnode_data->fqnode.ever + 1;

				if (fsnode_data) {
				    struct fpnode_type *fznode_data;

				    fznode_data = fsnode_data->fpnode_data[1];
				    if (fznode_data) {
					if (fznode_data->fqnode.ever
					    == fqnode_data->fqnode.ever) {
					    struct fpnode_type *fbnode_data;

					    fqnode_data->uplink_data =
						fsnode_data;

					    fbnode_data =
						fsnode_data->fpnode_data[0];
					    fqnode_data->fpnode_data[1] =
						fbnode_data;
					    if (fbnode_data) {
						fbnode_data->uplink_data =
						    fqnode_data;
					    }

					    fsnode_data->fpnode_data[0] =
						fqnode_data;
					    fsnode_data->fqnode.ever =
						fqnode_data->fqnode.ever + 1;

					    fdnode_data->fpnode_data[S] =
						fsnode_data;

					    fsnode_data->uplink_data =
						fdnode_data;
					    fjnode_data->uplink_data =
						fsnode_data;

					    fjnode_data->fpnode_data[0] =
						fznode_data;

					    fsnode_data->fpnode_data[1] =
						fjnode_data;

					    fznode_data->uplink_data =
						fjnode_data;

					    fjnode_data->fqnode.ever =
						fznode_data->fqnode.ever + 1;
					} else {
					    fdnode_data->fpnode_data[S] =
						fjnode_data;

					    fjnode_data->uplink_data =
						fdnode_data;
					    fqnode_data->uplink_data =
						fjnode_data;

					    fsnode_data->uplink_data =
						fqnode_data;
					}
				    } else {
					if (1) {
					    fsnode_data->uplink_data =
						fqnode_data;

					    fjnode_data->uplink_data =
						fdnode_data;
					    fqnode_data->uplink_data =
						fjnode_data;

					    fdnode_data->fpnode_data[S] =
						fjnode_data;
					}
				    }
				} else {
				    fjnode_data->uplink_data = fdnode_data;
				    fqnode_data->uplink_data = fjnode_data;

				    fdnode_data->fpnode_data[S] = fjnode_data;
				}

				break;
			    }
			}
		    }

		    fqnode_data = fqnode_data->uplink_data;
		} else {
		    ffnode_data = fqnode_data->fpnode_data[1];
		    if (ffnode_data) {
			ever = ffnode_data->fqnode.ever + 1;
		    } else {
			ever = 1;
		    }
		    if (ever < miss) {
			struct fpnode_type *fsnode_data, *fznode_data;

			fjnode_data = fqnode_data->fpnode_data[0];

			fznode_data = fqnode_data->uplink_data;
			if (fqnode_data == fznode_data->fpnode_data[0]) {
			    fznode_data->fpnode_data[0] = fjnode_data;
			} else {
			    fznode_data->fpnode_data[1] = fjnode_data;
			}

			fjnode_data->uplink_data = fznode_data;
			fqnode_data->uplink_data = fjnode_data;

			fsnode_data = fjnode_data->fpnode_data[1];
			fqnode_data->fpnode_data[0] = fsnode_data;

			fjnode_data->fpnode_data[1] = fqnode_data;

			if (fsnode_data) {
			    fsnode_data->uplink_data = fqnode_data;

			    ever = fsnode_data->fqnode.ever + 1;
			} else {
			    ever = 1;
			}

			if (fjnode_data->fqnode.ever < ever) {
			    struct fpnode_type *fxnode_data;

			    fjnode_data->fpnode_data[1] = fsnode_data;

			    fsnode_data->uplink_data = fjnode_data;
			    fqnode_data->uplink_data = fsnode_data;

			    fxnode_data = fsnode_data->fpnode_data[1];
			    fqnode_data->fpnode_data[0] = fxnode_data;

			    fsnode_data->fpnode_data[1] = fqnode_data;

			    if (fxnode_data) {
				fxnode_data->uplink_data = fqnode_data;

				fqnode_data->fqnode.ever =
				    fxnode_data->fqnode.ever + 1;
			    } else {
				fqnode_data->fqnode.ever = 1;
			    }

			    if (fqnode_data->fqnode.ever
				== fjnode_data->fqnode.ever) {
				if (fjnode_data
				    == fznode_data->fpnode_data[0]) {
				    fznode_data->fpnode_data[0] = fsnode_data;
				} else {
				    fznode_data->fpnode_data[1] = fsnode_data;
				}

				fsnode_data->uplink_data = fznode_data;
				fjnode_data->uplink_data = fsnode_data;

				fznode_data = fsnode_data->fpnode_data[0];
				fjnode_data->fpnode_data[1] = fznode_data;
				if (fznode_data) {
				    fznode_data->uplink_data = fjnode_data;
				}

				fsnode_data->fpnode_data[0] = fjnode_data;
				fsnode_data->fqnode.ever =
				    fjnode_data->fqnode.ever + 1;
			    }

			    break;
			} else {
			    fqnode_data->fqnode.ever = ever;
			}

			fqnode_data = fqnode_data->uplink_data->uplink_data;
		    } else {
			break;
		    }
		}
	    }
	} while (0);

	fpnode_data = fznode_data->fpnode_data[0];
	if (fpnode_data) {
	    fpnode_data->uplink_data = NULL;
	}
    }

    return status;
}
