/*
 * tsqp.b.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tsqp-types.h>

#define Delete				0

#define tsline(tsline)			((struct tsline_type *) (tsline))

static int back_node(struct fpnode_type *, void *,
		     int (*) (void *, void *, unsigned), unsigned);

static int
back_node(struct fpnode_type *fpnode_data, void *back,
	  int (*call) (void *, void *, unsigned), unsigned scan)
{
    int delete;

    do {
	if (fpnode_data->fqnode.fbnode.bits & LAST_T) {
	} else {
	    delete = back_node
		(fpnode_data->fpnode_data[0], back, call, scan + 1);
	    if (delete) {
		break;
	    }
	}

	if (1) {
	    delete = call(back, fpnode_data + 1, scan);
	    if (delete) {
		break;
	    }
	}

	if (fpnode_data->fqnode.fbnode.bits & NEXT_T) {
	} else {
	    delete = back_node
		(fpnode_data->fpnode_data[1], back, call, scan + 1);
	    if (Delete) {
		break;
	    }
	}
    } while (0);

    return delete;
}


int
x1f4_scan_tsline(void *tsline, void *back,
		 int (*call) (void *, void *, unsigned))
{
    int delete;
    struct fpnode_type *fpnode_data;

    fpnode_data = tsline(tsline)->link_a.fpline.fplink.fpnode_data[0];
    if (fpnode_data) {
	delete = back_node(fpnode_data, back, call, 0);
    } else {
	delete = 0;
    }

    return delete;
}
