/*
 * tsxv.g.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tsqp-types.h>

#define GET_L(fpnode_data) \
    ((fpnode_data)->fqnode.fbnode.bits & LAST_T)
#define GET_N(fpnode_data) \
    ((fpnode_data)->fqnode.fbnode.bits & NEXT_T)

#define SET_L(fpnode_data) \
    (fpnode_data)->fqnode.fbnode.bits |= LAST_T
#define SET_N(fpnode_data) \
    (fpnode_data)->fqnode.fbnode.bits |= NEXT_T

#define FIX_L(fpnode_data) \
    (fpnode_data)->fqnode.fbnode.bits &= ~LAST_T
#define FIX_N(fpnode_data) \
    (fpnode_data)->fqnode.fbnode.bits &= ~NEXT_T

#define class_index(fbnode_data, fsnode_data, tilt, tsline) \
    {									      \
	if ((fsnode_data)						      \
	    == tsline((tsline))->link_a.fpline.fplink.fpnode_data[0]) {	      \
	    (fbnode_data) = &tsline((tsline))->link_a.fpline.fplink;	      \
									      \
	    (tilt) = 0;							      \
	} else {							      \
	    struct fpnode_type *f1node_data, *f2node_data;		      \
									      \
	    f1node_data = (fsnode_data);				      \
	    f2node_data = (fsnode_data);				      \
									      \
	    while (1) {							      \
		if (GET_N(f2node_data)) {				      \
		    if (1) {						      \
			struct fpnode_type *fdnode_data;		      \
									      \
			fdnode_data = f2node_data->fpnode_data[1];	      \
			do {						      \
			    if (fdnode_data) {				      \
				if (fdnode_data->fpnode_data[0]		      \
				    == (fsnode_data)) {			      \
				    (fbnode_data) = fdnode_data;	      \
									      \
				    (tilt) = 0;				      \
									      \
				    break;				      \
				}					      \
			    }						      \
									      \
			    while (!GET_L(f1node_data)) {		      \
				f1node_data = f1node_data->fpnode_data[0];    \
			    }						      \
									      \
			    (tilt) = 1;					      \
									      \
			    (fbnode_data) = f1node_data->fpnode_data[0];      \
			} while (0);					      \
									      \
			break;						      \
		    }							      \
		} else {						      \
		    if (GET_L(f1node_data)) {				      \
			struct fpnode_type *fdnode_data;		      \
									      \
			fdnode_data = f1node_data->fpnode_data[0];	      \
			do {						      \
			    if (fdnode_data) {				      \
				if (fdnode_data->fpnode_data[1]		      \
				    == (fsnode_data)) {			      \
				    (fbnode_data) = fdnode_data;	      \
									      \
				    (tilt) = 1;				      \
									      \
				    break;				      \
				}					      \
			    }						      \
									      \
			    while (!GET_N(f2node_data)) {		      \
				f2node_data = f2node_data->fpnode_data[1];    \
			    }						      \
									      \
			    (tilt) = 0;					      \
									      \
			    (fbnode_data) = f2node_data->fpnode_data[1];      \
			} while (0);					      \
									      \
			break;						      \
		    } else {						      \
			f1node_data = f1node_data->fpnode_data[0];	      \
			f2node_data = f2node_data->fpnode_data[1];	      \
		    }							      \
		}							      \
	    }								      \
	}								      \
    }

#define class_shift(fbnode_data, fsnode_data, fznode_data, tilt, tsline) \
    {									      \
	if ((fznode_data)						      \
	    == tsline((tsline))->link_a.fpline.fplink.fpnode_data[0]) {	      \
	    (fbnode_data) = &tsline((tsline))->link_a.fpline.fplink;	      \
									      \
	    (tilt) = 0;							      \
	} else {							      \
	    struct fpnode_type *f1node_data, *f2node_data;		      \
									      \
	    f1node_data = (fsnode_data);				      \
	    f2node_data = (fsnode_data);				      \
									      \
	    while (1) {							      \
		if (GET_N(f2node_data)) {				      \
		    if (1) {						      \
			struct fpnode_type *fdnode_data;		      \
									      \
			fdnode_data = f2node_data->fpnode_data[1];	      \
			do {						      \
			    if (fdnode_data) {				      \
				if (fdnode_data->fpnode_data[0]		      \
				    == (fznode_data)) {			      \
				    (fbnode_data) = fdnode_data;	      \
									      \
				    (tilt) = 0;				      \
									      \
				    break;				      \
				}					      \
			    }						      \
									      \
			    while (!GET_L(f1node_data)) {		      \
				f1node_data = f1node_data->fpnode_data[0];    \
			    }						      \
									      \
			    (tilt) = 1;					      \
									      \
			    (fbnode_data) = f1node_data->fpnode_data[0];      \
			} while (0);					      \
									      \
			break;						      \
		    }							      \
		} else {						      \
		    if (GET_L(f1node_data)) {				      \
			struct fpnode_type *fdnode_data;		      \
									      \
			fdnode_data = f1node_data->fpnode_data[0];	      \
			do {						      \
			    if (fdnode_data) {				      \
				if (fdnode_data->fpnode_data[1]		      \
				    == (fznode_data)) {			      \
				    (fbnode_data) = fdnode_data;	      \
									      \
				    (tilt) = 1;				      \
									      \
				    break;				      \
				}					      \
			    }						      \
									      \
			    while (!GET_N(f2node_data)) {		      \
				f2node_data = f2node_data->fpnode_data[1];    \
			    }						      \
									      \
			    (tilt) = 0;					      \
									      \
			    (fbnode_data) = f2node_data->fpnode_data[1];      \
			} while (0);					      \
									      \
			break;						      \
		    } else {						      \
			f1node_data = f1node_data->fpnode_data[0];	      \
			f2node_data = f2node_data->fpnode_data[1];	      \
		    }							      \
		}							      \
	    }								      \
	}								      \
    }

#define tsline(tsline)			((struct tsline_type *) (tsline))

int
_libx1f4l2_wave_tsline(void *tsline, void *tsnode, void *back,
		       int (*call) (void *, void *))
{
    int delete;
    struct fpnode_type fpnode;

    fpnode = *(struct fpnode_type *) tsnode;

    delete = call(back, tsnode);
    if (delete) {
    } else {
	struct fpnode_type *fhnode_data, *fpnode_data;
	unsigned slip;

	fpnode_data = &fpnode;

	class_shift(fhnode_data, fpnode_data, tsnode, slip, tsline);

	do {
	    if (GET_N(fpnode_data)) {
		if (GET_L(fpnode_data)) {
		    fhnode_data->fpnode_data[slip] =
			fpnode_data->fpnode_data[slip];

		    if (fhnode_data != &tsline(tsline)->link_a.fpline.fplink) {
			if (slip) {
			    SET_N(fhnode_data);
			} else {
			    SET_L(fhnode_data);
			}
		    }
		} else {
		    struct fpnode_type *ftnode_data;

		    ftnode_data = fpnode_data->fpnode_data[0];

		    fhnode_data->fpnode_data[slip] = ftnode_data;

		    while (!GET_N(ftnode_data)) {
			ftnode_data = ftnode_data->fpnode_data[1];
		    }

		    ftnode_data->fpnode_data[1] = fpnode_data->fpnode_data[1];
		}
	    } else {
		struct fpnode_type *fqnode_data;

		fqnode_data = fpnode_data->fpnode_data[1];
		if (GET_L(fqnode_data)) {
		    struct fpnode_type *fjnode_data;

		    fjnode_data = fpnode_data->fpnode_data[0];
		    fqnode_data->fpnode_data[0] = fjnode_data;

		    if (GET_L(fpnode_data)) {
			SET_L(fqnode_data);
		    } else {
			struct fpnode_type *ftnode_data;

			FIX_L(fqnode_data);

			ftnode_data = fjnode_data;

			while (!GET_N(ftnode_data)) {
			    ftnode_data = ftnode_data->fpnode_data[1];
			}

			ftnode_data->fpnode_data[1] = fqnode_data;
		    }

		    fhnode_data->fpnode_data[slip] = fqnode_data;
		    fhnode_data = fqnode_data;
		    slip = 1;
		    fqnode_data->fqnode.tilt = fpnode_data->fqnode.tilt;
		} else {
		    struct fpnode_type *fjnode_data, *fsnode_data;

		    for (;;) {
			fsnode_data = fqnode_data->fpnode_data[0];
			if (!GET_L(fsnode_data)) {
			    fqnode_data = fsnode_data;
			} else {
			    break;
			}
		    }

		    if (GET_N(fsnode_data)) {
			SET_L(fqnode_data);
			fqnode_data->fpnode_data[0] = fsnode_data;
		    } else {
			fqnode_data->fpnode_data[0] =
			    fsnode_data->fpnode_data[1];
		    }

		    fjnode_data = fpnode_data->fpnode_data[0];
		    fsnode_data->fpnode_data[0] = fjnode_data;

		    if (GET_L(fpnode_data)) {
		    } else {
			struct fpnode_type *ftnode_data;

			FIX_L(fsnode_data);

			ftnode_data = fjnode_data;

			while (!GET_N(ftnode_data)) {
			    ftnode_data = ftnode_data->fpnode_data[1];
			}

			ftnode_data->fpnode_data[1] = fsnode_data;
		    }

		    FIX_N(fsnode_data);

		    fsnode_data->fpnode_data[1] = fpnode_data->fpnode_data[1];

		    fhnode_data->fpnode_data[slip] = fsnode_data;

		    fhnode_data = fqnode_data;
		    fsnode_data->fqnode.tilt = fpnode_data->fqnode.tilt;

		    slip = 0;
		}
	    }

	    while (1) {
		struct fpnode_type *fqnode_data;
		unsigned miss;

		fqnode_data = fhnode_data;

		if (fqnode_data == &tsline(tsline)->link_a.fpline.fplink) {
		    break;
		}

		class_index(fhnode_data, fqnode_data, miss, tsline);

		if (!slip) {
		    int tilt;

		    slip = miss;

		    tilt = fqnode_data->fqnode.tilt;

		    tilt++;

		    fqnode_data->fqnode.tilt = tilt;

		    if (tilt == 1) {
			break;
		    } else {
			if (tilt == 2) {
			    struct fpnode_type *fxnode_data;

			    fxnode_data = fqnode_data->fpnode_data[1];
			    if (fxnode_data->fqnode.tilt == -1) {
				struct fpnode_type *fwnode_data;

				fwnode_data = fxnode_data->fpnode_data[0];
				if (GET_N(fwnode_data)) {
				    FIX_N(fwnode_data);
				    SET_L(fxnode_data);
				    fxnode_data->fpnode_data[0] = fwnode_data;
				} else {
				    struct fpnode_type *fbnode_data;

				    fbnode_data = fwnode_data->fpnode_data[1];
				    fxnode_data->fpnode_data[0] = fbnode_data;
				}
				fwnode_data->fpnode_data[1] = fxnode_data;
				if (GET_L(fwnode_data)) {
				    FIX_L(fwnode_data);
				    SET_N(fqnode_data);
				    fqnode_data->fpnode_data[1] = fwnode_data;
				} else {
				    struct fpnode_type *fdnode_data;

				    fdnode_data = fwnode_data->fpnode_data[0];
				    fqnode_data->fpnode_data[1] = fdnode_data;
				}
				fwnode_data->fpnode_data[0] = fqnode_data;
				tilt = fwnode_data->fqnode.tilt;
				fwnode_data->fqnode.tilt = 0;
				if (tilt == 1) {
				    fxnode_data->fqnode.tilt = 0;
				    fqnode_data->fqnode.tilt = -1;
				} else {
				    if (!tilt) {
					fxnode_data->fqnode.tilt = 0;
					fqnode_data->fqnode.tilt = 0;
				    } else {
					fxnode_data->fqnode.tilt = 1;
					fqnode_data->fqnode.tilt = 0;
				    }
				}
				fhnode_data->fpnode_data[slip] = fwnode_data;
			    } else {
				if (GET_L(fxnode_data)) {
				    if (fxnode_data->fqnode.tilt) {
					FIX_L(fxnode_data);
					SET_N(fqnode_data);
				    } else {
					fqnode_data->fpnode_data[1] =
					    fxnode_data->fpnode_data[0];
				    }
				} else {
				    struct fpnode_type *fmnode_data;

				    fmnode_data = fxnode_data->fpnode_data[0];
				    fqnode_data->fpnode_data[1] = fmnode_data;
				}
				fxnode_data->fpnode_data[0] = fqnode_data;
				fhnode_data->fpnode_data[slip] = fxnode_data;
				if (fxnode_data->fqnode.tilt) {
				    fqnode_data->fqnode.tilt = 0;
				    fxnode_data->fqnode.tilt = 0;
				} else {
				    fqnode_data->fqnode.tilt = 1;
				    fxnode_data->fqnode.tilt = -1;
				    break;
				}
			    }
			}
		    }
		} else {
		    int tilt;

		    slip = miss;

		    tilt = fqnode_data->fqnode.tilt;

		    tilt--;

		    fqnode_data->fqnode.tilt = tilt;

		    if (tilt == -1) {
			break;
		    } else {
			if (tilt == -2) {
			    struct fpnode_type *fxnode_data;

			    fxnode_data = fqnode_data->fpnode_data[0];
			    if (fxnode_data->fqnode.tilt == 1) {
				struct fpnode_type *fwnode_data;

				fwnode_data = fxnode_data->fpnode_data[1];
				if (GET_L(fwnode_data)) {
				    FIX_L(fwnode_data);
				    SET_N(fxnode_data);
				    fxnode_data->fpnode_data[1] = fwnode_data;
				} else {
				    struct fpnode_type *fbnode_data;

				    fbnode_data = fwnode_data->fpnode_data[0];
				    fxnode_data->fpnode_data[1] = fbnode_data;
				}
				fwnode_data->fpnode_data[0] = fxnode_data;
				if (GET_N(fwnode_data)) {
				    FIX_N(fwnode_data);
				    SET_L(fqnode_data);
				    fqnode_data->fpnode_data[0] = fwnode_data;
				} else {
				    struct fpnode_type *fdnode_data;

				    fdnode_data = fwnode_data->fpnode_data[1];
				    fqnode_data->fpnode_data[0] = fdnode_data;
				}
				fwnode_data->fpnode_data[1] = fqnode_data;
				tilt = fwnode_data->fqnode.tilt;
				fwnode_data->fqnode.tilt = 0;
				if (tilt == -1) {
				    fxnode_data->fqnode.tilt = 0;
				    fqnode_data->fqnode.tilt = 1;
				} else {
				    if (!tilt) {
					fxnode_data->fqnode.tilt = 0;
					fqnode_data->fqnode.tilt = 0;
				    } else {
					fxnode_data->fqnode.tilt = -1;
					fqnode_data->fqnode.tilt = 0;
				    }
				}
				fhnode_data->fpnode_data[slip] = fwnode_data;
			    } else {
				if (GET_N(fxnode_data)) {
				    if (fxnode_data->fqnode.tilt) {
					FIX_N(fxnode_data);
					SET_L(fqnode_data);
				    } else {
					fqnode_data->fpnode_data[0] =
					    fxnode_data->fpnode_data[1];
				    }
				} else {
				    struct fpnode_type *fmnode_data;

				    fmnode_data = fxnode_data->fpnode_data[1];
				    fqnode_data->fpnode_data[0] = fmnode_data;
				}
				fxnode_data->fpnode_data[1] = fqnode_data;
				fhnode_data->fpnode_data[slip] = fxnode_data;
				if (fxnode_data->fqnode.tilt) {
				    fqnode_data->fqnode.tilt = 0;
				    fxnode_data->fqnode.tilt = 0;
				} else {
				    fqnode_data->fqnode.tilt = -1;
				    fxnode_data->fqnode.tilt = 1;
				    break;
				}
			    }
			}
		    }
		}
	    }
	} while (0);
    }

    return delete;
}
