/*
 * tsxy.w.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tsxx-names.h>
#include <tsxx-types.h>

#define tslist(tslist)			((struct tslist_type *) (tslist))

static int back_node(struct fpnode_type *);

static int
back_node(struct fpnode_type *fpnode_data)
{
    struct fpnode_type *fqnode_data, *ftnode_data;
    unsigned bits, post;

    bits = fpnode_data->fqnode.fbnode.bits;

    post = bits & ~FLAT_T;

    fqnode_data = fpnode_data->fpnode_data[0];
    if (bits & LAST_T) {
	post |= NEXT_T;
    } else {
	back_node(fqnode_data);
    }

    ftnode_data = fpnode_data->fpnode_data[1];
    if (bits & NEXT_T) {
	post |= LAST_T;
    } else {
	back_node(ftnode_data);
    }

    fpnode_data->fpnode_data[0] = ftnode_data;

    fpnode_data->fpnode_data[1] = fqnode_data;

    fpnode_data->fqnode.fbnode.bits = post;

    fpnode_data->fqnode.tilt = -fpnode_data->fqnode.tilt;

    return 0;
}


int
x1f4_flip_tslist(void *tslist)
{
    struct fpnode_type *fpnode_data;

    fpnode_data = tslist(tslist)->link_a.fplist.fplink.fpnode_data[0];
    if (fpnode_data) {
	back_node(fpnode_data);
    }

    return 0;
}
