/*
 * tvqb.6.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tvqp-defs.h>
#include <tvqp-inter.h>
#include <tvqp-names.h>
#include <tvqp-types.h>

#define tvline(tvline)			((struct tvline_type *) (tvline))

typedef struct back_type {
    int (*call) (void *, void *);
    void *back, *line;
} back_type;

static int near_line(void *, void *);

static int
near_line(void *back, void *tvnode)
{
    int status;

    if (((struct back_type *) back)->call
	(((struct back_type *) back)->back,
	 ((struct fpnode_type *) tvnode) + 1)) {
	status = CALL_ERROR;
    } else {
	struct tvline_type *tvline_data;

	tvline_data = ((struct back_type *) back)->line;
	status = tvline_data->link_m.free(tvline_data->link_m.data, tvnode);
	if (status) {
	    status = FREE_ERROR;
	}
    }

    return status;
}


int
x1f4_near_tvline(void *tvline, void *text, int (*land) (void *, void *),
		 unsigned offset, void *back, int (*call) (void *, void *))
{
    int status;

    if (tvline(tvline)->link_a.fpline.fplink.fpnode_data[0]) {
	struct back_type nand;

	nand.line = tvline;

	nand.back = back;
	nand.call = call;

	status = _libx1f4l2_nand_tvline
	    (tvline, text, land, sizeof(struct fpnode_type) + offset, &nand,
	     near_line);
	if (status) {
	    if (status == CALL_ERROR) {
		status = 0;
	    } else {
		if (status == MISS_CLASS) {
		    status = 0;
		}
	    }
	}
    } else {
	status = 0;
    }

    return status;
}
