/*
 * tvxv.j.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tvxx-names.h>
#include <tvxx-types.h>

#define tvlist(tvlist)			((struct tvlist_type *) (tvlist))

int
_libx1f4l2_nand_tvlist(void *tvlist, unsigned index, void *back,
		       int (*call) (void *, void *))
{
    int delete;
    struct fpnode_type fpnode, *fpnode_data;
    unsigned tilt = 0;

    fpnode_data = tvlist(tvlist)->link_a.fplist.fplink.fpnode_data[0];

    while (1) {
	unsigned class;

	class = fpnode_data->fqnode.size;
	if (class == 1) {
	    break;
	} else {
	    struct fpnode_type *fpnode_miss;

	    fpnode_miss = fpnode_data->fpnode_data[0];
	    if (!fpnode_miss) {
		if (!index) {
		    break;
		} else {
		    if (0) {
		    } else {
			index--;
			tilt = 1;
		    }
		}
	    } else {
		unsigned Class;

		Class = fpnode_miss->fqnode.size;
		if (Class == index) {
		    break;
		} else {
		    if (index < Class) {
			tilt = 0;
		    } else {
			index -= Class + 1;
			tilt = 1;
		    }
		}
	    }
	}

	fpnode_data->fqnode.size = class - 1;

	fpnode_data = fpnode_data->fpnode_data[tilt];
    }

    fpnode = *fpnode_data;

    delete = call(back, fpnode_data);
    if (delete) {
	fpnode_data = fpnode_data->uplink_data;
	while (fpnode_data) {
	    fpnode_data->fqnode.size++;
	    fpnode_data = fpnode_data->uplink_data;
	}
    } else {
	struct fpnode_type *fhnode_data;

	fpnode_data = &fpnode;

	fhnode_data = fpnode_data->uplink_data;
	if (fhnode_data) {
	} else {
	    fhnode_data = &tvlist(tvlist)->link_a.fplist.fplink;
	}

	do {
	    struct fpnode_type *fqnode_data;

	    fqnode_data = fpnode_data->fpnode_data[1];
	    if (!fqnode_data) {
		struct fpnode_type *fsnode_data;

		fsnode_data = fpnode_data->fpnode_data[0];
		fhnode_data->fpnode_data[tilt] = fsnode_data;
		if (fsnode_data) {
		    fsnode_data->uplink_data = fpnode_data->uplink_data;
		}
	    } else {
		if (!fqnode_data->fpnode_data[0]) {
		    struct fpnode_type *fjnode_data;

		    fjnode_data = fpnode_data->fpnode_data[0];
		    fqnode_data->fpnode_data[0] = fjnode_data;
		    fqnode_data->fqnode.tilt = fpnode_data->fqnode.tilt;
		    fqnode_data->uplink_data = fpnode_data->uplink_data;
		    fhnode_data->fpnode_data[tilt] = fqnode_data;

		    if (fjnode_data) {
			fjnode_data->uplink_data = fqnode_data;
			fqnode_data->fqnode.size += fjnode_data->fqnode.size;
		    }

		    tilt = 1;

		    fhnode_data = fqnode_data;
		} else {
		    struct fpnode_type *fjnode_data, *flnode_data,
			*fsnode_data, *ftnode_data;

		    for (;;) {
			fqnode_data->fqnode.size--;

			fsnode_data = fqnode_data->fpnode_data[0];
			if (fsnode_data->fpnode_data[0]) {
			    fqnode_data = fsnode_data;
			} else {
			    break;
			}
		    }

		    ftnode_data = fpnode_data->fpnode_data[1];

		    fjnode_data = fpnode_data->fpnode_data[0];
		    flnode_data = fsnode_data->fpnode_data[1];
		    fsnode_data->fpnode_data[0] = fjnode_data;
		    fqnode_data->fpnode_data[0] = flnode_data;
		    fsnode_data->fpnode_data[1] = ftnode_data;
		    fsnode_data->fqnode.tilt = fpnode_data->fqnode.tilt;

		    fhnode_data->fpnode_data[tilt] = fsnode_data;

		    if (fjnode_data) {
			fjnode_data->uplink_data = fsnode_data;
		    }

		    ftnode_data->uplink_data = fsnode_data;
		    fsnode_data->uplink_data = fpnode_data->uplink_data;

		    if (flnode_data) {
			flnode_data->uplink_data = fqnode_data;
		    }

		    tilt = 0;

		    fhnode_data = fqnode_data;

		    if (1) {
			fsnode_data->fqnode.size =
			    fpnode_data->fqnode.size - 1;
		    }
		}
	    }

	    while (1) {
		if (fhnode_data == &tvlist(tvlist)->link_a.fplist.fplink) {
		    break;
		}

		fqnode_data = fhnode_data;
		fhnode_data = fqnode_data->uplink_data;
		if (fhnode_data) {
		} else {
		    fhnode_data = &tvlist(tvlist)->link_a.fplist.fplink;
		}

		if (!tilt) {
		    int silt;

		    if (fqnode_data == fhnode_data->fpnode_data[0]) {
			tilt = 0;
		    } else {
			tilt = 1;
		    }

		    silt = fqnode_data->fqnode.tilt;

		    silt++;

		    fqnode_data->fqnode.tilt = silt;

		    if (silt == 1) {
			break;
		    } else {
			if (silt == 2) {
			    struct fpnode_type *fxnode_data;

			    fxnode_data = fqnode_data->fpnode_data[1];
			    if (fxnode_data->fqnode.tilt == -1) {
				int slip;
				struct fpnode_type *fbnode_data, *fdnode_data,
				    *fwnode_data;
				unsigned sx_b, sx_d;

				fwnode_data = fxnode_data->fpnode_data[0];
				fbnode_data = fwnode_data->fpnode_data[1];
				fxnode_data->fpnode_data[0] = fbnode_data;
				fwnode_data->fpnode_data[1] = fxnode_data;
				fdnode_data = fwnode_data->fpnode_data[0];
				fqnode_data->fpnode_data[1] = fdnode_data;
				fwnode_data->fpnode_data[0] = fqnode_data;
				slip = fwnode_data->fqnode.tilt;
				fwnode_data->fqnode.tilt = 0;
				if (slip == 1) {
				    fxnode_data->fqnode.tilt = 0;
				    fqnode_data->fqnode.tilt = -1;
				} else {
				    if (!slip) {
					fxnode_data->fqnode.tilt = 0;
					fqnode_data->fqnode.tilt = 0;
				    } else {
					fxnode_data->fqnode.tilt = 1;
					fqnode_data->fqnode.tilt = 0;
				    }
				}
				fwnode_data->uplink_data =
				    fqnode_data->uplink_data;
				fqnode_data->uplink_data = fwnode_data;
				fxnode_data->uplink_data = fwnode_data;
				if (fbnode_data) {
				    fbnode_data->uplink_data = fxnode_data;
				    sx_b = fbnode_data->fqnode.size;
				} else {
				    sx_b = 0;
				}
				if (fdnode_data) {
				    fdnode_data->uplink_data = fqnode_data;
				    sx_d = fdnode_data->fqnode.size;
				} else {
				    sx_d = 0;
				}
				fhnode_data->fpnode_data[tilt] = fwnode_data;
				if (1) {
				    unsigned sx_w, sx_v, sx_x;

				    sx_v = fxnode_data->fqnode.size;
				    sx_w = fwnode_data->fqnode.size;
				    sx_x = fqnode_data->fqnode.size;
				    fxnode_data->fqnode.size =
					sx_v + sx_b - sx_w;
				    fwnode_data->fqnode.size = sx_x;
				    fqnode_data->fqnode.size =
					sx_x + sx_d - sx_v;
				}
			    } else {
				struct fpnode_type *fmnode_data;
				unsigned sx_m;

				fmnode_data = fxnode_data->fpnode_data[0];
				fqnode_data->fpnode_data[1] = fmnode_data;
				fxnode_data->fpnode_data[0] = fqnode_data;
				fxnode_data->uplink_data =
				    fqnode_data->uplink_data;
				fqnode_data->uplink_data = fxnode_data;
				if (fmnode_data) {
				    fmnode_data->uplink_data = fqnode_data;
				    sx_m = fmnode_data->fqnode.size;
				} else {
				    sx_m = 0;
				}
				fhnode_data->fpnode_data[tilt] = fxnode_data;
				if (1) {
				    unsigned sx_q, sx_x;

				    sx_x = fxnode_data->fqnode.size;
				    sx_q = fqnode_data->fqnode.size;
				    fxnode_data->fqnode.size = sx_q;
				    fqnode_data->fqnode.size =
					sx_q + sx_m - sx_x;
				}
				if (fxnode_data->fqnode.tilt) {
				    fqnode_data->fqnode.tilt = 0;
				    fxnode_data->fqnode.tilt = 0;
				} else {
				    fqnode_data->fqnode.tilt = 1;
				    fxnode_data->fqnode.tilt = -1;
				    break;
				}
			    }
			}
		    }
		} else {
		    int silt;

		    if (fqnode_data == fhnode_data->fpnode_data[0]) {
			tilt = 0;
		    } else {
			tilt = 1;
		    }

		    silt = fqnode_data->fqnode.tilt;

		    silt--;

		    fqnode_data->fqnode.tilt = silt;

		    if (silt == -1) {
			break;
		    } else {
			if (silt == -2) {
			    struct fpnode_type *fxnode_data;

			    fxnode_data = fqnode_data->fpnode_data[0];
			    if (fxnode_data->fqnode.tilt == 1) {
				int slip;
				struct fpnode_type *fbnode_data, *fdnode_data,
				    *fwnode_data;
				unsigned sx_b, sx_d;

				fwnode_data = fxnode_data->fpnode_data[1];
				fbnode_data = fwnode_data->fpnode_data[0];
				fxnode_data->fpnode_data[1] = fbnode_data;
				fwnode_data->fpnode_data[0] = fxnode_data;
				fdnode_data = fwnode_data->fpnode_data[1];
				fqnode_data->fpnode_data[0] = fdnode_data;
				fwnode_data->fpnode_data[1] = fqnode_data;
				slip = fwnode_data->fqnode.tilt;
				fwnode_data->fqnode.tilt = 0;
				if (slip == -1) {
				    fxnode_data->fqnode.tilt = 0;
				    fqnode_data->fqnode.tilt = 1;
				} else {
				    if (!slip) {
					fxnode_data->fqnode.tilt = 0;
					fqnode_data->fqnode.tilt = 0;
				    } else {
					fxnode_data->fqnode.tilt = -1;
					fqnode_data->fqnode.tilt = 0;
				    }
				}
				fwnode_data->uplink_data =
				    fqnode_data->uplink_data;
				fqnode_data->uplink_data = fwnode_data;
				fxnode_data->uplink_data = fwnode_data;
				if (fbnode_data) {
				    fbnode_data->uplink_data = fxnode_data;
				    sx_b = fbnode_data->fqnode.size;
				} else {
				    sx_b = 0;
				}
				if (fdnode_data) {
				    fdnode_data->uplink_data = fqnode_data;
				    sx_d = fdnode_data->fqnode.size;
				} else {
				    sx_d = 0;
				}
				fhnode_data->fpnode_data[tilt] = fwnode_data;
				if (1) {
				    unsigned sx_w, sx_v, sx_x;

				    sx_v = fxnode_data->fqnode.size;
				    sx_w = fwnode_data->fqnode.size;
				    sx_x = fqnode_data->fqnode.size;
				    fxnode_data->fqnode.size =
					sx_v + sx_b - sx_w;
				    fwnode_data->fqnode.size = sx_x;
				    fqnode_data->fqnode.size =
					sx_x + sx_d - sx_v;
				}
			    } else {
				struct fpnode_type *fmnode_data;
				unsigned sx_m;

				fmnode_data = fxnode_data->fpnode_data[1];
				fqnode_data->fpnode_data[0] = fmnode_data;
				fxnode_data->fpnode_data[1] = fqnode_data;
				fxnode_data->uplink_data =
				    fqnode_data->uplink_data;
				fqnode_data->uplink_data = fxnode_data;
				if (fmnode_data) {
				    fmnode_data->uplink_data = fqnode_data;
				    sx_m = fmnode_data->fqnode.size;
				} else {
				    sx_m = 0;
				}
				fhnode_data->fpnode_data[tilt] = fxnode_data;
				if (1) {
				    unsigned sx_q, sx_x;

				    sx_x = fxnode_data->fqnode.size;
				    sx_q = fqnode_data->fqnode.size;
				    fxnode_data->fqnode.size = sx_q;
				    fqnode_data->fqnode.size =
					sx_q + sx_m - sx_x;
				}
				if (fxnode_data->fqnode.tilt) {
				    fqnode_data->fqnode.tilt = 0;
				    fxnode_data->fqnode.tilt = 0;
				} else {
				    fqnode_data->fqnode.tilt = -1;
				    fxnode_data->fqnode.tilt = 1;
				    break;
				}
			    }
			}
		    }
		}
	    }
	} while (0);
    }

    return delete;
}
