/*
 * tvxx-inter.h
 * Copyright (C) 2008-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#ifndef __LIBx1f4_tvxx_inter_H__
#define __LIBx1f4_tvxx_inter_H__

#include <tvxx-names.h>
#include <tvxx-types.h>

#define _libx1f4l2_fast_tvlist		x1f4_fast_tvlist
#define _libx1f4l2_fini_tvlist		x1f4_fini_tvlist
#define _libx1f4l2_flat_tvlist		x1f4_flat_tvlist
#define _libx1f4l2_init_tvlist		x1f4_init_tvlist
#define _libx1f4l2_last_tvlist		x1f4_last_tvlist
#define _libx1f4l2_move_tvlist		x1f4_move_tvlist
#define _libx1f4l2_next_tvlist		x1f4_next_tvlist
#define _libx1f4l2_spin_tvlist		x1f4_spin_tvlist

extern int _libx1f4l2_away_tvlist(void *, void *, int (*) (void *, void *));
extern int _libx1f4l2_beta_tvlist(void *, void *);
extern int _libx1f4l2_case_tvlist(void *, unsigned, void *, void **);
extern int _libx1f4l2_ceil_tvlist(void *);
extern int _libx1f4l2_dana_tvlist(void *, void *);
extern int _libx1f4l2_dawn_tvlist
    (void *, void *, void *, int (*) (void *, void *, void *), unsigned);
extern int _libx1f4l2_elif_tvlist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **,
     int (*) (void *, unsigned, void **));
extern int _libx1f4l2_else_tvlist(void *, unsigned, void **);
extern int _libx1f4l2_even_tvlist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **,
     int (*) (void *, unsigned, void **));
extern int _libx1f4l2_fair_tvlist(void *, unsigned, void *, unsigned);
extern int _libx1f4l2_fast_tvlist(void *, unsigned, struct screen_type *);
extern int _libx1f4l2_fini_tvlist(void **);
extern int _libx1f4l2_flat_tvlist(void *);
extern int _libx1f4l2_here_tvlist(void *, unsigned, void **);
extern int _libx1f4l2_init_tvlist(void **, unsigned, struct screen_type *);
extern int _libx1f4l2_lane_tvlist(void *, unsigned, unsigned);
extern int _libx1f4l2_last_tvlist(void **, void *);
extern int _libx1f4l2_long_tvlist(void *, void *, int (*) (void *, void *));
extern int _libx1f4l2_lose_tvlist(void *, unsigned, void **);
extern int _libx1f4l2_moon_tvlist(void *, unsigned, void *);
extern int _libx1f4l2_move_tvlist(void *, unsigned, unsigned);
extern int _libx1f4l2_nand_tvlist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int _libx1f4l2_next_tvlist(void **, void *);
extern int _libx1f4l2_rail_tvlist
    (void *, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int _libx1f4l2_spin_tvlist(void *, unsigned, unsigned);
extern int _libx1f4l2_wave_tvlist
    (void *, void *, void *, int (*) (void *, void *));

#endif				/* __LIBx1f4_tvxx_inter_H__ */
