/*
 * tvxx.8.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tvxx-defs.h>
#include <tvxx-inter.h>
#include <tvxx-names.h>
#include <tvxx-types.h>

#define tvlist(tvlist)			((struct tvlist_type *) (tvlist))

int
x1f4_mode_tvlist(void *tvlist, unsigned index, unsigned size, void **mode)
{
    int status;

    if (!(index < tvlist(tvlist)->link_a.fplist.fplink.fqnode.size)) {
	status = DECK_ERROR;
    } else {
	void *tvnode;

	status = tvlist(tvlist)->link_m.link
	    (tvlist(tvlist)->link_m.data, &tvnode,
	     sizeof(struct fpnode_type) + size);
	if (status) {
	    status = LINK_ERROR;
	} else {
	    void *txnode;

	    status = _libx1f4l2_case_tvlist(tvlist, index, tvnode, &txnode);
	    if (status) {
	    } else {
		*mode = ((struct fpnode_type *) tvnode) + 1;

		status = tvlist(tvlist)->link_m.free
		    (tvlist(tvlist)->link_m.data, txnode);
		if (status) {
		    /*
		     * TODO/FEATURES
		     *
		     * some leakage here...
		     */
		    status = FREE_ERROR;
		} else {
		}
	    }
	}
    }

    return status;
}
