/*
 * tvxx.f.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <tvxx-defs.h>
#include <tvxx-inter.h>
#include <tvxx-names.h>
#include <tvxx-types.h>

#define tvlist(tvlist)			((struct tvlist_type *) (tvlist))

int
x1f4_deux_tvlist(void *tvdata, unsigned index, void *tvtext, unsigned class)
{
    int status;

    if (tvdata == tvtext) {
	status = _libx1f4l2_spin_tvlist(tvdata, index, class);
    } else {
	if (!(index < tvlist(tvdata)->link_a.fplist.fplink.fqnode.size)) {
	    status = DECK_ERROR;
	} else {
	    if (!(class < tvlist(tvtext)->link_a.fplist.fplink.fqnode.size)) {
		status = DECK_ERROR;
	    } else {
		status = _libx1f4l2_fair_tvlist(tvdata, index, tvtext, class);
	    }
	}
    }

    return status;
}
