/*
 * tzqp.i.c
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <tzqp-defs.h>
#include <tzqp-types.h>

#define eBLACK(fpnode) \
    ((fpnode)->fqnode.bits & cBLACK)

#define fBLACK(fpnode) \
    ((fpnode)->fqnode.bits &= ~cBLACK)

#define sBLACK(fpnode) \
    ((fpnode)->fqnode.bits |= cBLACK)

#define tzline(tzline)			((struct tzline_type *) (tzline))

int
_libx1f4l2_elif_tzline(void *tzline, void *text, int (*land) (void *, void *),
		       unsigned offset, unsigned flat, void **push,
		       int (*line) (void *, unsigned, void **))
{
    int status = 0;
    struct fpnode_type *fpnode_data, *fqnode_data;
    unsigned tilt = 0;
    void *tznode;

    fpnode_data = tzline(tzline)->link_a.fpline.fplink.fpnode_data[0];
    fqnode_data = NULL;

    if (fpnode_data) {
	while (1) {
	    int slip;

	    slip = land(text, (char *) fpnode_data + offset);

	    if (slip) {
		if (slip < 0) {
		    fqnode_data = fpnode_data;
		    fpnode_data = fpnode_data->fpnode_data[0];
		    if (fpnode_data) {
		    } else {
			tilt = 0;
			if (1) {
			    break;
			}
		    }
		} else {
		    fqnode_data = fpnode_data;
		    fpnode_data = fpnode_data->fpnode_data[1];
		    if (fpnode_data) {
		    } else {
			tilt = 1;
			if (1) {
			    break;
			}
		    }
		}
	    } else {
		status = EVER_MATCH;

		*push = fpnode_data + 1;

		if (1) {
		    break;
		}
	    }
	}
    }

    if (status) {
    } else {
	status = line(tzline, flat, &tznode);
    }

    if (status) {
    } else {
	struct fpnode_type *fnnode_data;

	fnnode_data = tznode;

	*push = fnnode_data + 1;

	fnnode_data->fpnode_data[0] = NULL;
	fnnode_data->fpnode_data[1] = NULL;

	fnnode_data->fqnode.bits = 0;

	if (!fqnode_data) {
	    fnnode_data->uplink_data = NULL;

	    sBLACK(fnnode_data);

	    tzline(tzline)->link_a.fpline.fplink.fpnode_data[0] = fnnode_data;
	} else {
	    fqnode_data->fpnode_data[tilt] = fnnode_data;

	    fnnode_data->uplink_data = fqnode_data;

	    fqnode_data = fnnode_data;
	    for (;;) {
		struct fpnode_type *ffnode_data, *fgnode_data;

		ffnode_data = fqnode_data->uplink_data;
		if (ffnode_data) {
		    if (eBLACK(ffnode_data)) {
			break;
		    }
		} else {
		    break;
		}

		fgnode_data = ffnode_data->uplink_data;
		if (fgnode_data) {
		} else {
		    break;
		}

		if (fgnode_data->fpnode_data[0] == ffnode_data) {
		    int fast;
		    struct fpnode_type *fynode_data;

		    fynode_data = fgnode_data->fpnode_data[1];
		    if (fynode_data) {
			fast = eBLACK(fynode_data);
		    } else {
			fast = 1;
		    }

		    if (fast) {
			struct fpnode_type *fhnode_data;

			fhnode_data = fgnode_data->uplink_data;
			if (fhnode_data) {
			} else {
			    fhnode_data =
				&tzline(tzline)->link_a.fpline.fplink;
			}

			if (ffnode_data->fpnode_data[1] == fqnode_data) {
			    struct fpnode_type *fdnode_data;

			    fdnode_data = fqnode_data->fpnode_data[0];
			    ffnode_data->fpnode_data[1] = fdnode_data;
			    fqnode_data->fpnode_data[0] = ffnode_data;
			    fgnode_data->fpnode_data[0] = fqnode_data;
			    ffnode_data->uplink_data = fqnode_data;
			    if (fdnode_data) {
				fdnode_data->uplink_data = ffnode_data;
			    }

			    ffnode_data = fqnode_data;
			}

			fBLACK(fgnode_data);
			sBLACK(ffnode_data);

			if (1) {
			    struct fpnode_type *fdnode_data;

			    fdnode_data = ffnode_data->fpnode_data[1];
			    fgnode_data->fpnode_data[0] = fdnode_data;
			    ffnode_data->fpnode_data[1] = fgnode_data;
			    if (fhnode_data->fpnode_data[0] == fgnode_data) {
				fhnode_data->fpnode_data[0] = ffnode_data;
			    } else {
				fhnode_data->fpnode_data[1] = ffnode_data;
			    }

			    ffnode_data->uplink_data =
				fgnode_data->uplink_data;
			    fgnode_data->uplink_data = ffnode_data;
			    if (fdnode_data) {
				fdnode_data->uplink_data = fgnode_data;
			    }
			}

			break;
		    } else {
			sBLACK(ffnode_data);
			sBLACK(fynode_data);
			fBLACK(fgnode_data);
			fqnode_data = fgnode_data;
		    }
		} else {
		    int fast;
		    struct fpnode_type *fynode_data;

		    fynode_data = fgnode_data->fpnode_data[0];
		    if (fynode_data) {
			fast = eBLACK(fynode_data);
		    } else {
			fast = 1;
		    }

		    if (fast) {
			struct fpnode_type *fhnode_data;

			fhnode_data = fgnode_data->uplink_data;
			if (fhnode_data) {
			} else {
			    fhnode_data =
				&tzline(tzline)->link_a.fpline.fplink;
			}

			if (ffnode_data->fpnode_data[0] == fqnode_data) {
			    struct fpnode_type *fdnode_data;

			    fdnode_data = fqnode_data->fpnode_data[1];
			    ffnode_data->fpnode_data[0] = fdnode_data;
			    fqnode_data->fpnode_data[1] = ffnode_data;
			    fgnode_data->fpnode_data[1] = fqnode_data;
			    ffnode_data->uplink_data = fqnode_data;
			    if (fdnode_data) {
				fdnode_data->uplink_data = ffnode_data;
			    }

			    ffnode_data = fqnode_data;
			}

			fBLACK(fgnode_data);
			sBLACK(ffnode_data);

			if (1) {
			    struct fpnode_type *fdnode_data;

			    fdnode_data = ffnode_data->fpnode_data[0];
			    fgnode_data->fpnode_data[1] = fdnode_data;
			    ffnode_data->fpnode_data[0] = fgnode_data;
			    if (fhnode_data->fpnode_data[0] == fgnode_data) {
				fhnode_data->fpnode_data[0] = ffnode_data;
			    } else {
				fhnode_data->fpnode_data[1] = ffnode_data;
			    }

			    ffnode_data->uplink_data =
				fgnode_data->uplink_data;
			    fgnode_data->uplink_data = ffnode_data;
			    if (fdnode_data) {
				fdnode_data->uplink_data = fgnode_data;
			    }
			}

			break;
		    } else {
			sBLACK(ffnode_data);
			sBLACK(fynode_data);
			fBLACK(fgnode_data);
			fqnode_data = fgnode_data;
		    }
		}
	    }

	    sBLACK(tzline(tzline)->link_a.fpline.fplink.fpnode_data[0]);
	}
    }

    return status;
}
