/*
 * count2.h
 * Copyright (C) 2008-2009, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4l2_COUNT2_H__
#define __LIBx1f4l2_COUNT2_H__

#if !defined __GNUC__
#include <stdarg.h>
#endif				/* !__GNUC__ */
#include <stdio.h>
#include <unistd.h>

#include <sys/time.h>

#define count2_decls \
    struct timeval finish_gettimeofday, start_gettimeofday

#define start_count2() \
    do {								      \
	gettimeofday(&start_gettimeofday, NULL);			      \
    } while (0)

#define finish_count2() \
    do {								      \
	double count;							      \
									      \
	gettimeofday(&finish_gettimeofday, NULL);			      \
	count = finish_gettimeofday.tv_sec;				      \
	count -= start_gettimeofday.tv_sec;				      \
	count *= 1000000;						      \
	count += finish_gettimeofday.tv_usec;				      \
	count -= start_gettimeofday.tv_usec;				      \
	count /= 1000000;						      \
	count2_print("%.6f seconds\n", count);				      \
    } while (0)

#define finish_count2_l(label, class) \
    do {								      \
	double count;							      \
									      \
	gettimeofday(&finish_gettimeofday, NULL);			      \
	count = finish_gettimeofday.tv_sec;				      \
	count -= start_gettimeofday.tv_sec;				      \
	count *= 1000000;						      \
	count += finish_gettimeofday.tv_usec;				      \
	count -= start_gettimeofday.tv_usec;				      \
	count /= 1000000;						      \
	count2_print("%*s: %.6f seconds\n", class, label, count);	      \
    } while (0)

#if defined __GNUC__
# define count2_print(format, args...) \
    do {								      \
	fprintf(stdout, format, ## args);				      \
    } while (0)
#else
static void
count2_print(char *format, ...)
{
    va_list ap;

    va_start(ap, format);
    vfprintf(stdout, format, ap);
    va_end(ap);
}
#endif				/* __GNUC__ */

#endif				/*  __LIBx1f4l2_COUNT2_H__ */
