/*
 * libx1f4l2.h
 * Copyright (C) 2008, 2009, 2010, 2011, 2012, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4l2_H__
#define __LIBx1f4l2_H__

#define __x1f4_here_case_tcmini__	1
#define __x1f4_here_suit_tcmini__	1

/*
 * bpfset attribute bit definitions
 */
#define X1f4_BPFSET_TRANS_MASK		(1u << 0x00)

/*
 * bpfset error definitions
 */
#define X1f4_BQFSET_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_BPFSET_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_BPFSET_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_BPFSET_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * bpfset error definitions (continued)
 */
#define X1f4_BPFSET_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_BPFSET_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * bqfset attribute bit definitions
 */
#define X1f4_BQFSET_SIZE_FRAME		(1u << 0x00)
#define X1f4_BQFSET_TRANS_MASK		(1u << 0x01)

/*
 * bqfset error definitions
 */
#define X1f4_BQFSET_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_BQFSET_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_BQFSET_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_BQFSET_TEXT_ERROR		X1f4_L2CLIP_TEXT_ERROR

/*
 * bqfset error definitions (continued)
 */
#define X1f4_BQFSET_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_BQFSET_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * dflist attribute bit definitions
 */
#define X1f4_DFLIST_TRANS_MASK		(1u << 0x00)

/*
 * dflist error definitions
 */
#define X1f4_DFLIST_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_DFLIST_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_DFLIST_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_DFLIST_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_DFLIST_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * dllist attribute bit definitions
 */
#define X1f4_DLLIST_TRANS_MASK		(1u << 0x00)

/*
 * dllist error definitions
 */
#define X1f4_DLLIST_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_DLLIST_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_DLLIST_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_DLLIST_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_DLLIST_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR
#define X1f4_DLLIST_TEXT_ERROR		X1f4_L2CLIP_TEXT_ERROR

/*
 * fslist attribute bit definitions
 */
#define X1f4_FSLIST_TRANS_MASK		(1u << 0x00)

/*
 * fslist error definitions
 */
#define X1f4_FSLIST_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_FSLIST_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_FSLIST_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * fspost attribute bit definitions
 */
#define X1f4_FSPOST_TRANS_MASK		(1u << 0x00)

/*
 * fspost error definitions
 */
#define X1f4_FSPOST_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_FSPOST_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_FSPOST_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * l2list attribute bit definitions
 */
#define X1f4_L2LIST_TRANS_MASK		(1u << 0x00)

/*
 * l2list error definitions
 */
#define X1f4_L2LIST_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_L2LIST_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_L2LIST_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_L2LIST_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_L2LIST_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * l4list attribute bit definitions
 */
#define X1f4_L4LIST_TRANS_MASK		(1u << 0x00)

/*
 * l4list error definitions
 */
#define X1f4_L4LIST_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_L4LIST_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_L4LIST_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_L4LIST_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_L4LIST_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * lsnote attribute bit definitions
 */
#define X1f4_LSNOTE_INNER_MASK		(1u << 0x00)
#define X1f4_LSNOTE_OUTER_MASK		(1u << 0x01)
#define X1f4_LSNOTE_TRANS_MASK		(1u << 0x02)

/*
 * lsnote error definitions
 */
#define X1f4_LSNOTE_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_LSNOTE_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_LSNOTE_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * lsnote error definitions (continued)
 */
#define X1f4_LSNOTE_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH

/*
 * lvlist attribute bit definitions
 */
#define X1f4_LVLIST_TRANS_MASK		(1u << 0x00)

/*
 * lvlist error definitions
 */
#define X1f4_LVLIST_CALL_ERROR		X1f4_L2CLIP_CALL_ERROR
#define X1f4_LVLIST_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_LVLIST_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_LVLIST_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_LVLIST_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_LVLIST_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * nclist attribute bit definitions
 */
#define X1f4_NCLIST_TRANS_MASK		(1u << 0x00)

/*
 * nclist error definitions
 */
#define X1f4_NCLIST_CALL_ERROR		X1f4_L2CLIP_CALL_ERROR
#define X1f4_NCLIST_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_NCLIST_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_NCLIST_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_NCLIST_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_NCLIST_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * nvlist attribute bit definitions
 */
#define X1f4_NVLIST_TRANS_MASK		(1u << 0x00)

/*
 * nvlist error definitions
 */
#define X1f4_NVLIST_CALL_ERROR		X1f4_L2CLIP_CALL_ERROR
#define X1f4_NVLIST_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_NVLIST_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_NVLIST_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_NVLIST_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_NVLIST_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * qcrate attribute bit definitions
 */
#define X1f4_QCRATE_RATE_FRAME		(1u << 0x01)
#define X1f4_QCRATE_TRANS_MASK		(1u << 0x02)

/*
 * qcrate error definitions
 */
#define X1f4_QCRATE_CALL_ERROR		X1f4_L2CLIP_CALL_ERROR
#define X1f4_QCRATE_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_QCRATE_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_QCRATE_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_QCRATE_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_QCRATE_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * qlrate attribute bit definitions
 */
#define X1f4_QLRATE_RATE_FRAME		(1u << 0x01)
#define X1f4_QLRATE_TRANS_MASK		(1u << 0x02)

/*
 * qlrate error definitions
 */
#define X1f4_QLRATE_CALL_ERROR		X1f4_L2CLIP_CALL_ERROR
#define X1f4_QLRATE_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_QLRATE_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_QLRATE_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_QLRATE_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_QLRATE_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * qsrate attribute bit definitions
 */
#define X1f4_QSRATE_FOUR_FRAME		(1u << 0x00)
#define X1f4_QSRATE_RATE_FRAME		(1u << 0x01)
#define X1f4_QSRATE_TRANS_MASK		(1u << 0x02)

/*
 * qsrate error definitions
 */
#define X1f4_QSRATE_CALL_ERROR		X1f4_L2CLIP_CALL_ERROR
#define X1f4_QSRATE_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_QSRATE_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_QSRATE_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_QSRATE_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_QSRATE_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR
#define X1f4_QSRATE_TEXT_ERROR		X1f4_L2CLIP_TEXT_ERROR

/*
 * qxrate attribute bit definitions
 */
#define X1f4_QXRATE_FOUR_FRAME		(1u << 0x00)
#define X1f4_QXRATE_RATE_FRAME		(1u << 0x01)
#define X1f4_QXRATE_TRANS_MASK		(1u << 0x02)

/*
 * qxrate error definitions
 */
#define X1f4_QXRATE_CALL_ERROR		X1f4_L2CLIP_CALL_ERROR
#define X1f4_QXRATE_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_QXRATE_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_QXRATE_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_QXRATE_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_QXRATE_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * s3deck attribute bit definitions
 */
#define X1f4_S3DECK_TRANS_MASK		(1u << 0x00)

/*
 * s3deck error definitions
 */
#define X1f4_S3DECK_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_S3DECK_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_S3DECK_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * s3deck error definitions (continued)
 */
#define X1f4_S3DECK_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_S3DECK_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * s4deck attribute bit definitions
 */
#define X1f4_S4DECK_TRANS_MASK		(1u << 0x00)

/*
 * s4deck error definitions
 */
#define X1f4_S4DECK_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_S4DECK_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_S4DECK_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * s4deck error definitions (continued)
 */
#define X1f4_S4DECK_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH

/*
 * s5deck attribute bit definitions
 */
#define X1f4_S5DECK_TRANS_MASK		(1u << 0x00)

/*
 * s5deck error definitions
 */
#define X1f4_S5DECK_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_S5DECK_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_S5DECK_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * s5deck error definitions (continued)
 */
#define X1f4_S5DECK_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH

/*
 * s8deck attribute bit definitions
 */
#define X1f4_S8DECK_TRANS_MASK		(1u << 0x00)

/*
 * s8deck error definitions
 */
#define X1f4_S8DECK_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_S8DECK_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_S8DECK_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * s8deck error definitions (continued)
 */
#define X1f4_S8DECK_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH

/*
 * scdeck attribute bit definitions
 */
#define X1f4_SCDECK_TRANS_MASK		(1u << 0x00)

/*
 * scdeck error definitions
 */
#define X1f4_SCDECK_CALL_ERROR		X1f4_L2CLIP_CALL_ERROR
#define X1f4_SCDECK_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_SCDECK_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_SCDECK_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_SCDECK_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_SCDECK_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * scdeck error definitions (continued)
 */
#define X1f4_SCDECK_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_SCDECK_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * sfdeck attribute bit definitions
 */
#define X1f4_SFDECK_TRANS_MASK		(1u << 0x00)

/*
 * sfdeck error definitions
 */
#define X1f4_SFDECK_CALL_ERROR		X1f4_L2CLIP_CALL_ERROR
#define X1f4_SFDECK_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_SFDECK_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_SFDECK_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_SFDECK_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_SFDECK_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * sfdeck error definitions (continued)
 */
#define X1f4_SFDECK_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_SFDECK_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * sfnote attribute bit definitions
 */
#define X1f4_SFNOTE_TRANS_MASK		(1u << 0x00)

/*
 * sfnote error definitions
 */
#define X1f4_SFNOTE_CALL_ERROR		X1f4_L2CLIP_CALL_ERROR
#define X1f4_SFNOTE_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_SFNOTE_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_SFNOTE_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_SFNOTE_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_SFNOTE_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * sfnote error definitions (continued)
 */
#define X1f4_SFNOTE_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH

/*
 * sjdeck attribute bit definitions
 */
#define X1f4_SJDECK_TRANS_MASK		(1u << 0x00)

/*
 * sjdeck error definitions
 */
#define X1f4_SJDECK_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_SJDECK_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_SJDECK_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * sjdeck error definitions (continued)
 */
#define X1f4_SJDECK_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_SJDECK_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * sldeck attribute bit definitions
 */
#define X1f4_SLDECK_TRANS_MASK		(1u << 0x00)

/*
 * sldeck error definitions
 */
#define X1f4_SLDECK_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_SLDECK_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_SLDECK_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * sldeck error definitions (continued)
 */
#define X1f4_SLDECK_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_SLDECK_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * tcline attribute bit definitions
 */
#define X1f4_TCLINE_TRANS_MASK		(1u << 0x00)

/*
 * tcline error definitions
 */
#define X1f4_TCLINE_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_TCLINE_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_TCLINE_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_TCLINE_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * tcline error definitions (continued)
 */
#define X1f4_TCLINE_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_TCLINE_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * tclist attribute bit definitions
 */
#define X1f4_TCLIST_TRANS_MASK		(1u << 0x00)

/*
 * tclist error definitions
 */
#define X1f4_TCLIST_CALL_ERROR		X1f4_L2CLIP_CALL_ERROR
#define X1f4_TCLIST_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_TCLIST_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_TCLIST_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_TCLIST_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_TCLIST_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * tcmini error definitions
 */
#define X1f4_TCMINI_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_TCMINI_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_TCMINI_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_TCMINI_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * tcmini error definitions (continued)
 */
#define X1f4_TCMINI_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_TCMINI_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * tcmini size definitions
 */
#define X1f4_TCMINI_SIZE_BOUND		(1 << 14)

/*
 * tfline attribute bit definitions
 */
#define X1f4_TFLINE_TRANS_MASK		(1u << 0x00)

/*
 * tfline error definitions
 */
#define X1f4_TFLINE_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_TFLINE_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_TFLINE_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_TFLINE_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * tfline error definitions (continued)
 */
#define X1f4_TFLINE_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_TFLINE_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * tnline attribute bit definitions
 */
#define X1f4_TNLINE_TRANS_MASK		(1u << 0x00)

/*
 * tnline error definitions
 */
#define X1f4_TNLINE_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_TNLINE_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_TNLINE_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_TNLINE_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * tnline error definitions (continued)
 */
#define X1f4_TNLINE_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_TNLINE_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * tqline attribute bit definitions
 */
#define X1f4_TQLINE_TRANS_MASK		(1u << 0x00)

/*
 * tqline error definitions
 */
#define X1f4_TQLINE_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_TQLINE_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_TQLINE_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_TQLINE_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * tqline error definitions (continued)
 */
#define X1f4_TQLINE_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_TQLINE_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * tsline attribute bit definitions
 */
#define X1f4_TSLINE_TRANS_MASK		(1u << 0x00)

/*
 * tsline error definitions
 */
#define X1f4_TSLINE_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_TSLINE_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_TSLINE_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_TSLINE_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * tsline error definitions (continued)
 */
#define X1f4_TSLINE_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_TSLINE_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * tslist attribute bit definitions
 */
#define X1f4_TSLIST_TRANS_MASK		(1u << 0x00)

/*
 * tslist error definitions
 */
#define X1f4_TSLIST_CALL_ERROR		X1f4_L2CLIP_CALL_ERROR
#define X1f4_TSLIST_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_TSLIST_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_TSLIST_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_TSLIST_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_TSLIST_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * tvline attribute bit definitions
 */
#define X1f4_TVLINE_TRANS_MASK		(1u << 0x00)

/*
 * tvline error definitions
 */
#define X1f4_TVLINE_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_TVLINE_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_TVLINE_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_TVLINE_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * tvline error definitions (continued)
 */
#define X1f4_TVLINE_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_TVLINE_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * tvlist attribute bit definitions
 */
#define X1f4_TVLIST_TRANS_MASK		(1u << 0x00)

/*
 * tvlist error definitions
 */
#define X1f4_TVLIST_CALL_ERROR		X1f4_L2CLIP_CALL_ERROR
#define X1f4_TVLIST_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_TVLIST_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_TVLIST_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_TVLIST_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR
#define X1f4_TVLIST_SIZE_ERROR		X1f4_L2CLIP_SIZE_ERROR

/*
 * tvlist error definitions (continued)
 */
#define X1f4_TVLIST_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH

/*
 * tzline attribute bit definitions
 */
#define X1f4_TZLINE_TRANS_MASK		(1u << 0x00)

/*
 * tzline error definitions
 */
#define X1f4_TZLINE_DECK_ERROR		X1f4_L2CLIP_DECK_ERROR
#define X1f4_TZLINE_FREE_ERROR		X1f4_L2CLIP_FREE_ERROR
#define X1f4_TZLINE_LINK_ERROR		X1f4_L2CLIP_LINK_ERROR
#define X1f4_TZLINE_MODE_ERROR		X1f4_L2CLIP_MODE_ERROR

/*
 * tzline error definitions (continued)
 */
#define X1f4_TZLINE_EVER_MATCH		X1f4_L2CLIP_EVER_MATCH
#define X1f4_TZLINE_MISS_CLASS		X1f4_L2CLIP_MISS_CLASS

/*
 * x1f4l2 error definitions
 */
#define X1f4_L2CLIP_CALL_ERROR		-1
#define X1f4_L2CLIP_DECK_ERROR		-2
#define X1f4_L2CLIP_FREE_ERROR		-3
#define X1f4_L2CLIP_LINK_ERROR		-4
#define X1f4_L2CLIP_MODE_ERROR		-5
#define X1f4_L2CLIP_MOVE_ERROR		-5
#define X1f4_L2CLIP_SIZE_ERROR		-7
#define X1f4_L2CLIP_TEXT_ERROR		-8

/*
 * x1f4l2 error definitions (continued)
 */
#define X1f4_L2CLIP_EVER_MATCH		1
#define X1f4_L2CLIP_MISS_CLASS		2

#define x1f4_file_fslist(___a, ___b) \
    x1f4_file_fspost((___a), (___b))
#define x1f4_line_fslist(___a, ___b, ___c) \
    x1f4_line_fspost((___a), (___b), (___c))
#define x1f4_rand_fslist(___a) \
    x1f4_rand_tslist((___a))
#define x1f4_size_fslist(___a, ___b) \
    x1f4_size_tslist((___a), (___b))
#define x1f4_type_fslist(___a, ___b) \
    x1f4_type_fspost((___a), (___b))

#if 1
# define __x1f4_pick_tcmini(___m) \
    (*(unsigned *) (___m))
#endif				/* 1 */

#if __x1f4_here_case_tcmini__
# define x1f4_case_tcmini(___m) \
    (__x1f4_pick_tcmini((___m)) & (((1 << 14) - 1) << 18))
#endif				/* __x1f4_here_case_tcmini__ */

#if __x1f4_here_suit_tcmini__
# define x1f4_suit_tcmini(___m) \
    (__x1f4_pick_tcmini((___m)) & ((1 << 14) - 1))
#endif				/* __x1f4_here_suit_tcmini__ */

#if !defined __x1f4_trans_type_defined__
typedef struct x1f4_trans_type {
    int (*free) (void *, void *), (*link) (void *, void **, unsigned),
	(*mode) (void *, void **, unsigned);
    void *context;
} x1f4_trans_type;
#endif				/* !__x1f4_trans_type_defined__ */

#if !defined __x1f4_trans_type_defined__
# define __x1f4_trans_type_defined__
#endif				/* !__x1f4_trans_type_defined__ */

typedef struct x1f4_bpfset_type {
    void *trans;
} x1f4_bpfset_type;

typedef struct x1f4_bqfset_type {
    int (*fare) (void *, void *), (*look) (void *, void *, unsigned *),
	(*move) (void *, void *, unsigned),
	(*pick) (void *, void *, unsigned *);
    unsigned size;
    void *trans;
} x1f4_bqfset_type;

typedef struct x1f4_dflist_type {
    void *trans;
} x1f4_dflist_type;

typedef struct x1f4_dllist_type {
    unsigned item, node;
    void *trans;
} x1f4_dllist_type;

typedef struct x1f4_fslist_type {
    void *trans;
    unsigned base;
} x1f4_fslist_type;

typedef struct x1f4_fspost_type {
    int (*link) (void *, const char *, unsigned, void *);
    void *trans, *text;
} x1f4_fspost_type;

typedef struct x1f4_l2list_type {
    void *trans;
} x1f4_l2list_type;

typedef struct x1f4_l4list_type {
    void *trans;
} x1f4_l4list_type;

typedef struct x1f4_lsnote_type {
    unsigned inner, outer;
    void *trans;
} x1f4_lsnote_type;

typedef struct x1f4_lvlist_type {
    void *trans;
} x1f4_lvlist_type;

typedef struct x1f4_nclist_type {
    void *trans;
} x1f4_nclist_type;

typedef struct x1f4_nvlist_type {
    void *trans;
} x1f4_nvlist_type;

typedef struct x1f4_qcrate_type {
    unsigned rate, size;
    void *trans;
} x1f4_qcrate_type;

typedef struct x1f4_qlrate_type {
    unsigned rate, size;
    void *trans;
} x1f4_qlrate_type;

typedef struct x1f4_qsrate_type {
    unsigned quarter, rate, size;
    void *trans;
} x1f4_qsrate_type;

typedef struct x1f4_qxrate_type {
    unsigned quarter, rate, size;
    void *trans;
} x1f4_qxrate_type;

typedef struct x1f4_s3deck_type {
    void *trans;
} x1f4_s3deck_type;

typedef struct x1f4_s4deck_type {
    void *trans;
} x1f4_s4deck_type;

typedef struct x1f4_s5deck_type {
    void *trans;
} x1f4_s5deck_type;

typedef struct x1f4_s8deck_type {
    void *trans;
} x1f4_s8deck_type;

typedef struct x1f4_scdeck_type {
    void *trans;
} x1f4_scdeck_type;

typedef struct x1f4_sfdeck_type {
    void *trans;
} x1f4_sfdeck_type;

typedef struct x1f4_sfnote_type {
    void *trans;
} x1f4_sfnote_type;

typedef struct x1f4_sjdeck_type {
    void *trans;
} x1f4_sjdeck_type;

typedef struct x1f4_sldeck_type {
    void *trans;
} x1f4_sldeck_type;

typedef struct x1f4_tccase_type {
    int (*high) (void **, const void **, struct x1f4_trans_type *),
	(*lime) (void *, void *, int (*) (void *, void *)),
	(*miss) (void **, const void **, const void *,
		 struct x1f4_trans_type *),
	(*mode) (void **, const void *, const void *),
	(*push) (void **, const void **, const void *,
		 struct x1f4_trans_type *), (*size) (void *, unsigned *);
} x1f4_tccase_type;

typedef struct x1f4_tcline_type {
    void *trans;
} x1f4_tcline_type;

typedef struct x1f4_tclist_type {
    void *trans;
} x1f4_tclist_type;

typedef struct x1f4_tfline_type {
    void *trans;
} x1f4_tfline_type;

typedef struct x1f4_tnline_type {
    void *trans;
} x1f4_tnline_type;

typedef struct x1f4_tqline_type {
    void *trans;
} x1f4_tqline_type;

typedef struct x1f4_tsline_type {
    void *trans;
} x1f4_tsline_type;

typedef struct x1f4_tslist_type {
    void *trans;
} x1f4_tslist_type;

typedef struct x1f4_tvline_type {
    void *trans;
} x1f4_tvline_type;

typedef struct x1f4_tvlist_type {
    void *trans;
} x1f4_tvlist_type;

typedef struct x1f4_tzline_type {
    void *trans;
} x1f4_tzline_type;

extern int x1f4_back_fslist(void **, void *);
extern int x1f4_bank_scdeck
    (void *, void *, int (*) (void *, const char *, unsigned));
extern int x1f4_bank_sfdeck
    (void *, void *, int (*) (void *, const char *, unsigned));
extern int x1f4_base_tcline(unsigned *);
extern int x1f4_base_tsline(unsigned *);
extern int x1f4_base_tfline(unsigned *);
extern int x1f4_base_tnline(unsigned *);
extern int x1f4_base_tqline(unsigned *);
extern int x1f4_base_tvline(unsigned *);
extern int x1f4_base_tzline(unsigned *);
extern int x1f4_beta_fslist(void *, unsigned, void **);
extern int x1f4_bind_s4path(void *, const char *, unsigned, const void ***);
extern int x1f4_bind_scdeck(void *, const char *, const void ***);
extern int x1f4_call_bpfset(unsigned *);
extern int x1f4_call_bqfset(unsigned *);
extern int x1f4_call_dllist(unsigned *);
extern int x1f4_call_fspost(unsigned *);
extern int x1f4_call_nclist(unsigned *);
extern int x1f4_call_nvlist(unsigned *);
extern int x1f4_call_qlrate(unsigned *);
extern int x1f4_call_qsrate(unsigned *);
extern int x1f4_call_sfnote(unsigned *);
extern int x1f4_call_tcline(unsigned *);
extern int x1f4_call_tclist(unsigned *);
extern int x1f4_call_tfline(unsigned *);
extern int x1f4_call_tsline(unsigned *);
extern int x1f4_call_tslist(unsigned *);
extern int x1f4_call_tvline(unsigned *);
extern int x1f4_call_tvlist(unsigned *);
extern int x1f4_case_bqfset(void *);
extern int x1f4_case_qlrate(void *);
extern int x1f4_case_qsrate(void *);
extern int x1f4_case_qxrate(void *);
extern int x1f4_case_s3deck(void *);
extern int x1f4_case_s4deck(void *);
extern int x1f4_case_s5deck(void *);
extern int x1f4_case_scdeck(void *);
extern int x1f4_case_sfdeck(void *);
extern int x1f4_case_sfnote(void *);
extern int x1f4_case_sldeck(void *);
extern int x1f4_case_tcline(void *);
#if __x1f4_here_case_tcmini__
#else
extern int x1f4_case_tcmini(void *);
#endif				/* __x1f4_here_case_tcmini__ */
extern int x1f4_case_tfline(void *);
extern int x1f4_case_tnline(void *);
extern int x1f4_case_tqline(void *);
extern int x1f4_case_tsline(void *);
extern int x1f4_case_tvline(void *);
extern int x1f4_case_tzline(void *);
extern int x1f4_cast_bppset(void *, void *);
extern int x1f4_cast_bqfset(void *, void *);
extern int x1f4_cast_bqpset(void *, void *);
extern int x1f4_cast_s3deck(void *, const char *);
extern int x1f4_cast_scdeck(void *, const char *);
extern int x1f4_cast_sfdeck(void *, const char *);
extern int x1f4_cast_sjdeck(void *, const char *);
extern int x1f4_cast_sldeck(void *, const char *);
extern int x1f4_cast_tcline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_cast_tfline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_cast_tnline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_cast_tqline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_cast_tsline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_cast_tvline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_cast_tzline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_clip_nclist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int x1f4_clip_nvlist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int x1f4_clip_tclist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int x1f4_clip_tslist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int x1f4_clip_tvlist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int x1f4_copy_l4list
    (void **, void *, int (*) (unsigned *, const void *));
extern int x1f4_copy_s3deck(void **, void *);
extern int x1f4_copy_s5deck(void **, void *);
extern int x1f4_dash_qsrate(void *, unsigned, unsigned);
extern int x1f4_deck_l4list(void *, int);
extern int x1f4_deck_nclist(void *, int);
extern int x1f4_deck_nvlist(void *, int);
extern int x1f4_deck_tclist(void *, int);
extern int x1f4_deck_tslist(void *, int);
extern int x1f4_deck_tvlist(void *, int);
extern int x1f4_deux_l4list(void *, unsigned, void *, unsigned);
extern int x1f4_deux_nclist(void *, unsigned, void *, unsigned);
extern int x1f4_deux_tclist(void *, unsigned, void *, unsigned);
extern int x1f4_deux_tslist(void *, unsigned, void *, unsigned);
extern int x1f4_deux_tvlist(void *, unsigned, void *, unsigned);
extern int x1f4_draw_bqfset(void *, void *, int (*) (void *, void *));
extern int x1f4_dump_fspost
    (void *, void *, int (*) (void *, const char *, unsigned));
extern int x1f4_ever_bqfset(void *, void **);
extern int x1f4_ever_dflist(void *, void **);
extern int x1f4_ever_dllist(void *, void **);
extern int x1f4_ever_l2list(void *, void **);
extern int x1f4_ever_lvlist(void *, void **);
extern int x1f4_ever_nclist(void *, void **);
extern int x1f4_ever_nvlist(void *, void **);
extern int x1f4_ever_qlrate(void *, void **);
extern int x1f4_ever_qsrate(void *, void **);
extern int x1f4_ever_scdeck(void *, const void **);
extern int x1f4_ever_sfdeck(void *, const void **);
extern int x1f4_ever_sfnote(void *, void **);
extern int x1f4_ever_tcline(void *, void **);
extern int x1f4_ever_tclist(void *, void **);
extern int x1f4_ever_tfline(void *, void **);
extern int x1f4_ever_tnline(void *, void **);
extern int x1f4_ever_tqline(void *, void **);
extern int x1f4_ever_tsline(void *, void **);
extern int x1f4_ever_tslist(void *, void **);
extern int x1f4_ever_tvline(void *, void **);
extern int x1f4_ever_tvlist(void *, void **);
extern int x1f4_ever_tzline(void *, void **);
extern int x1f4_fast_bpfset(void *, unsigned, struct x1f4_bpfset_type *);
extern int x1f4_fast_bqfset(void *, unsigned, struct x1f4_bqfset_type *);
extern int x1f4_fast_dflist(void *, unsigned, struct x1f4_dflist_type *);
extern int x1f4_fast_dllist(void *, unsigned, struct x1f4_dllist_type *);
extern int x1f4_fast_fspost(void *, unsigned, struct x1f4_fspost_type *);
extern int x1f4_fast_l2list(void *, unsigned, struct x1f4_l2list_type *);
extern int x1f4_fast_lsnote(void *, unsigned, struct x1f4_lsnote_type *);
extern int x1f4_fast_lvlist(void *, unsigned, struct x1f4_lvlist_type *);
extern int x1f4_fast_nclist(void *, unsigned, struct x1f4_nclist_type *);
extern int x1f4_fast_nvlist(void *, unsigned, struct x1f4_nvlist_type *);
extern int x1f4_fast_qcrate(void *, unsigned, struct x1f4_qcrate_type *);
extern int x1f4_fast_qlrate(void *, unsigned, struct x1f4_qlrate_type *);
extern int x1f4_fast_qsrate(void *, unsigned, struct x1f4_qsrate_type *);
extern int x1f4_fast_qxrate(void *, unsigned, struct x1f4_qxrate_type *);
extern int x1f4_fast_s3deck(void *, unsigned, struct x1f4_s3deck_type *);
extern int x1f4_fast_s4deck(void *, unsigned, struct x1f4_s4deck_type *);
extern int x1f4_fast_s5deck(void *, unsigned, struct x1f4_s5deck_type *);
extern int x1f4_fast_s8deck(void *, unsigned, struct x1f4_s8deck_type *);
extern int x1f4_fast_scdeck(void *, unsigned, struct x1f4_scdeck_type *);
extern int x1f4_fast_sfdeck(void *, unsigned, struct x1f4_sfdeck_type *);
extern int x1f4_fast_sfnote(void *, unsigned, struct x1f4_sfnote_type *);
extern int x1f4_fast_sjdeck(void *, unsigned, struct x1f4_sjdeck_type *);
extern int x1f4_fast_sldeck(void *, unsigned, struct x1f4_sldeck_type *);
extern int x1f4_fast_tcline(void *, unsigned, struct x1f4_tcline_type *);
extern int x1f4_fast_tclist(void *, unsigned, struct x1f4_tclist_type *);
extern int x1f4_fast_tfline(void *, unsigned, struct x1f4_tfline_type *);
extern int x1f4_fast_tnline(void *, unsigned, struct x1f4_tnline_type *);
extern int x1f4_fast_tqline(void *, unsigned, struct x1f4_tsline_type *);
extern int x1f4_fast_tsline(void *, unsigned, struct x1f4_tsline_type *);
extern int x1f4_fast_tslist(void *, unsigned, struct x1f4_tslist_type *);
extern int x1f4_fast_tvline(void *, unsigned, struct x1f4_tvline_type *);
extern int x1f4_fast_tvlist(void *, unsigned, struct x1f4_tvlist_type *);
extern int x1f4_fast_tzline(void *, unsigned, struct x1f4_tzline_type *);
extern int x1f4_fgvq_scdeck
    (void *, const char *, const void ***, char **, unsigned *, unsigned *);
extern int x1f4_fgxd_bqfset(void *, void *, void **);
extern int x1f4_fgxd_scdeck(void *, const char *, const void ***);
extern int x1f4_fgxd_sfdeck(void *, const char *, const void ***);
extern int x1f4_fgxd_tcline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_fgxd_tsline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_fgxd_tvline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_fgxp_nclist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_fgxp_nvlist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_fgxp_tclist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_fgxp_tslist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_fgxp_tvlist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_fgxq_sfnote
    (void *, const char *, void **, const char **, unsigned *);
extern int x1f4_fgzd_bqfset(void *, void *, void *, int (*) (void *, void *));
extern int x1f4_file_fspost(void *, unsigned *);
extern int x1f4_fill_s5deck(void *, void *);
extern int x1f4_find_bppset(void *, void *);
extern int x1f4_find_bqfset(void *, void *, void **);
extern int x1f4_find_bqpset(void *, void *);
extern int x1f4_find_fslist
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_find_lsbill(void *, const char *, unsigned, void **);
extern int x1f4_find_nclist
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_find_s3deck(void *, const char *, const void **);
extern int x1f4_find_s3path(void *, const char *, unsigned, const void **);
extern int x1f4_find_s4path(void *, const char *, unsigned, const void **);
extern int x1f4_find_s5path(void *, const char *, unsigned, const void **);
extern int x1f4_find_s8path(void *, const char *, unsigned, const void **);
extern int x1f4_find_scdeck(void *, const char *, const void **);
extern int x1f4_find_sfdeck(void *, const char *, const void **);
extern int x1f4_find_sfnote(void *, const char *, void **);
extern int x1f4_find_sjdeck(void *, const char *, const void **);
extern int x1f4_find_sldeck(void *, const char *, const void **);
extern int x1f4_find_tcclip
    (void *, unsigned long, unsigned, void **);
extern int x1f4_find_tcfare
    (void *, unsigned, unsigned, void **);
extern int x1f4_find_tcfine
    (void *, unsigned, unsigned, void **);
extern int x1f4_find_tcline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_find_tclist
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_find_tcmini
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_find_tcnear
    (void *, unsigned long, unsigned, void **);
extern int x1f4_find_tcword
    (void *, const unsigned char *, unsigned, void **);
extern int x1f4_find_tfline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_find_tnline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_find_tqline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_find_tsline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_find_tslist
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_find_tvline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_find_tvlist
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_find_tzline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_fine_nclist(void *, void *, int (*) (void *, void *));
extern int x1f4_fine_tclist(void *, void *, int (*) (void *, void *));
extern int x1f4_fine_tslist(void *, void *, int (*) (void *, void *));
extern int x1f4_fine_tvlist(void *, void *, int (*) (void *, void *));
extern int x1f4_fini_bpfset(void **);
extern int x1f4_fini_bqfset(void **);
extern int x1f4_fini_dflist(void **);
extern int x1f4_fini_dllist(void **);
extern int x1f4_fini_fslist(void **);
extern int x1f4_fini_fspost(void **);
extern int x1f4_fini_l2list(void **);
extern int x1f4_fini_l4list(void **);
extern int x1f4_fini_lsnote(void **);
extern int x1f4_fini_lvlist(void **);
extern int x1f4_fini_nclist(void **);
extern int x1f4_fini_nvlist(void **);
extern int x1f4_fini_qcrate(void **);
extern int x1f4_fini_qlrate(void **);
extern int x1f4_fini_qsrate(void **);
extern int x1f4_fini_qxrate(void **);
extern int x1f4_fini_s3deck(void **);
extern int x1f4_fini_s4deck(void **);
extern int x1f4_fini_s5deck(void **);
extern int x1f4_fini_s8deck(void **);
extern int x1f4_fini_scdeck(void **);
extern int x1f4_fini_sfdeck(void **);
extern int x1f4_fini_sfnote(void **);
extern int x1f4_fini_sjdeck(void **);
extern int x1f4_fini_sldeck(void **);
extern int x1f4_fini_tcline(void **);
extern int x1f4_fini_tclist(void **);
extern int x1f4_fini_tcvset(void **, const void **, struct x1f4_trans_type *);
extern int x1f4_fini_tfline(void **);
extern int x1f4_fini_tnline(void **);
extern int x1f4_fini_tqline(void **);
extern int x1f4_fini_tsline(void **);
extern int x1f4_fini_tslist(void **);
extern int x1f4_fini_tvline(void **);
extern int x1f4_fini_tvlist(void **);
extern int x1f4_fini_tzline(void **);
extern int x1f4_flat_bpfset(void *);
extern int x1f4_flat_bqfset(void *);
extern int x1f4_flat_dflist(void *);
extern int x1f4_flat_dllist(void *);
extern int x1f4_flat_fspost(void *);
extern int x1f4_flat_l2list(void *);
extern int x1f4_flat_lsnote(void *);
extern int x1f4_flat_lvlist(void *);
extern int x1f4_flat_nclist(void *);
extern int x1f4_flat_nvlist(void *);
extern int x1f4_flat_qcrate(void *);
extern int x1f4_flat_qlrate(void *);
extern int x1f4_flat_qsrate(void *);
extern int x1f4_flat_qxrate(void *);
extern int x1f4_flat_s3deck(void *);
extern int x1f4_flat_s4deck(void *);
extern int x1f4_flat_s5deck(void *);
extern int x1f4_flat_s8deck(void *);
extern int x1f4_flat_scdeck(void *);
extern int x1f4_flat_sfdeck(void *);
extern int x1f4_flat_sfnote(void *);
extern int x1f4_flat_sjdeck(void *);
extern int x1f4_flat_sldeck(void *);
extern int x1f4_flat_tcline(void *);
extern int x1f4_flat_tclist(void *);
extern int x1f4_flat_tfline(void *);
extern int x1f4_flat_tnline(void *);
extern int x1f4_flat_tqline(void *);
extern int x1f4_flat_tsline(void *);
extern int x1f4_flat_tslist(void *);
extern int x1f4_flat_tvline(void *);
extern int x1f4_flat_tvlist(void *);
extern int x1f4_flat_tzline(void *);
extern int x1f4_flip_dflist(void *);
extern int x1f4_flip_l2list(void *);
extern int x1f4_flip_nclist(void *);
extern int x1f4_flip_nvlist(void *);
extern int x1f4_flip_qsrate(void *);
extern int x1f4_flip_tclist(void *);
extern int x1f4_flip_tslist(void *);
extern int x1f4_flip_tvlist(void *);
extern int x1f4_flow_bppset(void *);
extern int x1f4_flow_bqpset(void *);
extern int x1f4_flow_lvlist(void *);
extern int x1f4_flow_nclist(void *);
extern int x1f4_flow_nvlist(void *);
extern int x1f4_flow_tclist(void *);
extern int x1f4_flow_tslist(void *);
extern int x1f4_flow_tvlist(void *);
extern int x1f4_fmxd_bqfset(void *, void *, void **);
extern int x1f4_fmxd_tcline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_fmxd_tsline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_fmxd_tvline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_fmxp_nvlist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_fmxp_tslist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_fold_sfnote(void *, void **, const char **, unsigned *);
extern int x1f4_fxxd_bqfset(void *, void *, void **);
extern int x1f4_fxxd_tcline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_fxxd_tsline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_fxxd_tvline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_fxxp_nvlist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_fxxp_tslist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_fxzd_bqfset(void *, void *, void *, int (*) (void *, void *));
extern int x1f4_head_dflist(void *, unsigned, void **);
extern int x1f4_head_dllist(void *, void **);
extern int x1f4_head_l2list(void *, unsigned, void **);
extern int x1f4_head_l4list(void *, unsigned, void **);
extern int x1f4_head_lvlist(void *, unsigned, void **);
extern int x1f4_head_nclist(void *, unsigned, void **);
extern int x1f4_head_nvlist(void *, unsigned, void **);
extern int x1f4_head_qsrate(void *, void **);
extern int x1f4_head_tclist(void *, unsigned, void **);
extern int x1f4_head_tslist(void *, unsigned, void **);
extern int x1f4_head_tvlist(void *, unsigned, void **);
extern int x1f4_high_bpfset(void *);
extern int x1f4_high_bqfset(void *);
extern int x1f4_high_dflist(void *);
extern int x1f4_high_dllist(void *);
extern int x1f4_high_l2list(void *);
extern int x1f4_high_lvlist(void *);
extern int x1f4_high_nclist(void *);
extern int x1f4_high_nvlist(void *);
extern int x1f4_high_qcrate(void *);
extern int x1f4_high_qlrate(void *);
extern int x1f4_high_qsrate(void *);
extern int x1f4_high_qxrate(void *);
extern int x1f4_high_scdeck(void *);
extern int x1f4_high_sfdeck(void *);
extern int x1f4_high_sfnote(void *);
extern int x1f4_high_tcline(void *);
extern int x1f4_high_tclist(void *);
extern int x1f4_high_tfline(void *);
extern int x1f4_high_tnline(void *);
extern int x1f4_high_tqline(void *);
extern int x1f4_high_tsline(void *);
extern int x1f4_high_tslist(void *);
extern int x1f4_high_tvline(void *);
extern int x1f4_high_tvlist(void *);
extern int x1f4_high_tzline(void *);
extern int x1f4_hike_sfnote(void *, void **, const char **, unsigned *);
extern int x1f4_hook_s3deck
    (void *, void *, int (*) (void *, const void *, const char *, unsigned),
     char *);
extern int x1f4_init_bpfset(void **, unsigned, struct x1f4_bpfset_type *);
extern int x1f4_init_bqfset(void **, unsigned, struct x1f4_bqfset_type *);
extern int x1f4_init_dflist(void **, unsigned, struct x1f4_dflist_type *);
extern int x1f4_init_dllist(void **, unsigned, struct x1f4_dllist_type *);
extern int x1f4_init_fslist(void **, unsigned, struct x1f4_fslist_type *);
extern int x1f4_init_fspost(void **, unsigned, struct x1f4_fspost_type *);
extern int x1f4_init_l2list(void **, unsigned, struct x1f4_l2list_type *);
extern int x1f4_init_l4list(void **, unsigned, struct x1f4_l4list_type *);
extern int x1f4_init_lsnote(void **, unsigned, struct x1f4_lsnote_type *);
extern int x1f4_init_lvlist(void **, unsigned, struct x1f4_lvlist_type *);
extern int x1f4_init_nclist(void **, unsigned, struct x1f4_nclist_type *);
extern int x1f4_init_nvlist(void **, unsigned, struct x1f4_nvlist_type *);
extern int x1f4_init_qcrate(void **, unsigned, struct x1f4_qcrate_type *);
extern int x1f4_init_qlrate(void **, unsigned, struct x1f4_qlrate_type *);
extern int x1f4_init_qsrate(void **, unsigned, struct x1f4_qsrate_type *);
extern int x1f4_init_qxrate(void **, unsigned, struct x1f4_qxrate_type *);
extern int x1f4_init_s3deck(void **, unsigned, struct x1f4_s3deck_type *);
extern int x1f4_init_s4deck(void **, unsigned, struct x1f4_s4deck_type *);
extern int x1f4_init_s5deck(void **, unsigned, struct x1f4_s5deck_type *);
extern int x1f4_init_s8deck(void **, unsigned, struct x1f4_s8deck_type *);
extern int x1f4_init_scdeck(void **, unsigned, struct x1f4_scdeck_type *);
extern int x1f4_init_sfdeck(void **, unsigned, struct x1f4_sfdeck_type *);
extern int x1f4_init_sfnote(void **, unsigned, struct x1f4_sfnote_type *);
extern int x1f4_init_sjdeck(void **, unsigned, struct x1f4_sjdeck_type *);
extern int x1f4_init_sldeck(void **, unsigned, struct x1f4_sldeck_type *);
extern int x1f4_init_tcline(void **, unsigned, struct x1f4_tcline_type *);
extern int x1f4_init_tclist(void **, unsigned, struct x1f4_tclist_type *);
extern int x1f4_init_tcvset(void **, const void **);
extern int x1f4_init_tfline(void **, unsigned, struct x1f4_tfline_type *);
extern int x1f4_init_tnline(void **, unsigned, struct x1f4_tnline_type *);
extern int x1f4_init_tqline(void **, unsigned, struct x1f4_tqline_type *);
extern int x1f4_init_tsline(void **, unsigned, struct x1f4_tsline_type *);
extern int x1f4_init_tslist(void **, unsigned, struct x1f4_tslist_type *);
extern int x1f4_init_tvline(void **, unsigned, struct x1f4_tvline_type *);
extern int x1f4_init_tvlist(void **, unsigned, struct x1f4_tvlist_type *);
extern int x1f4_init_tzline(void **, unsigned, struct x1f4_tzline_type *);
extern int x1f4_jack_scdeck(void *, void *);
extern int x1f4_land_lvlist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_land_nclist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_land_nvlist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_land_tcline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_land_tclist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_land_tfline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_land_tnline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_land_tqline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_land_tsline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_land_tslist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_land_tvlist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_land_tvline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_land_tzline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_last_fslist
    (void *, void **, void **, void **, void **, void *);
extern int x1f4_last_l2list(void **, void *);
extern int x1f4_last_lvlist(void **, void *);
extern int x1f4_last_nvlist(void **, void *);
extern int x1f4_last_tqline(void **, void *);
extern int x1f4_last_tsline(void **, void *);
extern int x1f4_last_tslist(void **, void *);
extern int x1f4_last_tvline(void **, void *);
extern int x1f4_last_tvlist(void **, void *);
extern int x1f4_last_tzline(void **, void *);
extern int x1f4_lead_bqfset(void *, void **);
extern int x1f4_lead_dflist(void *, void **);
extern int x1f4_lead_dllist(void *, void **);
extern int x1f4_lead_l2list(void *, void **);
extern int x1f4_lead_lvlist(void *, void **);
extern int x1f4_lead_nclist(void *, void **);
extern int x1f4_lead_nvlist(void *, void **);
extern int x1f4_lead_qlrate(void *, void **);
extern int x1f4_lead_qsrate(void *, void **);
extern int x1f4_lead_scdeck(void *, const void **);
extern int x1f4_lead_sfdeck(void *, const void **);
extern int x1f4_lead_sfnote(void *, void **);
extern int x1f4_lead_tcline(void *, void **);
extern int x1f4_lead_tclist(void *, void **);
extern int x1f4_lead_tfline(void *, void **);
extern int x1f4_lead_tnline(void *, void **);
extern int x1f4_lead_tqline(void *, void **);
extern int x1f4_lead_tsline(void *, void **);
extern int x1f4_lead_tslist(void *, void **);
extern int x1f4_lead_tvline(void *, void **);
extern int x1f4_lead_tvlist(void *, void **);
extern int x1f4_lead_tzline(void *, void **);
extern int x1f4_lift_scdeck
    (void *, const void **, char **, unsigned *, unsigned *);
extern int x1f4_lime_bpfset(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_bqfset(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_dflist(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_dllist(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_l2list(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_l4list(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_lvlist(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_nclist(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_nvlist(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_qcrate(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_qlrate(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_qsrate(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_qxrate(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_s3deck(void *, void *, int (*) (void *, const void *));
extern int x1f4_lime_s4deck(void *, void *, int (*) (void *, const void *));
extern int x1f4_lime_s5deck(void *, void *, int (*) (void *, const void *));
extern int x1f4_lime_scdeck(void *, void *, int (*) (void *, const void *));
extern int x1f4_lime_sfdeck(void *, void *, int (*) (void *, const void *));
extern int x1f4_lime_sldeck(void *, void *, int (*) (void *, const void *));
extern int x1f4_lime_sfnote(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_tcline(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_tclist(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_tcmini(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_tfline(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_tnline(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_tqline(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_tsline(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_tslist(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_tvline(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_tvlist(void *, void *, int (*) (void *, void *));
extern int x1f4_lime_tzline(void *, void *, int (*) (void *, void *));
extern int x1f4_line_dllist
    (void *, void *, int (*) (void *, void *, const void *),
     int (*) (void *, void *), void *);
extern int x1f4_line_fspost
    (void *, void *, int (*) (void *, const char *, unsigned));
extern int x1f4_line_l4list
    (void *, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int x1f4_line_nclist
    (void *, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int x1f4_line_qsrate
    (void *, void *, int (*) (void *, void *, const void *),
     int (*) (void *, void *), void *);
extern int x1f4_line_scdeck
    (void *, void *, int (*) (void *, const void **, const void *),
     int (*) (void *, const void *), void *);
extern int x1f4_line_sfdeck
    (void *, void *, int (*) (void *, const void **, const void *),
     int (*) (void *, const void *), void *);
extern int x1f4_line_sfnote
    (void *, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int x1f4_line_tclist
    (void *, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int x1f4_line_tslist
    (void *, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int x1f4_line_tvlist
    (void *, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int x1f4_list_s3deck
    (void *, void *, int (*) (void *, const char *, unsigned), char *);
extern int x1f4_list_scdeck
    (void *, void *, int (*) (void *, const char *, unsigned), char *);
extern int x1f4_list_sfdeck
    (void *, void *, int (*) (void *, const char *, unsigned), char *);
extern int x1f4_list_sjdeck
    (void *, void *, int (*) (void *, const char *, unsigned), char *);
extern int x1f4_list_sldeck
    (void *, void *, int (*) (void *, const char *, unsigned), char *);
extern int x1f4_llvq_scdeck
    (void *, const char *, const void ***, char **, unsigned *, unsigned *);
extern int x1f4_llxd_bqfset(void *, void *, void **);
extern int x1f4_llxd_scdeck(void *, const char *, const void ***);
extern int x1f4_llxd_sfdeck(void *, const char *, const void ***);
extern int x1f4_llxd_tcfare
    (void *, unsigned, unsigned, void **);
extern int x1f4_llxd_tcline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_llxd_tcmini
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_llxd_tsline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_llxd_tvline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_llxp_nvlist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_llxp_tslist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_llxq_sfnote
    (void *, const char *, void **, const char **, unsigned *);
extern int x1f4_llzd_bqfset(void *, void *, void *, int (*) (void *, void *));
extern int x1f4_lmxd_bqfset(void *, void *, void **);
extern int x1f4_lmxd_tcline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_lmxd_tsline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_lmxd_tvline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_lmxp_nvlist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_lmxp_tslist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_lock_fslist(void **, void *);
extern int x1f4_look_tcfare
    (void *, unsigned, unsigned, void **);
extern int x1f4_look_tcmini
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_lxxd_bqfset(void *, void *, void **);
extern int x1f4_lxxd_tcfare
    (void *, unsigned, unsigned, void **);
extern int x1f4_lxxd_tcline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_lxxd_tcmini
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_lxxd_tsline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_lxxd_tvline
    (void *, void *, unsigned, int (*) (void *, void *), void **);
extern int x1f4_lxxp_nvlist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_lxxp_tslist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_lxzd_bqfset(void *, void *, void *, int (*) (void *, void *));
extern int x1f4_mind_bqfset(void *);
extern int x1f4_mind_dflist(void *);
extern int x1f4_mind_dllist(void *);
extern int x1f4_mind_l2list(void *);
extern int x1f4_mind_nclist(void *);
extern int x1f4_mind_nvlist(void *);
extern int x1f4_mind_qsrate(void *);
extern int x1f4_mind_scdeck(void *);
extern int x1f4_mind_sfdeck(void *);
extern int x1f4_mind_sfnote(void *);
extern int x1f4_mind_tclist(void *);
extern int x1f4_mind_tslist(void *);
extern int x1f4_mind_tvlist(void *);
extern int x1f4_miss_fslist(void *, unsigned);
extern int x1f4_miss_fspost(void *, void *);
extern int x1f4_miss_l4list(void *, unsigned);
extern int x1f4_miss_lvlist(void *, unsigned);
extern int x1f4_miss_nclist(void *, unsigned);
extern int x1f4_miss_nvlist(void *, unsigned);
extern int x1f4_miss_qlrate(void *, unsigned);
extern int x1f4_miss_qsrate(void *, unsigned);
extern int x1f4_miss_qxrate(void *, unsigned);
extern int x1f4_miss_tclist(void *, unsigned);
extern int x1f4_miss_tslist(void *, unsigned);
extern int x1f4_miss_tvlist(void *, unsigned);
extern int x1f4_mode_l4list(void *, unsigned, unsigned, void **);
extern int x1f4_mode_nclist(void *, unsigned, unsigned, void **);
extern int x1f4_mode_nvlist(void *, unsigned, unsigned, void **);
extern int x1f4_mode_tclist(void *, unsigned, unsigned, void **);
extern int x1f4_mode_tslist(void *, unsigned, unsigned, void **);
extern int x1f4_mode_tvlist(void *, unsigned, unsigned, void **);
extern int x1f4_move_l4list(void *, unsigned, unsigned);
extern int x1f4_move_nclist(void *, unsigned, unsigned);
extern int x1f4_move_nvlist(void *, unsigned, unsigned);
extern int x1f4_move_tclist(void *, unsigned, unsigned);
extern int x1f4_move_tslist(void *, unsigned, unsigned);
extern int x1f4_move_tvlist(void *, unsigned, unsigned);
extern int x1f4_near_tcline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_near_tfline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_near_tnline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_near_tqline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_near_tsline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_near_tvline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_near_tzline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_next_fslist
    (void *, void **, void **, void **, void **, void *);
extern int x1f4_next_l2list(void **, void *);
extern int x1f4_next_lvlist(void **, void *);
extern int x1f4_next_nvlist(void **, void *);
extern int x1f4_next_tqline(void **, void *);
extern int x1f4_next_tsline(void **, void *);
extern int x1f4_next_tslist(void **, void *);
extern int x1f4_next_tvline(void **, void *);
extern int x1f4_next_tvlist(void **, void *);
extern int x1f4_next_tzline(void **, void *);
extern int x1f4_nice_nclist(void *, void *, int (*) (void *, void *));
extern int x1f4_nice_tclist(void *, void *, int (*) (void *, void *));
extern int x1f4_nice_tslist(void *, void *, int (*) (void *, void *));
extern int x1f4_nice_tvlist(void *, void *, int (*) (void *, void *));
extern int x1f4_note_lsnote
    (void *, void *, int (*) (void *, const char *, unsigned));
extern int x1f4_note_s4deck
    (void *, void *, int (*) (void *, const char *, unsigned));
extern int x1f4_note_s5deck
    (void *, void *, int (*) (void *, const char *, unsigned));
extern int x1f4_note_s8deck
    (void *, void *, int (*) (void *, const char *, unsigned));
extern int x1f4_note_sfnote
    (void *, void *, int (*) (void *, const char *, unsigned));
extern int x1f4_over_qsrate
    (void *, unsigned, unsigned, void *, int (*) (void *, void *));
extern int x1f4_part_tcmini(void *, void *, unsigned, unsigned, void **);
extern int x1f4_pass_s3deck(void *, const char *);
extern int x1f4_pass_s3path(void *, const char *, unsigned);
extern int x1f4_pass_s4path(void *, const char *, unsigned);
extern int x1f4_pass_s5path(void *, const char *, unsigned);
extern int x1f4_pass_s8path(void *, const char *, unsigned);
extern int x1f4_pass_scdeck(void *, const char *);
extern int x1f4_pass_sfdeck(void *, const char *);
extern int x1f4_pass_sfnote(void *, const char *);
extern int x1f4_pass_sjdeck(void *, const char *);
extern int x1f4_pass_sldeck(void *, const char *);
extern int x1f4_pass_tcline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_pass_tfline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_pass_tnline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_pass_tqline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_pass_tsline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_pass_tvline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_pass_tzline
    (void *, void *, int (*) (void *, void *), unsigned);
extern int x1f4_peek_fslist
    (void *, unsigned, void **, void **, void **, void **);
extern int x1f4_peek_l4list(void *, unsigned, void **);
extern int x1f4_peek_lvlist(void *, unsigned, void **);
extern int x1f4_peek_nclist(void *, unsigned, void **);
extern int x1f4_peek_nvlist(void *, unsigned, void **);
extern int x1f4_peek_qcrate(void *, unsigned, void **);
extern int x1f4_peek_qlrate(void *, unsigned, void **);
extern int x1f4_peek_qsrate(void *, unsigned, void **);
extern int x1f4_peek_qxrate(void *, unsigned, void **);
extern int x1f4_peek_tclist(void *, unsigned, void **);
extern int x1f4_peek_tslist(void *, unsigned, void **);
extern int x1f4_peek_tvlist(void *, unsigned, void **);
extern int x1f4_pick_s3deck(void *, const char *, const void ***);
extern int x1f4_pick_s3path(void *, const char *, unsigned, const void ***);
extern int x1f4_pick_s4path(void *, const char *, unsigned, const void ***);
extern int x1f4_pick_s5path(void *, const char *, unsigned, const void ***);
extern int x1f4_pick_scdeck(void *, const char *, const void ***);
extern int x1f4_plot_scdeck
    (void *, const void **, char **, unsigned *, unsigned *);
extern int x1f4_port_tcmini
    (void *, void *, int (*) (void *, void *), unsigned, void **);
extern int x1f4_post_bppset(void *, void *);
extern int x1f4_post_bqfset(void *, void *, void **);
extern int x1f4_post_bqpset(void *, void *);
extern int x1f4_post_lsbill(void *, const char *, unsigned, unsigned, void **);
extern int x1f4_post_s3deck(void *, const char *, const void *);
extern int x1f4_post_s3path(void *, const char *, unsigned, const void *);
extern int x1f4_post_s4path(void *, const char *, unsigned, const void *);
extern int x1f4_post_s5path(void *, const char *, unsigned, const void *);
extern int x1f4_post_s8path(void *, const char *, unsigned, const void *);
extern int x1f4_post_scdeck(void *, const char *, const void *);
extern int x1f4_post_scpath(void *, const char *, unsigned, const void *);
extern int x1f4_post_sfnote(void *, const char *, unsigned, void **);
extern int x1f4_post_sfdeck(void *, const char *, const void *);
extern int x1f4_post_sjdeck(void *, const char *, const void *);
extern int x1f4_post_sldeck(void *, const char *, const void *);
extern int x1f4_post_tcline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_post_tfline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_post_tnline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_post_tqline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_post_tsline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_post_tvline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_post_tvlist
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_post_tzline
    (void *, void *, int (*) (void *, void *), unsigned, unsigned, void **);
extern int x1f4_pull_nclist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int x1f4_pull_tclist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int x1f4_pull_tslist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int x1f4_pull_tvlist
    (void *, unsigned, void *, int (*) (void *, void *));
extern int x1f4_push_fslist
    (void *, unsigned, unsigned, const char *, unsigned, unsigned *, void **);
extern int x1f4_push_fspost(void *, const char *, unsigned);
extern int x1f4_push_l4list(void *, unsigned, unsigned, void **);
extern int x1f4_push_lvlist(void *, unsigned, unsigned, void **);
extern int x1f4_push_nclist(void *, unsigned, unsigned, void **);
extern int x1f4_push_nvlist(void *, unsigned, unsigned, void **);
extern int x1f4_push_qcrate(void *, unsigned, void **);
extern int x1f4_push_qlrate(void *, unsigned, void **);
extern int x1f4_push_qsrate(void *, unsigned, void **);
extern int x1f4_push_qxrate(void *, unsigned, void **);
extern int x1f4_push_tclist(void *, unsigned, unsigned, void **);
extern int x1f4_push_tslist(void *, unsigned, unsigned, void **);
extern int x1f4_push_tvlist(void *, unsigned, unsigned, void **);
extern int x1f4_rand_lvlist(void *);
extern int x1f4_rand_nclist(void *);
extern int x1f4_rand_nvlist(void *);
extern int x1f4_rand_tclist(void *);
extern int x1f4_rand_tslist(void *);
extern int x1f4_rand_tvlist(void *);
extern int x1f4_reel_dllist(void *);
extern int x1f4_reel_l2list(void *);
extern int x1f4_roll_dllist(void *);
extern int x1f4_roll_l2list(void *);
extern int x1f4_rush_scdeck
    (void *, void *, int (*) (void *, unsigned, unsigned));
extern int x1f4_scan_s4deck
    (void *, void *, int (*) (void *, const void *, unsigned));
extern int x1f4_scan_scdeck
    (void *, void *, int (*) (void *, const void *, unsigned));
extern int x1f4_scan_tcline
    (void *, void *, int (*) (void *, void *, unsigned));
extern int x1f4_scan_tfline
    (void *, void *, int (*) (void *, void *, unsigned));
extern int x1f4_scan_tnline
    (void *, void *, int (*) (void *, void *, unsigned));
extern int x1f4_scan_tqline
    (void *, void *, int (*) (void *, void *, unsigned));
extern int x1f4_scan_tsline
    (void *, void *, int (*) (void *, void *, unsigned));
extern int x1f4_scan_tvline
    (void *, void *, int (*) (void *, void *, unsigned));
extern int x1f4_scan_tzline
    (void *, void *, int (*) (void *, void *, unsigned));
extern int x1f4_seek_fslist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_seek_nclist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_seek_nvlist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_seek_tclist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_seek_tslist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_seek_tvlist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *);
extern int x1f4_shut_tcline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_shut_tfline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_shut_tnline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_shut_tqline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_shut_tsline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_shut_tvline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_shut_tzline
    (void *, void *, int (*) (void *, void *), unsigned, void *,
     int (*) (void *, void *));
extern int x1f4_side_tsline(void *, void *);
extern int x1f4_side_tslist(void *, void *);
extern int x1f4_side_tvline(void *, void *);
extern int x1f4_side_tvlist(void *, void *);
extern int x1f4_size_dflist(void *, unsigned *);
extern int x1f4_size_dllist(void *, unsigned *);
extern int x1f4_size_l2list(void *, unsigned *);
extern int x1f4_size_lvlist(void *, unsigned *);
extern int x1f4_size_nclist(void *, unsigned *);
extern int x1f4_size_nvlist(void *, unsigned *);
extern int x1f4_size_qlrate(void *, unsigned *);
extern int x1f4_size_qsrate(void *, unsigned *);
extern int x1f4_size_qxrate(void *, unsigned *);
extern int x1f4_size_tclist(void *, unsigned *);
extern int x1f4_size_tslist(void *, unsigned *);
extern int x1f4_size_tvlist(void *, unsigned *);
extern int x1f4_skew_nclist(void *, void *);
extern int x1f4_skew_nvlist(void *, void *);
extern int x1f4_skew_scdeck(void *, void *);
extern int x1f4_skew_sfdeck(void *, void *);
extern int x1f4_skew_sfnote(void *, void *);
extern int x1f4_skew_tcline(void *, void *);
extern int x1f4_skew_tclist(void *, void *);
extern int x1f4_skew_tsline(void *, void *);
extern int x1f4_skew_tslist(void *, void *);
extern int x1f4_skew_tvline(void *, void *);
extern int x1f4_skew_tvlist(void *, void *);
extern int x1f4_slip_bqfset(void *);
extern int x1f4_slip_dflist(void *);
extern int x1f4_slip_dllist(void *);
extern int x1f4_slip_l2list(void *);
extern int x1f4_slip_nclist(void *);
extern int x1f4_slip_nvlist(void *);
extern int x1f4_slip_qsrate(void *);
extern int x1f4_slip_scdeck(void *);
extern int x1f4_slip_sfdeck(void *);
extern int x1f4_slip_sfnote(void *);
extern int x1f4_slip_tclist(void *);
extern int x1f4_slip_tslist(void *);
extern int x1f4_slip_tvlist(void *);
extern int x1f4_sort_fslist
    (void *, void *, unsigned, int (*) (void *, void *, void *));
extern int x1f4_sort_lvlist
    (void *, void *, unsigned, int (*) (void *, void *, void *));
extern int x1f4_sort_nclist
    (void *, void *, unsigned, int (*) (void *, void *, void *));
extern int x1f4_sort_nvlist
    (void *, void *, unsigned, int (*) (void *, void *, void *));
extern int x1f4_sort_tclist
    (void *, void *, unsigned, int (*) (void *, void *, void *));
extern int x1f4_sort_tslist
    (void *, void *, unsigned, int (*) (void *, void *, void *));
extern int x1f4_sort_tvlist
    (void *, void *, unsigned, int (*) (void *, void *, void *));
extern int x1f4_span_lsnote
    (void *, void *, int (*) (void *, void *, const char *, unsigned));
extern int x1f4_span_s5deck
    (void *, void *, int (*) (void *, const void *, const char *, unsigned));
extern int x1f4_span_sfnote
    (void *, void *, int (*) (void *, void *, const char *, unsigned));
extern int x1f4_spin_l4list(void *, unsigned, unsigned);
extern int x1f4_spin_nclist(void *, unsigned, unsigned);
extern int x1f4_spin_tclist(void *, unsigned, unsigned);
extern int x1f4_spin_tslist(void *, unsigned, unsigned);
extern int x1f4_spin_tvlist(void *, unsigned, unsigned);
#if __x1f4_here_suit_tcmini__
#else
extern int x1f4_suit_tcmini(void *);
#endif				/* __x1f4_here_suit_tcmini__ */
extern int x1f4_swap_dllist(void *, void *);
extern int x1f4_swap_qlrate(void *, void *);
extern int x1f4_swap_qsrate(void *, void *);
extern int x1f4_swap_sfnote(void *, void *);
extern int x1f4_tail_dflist(void *, unsigned, void **);
extern int x1f4_tail_dllist(void *, void **);
extern int x1f4_tail_l2list(void *, unsigned, void **);
extern int x1f4_tail_l4list(void *, unsigned, void **);
extern int x1f4_tail_lvlist(void *, unsigned, void **);
extern int x1f4_tail_nclist(void *, unsigned, void **);
extern int x1f4_tail_nvlist(void *, unsigned, void **);
extern int x1f4_tail_qsrate(void *, void **);
extern int x1f4_tail_tclist(void *, unsigned, void **);
extern int x1f4_tail_tslist(void *, unsigned, void **);
extern int x1f4_tail_tvlist(void *, unsigned, void **);
extern int x1f4_text_dllist
    (void **, void *, int (*) (void *, void *, const void *),
     int (*) (void *, void *), void *);
extern int x1f4_text_l4list
    (void **, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int x1f4_text_nclist
    (void **, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int x1f4_text_qsrate
    (void **, void *, int (*) (void *, void *, const void *),
     int (*) (void *, void *), void *);
extern int x1f4_text_scdeck
    (void **, void *, int (*) (void *, const void **, const void *),
     int (*) (void *, const void *), void *);
extern int x1f4_text_sfdeck
    (void **, void *, int (*) (void *, const void **, const void *),
     int (*) (void *, const void *), void *);
extern int x1f4_text_sfnote
    (void **, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int x1f4_text_tclist
    (void **, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int x1f4_text_tslist
    (void **, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int x1f4_text_tvlist
    (void **, void *, int (*) (void *, unsigned *, const void *),
     int (*) (void *, void *, const void *), int (*) (void *, void *), void *);
extern int x1f4_tick_fslist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *, void **);
extern int x1f4_tick_nclist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *, void **);
extern int x1f4_tick_tclist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *, void **);
extern int x1f4_tick_tslist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *, void **);
extern int x1f4_tick_tvlist
    (void *, void *, unsigned, int (*) (void *, void *), unsigned *, void **);
extern int x1f4_tile_fslist(unsigned *, void *);
extern int x1f4_tile_tslist(unsigned *, void *);
extern int x1f4_tile_tvlist(unsigned *, void *);
extern int x1f4_turn_nclist(void *);
extern int x1f4_turn_nvlist(void *);
extern int x1f4_turn_tclist(void *);
extern int x1f4_turn_tslist(void *);
extern int x1f4_turn_tvlist(void *);
extern int x1f4_type_fspost(void *, void **);
extern int x1f4_type_tcmini(void *, unsigned, unsigned);
extern int x1f4_well_tslist(void *, void *, int (*) (void *, void *));
extern int x1f4_wind_l4list(void *, unsigned, void *, unsigned);
extern int x1f4_wind_nclist(void *, unsigned, void *, unsigned);
extern int x1f4_wind_nvlist(void *, unsigned, void *, unsigned);
extern int x1f4_wind_tclist(void *, unsigned, void *, unsigned);
extern int x1f4_wind_tslist(void *, unsigned, void *, unsigned);
extern int x1f4_wind_tvlist(void *, unsigned, void *, unsigned);

#endif				/* __LIBx1f4l2_H__ */
