/*
 * qxcc.h
 * Copyright (C) 2008-2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4l2_QXCC_H__
#define __LIBx1f4l2_QXCC_H__

#define __QCRATE__			1
#define __QLRATE__			2
#define __QSRATE__			3
#define __QXRATE__			4

#define __XXRATE__			__QSRATE__

#define ____XXRATE__			__XXRATE__

#if ____XXRATE__ == __QCRATE__
# define qxname				"qc"
#elif __XXRATE__ == __QLRATE__
# define qxname				"ql"
#elif __XXRATE__ == __QSRATE__
# define qxname				"qs"
#elif __XXRATE__ == __QXRATE__
# define qxname				"qx"
#endif				/* ____XXRATE__ == __QCRATE__ */

#if ____XXRATE__ == __QCRATE__
# define x1f4_qxrate_type		x1f4_qcrate_type
#elif __XXRATE__ == __QLRATE__
# define x1f4_qxrate_type		x1f4_qlrate_type
#elif __XXRATE__ == __QSRATE__
# define x1f4_qxrate_type		x1f4_qsrate_type
#elif __XXRATE__ == __QXRATE__
#endif				/* ____XXRATE__ == __QCRATE__ */

#if ____XXRATE__ == __QCRATE__
# define __MISS_FOUR_RATE__		1
#elif __XXRATE__ == __QLRATE__
# define __MISS_FOUR_RATE__		1
#elif __XXRATE__ == __QSRATE__
# define __MISS_FOUR_RATE__		0
#elif __XXRATE__ == __QXRATE__
# define __MISS_FOUR_RATE__		0
#endif				/* ____XXRATE__ == __QCRATE__ */

#if ____XXRATE__ == __QSRATE__
# define __HAVE_HEAD_RATE__		1
#else
# define __HAVE_HEAD_RATE__		0
#endif				/* ____XXRATE__ == __QSRATE__ */

#if ____XXRATE__ == __QSRATE__
# define __HAVE_TAIL_RATE__		1
#else
# define __HAVE_TAIL_RATE__		0
#endif				/* ____XXRATE__ == __QSRATE__ */

#if ____XXRATE__ == __QSRATE__
# define __HAVE_TEXT_RATE__		1
#else
# define __HAVE_TEXT_RATE__		0
#endif				/* ____XXRATE__ == __QSRATE__ */

#if ____XXRATE__ == __QSRATE__
# define __HEAD_FLIP_RATE__		1
#else
# define __HEAD_FLIP_RATE__		0
#endif				/* ____XXRATE__ == __QSRATE__ */

#if ____XXRATE__ == __QLRATE__
# define __HEAD_MISS_RATE__		1
#elif ____XXRATE__ == __QSRATE__
# define __HEAD_MISS_RATE__		1
#elif __XXRATE__ == __QXRATE__
# define __HEAD_MISS_RATE__		1
#else
# define __HEAD_MISS_RATE__		0
#endif				/* ____XXRATE__ == __QLRATE__ */

#if ____XXRATE__ == __QLRATE__
# define __HEAD_EVER_RATE__		1
#elif ____XXRATE__ == __QSRATE__
# define __HEAD_EVER_RATE__		1
#else
# define __HEAD_EVER_RATE__		0
#endif				/* ____XXRATE__ == __QLRATE__ */

#if ____XXRATE__ == __QLRATE__
# define __HEAD_LEAD_RATE__		1
#elif ____XXRATE__ == __QSRATE__
# define __HEAD_LEAD_RATE__		1
#else
# define __HEAD_LEAD_RATE__		0
#endif				/* ____XXRATE__ == __QLRATE__ */

#if ____XXRATE__ == __QLRATE__
# define __HEAD_MIND_RATE__		0
#elif ____XXRATE__ == __QSRATE__
# define __HEAD_MIND_RATE__		1
#else
# define __HEAD_MIND_RATE__		0
#endif				/* ____XXRATE__ == __QLRATE__ */

#if ____XXRATE__ == __QLRATE__
# define __HEAD_SLIP_RATE__		0
#elif ____XXRATE__ == __QSRATE__
# define __HEAD_SLIP_RATE__		1
#else
# define __HEAD_SLIP_RATE__		0
#endif				/* ____XXRATE__ == __QLRATE__ */

#if ____XXRATE__ == __QCRATE__
# define x1f4_case_qxrate		x1f4_case_qcrate
# define x1f4_dash_qxrate		x1f4_dash_qcrate
# define x1f4_ever_qxrate		x1f4_ever_qcrate
# define x1f4_fini_qxrate		x1f4_fini_qcrate
# define x1f4_flip_qxrate		x1f4_flip_qcrate
# define x1f4_head_qxrate		x1f4_head_qcrate
# define x1f4_high_qxrate		x1f4_high_qcrate
# define x1f4_init_qxrate		x1f4_init_qcrate
# define x1f4_lead_qxrate		x1f4_lead_qcrate
# define x1f4_lime_qxrate		x1f4_lime_qcrate
# define x1f4_mind_qxrate		x1f4_mind_qcrate
# define x1f4_miss_qxrate		x1f4_miss_qcrate
# define x1f4_over_qxrate		x1f4_over_qcrate
# define x1f4_peek_qxrate		x1f4_peek_qcrate
# define x1f4_push_qxrate		x1f4_push_qcrate
# define x1f4_size_qxrate		x1f4_size_qcrate
# define x1f4_slip_qxrate		x1f4_slip_qcrate
# define x1f4_tail_qxrate		x1f4_tail_qcrate
# define x1f4_text_qxrate		x1f4_text_qcrate
#elif __XXRATE__ == __QLRATE__
# define x1f4_case_qxrate		x1f4_case_qlrate
# define x1f4_dash_qxrate		x1f4_dash_qlrate
# define x1f4_ever_qxrate		x1f4_ever_qlrate
# define x1f4_fini_qxrate		x1f4_fini_qlrate
# define x1f4_flip_qxrate		x1f4_flip_qlrate
# define x1f4_head_qxrate		x1f4_head_qlrate
# define x1f4_high_qxrate		x1f4_high_qlrate
# define x1f4_init_qxrate		x1f4_init_qlrate
# define x1f4_lead_qxrate		x1f4_lead_qlrate
# define x1f4_lime_qxrate		x1f4_lime_qlrate
# define x1f4_mind_qxrate		x1f4_mind_qlrate
# define x1f4_miss_qxrate		x1f4_miss_qlrate
# define x1f4_over_qxrate		x1f4_over_qlrate
# define x1f4_peek_qxrate		x1f4_peek_qlrate
# define x1f4_push_qxrate		x1f4_push_qlrate
# define x1f4_size_qxrate		x1f4_size_qlrate
# define x1f4_slip_qxrate		x1f4_slip_qlrate
# define x1f4_tail_qxrate		x1f4_tail_qlrate
# define x1f4_text_qxrate		x1f4_text_qlrate
#elif __XXRATE__ == __QSRATE__
# define x1f4_case_qxrate		x1f4_case_qsrate
# define x1f4_dash_qxrate		x1f4_dash_qsrate
# define x1f4_ever_qxrate		x1f4_ever_qsrate
# define x1f4_fini_qxrate		x1f4_fini_qsrate
# define x1f4_flip_qxrate		x1f4_flip_qsrate
# define x1f4_head_qxrate		x1f4_head_qsrate
# define x1f4_high_qxrate		x1f4_high_qsrate
# define x1f4_init_qxrate		x1f4_init_qsrate
# define x1f4_lead_qxrate		x1f4_lead_qsrate
# define x1f4_lime_qxrate		x1f4_lime_qsrate
# define x1f4_mind_qxrate		x1f4_mind_qsrate
# define x1f4_miss_qxrate		x1f4_miss_qsrate
# define x1f4_over_qxrate		x1f4_over_qsrate
# define x1f4_peek_qxrate		x1f4_peek_qsrate
# define x1f4_push_qxrate		x1f4_push_qsrate
# define x1f4_size_qxrate		x1f4_size_qsrate
# define x1f4_slip_qxrate		x1f4_slip_qsrate
# define x1f4_tail_qxrate		x1f4_tail_qsrate
# define x1f4_text_qxrate		x1f4_text_qsrate
#elif __XXRATE__ == __QXRATE__
#endif				/* ____XXRATE__ == __QCRATE__ */

#endif				/* __LIBx1f4l2_QXCC_H__ */
