/*
 * s3xx.h
 * Copyright (C) 2008, 2009, 2010, 2011, 2012, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4l2_S3XX_H__
#define __LIBx1f4l2_S3XX_H__

/*
 * sorted array radix tree
 */
#define __S3DECK__			1

/*
 * critical bit radix tree
 */
#define __S4DECK__			2

/*
 * critical bit radix tree (the second)
 */
#define __S5DECK__			3

/*
 * critical bit radix tree (the third)
 */
#define __S8DECK__			4

/*
 * sorted array radix tree (the second)
 */
#define __SCDECK__			5

/*
 * sorted array radix tree (the third)
 */
#define __SFDECK__			6

/*
 * bitmapped sorted array radix tree
 */
#define __SJDECK__			7

/*
 * radix tree
 */
#define __SLDECK__			8

#define __PATH_FOR_DECK__		0

#define __XXDECK__			__SCDECK__

#define ____XXDECK__			__XXDECK__

#if ____XXDECK__ == __S3DECK__
# define sxname				"s3"
#elif __XXDECK__ == __S4DECK__
# define sxname				"s4"
#elif __XXDECK__ == __S5DECK__
# define sxname				"s5"
#elif __XXDECK__ == __S8DECK__
# define sxname				"s8"
#elif __XXDECK__ == __SCDECK__
# define sxname				"sc"
#elif __XXDECK__ == __SFDECK__
# define sxname				"sf"
#elif __XXDECK__ == __SJDECK__
# define sxname				"sj"
#elif __XXDECK__ == __SLDECK__
# define sxname				"sl"
#endif				/* ____XXDECK__ == __S3DECK__ */

#if ____XXDECK__ == __S4DECK__
# undef __PATH_FOR_DECK__
# define __PATH_FOR_DECK__		1
#elif __XXDECK__ == __S5DECK__
# undef __PATH_FOR_DECK__
# define __PATH_FOR_DECK__		1
#elif __XXDECK__ == __S8DECK__
# undef __PATH_FOR_DECK__
# define __PATH_FOR_DECK__		1
#endif				/* ____XXDECK__ == __S4DECK__ */

#if ____XXDECK__ == __S4DECK__
# define __HEAD_CAST_DECK__		0
#elif __XXDECK__ == __S5DECK__
# define __HEAD_CAST_DECK__		0
#elif __XXDECK__ == __S8DECK__
# define __HEAD_CAST_DECK__		0
#else
# define __HEAD_CAST_DECK__		1
#endif				/* ____XXDECK__ == __S4DECK__ */

#if ____XXDECK__ == __S3DECK__
# define __HEAD_NOTE_DECK__		0
#elif __XXDECK__ == __S4DECK__
# define __HEAD_NOTE_DECK__		1
#elif __XXDECK__ == __S5DECK__
# define __HEAD_NOTE_DECK__		1
#elif __XXDECK__ == __S8DECK__
# define __HEAD_NOTE_DECK__		1
#elif __XXDECK__ == __SCDECK__
# define __HEAD_NOTE_DECK__		0
#elif __XXDECK__ == __SFDECK__
# define __HEAD_NOTE_DECK__		0
#elif __XXDECK__ == __SJDECK__
# define __HEAD_NOTE_DECK__		0
#elif __XXDECK__ == __SLDECK__
# define __HEAD_NOTE_DECK__		0
#endif				/* ____XXDECK__ == __S3DECK__ */

#if __HEAD_NOTE_DECK__
# define __HEAD_LIST_DECK__		0
#else
# define __HEAD_LIST_DECK__		1
#endif				/* __HEAD_NOTE_DECK__ */

#if ____XXDECK__ == __S4DECK__
# define __BINARY_DECK__		1
#elif __XXDECK__ == __S5DECK__
# define __BINARY_DECK__		1
#elif __XXDECK__ == __S8DECK__
# define __BINARY_DECK__		1
#else
# define __BINARY_DECK__		0
#endif				/* ____XXDECK__ == __S4DECK__ */

#if ____XXDECK__ == __S5DECK__
# define __POINTER_DECK__		1
#else
# define __POINTER_DECK__		0
#endif				/* ____XXDECK__ == __S4DECK__ */

#if ____XXDECK__ == __S4DECK__
# define __MISS_VOID_LINES__		0
#elif __XXDECK__ == __S5DECK__
# define __MISS_VOID_LINES__		0
#elif __XXDECK__ == __S8DECK__
# define __MISS_VOID_LINES__		0
#else
# define __MISS_VOID_LINES__		0
#endif				/* ____XXDECK__ == __S4DECK__ */

#if ____XXDECK__ == __S3DECK__
#elif __XXDECK__ == __S4DECK__
# define x1f4_bank_s3deck		x1f4_bank_s4deck
# define x1f4_case_s3deck		x1f4_case_s4deck
# define x1f4_cast_s3deck		x1f4_cast_s4deck
# define x1f4_copy_s3deck		x1f4_copy_s4deck
# define x1f4_fgvq_s3deck		x1f4_fgvq_s4deck
# define x1f4_find_s3deck		x1f4_find_s4deck
# define x1f4_find_s3path		x1f4_find_s4path
# define x1f4_fini_s3deck		x1f4_fini_s4deck
# define x1f4_init_s3deck		x1f4_init_s4deck
# define x1f4_jack_s3deck		x1f4_jack_s4deck
# define x1f4_lift_s3deck		x1f4_lift_s4deck
# define x1f4_lime_s3deck		x1f4_lime_s4deck
# define x1f4_list_s3deck		x1f4_list_s4deck
# define x1f4_llvq_s3deck		x1f4_llvq_s4deck
# define x1f4_mind_s3deck		x1f4_mind_s4deck
# define x1f4_note_s3deck		x1f4_note_s4deck
# define x1f4_pass_s3deck		x1f4_pass_s4deck
# define x1f4_pass_s3path		x1f4_pass_s4path
# define x1f4_plot_s3deck		x1f4_plot_s4deck
# define x1f4_post_s3deck		x1f4_post_s4deck
# define x1f4_post_s3path		x1f4_post_s4path
# define x1f4_rush_s3deck		x1f4_rush_s4deck
# define x1f4_scan_s3deck		x1f4_scan_s4deck
# define x1f4_slip_s3deck		x1f4_slip_s4deck
# define x1f4_text_s3deck		x1f4_text_s4deck
#elif __XXDECK__ == __S5DECK__
# define x1f4_bank_s3deck		x1f4_bank_s5deck
# define x1f4_case_s3deck		x1f4_case_s5deck
# define x1f4_cast_s3deck		x1f4_cast_s5deck
# define x1f4_copy_s3deck		x1f4_copy_s5deck
# define x1f4_fgvq_s3deck		x1f4_fgvq_s5deck
# define x1f4_find_s3deck		x1f4_find_s5deck
# define x1f4_find_s3path		x1f4_find_s5path
# define x1f4_fini_s3deck		x1f4_fini_s5deck
# define x1f4_init_s3deck		x1f4_init_s5deck
# define x1f4_jack_s3deck		x1f4_jack_s5deck
# define x1f4_lift_s3deck		x1f4_lift_s5deck
# define x1f4_lime_s3deck		x1f4_lime_s5deck
# define x1f4_list_s3deck		x1f4_list_s5deck
# define x1f4_llvq_s3deck		x1f4_llvq_s5deck
# define x1f4_mind_s3deck		x1f4_mind_s5deck
# define x1f4_note_s3deck		x1f4_note_s5deck
# define x1f4_pass_s3deck		x1f4_pass_s5deck
# define x1f4_pass_s3path		x1f4_pass_s5path
# define x1f4_plot_s3deck		x1f4_plot_s5deck
# define x1f4_post_s3deck		x1f4_post_s5deck
# define x1f4_post_s3path		x1f4_post_s5path
# define x1f4_rush_s3deck		x1f4_rush_s5deck
# define x1f4_scan_s3deck		x1f4_scan_s5deck
# define x1f4_slip_s3deck		x1f4_slip_s5deck
# define x1f4_text_s3deck		x1f4_text_s5deck
#elif __XXDECK__ == __S8DECK__
# define x1f4_bank_s3deck		x1f4_bank_s8deck
# define x1f4_case_s3deck		x1f4_case_s8deck
# define x1f4_cast_s3deck		x1f4_cast_s8deck
# define x1f4_copy_s3deck		x1f4_copy_s8deck
# define x1f4_fgvq_s3deck		x1f4_fgvq_s8deck
# define x1f4_find_s3deck		x1f4_find_s8deck
# define x1f4_find_s3path		x1f4_find_s8path
# define x1f4_fini_s3deck		x1f4_fini_s8deck
# define x1f4_init_s3deck		x1f4_init_s8deck
# define x1f4_jack_s3deck		x1f4_jack_s8deck
# define x1f4_lift_s3deck		x1f4_lift_s8deck
# define x1f4_lime_s3deck		x1f4_lime_s8deck
# define x1f4_list_s3deck		x1f4_list_s8deck
# define x1f4_llvq_s3deck		x1f4_llvq_s8deck
# define x1f4_mind_s3deck		x1f4_mind_s8deck
# define x1f4_note_s3deck		x1f4_note_s8deck
# define x1f4_pass_s3deck		x1f4_pass_s8deck
# define x1f4_pass_s3path		x1f4_pass_s8path
# define x1f4_plot_s3deck		x1f4_plot_s8deck
# define x1f4_post_s3deck		x1f4_post_s8deck
# define x1f4_post_s3path		x1f4_post_s8path
# define x1f4_rush_s3deck		x1f4_rush_s8deck
# define x1f4_scan_s3deck		x1f4_scan_s8deck
# define x1f4_slip_s3deck		x1f4_slip_s8deck
# define x1f4_text_s3deck		x1f4_text_s8deck
#elif __XXDECK__ == __SCDECK__
# define x1f4_bank_s3deck		x1f4_bank_scdeck
# define x1f4_case_s3deck		x1f4_case_scdeck
# define x1f4_cast_s3deck		x1f4_cast_scdeck
# define x1f4_copy_s3deck		x1f4_copy_scdeck
# define x1f4_fgvq_s3deck		x1f4_fgvq_scdeck
# define x1f4_find_s3deck		x1f4_find_scdeck
# define x1f4_find_s3path		x1f4_find_scpath
# define x1f4_fini_s3deck		x1f4_fini_scdeck
# define x1f4_init_s3deck		x1f4_init_scdeck
# define x1f4_jack_s3deck		x1f4_jack_scdeck
# define x1f4_lift_s3deck		x1f4_lift_scdeck
# define x1f4_lime_s3deck		x1f4_lime_scdeck
# define x1f4_list_s3deck		x1f4_list_scdeck
# define x1f4_llvq_s3deck		x1f4_llvq_scdeck
# define x1f4_mind_s3deck		x1f4_mind_scdeck
# define x1f4_note_s3deck		x1f4_note_scdeck
# define x1f4_pass_s3deck		x1f4_pass_scdeck
# define x1f4_pass_s3path		x1f4_pass_scpath
# define x1f4_plot_s3deck		x1f4_plot_scdeck
# define x1f4_post_s3deck		x1f4_post_scdeck
# define x1f4_post_s3path		x1f4_post_scpath
# define x1f4_rush_s3deck		x1f4_rush_scdeck
# define x1f4_scan_s3deck		x1f4_scan_scdeck
# define x1f4_slip_s3deck		x1f4_slip_scdeck
# define x1f4_text_s3deck		x1f4_text_scdeck
#elif __XXDECK__ == __SFDECK__
# define x1f4_bank_s3deck		x1f4_bank_sfdeck
# define x1f4_case_s3deck		x1f4_case_sfdeck
# define x1f4_cast_s3deck		x1f4_cast_sfdeck
# define x1f4_copy_s3deck		x1f4_copy_sfdeck
# define x1f4_fgvq_s3deck		x1f4_fgvq_sfdeck
# define x1f4_find_s3deck		x1f4_find_sfdeck
# define x1f4_find_s3path		x1f4_find_sfpath
# define x1f4_fini_s3deck		x1f4_fini_sfdeck
# define x1f4_init_s3deck		x1f4_init_sfdeck
# define x1f4_jack_s3deck		x1f4_jack_sfdeck
# define x1f4_lift_s3deck		x1f4_lift_sfdeck
# define x1f4_lime_s3deck		x1f4_lime_sfdeck
# define x1f4_list_s3deck		x1f4_list_sfdeck
# define x1f4_llvq_s3deck		x1f4_llvq_sfdeck
# define x1f4_mind_s3deck		x1f4_mind_sfdeck
# define x1f4_note_s3deck		x1f4_note_sfdeck
# define x1f4_pass_s3deck		x1f4_pass_sfdeck
# define x1f4_pass_s3path		x1f4_pass_sfpath
# define x1f4_plot_s3deck		x1f4_plot_sfdeck
# define x1f4_post_s3deck		x1f4_post_sfdeck
# define x1f4_post_s3path		x1f4_post_sfpath
# define x1f4_rush_s3deck		x1f4_rush_sfdeck
# define x1f4_scan_s3deck		x1f4_scan_sfdeck
# define x1f4_slip_s3deck		x1f4_slip_sfdeck
# define x1f4_text_s3deck		x1f4_text_sfdeck
#elif __XXDECK__ == __SJDECK__
# define x1f4_bank_s3deck		x1f4_bank_sjdeck
# define x1f4_case_s3deck		x1f4_case_sjdeck
# define x1f4_cast_s3deck		x1f4_cast_sjdeck
# define x1f4_copy_s3deck		x1f4_copy_sjdeck
# define x1f4_fgvq_s3deck		x1f4_fgvq_sjdeck
# define x1f4_find_s3deck		x1f4_find_sjdeck
# define x1f4_find_s3path		x1f4_find_sjpath
# define x1f4_fini_s3deck		x1f4_fini_sjdeck
# define x1f4_init_s3deck		x1f4_init_sjdeck
# define x1f4_jack_s3deck		x1f4_jack_sjdeck
# define x1f4_lift_s3deck		x1f4_lift_sjdeck
# define x1f4_lime_s3deck		x1f4_lime_sjdeck
# define x1f4_list_s3deck		x1f4_list_sjdeck
# define x1f4_llvq_s3deck		x1f4_llvq_sjdeck
# define x1f4_mind_s3deck		x1f4_mind_sjdeck
# define x1f4_note_s3deck		x1f4_note_sjdeck
# define x1f4_pass_s3deck		x1f4_pass_sjdeck
# define x1f4_pass_s3path		x1f4_pass_sjpath
# define x1f4_plot_s3deck		x1f4_plot_sjdeck
# define x1f4_post_s3deck		x1f4_post_sjdeck
# define x1f4_post_s3path		x1f4_post_sjpath
# define x1f4_rush_s3deck		x1f4_rush_sjdeck
# define x1f4_scan_s3deck		x1f4_scan_sjdeck
# define x1f4_slip_s3deck		x1f4_slip_sjdeck
# define x1f4_text_s3deck		x1f4_text_sjdeck
#elif __XXDECK__ == __SLDECK__
# define x1f4_bank_s3deck		x1f4_bank_sldeck
# define x1f4_case_s3deck		x1f4_case_sldeck
# define x1f4_cast_s3deck		x1f4_cast_sldeck
# define x1f4_copy_s3deck		x1f4_copy_sldeck
# define x1f4_fgvq_s3deck		x1f4_fgvq_sldeck
# define x1f4_find_s3deck		x1f4_find_sldeck
# define x1f4_find_s3path		x1f4_find_slpath
# define x1f4_fini_s3deck		x1f4_fini_sldeck
# define x1f4_init_s3deck		x1f4_init_sldeck
# define x1f4_jack_s3deck		x1f4_jack_sldeck
# define x1f4_lift_s3deck		x1f4_lift_sldeck
# define x1f4_lime_s3deck		x1f4_lime_sldeck
# define x1f4_list_s3deck		x1f4_list_sldeck
# define x1f4_llvq_s3deck		x1f4_llvq_sldeck
# define x1f4_mind_s3deck		x1f4_mind_sldeck
# define x1f4_note_s3deck		x1f4_note_sldeck
# define x1f4_pass_s3deck		x1f4_pass_sldeck
# define x1f4_pass_s3path		x1f4_pass_slpath
# define x1f4_plot_s3deck		x1f4_plot_sldeck
# define x1f4_post_s3deck		x1f4_post_sldeck
# define x1f4_post_s3path		x1f4_post_slpath
# define x1f4_rush_s3deck		x1f4_rush_sldeck
# define x1f4_scan_s3deck		x1f4_scan_sldeck
# define x1f4_slip_s3deck		x1f4_slip_sldeck
# define x1f4_text_s3deck		x1f4_text_sldeck
#endif				/* ____XXDECK__ == __S3DECK__ */

#endif				/* __LIBx1f4l2_S3XX_H__ */
