/*
 * tcqp.h
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4l2_TCQP_H__
#define __LIBx1f4l2_TCQP_H__

/*
 * AVL, threaded AVL and parent pointer AVL
 */
#define __TCLINE__			1
#define __TSLINE__			2
#define __TVLINE__			3

/*
 * red/black, threaded red/black and parent pointer red/black
 */
#define __TNLINE__			4
#define __TXLINE__			5
#define __TZLINE__			6

/*
 * AA, threaded AA and parent pointer AA
 */
#define __TGLINE__			7
#define __TPLINE__			8
#define __TQLINE__			9

/*
 * randomized, threaded randomized and parent pointer randomized
 */
#define __TFLINE__			10
#define __TJLINE__			11
#define __TKLINE__			12

#define __XXLINE__			__TCLINE__

#define ____XXLINE__			__XXLINE__

#if ____XXLINE__ == __TCLINE__
# define tcname				"tc"
#elif __XXLINE__ == __TFLINE__
# define tcname				"tf"
#elif __XXLINE__ == __TNLINE__
# define tcname				"tn"
#elif __XXLINE__ == __TQLINE__
# define tcname				"tq"
#elif __XXLINE__ == __TSLINE__
# define tcname				"ts"
#elif __XXLINE__ == __TVLINE__
# define tcname				"tv"
#elif __XXLINE__ == __TZLINE__
# define tcname				"tz"
#endif				/* ____XXLINE__ == __TCLINE__ */

#if ____XXLINE__ == __TCLINE__
# define __HEAD_FGXD_LINE__		1
#elif __XXLINE__ == __TSLINE__
# define __HEAD_FGXD_LINE__		1
#elif __XXLINE__ == __TVLINE__
# define __HEAD_FGXD_LINE__		1
#else
# define __HEAD_FGXD_LINE__		0
#endif				/* ____XXLINE__ == __TCLINE__ */

#if ____XXLINE__ == __TCLINE__
# define __HEAD_FIND_FINE__		1
#elif __XXLINE__ == __TFLINE__
# define __HEAD_FIND_FINE__		0
#elif __XXLINE__ == __TNLINE__
# define __HEAD_FIND_FINE__		0
#elif __XXLINE__ == __TQLINE__
# define __HEAD_FIND_FINE__		0
#elif __XXLINE__ == __TSLINE__
# define __HEAD_FIND_FINE__		0
#elif __XXLINE__ == __TVLINE__
# define __HEAD_FIND_FINE__		0
#elif __XXLINE__ == __TZLINE__
# define __HEAD_FIND_FINE__		0
#endif				/* ____XXLINE__ == __TCLINE__ */

#if ____XXLINE__ == __TCLINE__
# define __HEAD_FIND_WORD__		1
#else
# define __HEAD_FIND_WORD__		0
#endif				/* ____XXLINE__ == __TCLINE__ */

#if ____XXLINE__ == __TCLINE__
# define __HEAD_FMXD_LINE__		1
#elif __XXLINE__ == __TSLINE__
# define __HEAD_FMXD_LINE__		1
#elif __XXLINE__ == __TVLINE__
# define __HEAD_FMXD_LINE__		1
#else
# define __HEAD_FMXD_LINE__		0
#endif				/* ____XXLINE__ == __TCLINE__ */

#if ____XXLINE__ == __TCLINE__
# define __HEAD_FXXD_LINE__		1
#elif __XXLINE__ == __TSLINE__
# define __HEAD_FXXD_LINE__		1
#elif __XXLINE__ == __TVLINE__
# define __HEAD_FXXD_LINE__		1
#else
# define __HEAD_FXXD_LINE__		0
#endif				/* ____XXLINE__ == __TCLINE__ */

#if ____XXLINE__ == __TCLINE__
# define __HEAD_LLXD_LINE__		1
#elif __XXLINE__ == __TSLINE__
# define __HEAD_LLXD_LINE__		1
#elif __XXLINE__ == __TVLINE__
# define __HEAD_LLXD_LINE__		1
#else
# define __HEAD_LLXD_LINE__		0
#endif				/* ____XXLINE__ == __TCLINE__ */

#if ____XXLINE__ == __TCLINE__
# define __HEAD_LMXD_LINE__		1
#elif __XXLINE__ == __TSLINE__
# define __HEAD_LMXD_LINE__		1
#elif __XXLINE__ == __TVLINE__
# define __HEAD_LMXD_LINE__		1
#else
# define __HEAD_LMXD_LINE__		0
#endif				/* ____XXLINE__ == __TCLINE__ */

#if ____XXLINE__ == __TCLINE__
# define __HEAD_LXXD_LINE__		1
#elif __XXLINE__ == __TSLINE__
# define __HEAD_LXXD_LINE__		1
#elif __XXLINE__ == __TVLINE__
# define __HEAD_LXXD_LINE__		1
#else
# define __HEAD_LXXD_LINE__		0
#endif				/* ____XXLINE__ == __TCLINE__ */

#if ____XXLINE__ == __TCLINE__
# define __HEAD_NEXT_LINE__		0
#elif __XXLINE__ == __TFLINE__
# define __HEAD_NEXT_LINE__		0
#elif __XXLINE__ == __TNLINE__
# define __HEAD_NEXT_LINE__		0
#elif __XXLINE__ == __TQLINE__
# define __HEAD_NEXT_LINE__		1
#elif __XXLINE__ == __TSLINE__
# define __HEAD_NEXT_LINE__		1
#elif __XXLINE__ == __TVLINE__
# define __HEAD_NEXT_LINE__		1
#elif __XXLINE__ == __TZLINE__
# define __HEAD_NEXT_LINE__		1
#endif				/* ____XXLINE__ == __TCLINE__ */

#if ____XXLINE__ == __TSLINE__
# define __HEAD_SIDE_LINE__		1
#elif __XXLINE__ == __TVLINE__
# define __HEAD_SIDE_LINE__		1
#else
# define __HEAD_SIDE_LINE__		0
#endif				/* ____XXLINE__ == __TSLINE__ */

#if ____XXLINE__ == __TCLINE__
#elif __XXLINE__ == __TFLINE__
# define x1f4_case_tcline		x1f4_case_tfline
# define x1f4_ever_tcline		x1f4_ever_tfline
# define x1f4_fgxd_tcline		x1f4_fgxd_tfline
# define x1f4_find_tcline		x1f4_find_tfline
# define x1f4_fini_tcline		x1f4_fini_tfline
# define x1f4_fmxd_tcline		x1f4_fmxd_tfline
# define x1f4_fxxd_tcline		x1f4_fxxd_tfline
# define x1f4_high_tcline		x1f4_high_tfline
# define x1f4_init_tcline		x1f4_init_tfline
# define x1f4_land_tcline		x1f4_land_tfline
# define x1f4_last_tcline		x1f4_last_tfline
# define x1f4_lead_tcline		x1f4_lead_tfline
# define x1f4_lime_tcline		x1f4_lime_tfline
# define x1f4_llxd_tcline		x1f4_llxd_tfline
# define x1f4_lmxd_tcline		x1f4_lmxd_tfline
# define x1f4_lxxd_tcline		x1f4_lxxd_tfline
# define x1f4_next_tcline		x1f4_next_tfline
# define x1f4_pass_tcline		x1f4_pass_tfline
# define x1f4_post_tcline		x1f4_post_tfline
# define x1f4_scan_tcline		x1f4_scan_tfline
# define x1f4_side_tcline		x1f4_side_tfline
#elif __XXLINE__ == __TNLINE__
# define x1f4_case_tcline		x1f4_case_tnline
# define x1f4_ever_tcline		x1f4_ever_tnline
# define x1f4_fgxd_tcline		x1f4_fgxd_tnline
# define x1f4_find_tcline		x1f4_find_tnline
# define x1f4_fini_tcline		x1f4_fini_tnline
# define x1f4_fmxd_tcline		x1f4_fmxd_tnline
# define x1f4_fxxd_tcline		x1f4_fxxd_tnline
# define x1f4_high_tcline		x1f4_high_tnline
# define x1f4_init_tcline		x1f4_init_tnline
# define x1f4_land_tcline		x1f4_land_tnline
# define x1f4_last_tcline		x1f4_last_tnline
# define x1f4_lead_tcline		x1f4_lead_tnline
# define x1f4_lime_tcline		x1f4_lime_tnline
# define x1f4_llxd_tcline		x1f4_llxd_tnline
# define x1f4_lmxd_tcline		x1f4_lmxd_tnline
# define x1f4_lxxd_tcline		x1f4_lxxd_tnline
# define x1f4_next_tcline		x1f4_next_tnline
# define x1f4_pass_tcline		x1f4_pass_tnline
# define x1f4_post_tcline		x1f4_post_tnline
# define x1f4_scan_tcline		x1f4_scan_tnline
# define x1f4_side_tcline		x1f4_side_tnline
#elif __XXLINE__ == __TQLINE__
# define x1f4_case_tcline		x1f4_case_tqline
# define x1f4_ever_tcline		x1f4_ever_tqline
# define x1f4_fgxd_tcline		x1f4_fgxd_tqline
# define x1f4_find_tcline		x1f4_find_tqline
# define x1f4_fini_tcline		x1f4_fini_tqline
# define x1f4_fmxd_tcline		x1f4_fmxd_tqline
# define x1f4_fxxd_tcline		x1f4_fxxd_tqline
# define x1f4_high_tcline		x1f4_high_tqline
# define x1f4_init_tcline		x1f4_init_tqline
# define x1f4_land_tcline		x1f4_land_tqline
# define x1f4_last_tcline		x1f4_last_tqline
# define x1f4_lead_tcline		x1f4_lead_tqline
# define x1f4_lime_tcline		x1f4_lime_tqline
# define x1f4_llxd_tcline		x1f4_llxd_tqline
# define x1f4_lmxd_tcline		x1f4_lmxd_tqline
# define x1f4_lxxd_tcline		x1f4_lxxd_tqline
# define x1f4_next_tcline		x1f4_next_tqline
# define x1f4_pass_tcline		x1f4_pass_tqline
# define x1f4_post_tcline		x1f4_post_tqline
# define x1f4_scan_tcline		x1f4_scan_tqline
# define x1f4_side_tcline		x1f4_side_tqline
#elif __XXLINE__ == __TSLINE__
# define x1f4_case_tcline		x1f4_case_tsline
# define x1f4_ever_tcline		x1f4_ever_tsline
# define x1f4_fgxd_tcline		x1f4_fgxd_tsline
# define x1f4_find_tcline		x1f4_find_tsline
# define x1f4_fini_tcline		x1f4_fini_tsline
# define x1f4_fmxd_tcline		x1f4_fmxd_tsline
# define x1f4_fxxd_tcline		x1f4_fxxd_tsline
# define x1f4_high_tcline		x1f4_high_tsline
# define x1f4_init_tcline		x1f4_init_tsline
# define x1f4_land_tcline		x1f4_land_tsline
# define x1f4_last_tcline		x1f4_last_tsline
# define x1f4_lead_tcline		x1f4_lead_tsline
# define x1f4_lime_tcline		x1f4_lime_tsline
# define x1f4_llxd_tcline		x1f4_llxd_tsline
# define x1f4_lmxd_tcline		x1f4_lmxd_tsline
# define x1f4_lxxd_tcline		x1f4_lxxd_tsline
# define x1f4_next_tcline		x1f4_next_tsline
# define x1f4_pass_tcline		x1f4_pass_tsline
# define x1f4_post_tcline		x1f4_post_tsline
# define x1f4_scan_tcline		x1f4_scan_tsline
# define x1f4_side_tcline		x1f4_side_tsline
#elif __XXLINE__ == __TVLINE__
# define x1f4_case_tcline		x1f4_case_tvline
# define x1f4_ever_tcline		x1f4_ever_tvline
# define x1f4_fgxd_tcline		x1f4_fgxd_tvline
# define x1f4_find_tcline		x1f4_find_tvline
# define x1f4_fini_tcline		x1f4_fini_tvline
# define x1f4_fmxd_tcline		x1f4_fmxd_tvline
# define x1f4_fxxd_tcline		x1f4_fxxd_tvline
# define x1f4_high_tcline		x1f4_high_tvline
# define x1f4_init_tcline		x1f4_init_tvline
# define x1f4_land_tcline		x1f4_land_tvline
# define x1f4_last_tcline		x1f4_last_tvline
# define x1f4_lead_tcline		x1f4_lead_tvline
# define x1f4_lime_tcline		x1f4_lime_tvline
# define x1f4_llxd_tcline		x1f4_llxd_tvline
# define x1f4_lmxd_tcline		x1f4_lmxd_tvline
# define x1f4_lxxd_tcline		x1f4_lxxd_tvline
# define x1f4_next_tcline		x1f4_next_tvline
# define x1f4_pass_tcline		x1f4_pass_tvline
# define x1f4_post_tcline		x1f4_post_tvline
# define x1f4_scan_tcline		x1f4_scan_tvline
# define x1f4_side_tcline		x1f4_side_tvline
#elif __XXLINE__ == __TZLINE__
# define x1f4_case_tcline		x1f4_case_tzline
# define x1f4_ever_tcline		x1f4_ever_tzline
# define x1f4_fgxd_tcline		x1f4_fgxd_tzline
# define x1f4_find_tcline		x1f4_find_tzline
# define x1f4_fini_tcline		x1f4_fini_tzline
# define x1f4_fmxd_tcline		x1f4_fmxd_tzline
# define x1f4_fxxd_tcline		x1f4_fxxd_tzline
# define x1f4_high_tcline		x1f4_high_tzline
# define x1f4_init_tcline		x1f4_init_tzline
# define x1f4_lead_tcline		x1f4_lead_tzline
# define x1f4_land_tcline		x1f4_land_tzline
# define x1f4_last_tcline		x1f4_last_tzline
# define x1f4_lime_tcline		x1f4_lime_tzline
# define x1f4_llxd_tcline		x1f4_llxd_tzline
# define x1f4_lmxd_tcline		x1f4_lmxd_tzline
# define x1f4_lxxd_tcline		x1f4_lxxd_tzline
# define x1f4_next_tcline		x1f4_next_tzline
# define x1f4_pass_tcline		x1f4_pass_tzline
# define x1f4_post_tcline		x1f4_post_tzline
# define x1f4_scan_tcline		x1f4_scan_tzline
# define x1f4_side_tcline		x1f4_side_tzline
#endif				/* ____XXLINE__ == __TCLINE__ */

#endif				/* __LIBx1f4l2_TCQP_H__ */
