/*
 * tcxx.h
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4l2_TCXX_H__
#define __LIBx1f4l2_TCXX_H__

/*
 * AVL, threaded AVL and parent pointer AVL (the 2nd, incomplete)
 */
#define __LCLIST__			(256 + 1)
#define __LSLIST__			(256 + 2)
#define __LVLIST__			(256 + 3)

/*
 * AVL, threaded AVL and parent pointer AVL (the 3rd, incomplete)
 */
#define __NCLIST__			1
#define __NSLIST__			2
#define __NVLIST__			3

/*
 * AVL, threaded AVL and parent pointer AVL (the 1st, complete)
 */
#define __TCLIST__			(512 + 1)
#define __TSLIST__			(512 + 2)
#define __TVLIST__			(512 + 3)

#define __XXLIST__			__NVLIST__

#define ____XXLIST__			__XXLIST__

#if ____XXLIST__ == __LVLIST__
# define tcname				"lv"
#elif __XXLIST__ == __NCLIST__
# define tcname				"nc"
#elif __XXLIST__ == __NVLIST__
# define tcname				"nv"
#elif __XXLIST__ == __TCLIST__
# define tcname				"tc"
#elif __XXLIST__ == __TSLIST__
# define tcname				"ts"
#elif __XXLIST__ == __TVLIST__
# define tcname				"tv"
#endif				/* ____XXLIST__ == __LVLIST__ */

#if ____XXLIST__ == __LVLIST__
# define __HEAD_NEXT_LIST__		1
#elif __XXLIST__ == __NCLIST__
# define __HEAD_NEXT_LIST__		0
#elif __XXLIST__ == __NVLIST__
# define __HEAD_NEXT_LIST__		1
#elif __XXLIST__ == __TCLIST__
# define __HEAD_NEXT_LIST__		0
#elif __XXLIST__ == __TSLIST__
# define __HEAD_NEXT_LIST__		1
#elif __XXLIST__ == __TVLIST__
# define __HEAD_NEXT_LIST__		1
#endif				/* ____XXLIST__ == __LVLIST__ */

#if ____XXLIST__ == __TSLIST__
# define __HEAD_SIDE_LIST__		1
#elif __XXLIST__ == __TVLIST__
# define __HEAD_SIDE_LIST__		1
#else
# define __HEAD_SIDE_LIST__		0
#endif				/* ____XXLIST__ == __TSLIST__ */

#if ____XXLIST__ == __LVLIST__
# define x1f4_ever_tclist		x1f4_ever_lvlist
# define x1f4_fgxp_tclist		x1f4_fgxp_lvlist
# define x1f4_fini_tclist		x1f4_fini_lvlist
# define x1f4_flip_tclist		x1f4_flip_lvlist
# define x1f4_flow_tclist		x1f4_flow_lvlist
# define x1f4_fmxp_tclist		x1f4_fmxp_lvlist
# define x1f4_fxxp_tclist		x1f4_fxxp_lvlist
# define x1f4_head_tclist		x1f4_head_lvlist
# define x1f4_high_tclist		x1f4_high_lvlist
# define x1f4_init_tclist		x1f4_init_lvlist
# define x1f4_land_tclist		x1f4_land_lvlist
# define x1f4_last_tclist		x1f4_last_lvlist
# define x1f4_lead_tclist		x1f4_lead_lvlist
# define x1f4_lime_tclist		x1f4_lime_lvlist
# define x1f4_llxp_tclist		x1f4_llxp_lvlist
# define x1f4_lmxp_tclist		x1f4_lmxp_lvlist
# define x1f4_lxxp_tclist		x1f4_lxxp_lvlist
# define x1f4_mind_tclist		x1f4_mind_lvlist
# define x1f4_miss_tclist		x1f4_miss_lvlist
# define x1f4_move_tclist		x1f4_move_lvlist
# define x1f4_next_tclist		x1f4_next_lvlist
# define x1f4_peek_tclist		x1f4_peek_lvlist
# define x1f4_push_tclist		x1f4_push_lvlist
# define x1f4_rand_tclist		x1f4_rand_lvlist
# define x1f4_seek_tclist		x1f4_seek_lvlist
# define x1f4_side_tclist		x1f4_side_lvlist
# define x1f4_size_tclist		x1f4_size_lvlist
# define x1f4_slip_tclist		x1f4_slip_lvlist
# define x1f4_sort_tclist		x1f4_sort_lvlist
# define x1f4_tail_tclist		x1f4_tail_lvlist
# define x1f4_text_tclist		x1f4_text_lvlist
# define x1f4_tile_tclist		x1f4_tile_lvlist
#elif __XXLIST__ == __NCLIST__
# define x1f4_ever_tclist		x1f4_ever_nclist
# define x1f4_fgxp_tclist		x1f4_fgxp_nclist
# define x1f4_fini_tclist		x1f4_fini_nclist
# define x1f4_flip_tclist		x1f4_flip_nclist
# define x1f4_flow_tclist		x1f4_flow_nclist
# define x1f4_fmxp_tclist		x1f4_fmxp_nclist
# define x1f4_fxxp_tclist		x1f4_fxxp_nclist
# define x1f4_head_tclist		x1f4_head_nclist
# define x1f4_high_tclist		x1f4_high_nclist
# define x1f4_init_tclist		x1f4_init_nclist
# define x1f4_land_tclist		x1f4_land_nclist
# define x1f4_last_tclist		x1f4_last_nclist
# define x1f4_lead_tclist		x1f4_lead_nclist
# define x1f4_lime_tclist		x1f4_lime_nclist
# define x1f4_llxp_tclist		x1f4_llxp_nclist
# define x1f4_lmxp_tclist		x1f4_lmxp_nclist
# define x1f4_lxxp_tclist		x1f4_lxxp_nclist
# define x1f4_mind_tclist		x1f4_mind_nclist
# define x1f4_miss_tclist		x1f4_miss_nclist
# define x1f4_move_tclist		x1f4_move_nclist
# define x1f4_next_tclist		x1f4_next_nclist
# define x1f4_peek_tclist		x1f4_peek_nclist
# define x1f4_push_tclist		x1f4_push_nclist
# define x1f4_rand_tclist		x1f4_rand_nclist
# define x1f4_seek_tclist		x1f4_seek_nclist
# define x1f4_side_tclist		x1f4_side_nclist
# define x1f4_size_tclist		x1f4_size_nclist
# define x1f4_slip_tclist		x1f4_slip_nclist
# define x1f4_sort_tclist		x1f4_sort_nclist
# define x1f4_tail_tclist		x1f4_tail_nclist
# define x1f4_text_tclist		x1f4_text_nclist
# define x1f4_tile_tclist		x1f4_tile_nclist
#elif __XXLIST__ == __NVLIST__
# define x1f4_ever_tclist		x1f4_ever_nvlist
# define x1f4_fgxp_tclist		x1f4_fgxp_nvlist
# define x1f4_fini_tclist		x1f4_fini_nvlist
# define x1f4_flip_tclist		x1f4_flip_nvlist
# define x1f4_flow_tclist		x1f4_flow_nvlist
# define x1f4_fmxp_tclist		x1f4_fmxp_nvlist
# define x1f4_fxxp_tclist		x1f4_fxxp_nvlist
# define x1f4_head_tclist		x1f4_head_nvlist
# define x1f4_high_tclist		x1f4_high_nvlist
# define x1f4_init_tclist		x1f4_init_nvlist
# define x1f4_land_tclist		x1f4_land_nvlist
# define x1f4_last_tclist		x1f4_last_nvlist
# define x1f4_lead_tclist		x1f4_lead_nvlist
# define x1f4_lime_tclist		x1f4_lime_nvlist
# define x1f4_llxp_tclist		x1f4_llxp_nvlist
# define x1f4_lmxp_tclist		x1f4_lmxp_nvlist
# define x1f4_lxxp_tclist		x1f4_lxxp_nvlist
# define x1f4_mind_tclist		x1f4_mind_nvlist
# define x1f4_miss_tclist		x1f4_miss_nvlist
# define x1f4_move_tclist		x1f4_move_nvlist
# define x1f4_next_tclist		x1f4_next_nvlist
# define x1f4_peek_tclist		x1f4_peek_nvlist
# define x1f4_push_tclist		x1f4_push_nvlist
# define x1f4_rand_tclist		x1f4_rand_nvlist
# define x1f4_seek_tclist		x1f4_seek_nvlist
# define x1f4_side_tclist		x1f4_side_nvlist
# define x1f4_size_tclist		x1f4_size_nvlist
# define x1f4_slip_tclist		x1f4_slip_nvlist
# define x1f4_sort_tclist		x1f4_sort_nvlist
# define x1f4_tail_tclist		x1f4_tail_nvlist
# define x1f4_text_tclist		x1f4_text_nvlist
# define x1f4_tile_tclist		x1f4_tile_nvlist
#elif __XXLIST__ == __TCLIST__
#elif __XXLIST__ == __TSLIST__
# define x1f4_ever_tclist		x1f4_ever_tslist
# define x1f4_fgxp_tclist		x1f4_fgxp_tslist
# define x1f4_fini_tclist		x1f4_fini_tslist
# define x1f4_flip_tclist		x1f4_flip_tslist
# define x1f4_flow_tclist		x1f4_flow_tslist
# define x1f4_fmxp_tclist		x1f4_fmxp_tslist
# define x1f4_fxxp_tclist		x1f4_fxxp_tslist
# define x1f4_head_tclist		x1f4_head_tslist
# define x1f4_high_tclist		x1f4_high_tslist
# define x1f4_init_tclist		x1f4_init_tslist
# define x1f4_land_tclist		x1f4_land_tslist
# define x1f4_last_tclist		x1f4_last_tslist
# define x1f4_lead_tclist		x1f4_lead_tslist
# define x1f4_lime_tclist		x1f4_lime_tslist
# define x1f4_llxp_tclist		x1f4_llxp_tslist
# define x1f4_lmxp_tclist		x1f4_lmxp_tslist
# define x1f4_lxxp_tclist		x1f4_lxxp_tslist
# define x1f4_mind_tclist		x1f4_mind_tslist
# define x1f4_miss_tclist		x1f4_miss_tslist
# define x1f4_move_tclist		x1f4_move_tslist
# define x1f4_next_tclist		x1f4_next_tslist
# define x1f4_peek_tclist		x1f4_peek_tslist
# define x1f4_push_tclist		x1f4_push_tslist
# define x1f4_rand_tclist		x1f4_rand_tslist
# define x1f4_seek_tclist		x1f4_seek_tslist
# define x1f4_side_tclist		x1f4_side_tslist
# define x1f4_size_tclist		x1f4_size_tslist
# define x1f4_slip_tclist		x1f4_slip_tslist
# define x1f4_sort_tclist		x1f4_sort_tslist
# define x1f4_tail_tclist		x1f4_tail_tslist
# define x1f4_text_tclist		x1f4_text_tslist
# define x1f4_tile_tclist		x1f4_tile_tslist
#elif __XXLIST__ == __TVLIST__
# define x1f4_ever_tclist		x1f4_ever_tvlist
# define x1f4_fgxp_tclist		x1f4_fgxp_tvlist
# define x1f4_fini_tclist		x1f4_fini_tvlist
# define x1f4_flip_tclist		x1f4_flip_tvlist
# define x1f4_flow_tclist		x1f4_flow_tvlist
# define x1f4_fmxp_tclist		x1f4_fmxp_tvlist
# define x1f4_fxxp_tclist		x1f4_fxxp_tvlist
# define x1f4_head_tclist		x1f4_head_tvlist
# define x1f4_high_tclist		x1f4_high_tvlist
# define x1f4_init_tclist		x1f4_init_tvlist
# define x1f4_land_tclist		x1f4_land_tvlist
# define x1f4_last_tclist		x1f4_last_tvlist
# define x1f4_lead_tclist		x1f4_lead_tvlist
# define x1f4_lime_tclist		x1f4_lime_tvlist
# define x1f4_llxp_tclist		x1f4_llxp_tvlist
# define x1f4_lmxp_tclist		x1f4_lmxp_tvlist
# define x1f4_lxxp_tclist		x1f4_lxxp_tvlist
# define x1f4_mind_tclist		x1f4_mind_tvlist
# define x1f4_miss_tclist		x1f4_miss_tvlist
# define x1f4_move_tclist		x1f4_move_tvlist
# define x1f4_next_tclist		x1f4_next_tvlist
# define x1f4_peek_tclist		x1f4_peek_tvlist
# define x1f4_push_tclist		x1f4_push_tvlist
# define x1f4_rand_tclist		x1f4_rand_tvlist
# define x1f4_seek_tclist		x1f4_seek_tvlist
# define x1f4_side_tclist		x1f4_side_tvlist
# define x1f4_size_tclist		x1f4_size_tvlist
# define x1f4_slip_tclist		x1f4_slip_tvlist
# define x1f4_sort_tclist		x1f4_sort_tvlist
# define x1f4_tail_tclist		x1f4_tail_tvlist
# define x1f4_text_tclist		x1f4_text_tvlist
# define x1f4_tile_tclist		x1f4_tile_tvlist
#endif				/* ____XXLIST__ == __LVLIST__ */

#endif				/* __LIBx1f4l2_TCXX_H__ */
